// Koka generated module: std/time/astro, koka version: 3.1.3, platform: 64-bit
#include "std_time_astro.h"

kk_std_num_ddouble__ddouble kk_std_time_astro_secs_per_day;

kk_std_num_ddouble__ddouble kk_std_time_astro_offset_j2000;
 
// Return the instant corresponding to a J2000 julian date: this is the number of days, and
// the fraction of the day since J2000 (`epoch-j2000`) in terrestrial time (`ts-tt`).
// `instant-at-j2000(zero).time.show == "2000-01-01T11:58:55.816Z"`
// `instant-at-j2000(zero).time(cal=cal-tt).show == "2000-01-01T12:00:00Z TT"`

kk_std_time_instant__instant kk_std_time_astro_instant_at_j2000(kk_std_num_ddouble__ddouble jd, kk_context_t* _ctx) { /* (jd : std/num/ddouble/ddouble) -> std/time/instant/instant */ 
  kk_std_num_ddouble__ddouble t_0_10004;
  kk_std_num_ddouble__ddouble _x_x48 = kk_std_num_ddouble__lp__star__rp_(jd, kk_std_time_astro_secs_per_day, _ctx); /*std/num/ddouble/ddouble*/
  t_0_10004 = kk_std_num_ddouble__lp__plus__rp_(_x_x48, kk_std_time_astro_offset_j2000, _ctx); /*std/time/timestamp/timespan*/
  kk_std_time_timestamp__timestamp t_10003;
  int32_t _x_x49;
  kk_integer_t _x_x50;
  kk_std_core_types__optional _match_x38 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x38, _ctx)) {
    kk_box_t _box_x0 = _match_x38._cons._Optional.value;
    kk_integer_t _uniq_leap_675 = kk_integer_unbox(_box_x0, _ctx);
    kk_integer_dup(_uniq_leap_675, _ctx);
    kk_std_core_types__optional_drop(_match_x38, _ctx);
    _x_x50 = _uniq_leap_675; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x38, _ctx);
    _x_x50 = kk_integer_from_small(0); /*int*/
  }
  _x_x49 = kk_integer_clamp32(_x_x50,kk_context()); /*int32*/
  t_10003 = kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, t_0_10004, _x_x49, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_instant__timescale _x_x51 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  return kk_std_time_instant__new_Instant(t_10003, _x_x51, _ctx);
}
 
// The [J2000] epoch is defined as 2000-01-01T12:00:00 TT (Terrestrial time).
//
// [J2000]: https://en.wikipedia.org/wiki/Equinox_(celestial_coordinates)#J2000.0

kk_std_time_instant__instant kk_std_time_astro_epoch_j2000;
 
// Return the J2000 julian date for an instant. This is the number of days, and
// the fraction of the day since J2000 (`epoch-j2000`) in terrestrial time (`ts-tt`).
// `instant(2000,1,1,12,0,0).j2000.show == "0.00074287037037"`
// `instant(2000,1,1,12,0,0,cal=cal-tt).j2000.show == "0"`

kk_std_num_ddouble__ddouble kk_std_time_astro_j2000(kk_std_time_instant__instant i, kk_context_t* _ctx) { /* (i : std/time/instant/instant) -> std/num/ddouble/ddouble */ 
  kk_std_time_timestamp__timestamp ts_10009;
  kk_std_time_timestamp__timestamp _x_x52;
  kk_std_time_timestamp__timestamp _x_x53;
  {
    kk_std_time_timestamp__timestamp _x_0 = i.since;
    kk_std_time_instant__timescale _pat_2_0 = i.ts;
    struct kk_std_time_timestamp_Timestamp* _con_x54 = kk_std_time_timestamp__as_Timestamp(_x_0, _ctx);
    struct kk_std_time_instant_Timescale* _con_x55 = kk_std_time_instant__as_Timescale(_pat_2_0, _ctx);
    kk_std_time_timestamp__timestamp_dup(_x_0, _ctx);
    _x_x53 = _x_0; /*std/time/timestamp/timestamp*/
  }
  kk_std_time_instant__timescale _x_x56;
  {
    kk_std_time_timestamp__timestamp _pat_0_0_0 = i.since;
    kk_std_time_instant__timescale _x_0_0 = i.ts;
    struct kk_std_time_timestamp_Timestamp* _con_x57 = kk_std_time_timestamp__as_Timestamp(_pat_0_0_0, _ctx);
    struct kk_std_time_instant_Timescale* _con_x58 = kk_std_time_instant__as_Timescale(_x_0_0, _ctx);
    kk_std_time_instant__timescale_dup(_x_0_0, _ctx);
    kk_std_time_instant__instant_drop(i, _ctx);
    _x_x56 = _x_0_0; /*std/time/instant/timescale*/
  }
  kk_std_time_instant__timescale _x_x59 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  _x_x52 = kk_std_time_instant_convert(_x_x53, _x_x56, _x_x59, _ctx); /*std/time/timestamp/timestamp*/
  ts_10009 = kk_std_time_timestamp__lp__dash__rp_(_x_x52, kk_std_time_astro_offset_j2000, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x60;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x61 = kk_std_time_timestamp__as_Timestamp(ts_10009, _ctx);
    kk_std_num_ddouble__ddouble _x = _con_x61->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_10009, _ctx)) {
      kk_datatype_ptr_free(ts_10009, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_10009, _ctx);
    }
    _x_x60 = _x; /*std/time/timestamp/timespan*/
  }
  return kk_std_num_ddouble__lp__fs__rp_(_x_x60, kk_std_time_astro_secs_per_day, _ctx);
}

kk_std_num_ddouble__ddouble kk_std_time_astro_lg;
 
// 6.969290134e-10  // 1991: 6.969291e-10  // now: 6.969290134

kk_std_num_ddouble__ddouble kk_std_time_astro_tcg_epoch_delta;
 
// IAU 1991 recommendation IV :
// TCG - TT = L~g~&times;(JD~TT~ - TCG~epoch~)
// =>
// TCG = TT + Lg*(TT - TCG~epoch~)

kk_std_time_timestamp__timestamp kk_std_time_astro_tcg_from_tai(kk_std_time_duration__duration tai, kk_context_t* _ctx) { /* (tai : std/time/duration/duration) -> std/time/timestamp/timestamp */ 
  kk_std_time_timestamp__timestamp tt;
  kk_std_time_timestamp__timestamp _x_x65;
  kk_std_num_ddouble__ddouble _x_x66;
  {
    kk_std_num_ddouble__ddouble _x = tai.secs;
    _x_x66 = _x; /*std/time/timestamp/timespan*/
  }
  int32_t _x_x67;
  kk_integer_t _x_x68;
  kk_std_core_types__optional _match_x37 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x37, _ctx)) {
    kk_box_t _box_x1 = _match_x37._cons._Optional.value;
    kk_integer_t _uniq_leap_675 = kk_integer_unbox(_box_x1, _ctx);
    kk_integer_dup(_uniq_leap_675, _ctx);
    kk_std_core_types__optional_drop(_match_x37, _ctx);
    _x_x68 = _uniq_leap_675; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x37, _ctx);
    _x_x68 = kk_integer_from_small(0); /*int*/
  }
  _x_x67 = kk_integer_clamp32(_x_x68,kk_context()); /*int32*/
  _x_x65 = kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x66, _x_x67, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_instant__timescale _x_x69 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tai, _ctx); /*std/time/instant/timescale*/
  kk_std_time_instant__timescale _x_x70 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  tt = kk_std_time_instant_convert(_x_x65, _x_x69, _x_x70, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp ts_1_10016;
  kk_std_time_timestamp__timestamp _x_x71 = kk_std_time_timestamp__timestamp_dup(tt, _ctx); /*std/time/timestamp/timestamp*/
  ts_1_10016 = kk_std_time_timestamp__lp__dash__rp_(_x_x71, kk_std_time_astro_tcg_epoch_delta, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble t_10015;
  kk_std_num_ddouble__ddouble _x_x72;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x73 = kk_std_time_timestamp__as_Timestamp(ts_1_10016, _ctx);
    kk_std_num_ddouble__ddouble _x_1 = _con_x73->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_1_10016, _ctx)) {
      kk_datatype_ptr_free(ts_1_10016, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_1_10016, _ctx);
    }
    _x_x72 = _x_1; /*std/time/timestamp/timespan*/
  }
  t_10015 = kk_std_num_ddouble__lp__star__rp_(kk_std_time_astro_lg, _x_x72, _ctx); /*std/time/timestamp/timespan*/
  kk_std_num_ddouble__ddouble _x_x74;
  kk_std_num_ddouble__ddouble _x_x75;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x76 = kk_std_time_timestamp__as_Timestamp(tt, _ctx);
    kk_std_num_ddouble__ddouble _x_0 = _con_x76->since;
    _x_x75 = _x_0; /*std/time/timestamp/timespan*/
  }
  _x_x74 = kk_std_num_ddouble__lp__plus__rp_(_x_x75, t_10015, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x77;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x78 = kk_std_time_timestamp__as_Timestamp(tt, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_0_0 = _con_x78->since;
    int32_t _x_0_0 = _con_x78->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(tt, _ctx)) {
      kk_datatype_ptr_free(tt, _ctx);
    }
    else {
      kk_datatype_ptr_decref(tt, _ctx);
    }
    _x_x77 = _x_0_0; /*int32*/
  }
  return kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x74, _x_x77, _ctx);
}
 
// IAU 1991 recommendation [IV](https://www.iers.org/IERS/EN/Science/Recommendations/recommendation4.html?nn=12932):
// TCG - TT = L~g~&times;(JD~TT~ - TCG~epoch~)
// =>
// TT = TCG - Lg*(TCG - TCG~epoch~)

kk_std_time_duration__duration kk_std_time_astro_tcg_to_tai(kk_std_time_timestamp__timestamp t, kk_context_t* _ctx) { /* (t : std/time/timestamp/timestamp) -> std/time/duration/duration */ 
  kk_std_time_timestamp__timestamp ts_10017;
  kk_std_time_timestamp__timestamp _x_x79 = kk_std_time_timestamp__timestamp_dup(t, _ctx); /*std/time/timestamp/timestamp*/
  ts_10017 = kk_std_time_timestamp__lp__dash__rp_(_x_x79, kk_std_time_astro_tcg_epoch_delta, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp tt;
  kk_std_num_ddouble__ddouble _x_x80;
  kk_std_num_ddouble__ddouble _x_x81;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x82 = kk_std_time_timestamp__as_Timestamp(ts_10017, _ctx);
    kk_std_num_ddouble__ddouble _x = _con_x82->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_10017, _ctx)) {
      kk_datatype_ptr_free(ts_10017, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_10017, _ctx);
    }
    _x_x81 = _x; /*std/time/timestamp/timespan*/
  }
  _x_x80 = kk_std_num_ddouble__lp__star__rp_(kk_std_time_astro_lg, _x_x81, _ctx); /*std/num/ddouble/ddouble*/
  tt = kk_std_time_timestamp__lp__dash__rp_(t, _x_x80, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp t_0_10075;
  kk_std_time_instant__timescale _x_x83 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  kk_std_time_instant__timescale _x_x84 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tai, _ctx); /*std/time/instant/timescale*/
  t_0_10075 = kk_std_time_instant_convert(tt, _x_x83, _x_x84, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x85 = kk_std_time_timestamp_unsafe_timespan_withleap(t_0_10075, _ctx); /*std/time/timestamp/timespan*/
  return kk_std_time_duration__new_Duration(_x_x85, _ctx);
}
 
// The [TCG](https://en.wikipedia.org/wiki/Geocentric_Coordinate_Time) (Geocentric coordinate time) time scale.
// The unit of TCG is the SI second in a coordinate reference frame at the center of the Earth.


// lift anonymous function
struct kk_std_time_astro_ts_tcg_fun89__t {
  struct kk_function_s _base;
};
static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tcg_fun89(kk_function_t _fself, kk_std_time_duration__duration _x1_x88, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tcg_fun89(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_astro_ts_tcg_fun89, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tcg_fun89(kk_function_t _fself, kk_std_time_duration__duration _x1_x88, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_std_time_astro_tcg_from_tai(_x1_x88, _ctx);
}


// lift anonymous function
struct kk_std_time_astro_ts_tcg_fun91__t {
  struct kk_function_s _base;
};
static kk_std_time_duration__duration kk_std_time_astro_ts_tcg_fun91(kk_function_t _fself, kk_std_time_timestamp__timestamp _x1_x90, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tcg_fun91(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_astro_ts_tcg_fun91, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_std_time_duration__duration kk_std_time_astro_ts_tcg_fun91(kk_function_t _fself, kk_std_time_timestamp__timestamp _x1_x90, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_std_time_astro_tcg_to_tai(_x1_x90, _ctx);
}

kk_std_time_instant__timescale kk_std_time_astro_ts_tcg;
 
// /*----------------------------------------------------------------------------
//   TDB: Barycentric dynamical time
// ----------------------------------------------------------------------------*/

kk_std_num_ddouble__ddouble kk_std_time_astro_j2k_epoch;
 
// Compute tdb-delta(TT) = TDB - TT. This is the default function used for `ts-tdb`.
// Fairhead & Bretagnon (1990) initial coefficents.
// See also USNO circular 179 ([@Kaplan:circ], section 2.6).
// The error in this approximation is a maximum of 10 micro-seconds in the time period 1600 to 2200.
// (and probably less as we expanded to more terms and do JPL planetary mass adjustment)

kk_std_num_ddouble__ddouble kk_std_time_astro_tdb_delta(kk_std_time_timestamp__timestamp tt, kk_context_t* _ctx) { /* (tt : std/time/timestamp/timestamp) -> std/time/timestamp/timespan */ 
  kk_std_time_timestamp__timestamp ts_10021 = kk_std_time_timestamp__lp__dash__rp_(tt, kk_std_time_astro_j2k_epoch, _ctx); /*std/time/timestamp/timestamp*/;
  double t;
  double _x_x92;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x93 = kk_std_time_timestamp__as_Timestamp(ts_10021, _ctx);
    kk_std_num_ddouble__ddouble _x_0 = _con_x93->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_10021, _ctx)) {
      kk_datatype_ptr_free(ts_10021, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_10021, _ctx);
    }
    {
      double _x = _x_0.hi;
      _x_x92 = _x; /*float64*/
    }
  }
  double _x_x94 = ((0x1.e187ep24) * (0x1.f4p9)); /*float64*/
  t = (_x_x92 / _x_x94); /*float64*/
  double wf;
  double _x_x95;
  double _x_x96;
  double _x_x97;
  double _x_x98;
  double _x_x99;
  double _x_x100 = ((0x1.88b1367a0f909p12) * t); /*float64*/
  _x_x99 = (_x_x100 + (0x1.8f5dcc63f1412p2)); /*float64*/
  _x_x98 = sin(_x_x99); /*float64*/
  _x_x97 = ((0x1.b2498ce8908a9p-10) * _x_x98); /*float64*/
  double _x_x101;
  double _x_x102;
  double _x_x103;
  double _x_x104;
  double _x_x105;
  double _x_x106;
  double _x_x107 = ((0x1.67962ca57a787p12) * t); /*float64*/
  _x_x106 = (_x_x107 + (0x1.13020c49ba5e3p2)); /*float64*/
  _x_x105 = sin(_x_x106); /*float64*/
  _x_x104 = ((0x1.781a6dea693fep-16) * _x_x105); /*float64*/
  double _x_x108;
  double _x_x109;
  double _x_x110;
  double _x_x111 = ((0x1.88b138bac710dp13) * t); /*float64*/
  _x_x110 = (_x_x111 + (0x1.8c9a027525461p2)); /*float64*/
  _x_x109 = sin(_x_x110); /*float64*/
  _x_x108 = ((0x1.d062fa0d5c3aep-17) * _x_x109); /*float64*/
  _x_x103 = (_x_x104 + _x_x108); /*float64*/
  double _x_x112;
  double _x_x113;
  double _x_x114;
  double _x_x115 = ((0x1.08d872b020c4ap9) * t); /*float64*/
  _x_x114 = (_x_x115 + (0x1.c710cb295e9e2p-2)); /*float64*/
  _x_x113 = sin(_x_x114); /*float64*/
  _x_x112 = ((0x1.401db1a9a147cp-18) * _x_x113); /*float64*/
  _x_x102 = (_x_x103 + _x_x112); /*float64*/
  double _x_x116;
  double _x_x117;
  double _x_x118;
  double _x_x119 = ((0x1.7b5c6dc5d6388p12) * t); /*float64*/
  _x_x118 = (_x_x119 + (0x1.015b573eab368p2)); /*float64*/
  _x_x117 = sin(_x_x118); /*float64*/
  _x_x116 = ((0x1.39d9181e54b5dp-18) * _x_x117); /*float64*/
  _x_x101 = (_x_x102 + _x_x116); /*float64*/
  _x_x96 = (_x_x97 + _x_x101); /*float64*/
  double _x_x120;
  double _x_x121;
  double _x_x122;
  double _x_x123;
  double _x_x124;
  double _x_x125;
  double _x_x126;
  double _x_x127 = ((0x1.aa9923a29c77ap7) * t); /*float64*/
  _x_x126 = (_x_x127 + (0x1.62c226809d495p2)); /*float64*/
  _x_x125 = sin(_x_x126); /*float64*/
  _x_x124 = ((0x1.2ee39f1f8b22cp-19) * _x_x125); /*float64*/
  double _x_x128;
  double _x_x129;
  double _x_x130;
  double _x_x131;
  double _x_x132 = (-(0x1.c2f837b4a233ap1)); /*float64*/
  _x_x131 = (_x_x132 * t); /*float64*/
  _x_x130 = (_x_x131 + (0x1.419b3d07c84b6p2)); /*float64*/
  _x_x129 = sin(_x_x130); /*float64*/
  _x_x128 = ((0x1.c6c88998b0eb9p-20) * _x_x129); /*float64*/
  _x_x123 = (_x_x124 + _x_x128); /*float64*/
  double _x_x133;
  double _x_x134;
  double _x_x135;
  double _x_x136 = ((0x1.2f91c5810624ep16) * t); /*float64*/
  _x_x135 = (_x_x136 + (0x1.4cb4395810625p2)); /*float64*/
  _x_x134 = sin(_x_x135); /*float64*/
  _x_x133 = ((0x1.a163ea14992fbp-20) * _x_x134); /*float64*/
  _x_x122 = (_x_x123 + _x_x133); /*float64*/
  double _x_x137;
  double _x_x138;
  double _x_x139;
  double _x_x140 = ((0x1.eb46b5dcc63f1p12) * t); /*float64*/
  _x_x139 = (_x_x140 + (0x1.7f487fcb923a3p2)); /*float64*/
  _x_x138 = sin(_x_x139); /*float64*/
  _x_x137 = ((0x1.56bd07243a05bp-20) * _x_x138); /*float64*/
  _x_x121 = (_x_x122 + _x_x137); /*float64*/
  double _x_x141;
  double _x_x142;
  double _x_x143;
  double _x_x144 = ((0x1.467b1a36e2eb2p12) * t); /*float64*/
  _x_x143 = (_x_x144 + (0x1.d32ca57a786c2p1)); /*float64*/
  _x_x142 = sin(_x_x143); /*float64*/
  _x_x141 = ((0x1.4059d2d34dcfbp-20) * _x_x142); /*float64*/
  _x_x120 = (_x_x121 + _x_x141); /*float64*/
  _x_x95 = (_x_x96 + _x_x120); /*float64*/
  double _x_x145;
  double _x_x146;
  double _x_x147;
  double _x_x148;
  double _x_x149 = ((0x1.88b1367a0f909p12) * t); /*float64*/
  _x_x148 = (_x_x149 + (0x1.0fef9db22d0e5p2)); /*float64*/
  _x_x147 = sin(_x_x148); /*float64*/
  _x_x146 = ((0x1.ac79ebe055992p-14) * _x_x147); /*float64*/
  _x_x145 = (t * _x_x146); /*float64*/
  wf = (_x_x95 + _x_x145); /*float64*/
  double wj;
  double _x_x150;
  double _x_x151;
  double _x_x152;
  double _x_x153;
  double _x_x154;
  double _x_x155;
  double _x_x156 = ((0x1.7b5c6d959a30ap12) * t); /*float64*/
  _x_x155 = (_x_x156 + (0x1.015b3e1437c57p2)); /*float64*/
  _x_x154 = sin(_x_x155); /*float64*/
  _x_x153 = ((0x1.65575e0ff4a28p-31) * _x_x154); /*float64*/
  double _x_x157;
  double _x_x158;
  double _x_x159;
  double _x_x160 = ((0x1.aa9922fad6cb5p7) * t); /*float64*/
  _x_x159 = (_x_x160 + (0x1.62c2acb85a4fp2)); /*float64*/
  _x_x158 = sin(_x_x159); /*float64*/
  _x_x157 = ((0x1.6ad6be0852fbap-32) * _x_x158); /*float64*/
  _x_x152 = (_x_x153 + _x_x157); /*float64*/
  double _x_x161;
  double _x_x162 = (-(0x1.0d615e8a0f102p-29)); /*float64*/
  double _x_x163;
  double _x_x164;
  double _x_x165 = ((0x1.8404b540895d1p12) * t); /*float64*/
  _x_x164 = (_x_x165 + (0x1.6c96bfca85cabp2)); /*float64*/
  _x_x163 = sin(_x_x164); /*float64*/
  _x_x161 = (_x_x162 * _x_x163); /*float64*/
  _x_x151 = (_x_x152 + _x_x161); /*float64*/
  double _x_x166;
  double _x_x167 = (-(0x1.db89ed6be11f2p-30)); /*float64*/
  double _x_x168;
  double _x_x169;
  double _x_x170 = ((0x1.2b205b7cfe586p6) * t); /*float64*/
  _x_x169 = (_x_x170 + (0x1.37cb923a29c78p1)); /*float64*/
  _x_x168 = sin(_x_x169); /*float64*/
  _x_x166 = (_x_x167 * _x_x168); /*float64*/
  _x_x150 = (_x_x151 + _x_x166); /*float64*/
  double _x_x171;
  double _x_x172 = ((0x1.3880774e331b6p-25) * t); /*float64*/
  _x_x171 = (_x_x172 * t); /*float64*/
  wj = (_x_x150 + _x_x171); /*float64*/
  double d_10022;
  double _x_x173 = (wf + wj); /*float64*/
  d_10022 = (_x_x173 + (0x0p+0)); /*float64*/
  return kk_std_num_ddouble__new_Ddouble(d_10022, 0x0p+0, _ctx);
}
 
// From the ERFA routines

double kk_std_time_astro_tdb_topocentric(double t, kk_std_core_types__optional ut, kk_std_core_types__optional elong, kk_std_core_types__optional u, kk_std_core_types__optional v, kk_context_t* _ctx) { /* (t : float64, ut : ? float64, elong : ? float64, u : ? float64, v : ? float64) -> float64 */ 
  double tsol;
  double _x_x174;
  double _x_x175;
  double _x_x176;
  if (kk_std_core_types__is_Optional(ut, _ctx)) {
    kk_box_t _box_x2 = ut._cons._Optional.value;
    double _uniq_ut_565 = kk_double_unbox(_box_x2, KK_BORROWED, _ctx);
    kk_std_core_types__optional_drop(ut, _ctx);
    _x_x176 = _uniq_ut_565; /*float64*/
  }
  else {
    kk_std_core_types__optional_drop(ut, _ctx);
    _x_x176 = 0x0p+0; /*float64*/
  }
  _x_x175 = kk_std_num_float64_fraction(_x_x176, _ctx); /*float64*/
  _x_x174 = (_x_x175 * (0x1.921fb54442d18p2)); /*float64*/
  double _x_x177;
  double _x_x178;
  if (kk_std_core_types__is_Optional(elong, _ctx)) {
    kk_box_t _box_x3 = elong._cons._Optional.value;
    double _uniq_elong_569 = kk_double_unbox(_box_x3, KK_BORROWED, _ctx);
    kk_std_core_types__optional_drop(elong, _ctx);
    _x_x178 = _uniq_elong_569; /*float64*/
  }
  else {
    kk_std_core_types__optional_drop(elong, _ctx);
    _x_x178 = 0x0p+0; /*float64*/
  }
  _x_x177 = (_x_x178 * (0x1.1df46a2529d39p-6)); /*float64*/
  tsol = (_x_x174 + _x_x177); /*float64*/
  double w = (t / (0x1.c2p11)); /*float64*/;
  double elsun;
  double _x_x179;
  double _x_x180;
  double _x_x181 = ((0x1.34ff40fc231cfp30) * w); /*float64*/
  _x_x180 = ((0x1.187769b6fdd89p8) + _x_x181); /*float64*/
  _x_x179 = fmod(_x_x180,(0x1.68p8)); /*float64*/
  elsun = (_x_x179 * (0x1.1df46a2529d39p-6)); /*float64*/
  double emsun;
  double _x_x182;
  double _x_x183;
  double _x_x184 = ((0x1.34fb79c9ec8b4p30) * w); /*float64*/
  _x_x183 = ((0x1.658773b3001dp8) + _x_x184); /*float64*/
  _x_x182 = fmod(_x_x183,(0x1.68p8)); /*float64*/
  emsun = (_x_x182 * (0x1.1df46a2529d39p-6)); /*float64*/
  double d;
  double _x_x185;
  double _x_x186;
  double _x_x187 = ((0x1.ddb843c60b852p33) * w); /*float64*/
  _x_x186 = ((0x1.29d9a6690adb8p8) + _x_x187); /*float64*/
  _x_x185 = fmod(_x_x186,(0x1.68p8)); /*float64*/
  d = (_x_x185 * (0x1.1df46a2529d39p-6)); /*float64*/
  double elj;
  double _x_x188;
  double _x_x189;
  double _x_x190 = ((0x1.a0f904f93ffacp26) * w); /*float64*/
  _x_x189 = ((0x1.12cfe90ea1d96p5) + _x_x190); /*float64*/
  _x_x188 = fmod(_x_x189,(0x1.68p8)); /*float64*/
  elj = (_x_x188 * (0x1.1df46a2529d39p-6)); /*float64*/
  double els;
  double _x_x191;
  double _x_x192;
  double _x_x193 = ((0x1.500c1f3c35697p25) * w); /*float64*/
  _x_x192 = ((0x1.909e9b1dfe17dp5) + _x_x193); /*float64*/
  _x_x191 = fmod(_x_x192,(0x1.68p8)); /*float64*/
  els = (_x_x191 * (0x1.1df46a2529d39p-6)); /*float64*/
  double _x_x194;
  double _x_x195;
  double _x_x196;
  double _x_x197;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x4 = u._cons._Optional.value;
    double _uniq_u_573 = kk_double_unbox(_box_x4, KK_BORROWED, _ctx);
    _x_x197 = _uniq_u_573; /*float64*/
  }
  else {
    _x_x197 = 0x0p+0; /*float64*/
  }
  _x_x196 = ((0x1.053572801a604p-45) * _x_x197); /*float64*/
  double _x_x198;
  double _x_x199;
  double _x_x200 = (tsol + elsun); /*float64*/
  _x_x199 = (_x_x200 - els); /*float64*/
  _x_x198 = sin(_x_x199); /*float64*/
  _x_x195 = (_x_x196 * _x_x198); /*float64*/
  double _x_x201;
  double _x_x202;
  double _x_x203;
  double _x_x204;
  double _x_x205;
  double _x_x206;
  double _x_x207;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x5 = u._cons._Optional.value;
    double _uniq_u_573_0 = kk_double_unbox(_box_x5, KK_BORROWED, _ctx);
    _x_x207 = _uniq_u_573_0; /*float64*/
  }
  else {
    _x_x207 = 0x0p+0; /*float64*/
  }
  _x_x206 = ((0x1.c25c268497682p-44) * _x_x207); /*float64*/
  double _x_x208;
  double _x_x209;
  double _x_x210 = (0x1p1 * emsun); /*float64*/
  _x_x209 = (tsol - _x_x210); /*float64*/
  _x_x208 = sin(_x_x209); /*float64*/
  _x_x205 = (_x_x206 * _x_x208); /*float64*/
  double _x_x211;
  double _x_x212;
  double _x_x213;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x6 = u._cons._Optional.value;
    double _uniq_u_573_1 = kk_double_unbox(_box_x6, KK_BORROWED, _ctx);
    _x_x213 = _uniq_u_573_1; /*float64*/
  }
  else {
    _x_x213 = 0x0p+0; /*float64*/
  }
  _x_x212 = ((0x1.2b7d47b1c5f72p-43) * _x_x213); /*float64*/
  double _x_x214;
  double _x_x215 = (tsol - d); /*float64*/
  _x_x214 = sin(_x_x215); /*float64*/
  _x_x211 = (_x_x212 * _x_x214); /*float64*/
  _x_x204 = (_x_x205 + _x_x211); /*float64*/
  double _x_x216;
  double _x_x217;
  double _x_x218;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x7 = u._cons._Optional.value;
    double _uniq_u_573_2 = kk_double_unbox(_box_x7, KK_BORROWED, _ctx);
    _x_x218 = _uniq_u_573_2; /*float64*/
  }
  else {
    _x_x218 = 0x0p+0; /*float64*/
  }
  _x_x217 = ((0x1.2b7d47b1c5f72p-43) * _x_x218); /*float64*/
  double _x_x219;
  double _x_x220;
  double _x_x221 = (elsun - elj); /*float64*/
  _x_x220 = (tsol + _x_x221); /*float64*/
  _x_x219 = sin(_x_x220); /*float64*/
  _x_x216 = (_x_x217 * _x_x219); /*float64*/
  _x_x203 = (_x_x204 + _x_x216); /*float64*/
  double _x_x222;
  double _x_x223;
  double _x_x224;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x8 = u._cons._Optional.value;
    double _uniq_u_573_3 = kk_double_unbox(_box_x8, KK_BORROWED, _ctx);
    _x_x224 = _uniq_u_573_3; /*float64*/
  }
  else {
    _x_x224 = 0x0p+0; /*float64*/
  }
  _x_x223 = ((0x1.01d4c1924f001p-42) * _x_x224); /*float64*/
  double _x_x225;
  double _x_x226;
  double _x_x227;
  double _x_x228 = (0x1p1 * elsun); /*float64*/
  _x_x227 = (tsol + _x_x228); /*float64*/
  _x_x226 = (_x_x227 + emsun); /*float64*/
  _x_x225 = sin(_x_x226); /*float64*/
  _x_x222 = (_x_x223 * _x_x225); /*float64*/
  _x_x202 = (_x_x203 - _x_x222); /*float64*/
  double _x_x229;
  double _x_x230;
  double _x_x231;
  if (kk_std_core_types__is_Optional(v, _ctx)) {
    kk_box_t _box_x9 = v._cons._Optional.value;
    double _uniq_v_577 = kk_double_unbox(_box_x9, KK_BORROWED, _ctx);
    _x_x231 = _uniq_v_577; /*float64*/
  }
  else {
    _x_x231 = 0x0p+0; /*float64*/
  }
  _x_x230 = ((0x1.359f5a7b28179p-39) * _x_x231); /*float64*/
  double _x_x232;
  double _x_x233 = (elsun + emsun); /*float64*/
  _x_x232 = cos(_x_x233); /*float64*/
  _x_x229 = (_x_x230 * _x_x232); /*float64*/
  _x_x201 = (_x_x202 - _x_x229); /*float64*/
  _x_x194 = (_x_x195 + _x_x201); /*float64*/
  double _x_x234;
  double _x_x235;
  double _x_x236;
  double _x_x237;
  double _x_x238;
  double _x_x239;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x10 = u._cons._Optional.value;
    double _uniq_u_573_4 = kk_double_unbox(_box_x10, KK_BORROWED, _ctx);
    _x_x239 = _uniq_u_573_4; /*float64*/
  }
  else {
    _x_x239 = 0x0p+0; /*float64*/
  }
  _x_x238 = ((0x1.75cc7c21403a4p-38) * _x_x239); /*float64*/
  double _x_x240;
  double _x_x241 = (tsol - emsun); /*float64*/
  _x_x240 = sin(_x_x241); /*float64*/
  _x_x237 = (_x_x238 * _x_x240); /*float64*/
  double _x_x242;
  double _x_x243;
  double _x_x244;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x11 = u._cons._Optional.value;
    double _uniq_u_573_5 = kk_double_unbox(_box_x11, KK_BORROWED, _ctx);
    _x_x244 = _uniq_u_573_5; /*float64*/
  }
  else {
    _x_x244 = 0x0p+0; /*float64*/
  }
  _x_x243 = ((0x1.e13776d646a91p-37) * _x_x244); /*float64*/
  double _x_x245;
  double _x_x246;
  double _x_x247 = (0x1p1 * elsun); /*float64*/
  _x_x246 = (tsol + _x_x247); /*float64*/
  _x_x245 = sin(_x_x246); /*float64*/
  _x_x242 = (_x_x243 * _x_x245); /*float64*/
  _x_x236 = (_x_x237 - _x_x242); /*float64*/
  double _x_x248;
  double _x_x249;
  double _x_x250;
  if (kk_std_core_types__is_Optional(v, _ctx)) {
    kk_box_t _box_x12 = v._cons._Optional.value;
    double _uniq_v_577_0 = kk_double_unbox(_box_x12, KK_BORROWED, _ctx);
    kk_std_core_types__optional_drop(v, _ctx);
    _x_x250 = _uniq_v_577_0; /*float64*/
  }
  else {
    kk_std_core_types__optional_drop(v, _ctx);
    _x_x250 = 0x0p+0; /*float64*/
  }
  _x_x249 = ((0x1.21eb52655b117p-33) * _x_x250); /*float64*/
  double _x_x251 = cos(elsun); /*float64*/
  _x_x248 = (_x_x249 * _x_x251); /*float64*/
  _x_x235 = (_x_x236 - _x_x248); /*float64*/
  double _x_x252;
  double _x_x253;
  double _x_x254;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x13 = u._cons._Optional.value;
    double _uniq_u_573_6 = kk_double_unbox(_box_x13, KK_BORROWED, _ctx);
    kk_std_core_types__optional_drop(u, _ctx);
    _x_x254 = _uniq_u_573_6; /*float64*/
  }
  else {
    kk_std_core_types__optional_drop(u, _ctx);
    _x_x254 = 0x0p+0; /*float64*/
  }
  _x_x253 = ((0x1.5d4ab06a978bdp-32) * _x_x254); /*float64*/
  double _x_x255 = sin(tsol); /*float64*/
  _x_x252 = (_x_x253 * _x_x255); /*float64*/
  _x_x234 = (_x_x235 + _x_x252); /*float64*/
  return (_x_x194 + _x_x234);
}

kk_std_time_timestamp__timestamp kk_std_time_astro_tai_to_tdb(kk_std_time_duration__duration tai, kk_std_core_types__optional delta, kk_context_t* _ctx) { /* (tai : std/time/duration/duration, delta : ? ((std/time/timestamp/timestamp) -> std/time/timestamp/timespan)) -> std/time/timestamp/timestamp */ 
  kk_std_time_timestamp__timestamp tt;
  kk_std_time_timestamp__timestamp _x_x256;
  kk_std_num_ddouble__ddouble _x_x257;
  {
    kk_std_num_ddouble__ddouble _x = tai.secs;
    _x_x257 = _x; /*std/time/timestamp/timespan*/
  }
  int32_t _x_x258;
  kk_integer_t _x_x259;
  kk_std_core_types__optional _match_x36 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x36, _ctx)) {
    kk_box_t _box_x14 = _match_x36._cons._Optional.value;
    kk_integer_t _uniq_leap_675 = kk_integer_unbox(_box_x14, _ctx);
    kk_integer_dup(_uniq_leap_675, _ctx);
    kk_std_core_types__optional_drop(_match_x36, _ctx);
    _x_x259 = _uniq_leap_675; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x36, _ctx);
    _x_x259 = kk_integer_from_small(0); /*int*/
  }
  _x_x258 = kk_integer_clamp32(_x_x259,kk_context()); /*int32*/
  _x_x256 = kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x257, _x_x258, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_instant__timescale _x_x260 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tai, _ctx); /*std/time/instant/timescale*/
  kk_std_time_instant__timescale _x_x261 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  tt = kk_std_time_instant_convert(_x_x256, _x_x260, _x_x261, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble t_10026;
  if (kk_std_core_types__is_Optional(delta, _ctx)) {
    kk_box_t _fun_unbox_x18 = delta._cons._Optional.value;
    kk_box_dup(_fun_unbox_x18, _ctx);
    kk_std_core_types__optional_drop(delta, _ctx);
    kk_box_t _x_x262;
    kk_function_t _x_x265 = kk_function_unbox(_fun_unbox_x18, _ctx); /*(19) -> 20*/
    kk_box_t _x_x263;
    kk_std_time_timestamp__timestamp _x_x264 = kk_std_time_timestamp__timestamp_dup(tt, _ctx); /*std/time/timestamp/timestamp*/
    _x_x263 = kk_std_time_timestamp__timestamp_box(_x_x264, _ctx); /*19*/
    _x_x262 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x_x265, (_x_x265, _x_x263, _ctx), _ctx); /*20*/
    t_10026 = kk_std_num_ddouble__ddouble_unbox(_x_x262, KK_OWNED, _ctx); /*std/time/timestamp/timespan*/
  }
  else {
    kk_std_core_types__optional_drop(delta, _ctx);
    kk_std_time_timestamp__timestamp _x_x266 = kk_std_time_timestamp__timestamp_dup(tt, _ctx); /*std/time/timestamp/timestamp*/
    t_10026 = kk_std_time_astro_tdb_delta(_x_x266, _ctx); /*std/time/timestamp/timespan*/
  }
  kk_std_num_ddouble__ddouble _x_x267;
  kk_std_num_ddouble__ddouble _x_x268;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x269 = kk_std_time_timestamp__as_Timestamp(tt, _ctx);
    kk_std_num_ddouble__ddouble _x_0 = _con_x269->since;
    _x_x268 = _x_0; /*std/time/timestamp/timespan*/
  }
  _x_x267 = kk_std_num_ddouble__lp__plus__rp_(_x_x268, t_10026, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x270;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x271 = kk_std_time_timestamp__as_Timestamp(tt, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_0_0 = _con_x271->since;
    int32_t _x_0_0 = _con_x271->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(tt, _ctx)) {
      kk_datatype_ptr_free(tt, _ctx);
    }
    else {
      kk_datatype_ptr_decref(tt, _ctx);
    }
    _x_x270 = _x_0_0; /*int32*/
  }
  return kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x267, _x_x270, _ctx);
}

kk_std_time_duration__duration kk_std_time_astro_tdb_to_tai(kk_std_time_timestamp__timestamp tdb, kk_std_core_types__optional delta, kk_context_t* _ctx) { /* (tdb : std/time/timestamp/timestamp, delta : ? ((std/time/timestamp/timestamp) -> std/time/timestamp/timespan)) -> std/time/duration/duration */ 
  kk_std_time_timestamp__timestamp t_10028;
  kk_std_time_timestamp__timestamp _x_x272 = kk_std_time_timestamp__timestamp_dup(tdb, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x273;
  if (kk_std_core_types__is_Optional(delta, _ctx)) {
    kk_box_t _fun_unbox_x25 = delta._cons._Optional.value;
    kk_box_dup(_fun_unbox_x25, _ctx);
    kk_std_core_types__optional_drop(delta, _ctx);
    kk_box_t _x_x274;
    kk_function_t _x_x275 = kk_function_unbox(_fun_unbox_x25, _ctx); /*(26) -> 27*/
    _x_x274 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x_x275, (_x_x275, kk_std_time_timestamp__timestamp_box(tdb, _ctx), _ctx), _ctx); /*27*/
    _x_x273 = kk_std_num_ddouble__ddouble_unbox(_x_x274, KK_OWNED, _ctx); /*std/time/timestamp/timespan*/
  }
  else {
    kk_std_core_types__optional_drop(delta, _ctx);
    _x_x273 = kk_std_time_astro_tdb_delta(tdb, _ctx); /*std/time/timestamp/timespan*/
  }
  t_10028 = kk_std_time_timestamp__lp__dash__rp_(_x_x272, _x_x273, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp t_0_10075;
  kk_std_time_instant__timescale _x_x276 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  kk_std_time_instant__timescale _x_x277 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tai, _ctx); /*std/time/instant/timescale*/
  t_0_10075 = kk_std_time_instant_convert(t_10028, _x_x276, _x_x277, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x278 = kk_std_time_timestamp_unsafe_timespan_withleap(t_0_10075, _ctx); /*std/time/timestamp/timespan*/
  return kk_std_time_duration__new_Duration(_x_x278, _ctx);
}
 
// Creates a new TDB timescale given a user provided function to calculate TDB-TT.
// The default function used for `ts-tdb` uses the Fairhead &amp; Bretagnon approximation
// corrected for JPL planetary masses but assumes the geo center. Use this function
// to create a new TDB timescale if you need more precision.


// lift anonymous function
struct kk_std_time_astro_ts_tdb_create_fun282__t {
  struct kk_function_s _base;
  kk_function_t tdb_minus_tt;
};
static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tdb_create_fun282(kk_function_t _fself, kk_std_time_duration__duration tai, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tdb_create_fun282(kk_function_t tdb_minus_tt, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tdb_create_fun282__t* _self = kk_function_alloc_as(struct kk_std_time_astro_ts_tdb_create_fun282__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_astro_ts_tdb_create_fun282, kk_context());
  _self->tdb_minus_tt = tdb_minus_tt;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_time_astro_ts_tdb_create_fun284__t {
  struct kk_function_s _base;
  kk_function_t tdb_minus_tt;
};
static kk_box_t kk_std_time_astro_ts_tdb_create_fun284(kk_function_t _fself, kk_box_t _b_x32, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tdb_create_fun284(kk_function_t tdb_minus_tt, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tdb_create_fun284__t* _self = kk_function_alloc_as(struct kk_std_time_astro_ts_tdb_create_fun284__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_astro_ts_tdb_create_fun284, kk_context());
  _self->tdb_minus_tt = tdb_minus_tt;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_time_astro_ts_tdb_create_fun284(kk_function_t _fself, kk_box_t _b_x32, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tdb_create_fun284__t* _self = kk_function_as(struct kk_std_time_astro_ts_tdb_create_fun284__t*, _fself, _ctx);
  kk_function_t tdb_minus_tt = _self->tdb_minus_tt; /* (std/time/timestamp/timestamp) -> std/time/timestamp/timespan */
  kk_drop_match(_self, {kk_function_dup(tdb_minus_tt, _ctx);}, {}, _ctx)
  kk_std_num_ddouble__ddouble _x_x285;
  kk_std_time_timestamp__timestamp _x_x286 = kk_std_time_timestamp__timestamp_unbox(_b_x32, KK_OWNED, _ctx); /*std/time/timestamp/timestamp*/
  _x_x285 = kk_function_call(kk_std_num_ddouble__ddouble, (kk_function_t, kk_std_time_timestamp__timestamp, kk_context_t*), tdb_minus_tt, (tdb_minus_tt, _x_x286, _ctx), _ctx); /*std/time/timestamp/timespan*/
  return kk_std_num_ddouble__ddouble_box(_x_x285, _ctx);
}
static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tdb_create_fun282(kk_function_t _fself, kk_std_time_duration__duration tai, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tdb_create_fun282__t* _self = kk_function_as(struct kk_std_time_astro_ts_tdb_create_fun282__t*, _fself, _ctx);
  kk_function_t tdb_minus_tt = _self->tdb_minus_tt; /* (std/time/timestamp/timestamp) -> std/time/timestamp/timespan */
  kk_drop_match(_self, {kk_function_dup(tdb_minus_tt, _ctx);}, {}, _ctx)
  kk_std_core_types__optional _x_x283 = kk_std_core_types__new_Optional(kk_function_box(kk_std_time_astro_new_ts_tdb_create_fun284(tdb_minus_tt, _ctx), _ctx), _ctx); /*? 7*/
  return kk_std_time_astro_tai_to_tdb(tai, _x_x283, _ctx);
}


// lift anonymous function
struct kk_std_time_astro_ts_tdb_create_fun287__t {
  struct kk_function_s _base;
  kk_function_t tdb_minus_tt;
};
static kk_std_time_duration__duration kk_std_time_astro_ts_tdb_create_fun287(kk_function_t _fself, kk_std_time_timestamp__timestamp tdb, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tdb_create_fun287(kk_function_t tdb_minus_tt, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tdb_create_fun287__t* _self = kk_function_alloc_as(struct kk_std_time_astro_ts_tdb_create_fun287__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_astro_ts_tdb_create_fun287, kk_context());
  _self->tdb_minus_tt = tdb_minus_tt;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_time_duration__duration kk_std_time_astro_ts_tdb_create_fun287(kk_function_t _fself, kk_std_time_timestamp__timestamp tdb, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tdb_create_fun287__t* _self = kk_function_as(struct kk_std_time_astro_ts_tdb_create_fun287__t*, _fself, _ctx);
  kk_function_t tdb_minus_tt = _self->tdb_minus_tt; /* (std/time/timestamp/timestamp) -> std/time/timestamp/timespan */
  kk_drop_match(_self, {kk_function_dup(tdb_minus_tt, _ctx);}, {}, _ctx)
  kk_std_time_timestamp__timestamp t_10032;
  kk_std_time_timestamp__timestamp _x_x288 = kk_std_time_timestamp__timestamp_dup(tdb, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x289 = kk_function_call(kk_std_num_ddouble__ddouble, (kk_function_t, kk_std_time_timestamp__timestamp, kk_context_t*), tdb_minus_tt, (tdb_minus_tt, tdb, _ctx), _ctx); /*std/time/timestamp/timespan*/
  t_10032 = kk_std_time_timestamp__lp__dash__rp_(_x_x288, _x_x289, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp t_0_10075;
  kk_std_time_instant__timescale _x_x290 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  kk_std_time_instant__timescale _x_x291 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tai, _ctx); /*std/time/instant/timescale*/
  t_0_10075 = kk_std_time_instant_convert(t_10032, _x_x290, _x_x291, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x292 = kk_std_time_timestamp_unsafe_timespan_withleap(t_0_10075, _ctx); /*std/time/timestamp/timespan*/
  return kk_std_time_duration__new_Duration(_x_x292, _ctx);
}

kk_std_time_instant__timescale kk_std_time_astro_ts_tdb_create(kk_function_t tdb_minus_tt, kk_context_t* _ctx) { /* (tdb-minus-tt : (std/time/timestamp/timestamp) -> std/time/timestamp/timespan) -> std/time/instant/timescale */ 
  kk_string_t _x_x279;
  kk_define_string_literal(, _s_x280, 3, "TDB", _ctx)
  _x_x279 = kk_string_dup(_s_x280, _ctx); /*string*/
  kk_function_t _x_x281;
  kk_function_dup(tdb_minus_tt, _ctx);
  _x_x281 = kk_std_time_astro_new_ts_tdb_create_fun282(tdb_minus_tt, _ctx); /*(tai : std/time/duration/duration) -> std/time/timestamp/timestamp*/
  return kk_std_time_instant_timescale(_x_x279, _x_x281, kk_std_time_astro_new_ts_tdb_create_fun287(tdb_minus_tt, _ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), _ctx);
}
 
// The [TDB](https://en.wikipedia.org/wiki/Barycentric_Coordinate_Time) (Barycentric dynamical time) time scale
// (which can be considered equivalent T~eph~).
//
// TDB is approximated from TT using an initial set of coefficients by
// Fairhead &amp; Bretagnon [@Fairhead:tt] assuming the geo center (longitude and latitude of 0 degrees).
// See also USNO circular 179 ([@Kaplan:circ], equation 2.6).
// The approximation is within 10&mu;s precision in the time span 1600 to 2200 (and probably a bit less).


// lift anonymous function
struct kk_std_time_astro_ts_tdb_fun294__t {
  struct kk_function_s _base;
};
static kk_std_num_ddouble__ddouble kk_std_time_astro_ts_tdb_fun294(kk_function_t _fself, kk_std_time_timestamp__timestamp _x1_x293, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tdb_fun294(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_astro_ts_tdb_fun294, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_std_num_ddouble__ddouble kk_std_time_astro_ts_tdb_fun294(kk_function_t _fself, kk_std_time_timestamp__timestamp _x1_x293, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_std_time_astro_tdb_delta(_x1_x293, _ctx);
}

kk_std_time_instant__timescale kk_std_time_astro_ts_tdb;

kk_std_num_ddouble__ddouble kk_std_time_astro_lb;
 
// 1.55051976772e-8

kk_std_num_ddouble__ddouble kk_std_time_astro_tdb0;

kk_std_time_timestamp__timestamp kk_std_time_astro_tai_to_tcb(kk_std_time_duration__duration tai, kk_std_time_instant__timescale tstdb, kk_context_t* _ctx) { /* (tai : std/time/duration/duration, tstdb : std/time/instant/timescale) -> std/time/timestamp/timestamp */ 
  kk_std_time_timestamp__timestamp tdb;
  kk_std_time_timestamp__timestamp _x_x298;
  kk_std_num_ddouble__ddouble _x_x299;
  {
    kk_std_num_ddouble__ddouble _x = tai.secs;
    _x_x299 = _x; /*std/time/timestamp/timespan*/
  }
  int32_t _x_x300;
  kk_integer_t _x_x301;
  kk_std_core_types__optional _match_x35 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x35, _ctx)) {
    kk_box_t _box_x34 = _match_x35._cons._Optional.value;
    kk_integer_t _uniq_leap_675 = kk_integer_unbox(_box_x34, _ctx);
    kk_integer_dup(_uniq_leap_675, _ctx);
    kk_std_core_types__optional_drop(_match_x35, _ctx);
    _x_x301 = _uniq_leap_675; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x35, _ctx);
    _x_x301 = kk_integer_from_small(0); /*int*/
  }
  _x_x300 = kk_integer_clamp32(_x_x301,kk_context()); /*int32*/
  _x_x298 = kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x299, _x_x300, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_instant__timescale _x_x302 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tai, _ctx); /*std/time/instant/timescale*/
  tdb = kk_std_time_instant_convert(_x_x298, _x_x302, tstdb, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp ts_0_10035;
  kk_std_time_timestamp__timestamp _x_x303 = kk_std_time_timestamp__timestamp_dup(tdb, _ctx); /*std/time/timestamp/timestamp*/
  ts_0_10035 = kk_std_time_timestamp__lp__dash__rp_(_x_x303, kk_std_time_astro_tcg_epoch_delta, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble adj;
  kk_std_num_ddouble__ddouble _x_x304;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x305 = kk_std_time_timestamp__as_Timestamp(ts_0_10035, _ctx);
    kk_std_num_ddouble__ddouble _x_0 = _con_x305->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_0_10035, _ctx)) {
      kk_datatype_ptr_free(ts_0_10035, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_0_10035, _ctx);
    }
    _x_x304 = _x_0; /*std/time/timestamp/timespan*/
  }
  adj = kk_std_num_ddouble__lp__star__rp_(kk_std_time_astro_lb, _x_x304, _ctx); /*std/num/ddouble/ddouble*/
  kk_std_num_ddouble__ddouble t_10037;
  kk_std_num_ddouble__ddouble _x_x306;
  double _x_x307;
  double _x_x308;
  kk_std_num_ddouble__ddouble _x_x309 = kk_std_time_astro_tdb0; /*std/num/ddouble/ddouble*/
  {
    double _x_2 = _x_x309.hi;
    _x_x308 = _x_2; /*float64*/
  }
  _x_x307 = (-_x_x308); /*float64*/
  double _x_x310;
  double _x_x311;
  kk_std_num_ddouble__ddouble _x_x312 = kk_std_time_astro_tdb0; /*std/num/ddouble/ddouble*/
  {
    double _x_0_1 = _x_x312.lo;
    _x_x311 = _x_0_1; /*float64*/
  }
  _x_x310 = (-_x_x311); /*float64*/
  _x_x306 = kk_std_num_ddouble__new_Ddouble(_x_x307, _x_x310, _ctx); /*std/num/ddouble/ddouble*/
  t_10037 = kk_std_num_ddouble__lp__plus__rp_(adj, _x_x306, _ctx); /*std/time/timestamp/timespan*/
  kk_std_num_ddouble__ddouble _x_x313;
  kk_std_num_ddouble__ddouble _x_x314;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x315 = kk_std_time_timestamp__as_Timestamp(tdb, _ctx);
    kk_std_num_ddouble__ddouble _x_1 = _con_x315->since;
    _x_x314 = _x_1; /*std/time/timestamp/timespan*/
  }
  _x_x313 = kk_std_num_ddouble__lp__plus__rp_(_x_x314, t_10037, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x316;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x317 = kk_std_time_timestamp__as_Timestamp(tdb, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_0_0 = _con_x317->since;
    int32_t _x_0_0 = _con_x317->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(tdb, _ctx)) {
      kk_datatype_ptr_free(tdb, _ctx);
    }
    else {
      kk_datatype_ptr_decref(tdb, _ctx);
    }
    _x_x316 = _x_0_0; /*int32*/
  }
  return kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x313, _x_x316, _ctx);
}

kk_std_time_duration__duration kk_std_time_astro_tcb_to_tai(kk_std_time_timestamp__timestamp tcb, kk_std_time_instant__timescale tstdb, kk_context_t* _ctx) { /* (tcb : std/time/timestamp/timestamp, tstdb : std/time/instant/timescale) -> std/time/duration/duration */ 
  kk_std_time_timestamp__timestamp ts_10040;
  kk_std_time_timestamp__timestamp _x_x318 = kk_std_time_timestamp__timestamp_dup(tcb, _ctx); /*std/time/timestamp/timestamp*/
  ts_10040 = kk_std_time_timestamp__lp__dash__rp_(_x_x318, kk_std_time_astro_tcg_epoch_delta, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble adj;
  kk_std_num_ddouble__ddouble _x_x319;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x320 = kk_std_time_timestamp__as_Timestamp(ts_10040, _ctx);
    kk_std_num_ddouble__ddouble _x = _con_x320->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_10040, _ctx)) {
      kk_datatype_ptr_free(ts_10040, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_10040, _ctx);
    }
    _x_x319 = _x; /*std/time/timestamp/timespan*/
  }
  adj = kk_std_num_ddouble__lp__star__rp_(kk_std_time_astro_lb, _x_x319, _ctx); /*std/num/ddouble/ddouble*/
  kk_std_time_timestamp__timestamp tdb;
  kk_std_num_ddouble__ddouble _x_x321;
  kk_std_num_ddouble__ddouble _x_x322;
  double _x_x323;
  double _x_x324;
  kk_std_num_ddouble__ddouble _x_x325 = kk_std_time_astro_tdb0; /*std/num/ddouble/ddouble*/
  {
    double _x_0 = _x_x325.hi;
    _x_x324 = _x_0; /*float64*/
  }
  _x_x323 = (-_x_x324); /*float64*/
  double _x_x326;
  double _x_x327;
  kk_std_num_ddouble__ddouble _x_x328 = kk_std_time_astro_tdb0; /*std/num/ddouble/ddouble*/
  {
    double _x_0_0 = _x_x328.lo;
    _x_x327 = _x_0_0; /*float64*/
  }
  _x_x326 = (-_x_x327); /*float64*/
  _x_x322 = kk_std_num_ddouble__new_Ddouble(_x_x323, _x_x326, _ctx); /*std/num/ddouble/ddouble*/
  _x_x321 = kk_std_num_ddouble__lp__plus__rp_(adj, _x_x322, _ctx); /*std/num/ddouble/ddouble*/
  tdb = kk_std_time_timestamp__lp__dash__rp_(tcb, _x_x321, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp t_0_10075;
  kk_std_time_instant__timescale _x_x329 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tai, _ctx); /*std/time/instant/timescale*/
  t_0_10075 = kk_std_time_instant_convert(tdb, tstdb, _x_x329, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x330 = kk_std_time_timestamp_unsafe_timespan_withleap(t_0_10075, _ctx); /*std/time/timestamp/timespan*/
  return kk_std_time_duration__new_Duration(_x_x330, _ctx);
}
extern kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tcb_create_fun334(kk_function_t _fself, kk_std_time_duration__duration tai, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tcb_create_fun334__t* _self = kk_function_as(struct kk_std_time_astro_ts_tcb_create_fun334__t*, _fself, _ctx);
  kk_std_time_instant__timescale tstdb = _self->tstdb; /* std/time/instant/timescale */
  kk_drop_match(_self, {kk_std_time_instant__timescale_dup(tstdb, _ctx);}, {}, _ctx)
  return kk_std_time_astro_tai_to_tcb(tai, tstdb, _ctx);
}
extern kk_std_time_duration__duration kk_std_time_astro_ts_tcb_create_fun335(kk_function_t _fself, kk_std_time_timestamp__timestamp tcb, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tcb_create_fun335__t* _self = kk_function_as(struct kk_std_time_astro_ts_tcb_create_fun335__t*, _fself, _ctx);
  kk_std_time_instant__timescale tstdb = _self->tstdb; /* std/time/instant/timescale */
  kk_drop_match(_self, {kk_std_time_instant__timescale_dup(tstdb, _ctx);}, {}, _ctx)
  return kk_std_time_astro_tcb_to_tai(tcb, tstdb, _ctx);
}
 
// The [TCB](https://en.wikipedia.org/wiki/Geocentric_Coordinate_Time)
// (Barycentric coordinate time) time scale.\ The unit of TCB is the SI
// second, but in a coordinate reference frame at the barycenter of the solar
// system.


// lift anonymous function
struct kk_std_time_astro_ts_tcb_fun338__t {
  struct kk_function_s _base;
};
static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tcb_fun338(kk_function_t _fself, kk_std_time_duration__duration tai, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tcb_fun338(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_astro_ts_tcb_fun338, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tcb_fun338(kk_function_t _fself, kk_std_time_duration__duration tai, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_time_instant__timescale _x_x339 = kk_std_time_instant__timescale_dup(kk_std_time_astro_ts_tdb, _ctx); /*std/time/instant/timescale*/
  return kk_std_time_astro_tai_to_tcb(tai, _x_x339, _ctx);
}


// lift anonymous function
struct kk_std_time_astro_ts_tcb_fun340__t {
  struct kk_function_s _base;
};
static kk_std_time_duration__duration kk_std_time_astro_ts_tcb_fun340(kk_function_t _fself, kk_std_time_timestamp__timestamp tcb, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tcb_fun340(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_astro_ts_tcb_fun340, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_std_time_duration__duration kk_std_time_astro_ts_tcb_fun340(kk_function_t _fself, kk_std_time_timestamp__timestamp tcb, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_time_instant__timescale _x_x341 = kk_std_time_instant__timescale_dup(kk_std_time_astro_ts_tdb, _ctx); /*std/time/instant/timescale*/
  return kk_std_time_astro_tcb_to_tai(tcb, _x_x341, _ctx);
}

kk_std_time_instant__timescale kk_std_time_astro_ts_tcb;

// initialization
void kk_std_time_astro__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core_exn__init(_ctx);
  kk_std_core_bool__init(_ctx);
  kk_std_core_order__init(_ctx);
  kk_std_core_char__init(_ctx);
  kk_std_core_int__init(_ctx);
  kk_std_core_vector__init(_ctx);
  kk_std_core_string__init(_ctx);
  kk_std_core_sslice__init(_ctx);
  kk_std_core_list__init(_ctx);
  kk_std_core_maybe__init(_ctx);
  kk_std_core_maybe2__init(_ctx);
  kk_std_core_either__init(_ctx);
  kk_std_core_tuple__init(_ctx);
  kk_std_core_lazy__init(_ctx);
  kk_std_core_show__init(_ctx);
  kk_std_core_debug__init(_ctx);
  kk_std_core_delayed__init(_ctx);
  kk_std_core_console__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_num_float64__init(_ctx);
  kk_std_num_ddouble__init(_ctx);
  kk_std_time_timestamp__init(_ctx);
  kk_std_time_duration__init(_ctx);
  kk_std_time_instant__init(_ctx);
  kk_std_time_calendar__init(_ctx);
  kk_std_time_utc__init(_ctx);
  kk_std_time_calendars__init(_ctx);
  kk_std_num_int32__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_time_astro_secs_per_day = kk_std_num_ddouble_ddouble_int_exp(kk_integer_from_int(86400, _ctx), kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_std_time_astro_offset_j2000 = kk_std_num_ddouble_ddouble_int_exp(kk_integer_from_int(43200, _ctx), kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_std_time_astro_epoch_j2000 = kk_std_time_astro_instant_at_j2000(kk_std_num_ddouble_zero, _ctx); /*std/time/instant/instant*/
  }
  {
    kk_integer_t _x_x62 = kk_integer_neg((kk_integer_from_small(19)),kk_context()); /*int*/
    kk_std_time_astro_lg = kk_std_num_ddouble_int_fs_ddouble_exp(kk_integer_from_str("6969290134", _ctx), _x_x62, _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_integer_t _x_x63 = kk_integer_neg((kk_integer_from_str("725759967816", _ctx)),kk_context()); /*int*/
    kk_integer_t _x_x64 = kk_integer_neg((kk_integer_from_small(3)),kk_context()); /*int*/
    kk_std_time_astro_tcg_epoch_delta = kk_std_num_ddouble_int_fs_ddouble_exp(_x_x63, _x_x64, _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_string_t _x_x86;
    kk_define_string_literal(, _s_x87, 3, "TCG", _ctx)
    _x_x86 = kk_string_dup(_s_x87, _ctx); /*string*/
    kk_std_time_astro_ts_tcg = kk_std_time_instant_timescale(_x_x86, kk_std_time_astro_new_ts_tcg_fun89(_ctx), kk_std_time_astro_new_ts_tcg_fun91(_ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), _ctx); /*std/time/instant/timescale*/
  }
  {
    kk_std_time_astro_j2k_epoch = kk_std_time_timestamp_int_fs_timespan(kk_integer_from_int(43200, _ctx), kk_std_core_types__new_None(_ctx), _ctx); /*std/time/timestamp/timespan*/
  }
  {
    kk_std_time_astro_ts_tdb = kk_std_time_astro_ts_tdb_create(kk_std_time_astro_new_ts_tdb_fun294(_ctx), _ctx); /*std/time/instant/timescale*/
  }
  {
    kk_integer_t _x_x295 = kk_integer_neg((kk_integer_from_small(19)),kk_context()); /*int*/
    kk_std_time_astro_lb = kk_std_num_ddouble_int_fs_ddouble_exp(kk_integer_from_str("155051976772", _ctx), _x_x295, _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_integer_t _x_x296 = kk_integer_neg((kk_integer_from_small(655)),kk_context()); /*int*/
    kk_integer_t _x_x297 = kk_integer_neg((kk_integer_from_small(7)),kk_context()); /*int*/
    kk_std_time_astro_tdb0 = kk_std_num_ddouble_int_fs_ddouble_exp(_x_x296, _x_x297, _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_string_t _x_x336;
    kk_define_string_literal(, _s_x337, 3, "TCB", _ctx)
    _x_x336 = kk_string_dup(_s_x337, _ctx); /*string*/
    kk_std_time_astro_ts_tcb = kk_std_time_instant_timescale(_x_x336, kk_std_time_astro_new_ts_tcb_fun338(_ctx), kk_std_time_astro_new_ts_tcb_fun340(_ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), _ctx); /*std/time/instant/timescale*/
  }
}

// termination
void kk_std_time_astro__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_time_instant__timescale_drop(kk_std_time_astro_ts_tcb, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_tdb0, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_lb, _ctx);
  kk_std_time_instant__timescale_drop(kk_std_time_astro_ts_tdb, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_j2k_epoch, _ctx);
  kk_std_time_instant__timescale_drop(kk_std_time_astro_ts_tcg, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_tcg_epoch_delta, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_lg, _ctx);
  kk_std_time_instant__instant_drop(kk_std_time_astro_epoch_j2000, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_offset_j2000, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_secs_per_day, _ctx);
  kk_std_num_int32__done(_ctx);
  kk_std_time_calendars__done(_ctx);
  kk_std_time_utc__done(_ctx);
  kk_std_time_calendar__done(_ctx);
  kk_std_time_instant__done(_ctx);
  kk_std_time_duration__done(_ctx);
  kk_std_time_timestamp__done(_ctx);
  kk_std_num_ddouble__done(_ctx);
  kk_std_num_float64__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_console__done(_ctx);
  kk_std_core_delayed__done(_ctx);
  kk_std_core_debug__done(_ctx);
  kk_std_core_show__done(_ctx);
  kk_std_core_lazy__done(_ctx);
  kk_std_core_tuple__done(_ctx);
  kk_std_core_either__done(_ctx);
  kk_std_core_maybe2__done(_ctx);
  kk_std_core_maybe__done(_ctx);
  kk_std_core_list__done(_ctx);
  kk_std_core_sslice__done(_ctx);
  kk_std_core_string__done(_ctx);
  kk_std_core_vector__done(_ctx);
  kk_std_core_int__done(_ctx);
  kk_std_core_char__done(_ctx);
  kk_std_core_order__done(_ctx);
  kk_std_core_bool__done(_ctx);
  kk_std_core_exn__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
