#pragma once
#ifndef kk_std_time_astro_H
#define kk_std_time_astro_H
// Koka generated module: std/time/astro, koka version: 3.1.3, platform: 64-bit
#include <kklib.h>
#include "std_core_types.h"
#include "std_core_hnd.h"
#include "std_core_exn.h"
#include "std_core_bool.h"
#include "std_core_order.h"
#include "std_core_char.h"
#include "std_core_int.h"
#include "std_core_vector.h"
#include "std_core_string.h"
#include "std_core_sslice.h"
#include "std_core_list.h"
#include "std_core_maybe.h"
#include "std_core_maybe2.h"
#include "std_core_either.h"
#include "std_core_tuple.h"
#include "std_core_lazy.h"
#include "std_core_show.h"
#include "std_core_debug.h"
#include "std_core_delayed.h"
#include "std_core_console.h"
#include "std_core.h"
#include "std_num_float64.h"
#include "std_num_ddouble.h"
#include "std_time_timestamp.h"
#include "std_time_duration.h"
#include "std_time_instant.h"
#include "std_time_calendar.h"
#include "std_time_utc.h"
#include "std_time_calendars.h"
#include "std_num_int32.h"

// type declarations

// value declarations

extern kk_std_num_ddouble__ddouble kk_std_time_astro_secs_per_day;

extern kk_std_num_ddouble__ddouble kk_std_time_astro_offset_j2000;

kk_std_time_instant__instant kk_std_time_astro_instant_at_j2000(kk_std_num_ddouble__ddouble jd, kk_context_t* _ctx); /* (jd : std/num/ddouble/ddouble) -> std/time/instant/instant */ 

extern kk_std_time_instant__instant kk_std_time_astro_epoch_j2000;

kk_std_num_ddouble__ddouble kk_std_time_astro_j2000(kk_std_time_instant__instant i, kk_context_t* _ctx); /* (i : std/time/instant/instant) -> std/num/ddouble/ddouble */ 

extern kk_std_num_ddouble__ddouble kk_std_time_astro_lg;

extern kk_std_num_ddouble__ddouble kk_std_time_astro_tcg_epoch_delta;

kk_std_time_timestamp__timestamp kk_std_time_astro_tcg_from_tai(kk_std_time_duration__duration tai, kk_context_t* _ctx); /* (tai : std/time/duration/duration) -> std/time/timestamp/timestamp */ 

kk_std_time_duration__duration kk_std_time_astro_tcg_to_tai(kk_std_time_timestamp__timestamp t, kk_context_t* _ctx); /* (t : std/time/timestamp/timestamp) -> std/time/duration/duration */ 

extern kk_std_time_instant__timescale kk_std_time_astro_ts_tcg;

extern kk_std_num_ddouble__ddouble kk_std_time_astro_j2k_epoch;
 
// 2000-01-01T12:00:00 TT
#define kk_std_time_astro_secs_per_julian_year ((double)(0x1.e187ep24))

kk_std_num_ddouble__ddouble kk_std_time_astro_tdb_delta(kk_std_time_timestamp__timestamp tt, kk_context_t* _ctx); /* (tt : std/time/timestamp/timestamp) -> std/time/timestamp/timespan */ 
#define kk_std_time_astro_pi2 ((double)(0x1.921fb54442d18p2))
 
// 2pi
#define kk_std_time_astro_dd2r ((double)(0x1.1df46a2529d39p-6))

double kk_std_time_astro_tdb_topocentric(double t, kk_std_core_types__optional ut, kk_std_core_types__optional elong, kk_std_core_types__optional u, kk_std_core_types__optional v, kk_context_t* _ctx); /* (t : float64, ut : ? float64, elong : ? float64, u : ? float64, v : ? float64) -> float64 */ 

kk_std_time_timestamp__timestamp kk_std_time_astro_tai_to_tdb(kk_std_time_duration__duration tai, kk_std_core_types__optional delta, kk_context_t* _ctx); /* (tai : std/time/duration/duration, delta : ? ((std/time/timestamp/timestamp) -> std/time/timestamp/timespan)) -> std/time/timestamp/timestamp */ 

kk_std_time_duration__duration kk_std_time_astro_tdb_to_tai(kk_std_time_timestamp__timestamp tdb, kk_std_core_types__optional delta, kk_context_t* _ctx); /* (tdb : std/time/timestamp/timestamp, delta : ? ((std/time/timestamp/timestamp) -> std/time/timestamp/timespan)) -> std/time/duration/duration */ 

kk_std_time_instant__timescale kk_std_time_astro_ts_tdb_create(kk_function_t tdb_minus_tt, kk_context_t* _ctx); /* (tdb-minus-tt : (std/time/timestamp/timestamp) -> std/time/timestamp/timespan) -> std/time/instant/timescale */ 

extern kk_std_time_instant__timescale kk_std_time_astro_ts_tdb;

extern kk_std_num_ddouble__ddouble kk_std_time_astro_lb;

extern kk_std_num_ddouble__ddouble kk_std_time_astro_tdb0;

kk_std_time_timestamp__timestamp kk_std_time_astro_tai_to_tcb(kk_std_time_duration__duration tai, kk_std_time_instant__timescale tstdb, kk_context_t* _ctx); /* (tai : std/time/duration/duration, tstdb : std/time/instant/timescale) -> std/time/timestamp/timestamp */ 

kk_std_time_duration__duration kk_std_time_astro_tcb_to_tai(kk_std_time_timestamp__timestamp tcb, kk_std_time_instant__timescale tstdb, kk_context_t* _ctx); /* (tcb : std/time/timestamp/timestamp, tstdb : std/time/instant/timescale) -> std/time/duration/duration */ 
 
// Create a new TCB timescale given a TDB timescale (`tstdb`). The default
// `ts-tcb` uses the default `ts-tdb` timescale, but if you created
// a different TCB time scale (using `ts-tdb-create`) you can use
// this function to create a TCB time scale from it. It computes
// TCB from the provided TDB using the IAU 2006 resolution
// [B3](https://www.iau.org/static/resolutions/IAU2006_Resol3.pdf):\ TDB = TCB -
// L~b~ &times; (JD~TCB~ - T~0~) &times; 86400 + TDB~0~, with T~0~ =
// 2443144.5003725, L~b~ = 1.55051976772&times;10^-8^, TDB~0~ =
// -6.55&times;10^-5^.


// lift anonymous function
struct kk_std_time_astro_ts_tcb_create_fun334__t {
  struct kk_function_s _base;
  kk_std_time_instant__timescale tstdb;
};
extern kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tcb_create_fun334(kk_function_t _fself, kk_std_time_duration__duration tai, kk_context_t* _ctx);
static inline kk_function_t kk_std_time_astro_new_ts_tcb_create_fun334(kk_std_time_instant__timescale tstdb, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tcb_create_fun334__t* _self = kk_function_alloc_as(struct kk_std_time_astro_ts_tcb_create_fun334__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_astro_ts_tcb_create_fun334, kk_context());
  _self->tstdb = tstdb;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_time_astro_ts_tcb_create_fun335__t {
  struct kk_function_s _base;
  kk_std_time_instant__timescale tstdb;
};
extern kk_std_time_duration__duration kk_std_time_astro_ts_tcb_create_fun335(kk_function_t _fself, kk_std_time_timestamp__timestamp tcb, kk_context_t* _ctx);
static inline kk_function_t kk_std_time_astro_new_ts_tcb_create_fun335(kk_std_time_instant__timescale tstdb, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tcb_create_fun335__t* _self = kk_function_alloc_as(struct kk_std_time_astro_ts_tcb_create_fun335__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_astro_ts_tcb_create_fun335, kk_context());
  _self->tstdb = tstdb;
  return kk_datatype_from_base(&_self->_base, kk_context());
}


static inline kk_std_time_instant__timescale kk_std_time_astro_ts_tcb_create(kk_std_time_instant__timescale tstdb, kk_context_t* _ctx) { /* (tstdb : std/time/instant/timescale) -> std/time/instant/timescale */ 
  kk_string_t _x_x331;
  kk_define_string_literal(, _s_x332, 3, "TCB", _ctx)
  _x_x331 = kk_string_dup(_s_x332, _ctx); /*string*/
  kk_function_t _x_x333;
  kk_std_time_instant__timescale_dup(tstdb, _ctx);
  _x_x333 = kk_std_time_astro_new_ts_tcb_create_fun334(tstdb, _ctx); /*(tai : std/time/duration/duration) -> std/time/timestamp/timestamp*/
  return kk_std_time_instant_timescale(_x_x331, _x_x333, kk_std_time_astro_new_ts_tcb_create_fun335(tstdb, _ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), kk_std_core_types__new_None(_ctx), _ctx);
}

extern kk_std_time_instant__timescale kk_std_time_astro_ts_tcb;

void kk_std_time_astro__init(kk_context_t* _ctx);


void kk_std_time_astro__done(kk_context_t* _ctx);

#endif // header
