// Koka generated module: std/time/astro, koka version: 3.1.3, platform: 64-bit
#include "std_time_astro.h"

kk_std_num_ddouble__ddouble kk_std_time_astro_secs_per_day;

kk_std_num_ddouble__ddouble kk_std_time_astro_offset_j2000;
 
// Return the instant corresponding to a J2000 julian date: this is the number of days, and
// the fraction of the day since J2000 (`epoch-j2000`) in terrestrial time (`ts-tt`).
// `instant-at-j2000(zero).time.show == "2000-01-01T11:58:55.816Z"`
// `instant-at-j2000(zero).time(cal=cal-tt).show == "2000-01-01T12:00:00Z TT"`

kk_std_time_instant__instant kk_std_time_astro_instant_at_j2000(kk_std_num_ddouble__ddouble jd, kk_context_t* _ctx) { /* (jd : std/num/ddouble/ddouble) -> std/time/instant/instant */ 
  kk_std_num_ddouble__ddouble t_0_10004;
  kk_std_num_ddouble__ddouble _x_x76 = kk_std_num_ddouble__lp__star__rp_(jd, kk_std_time_astro_secs_per_day, _ctx); /*std/num/ddouble/ddouble*/
  t_0_10004 = kk_std_num_ddouble__lp__plus__rp_(_x_x76, kk_std_time_astro_offset_j2000, _ctx); /*std/num/ddouble/ddouble*/
  kk_std_time_timestamp__timestamp t_10003;
  int32_t _x_x77;
  kk_integer_t _x_x78;
  kk_std_core_types__optional _match_x60 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x60, _ctx)) {
    kk_box_t _box_x0 = _match_x60._cons._Optional.value;
    kk_integer_t _uniq_leap_675 = kk_integer_unbox(_box_x0, _ctx);
    kk_integer_dup(_uniq_leap_675, _ctx);
    kk_std_core_types__optional_drop(_match_x60, _ctx);
    _x_x78 = _uniq_leap_675; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x60, _ctx);
    _x_x78 = kk_integer_from_small(0); /*int*/
  }
  _x_x77 = kk_integer_clamp32(_x_x78,kk_context()); /*int32*/
  t_10003 = kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, t_0_10004, _x_x77, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_instant__timescale _x_x79 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  return kk_std_time_instant__new_Instant(t_10003, _x_x79, _ctx);
}
 
// The [J2000] epoch is defined as 2000-01-01T12:00:00 TT (Terrestrial time).
//
// [J2000]: https://en.wikipedia.org/wiki/Equinox_(celestial_coordinates)#J2000.0

kk_std_time_instant__instant kk_std_time_astro_epoch_j2000;
 
// Return the J2000 julian date for an instant. This is the number of days, and
// the fraction of the day since J2000 (`epoch-j2000`) in terrestrial time (`ts-tt`).
// `instant(2000,1,1,12,0,0).j2000.show == "0.00074287037037"`
// `instant(2000,1,1,12,0,0,cal=cal-tt).j2000.show == "0"`

kk_std_num_ddouble__ddouble kk_std_time_astro_j2000(kk_std_time_instant__instant i, kk_context_t* _ctx) { /* (i : std/time/instant/instant) -> std/num/ddouble/ddouble */ 
  kk_std_time_timestamp__timestamp ts_0_10010;
  kk_std_time_instant__timescale _x_x80 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  ts_0_10010 = kk_std_time_instant_timestamp_in(i, _x_x80, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp ts_10009;
  kk_std_num_ddouble__ddouble _x_x81;
  kk_std_num_ddouble__ddouble _x_x82;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x83 = kk_std_time_timestamp__as_Timestamp(ts_0_10010, _ctx);
    kk_std_num_ddouble__ddouble _x_1 = _con_x83->since;
    _x_x82 = _x_1; /*std/time/timestamp/timespan*/
  }
  kk_std_num_ddouble__ddouble _x_x84;
  double _x_x85;
  double _x_x86;
  kk_std_num_ddouble__ddouble _x_x87 = kk_std_time_astro_offset_j2000; /*std/num/ddouble/ddouble*/
  {
    double _x_0 = _x_x87.hi;
    _x_x86 = _x_0; /*float64*/
  }
  _x_x85 = (-_x_x86); /*float64*/
  double _x_x88;
  double _x_x89;
  kk_std_num_ddouble__ddouble _x_x90 = kk_std_time_astro_offset_j2000; /*std/num/ddouble/ddouble*/
  {
    double _x_0_0 = _x_x90.lo;
    _x_x89 = _x_0_0; /*float64*/
  }
  _x_x88 = (-_x_x89); /*float64*/
  _x_x84 = kk_std_num_ddouble__new_Ddouble(_x_x85, _x_x88, _ctx); /*std/num/ddouble/ddouble*/
  _x_x81 = kk_std_num_ddouble__lp__plus__rp_(_x_x82, _x_x84, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x91;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x92 = kk_std_time_timestamp__as_Timestamp(ts_0_10010, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_2 = _con_x92->since;
    int32_t _x_2 = _con_x92->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(ts_0_10010, _ctx)) {
      kk_datatype_ptr_free(ts_0_10010, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_0_10010, _ctx);
    }
    _x_x91 = _x_2; /*int32*/
  }
  ts_10009 = kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x81, _x_x91, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x93;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x94 = kk_std_time_timestamp__as_Timestamp(ts_10009, _ctx);
    kk_std_num_ddouble__ddouble _x = _con_x94->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_10009, _ctx)) {
      kk_datatype_ptr_free(ts_10009, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_10009, _ctx);
    }
    _x_x93 = _x; /*std/time/timestamp/timespan*/
  }
  return kk_std_num_ddouble__lp__fs__rp_(_x_x93, kk_std_time_astro_secs_per_day, _ctx);
}

kk_std_num_ddouble__ddouble kk_std_time_astro_lg;
 
// 6.969290134e-10  // 1991: 6.969291e-10  // now: 6.969290134

kk_std_num_ddouble__ddouble kk_std_time_astro_tcg_epoch_delta;
 
// IAU 1991 recommendation IV :
// TCG - TT = L~g~&times;(JD~TT~ - TCG~epoch~)
// =>
// TCG = TT + Lg*(TT - TCG~epoch~)

kk_std_time_timestamp__timestamp kk_std_time_astro_tcg_from_tai(kk_std_time_duration__duration tai, kk_context_t* _ctx) { /* (tai : std/time/duration/duration) -> std/time/timestamp/timestamp */ 
  kk_std_time_timestamp__timestamp tt;
  kk_std_time_instant__timescale _x_x98 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  tt = kk_std_time_instant_from_tai(_x_x98, tai, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp ts_0_10014;
  kk_std_time_timestamp__timestamp _x_x99 = kk_std_time_timestamp__timestamp_dup(tt, _ctx); /*std/time/timestamp/timestamp*/
  ts_0_10014 = kk_std_time_timestamp__lp__dash__rp_(_x_x99, kk_std_time_astro_tcg_epoch_delta, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble t_10013;
  kk_std_num_ddouble__ddouble _x_x100;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x101 = kk_std_time_timestamp__as_Timestamp(ts_0_10014, _ctx);
    kk_std_num_ddouble__ddouble _x_1 = _con_x101->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_0_10014, _ctx)) {
      kk_datatype_ptr_free(ts_0_10014, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_0_10014, _ctx);
    }
    _x_x100 = _x_1; /*std/time/timestamp/timespan*/
  }
  t_10013 = kk_std_num_ddouble__lp__star__rp_(kk_std_time_astro_lg, _x_x100, _ctx); /*std/num/ddouble/ddouble*/
  kk_std_num_ddouble__ddouble _x_x102;
  kk_std_num_ddouble__ddouble _x_x103;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x104 = kk_std_time_timestamp__as_Timestamp(tt, _ctx);
    kk_std_num_ddouble__ddouble _x = _con_x104->since;
    _x_x103 = _x; /*std/time/timestamp/timespan*/
  }
  _x_x102 = kk_std_num_ddouble__lp__plus__rp_(_x_x103, t_10013, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x105;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x106 = kk_std_time_timestamp__as_Timestamp(tt, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_0 = _con_x106->since;
    int32_t _x_0 = _con_x106->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(tt, _ctx)) {
      kk_datatype_ptr_free(tt, _ctx);
    }
    else {
      kk_datatype_ptr_decref(tt, _ctx);
    }
    _x_x105 = _x_0; /*int32*/
  }
  return kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x102, _x_x105, _ctx);
}
 
// IAU 1991 recommendation [IV](https://www.iers.org/IERS/EN/Science/Recommendations/recommendation4.html?nn=12932):
// TCG - TT = L~g~&times;(JD~TT~ - TCG~epoch~)
// =>
// TT = TCG - Lg*(TCG - TCG~epoch~)

kk_std_time_duration__duration kk_std_time_astro_tcg_to_tai(kk_std_time_timestamp__timestamp t, kk_context_t* _ctx) { /* (t : std/time/timestamp/timestamp) -> std/time/duration/duration */ 
  kk_std_time_timestamp__timestamp ts_0_10017;
  kk_std_time_timestamp__timestamp _x_x107 = kk_std_time_timestamp__timestamp_dup(t, _ctx); /*std/time/timestamp/timestamp*/
  ts_0_10017 = kk_std_time_timestamp__lp__dash__rp_(_x_x107, kk_std_time_astro_tcg_epoch_delta, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble t_0_10016;
  kk_std_num_ddouble__ddouble _x_x108;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x109 = kk_std_time_timestamp__as_Timestamp(ts_0_10017, _ctx);
    kk_std_num_ddouble__ddouble _x_3 = _con_x109->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_0_10017, _ctx)) {
      kk_datatype_ptr_free(ts_0_10017, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_0_10017, _ctx);
    }
    _x_x108 = _x_3; /*std/time/timestamp/timespan*/
  }
  t_0_10016 = kk_std_num_ddouble__lp__star__rp_(kk_std_time_astro_lg, _x_x108, _ctx); /*std/num/ddouble/ddouble*/
  kk_std_time_timestamp__timestamp tt;
  kk_std_num_ddouble__ddouble _x_x110;
  kk_std_num_ddouble__ddouble _x_x111;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x112 = kk_std_time_timestamp__as_Timestamp(t, _ctx);
    kk_std_num_ddouble__ddouble _x_1 = _con_x112->since;
    _x_x111 = _x_1; /*std/time/timestamp/timespan*/
  }
  kk_std_num_ddouble__ddouble _x_x113;
  double _x_x114;
  double _x_x115;
  {
    double _x = t_0_10016.hi;
    _x_x115 = _x; /*float64*/
  }
  _x_x114 = (-_x_x115); /*float64*/
  double _x_x116;
  double _x_x117;
  {
    double _x_0 = t_0_10016.lo;
    _x_x117 = _x_0; /*float64*/
  }
  _x_x116 = (-_x_x117); /*float64*/
  _x_x113 = kk_std_num_ddouble__new_Ddouble(_x_x114, _x_x116, _ctx); /*std/num/ddouble/ddouble*/
  _x_x110 = kk_std_num_ddouble__lp__plus__rp_(_x_x111, _x_x113, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x118;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x119 = kk_std_time_timestamp__as_Timestamp(t, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_2 = _con_x119->since;
    int32_t _x_2 = _con_x119->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(t, _ctx)) {
      kk_datatype_ptr_free(t, _ctx);
    }
    else {
      kk_datatype_ptr_decref(t, _ctx);
    }
    _x_x118 = _x_2; /*int32*/
  }
  tt = kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x110, _x_x118, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp t_0_10125;
  kk_std_time_instant__timescale _x_x120 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  kk_std_time_instant__timescale _x_x121 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tai, _ctx); /*std/time/instant/timescale*/
  t_0_10125 = kk_std_time_instant_convert(tt, _x_x120, _x_x121, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x122 = kk_std_time_timestamp_unsafe_timespan_withleap(t_0_10125, _ctx); /*std/time/timestamp/timespan*/
  return kk_std_time_duration__new_Duration(_x_x122, _ctx);
}
 
// The [TCG](https://en.wikipedia.org/wiki/Geocentric_Coordinate_Time) (Geocentric coordinate time) time scale.
// The unit of TCG is the SI second in a coordinate reference frame at the center of the Earth.


// lift anonymous function
struct kk_std_time_astro_ts_tcg_fun128__t {
  struct kk_function_s _base;
};
static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tcg_fun128(kk_function_t _fself, kk_std_time_duration__duration _x1_x127, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tcg_fun128(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_astro_ts_tcg_fun128, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tcg_fun128(kk_function_t _fself, kk_std_time_duration__duration _x1_x127, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_std_time_astro_tcg_from_tai(_x1_x127, _ctx);
}


// lift anonymous function
struct kk_std_time_astro_ts_tcg_fun130__t {
  struct kk_function_s _base;
};
static kk_std_time_duration__duration kk_std_time_astro_ts_tcg_fun130(kk_function_t _fself, kk_std_time_timestamp__timestamp _x1_x129, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tcg_fun130(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_astro_ts_tcg_fun130, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_std_time_duration__duration kk_std_time_astro_ts_tcg_fun130(kk_function_t _fself, kk_std_time_timestamp__timestamp _x1_x129, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_std_time_astro_tcg_to_tai(_x1_x129, _ctx);
}

kk_std_time_instant__timescale kk_std_time_astro_ts_tcg;
 
// /*----------------------------------------------------------------------------
//   TDB: Barycentric dynamical time
// ----------------------------------------------------------------------------*/

kk_std_num_ddouble__ddouble kk_std_time_astro_j2k_epoch;
 
// Compute tdb-delta(TT) = TDB - TT. This is the default function used for `ts-tdb`.
// Fairhead & Bretagnon (1990) initial coefficents.
// See also USNO circular 179 ([@Kaplan:circ], section 2.6).
// The error in this approximation is a maximum of 10 micro-seconds in the time period 1600 to 2200.
// (and probably less as we expanded to more terms and do JPL planetary mass adjustment)

kk_std_num_ddouble__ddouble kk_std_time_astro_tdb_delta(kk_std_time_timestamp__timestamp tt, kk_context_t* _ctx) { /* (tt : std/time/timestamp/timestamp) -> std/time/timestamp/timespan */ 
  kk_std_time_timestamp__timestamp ts_10030 = kk_std_time_timestamp__lp__dash__rp_(tt, kk_std_time_astro_j2k_epoch, _ctx); /*std/time/timestamp/timestamp*/;
  double t;
  double _x_x138;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x139 = kk_std_time_timestamp__as_Timestamp(ts_10030, _ctx);
    kk_std_num_ddouble__ddouble _x_0 = _con_x139->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_10030, _ctx)) {
      kk_datatype_ptr_free(ts_10030, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_10030, _ctx);
    }
    {
      double _x = _x_0.hi;
      _x_x138 = _x; /*float64*/
    }
  }
  double _x_x140 = ((0x1.e187ep24) * (0x1.f4p9)); /*float64*/
  t = (_x_x138 / _x_x140); /*float64*/
  double wf;
  double _x_x141;
  double _x_x142;
  double _x_x143;
  double _x_x144;
  double _x_x145;
  double _x_x146 = ((0x1.88b1367a0f909p12) * t); /*float64*/
  _x_x145 = (_x_x146 + (0x1.8f5dcc63f1412p2)); /*float64*/
  _x_x144 = sin(_x_x145); /*float64*/
  _x_x143 = ((0x1.b2498ce8908a9p-10) * _x_x144); /*float64*/
  double _x_x147;
  double _x_x148;
  double _x_x149;
  double _x_x150;
  double _x_x151;
  double _x_x152;
  double _x_x153 = ((0x1.67962ca57a787p12) * t); /*float64*/
  _x_x152 = (_x_x153 + (0x1.13020c49ba5e3p2)); /*float64*/
  _x_x151 = sin(_x_x152); /*float64*/
  _x_x150 = ((0x1.781a6dea693fep-16) * _x_x151); /*float64*/
  double _x_x154;
  double _x_x155;
  double _x_x156;
  double _x_x157 = ((0x1.88b138bac710dp13) * t); /*float64*/
  _x_x156 = (_x_x157 + (0x1.8c9a027525461p2)); /*float64*/
  _x_x155 = sin(_x_x156); /*float64*/
  _x_x154 = ((0x1.d062fa0d5c3aep-17) * _x_x155); /*float64*/
  _x_x149 = (_x_x150 + _x_x154); /*float64*/
  double _x_x158;
  double _x_x159;
  double _x_x160;
  double _x_x161 = ((0x1.08d872b020c4ap9) * t); /*float64*/
  _x_x160 = (_x_x161 + (0x1.c710cb295e9e2p-2)); /*float64*/
  _x_x159 = sin(_x_x160); /*float64*/
  _x_x158 = ((0x1.401db1a9a147cp-18) * _x_x159); /*float64*/
  _x_x148 = (_x_x149 + _x_x158); /*float64*/
  double _x_x162;
  double _x_x163;
  double _x_x164;
  double _x_x165 = ((0x1.7b5c6dc5d6388p12) * t); /*float64*/
  _x_x164 = (_x_x165 + (0x1.015b573eab368p2)); /*float64*/
  _x_x163 = sin(_x_x164); /*float64*/
  _x_x162 = ((0x1.39d9181e54b5dp-18) * _x_x163); /*float64*/
  _x_x147 = (_x_x148 + _x_x162); /*float64*/
  _x_x142 = (_x_x143 + _x_x147); /*float64*/
  double _x_x166;
  double _x_x167;
  double _x_x168;
  double _x_x169;
  double _x_x170;
  double _x_x171;
  double _x_x172;
  double _x_x173 = ((0x1.aa9923a29c77ap7) * t); /*float64*/
  _x_x172 = (_x_x173 + (0x1.62c226809d495p2)); /*float64*/
  _x_x171 = sin(_x_x172); /*float64*/
  _x_x170 = ((0x1.2ee39f1f8b22cp-19) * _x_x171); /*float64*/
  double _x_x174;
  double _x_x175;
  double _x_x176;
  double _x_x177;
  double _x_x178 = (-(0x1.c2f837b4a233ap1)); /*float64*/
  _x_x177 = (_x_x178 * t); /*float64*/
  _x_x176 = (_x_x177 + (0x1.419b3d07c84b6p2)); /*float64*/
  _x_x175 = sin(_x_x176); /*float64*/
  _x_x174 = ((0x1.c6c88998b0eb9p-20) * _x_x175); /*float64*/
  _x_x169 = (_x_x170 + _x_x174); /*float64*/
  double _x_x179;
  double _x_x180;
  double _x_x181;
  double _x_x182 = ((0x1.2f91c5810624ep16) * t); /*float64*/
  _x_x181 = (_x_x182 + (0x1.4cb4395810625p2)); /*float64*/
  _x_x180 = sin(_x_x181); /*float64*/
  _x_x179 = ((0x1.a163ea14992fbp-20) * _x_x180); /*float64*/
  _x_x168 = (_x_x169 + _x_x179); /*float64*/
  double _x_x183;
  double _x_x184;
  double _x_x185;
  double _x_x186 = ((0x1.eb46b5dcc63f1p12) * t); /*float64*/
  _x_x185 = (_x_x186 + (0x1.7f487fcb923a3p2)); /*float64*/
  _x_x184 = sin(_x_x185); /*float64*/
  _x_x183 = ((0x1.56bd07243a05bp-20) * _x_x184); /*float64*/
  _x_x167 = (_x_x168 + _x_x183); /*float64*/
  double _x_x187;
  double _x_x188;
  double _x_x189;
  double _x_x190 = ((0x1.467b1a36e2eb2p12) * t); /*float64*/
  _x_x189 = (_x_x190 + (0x1.d32ca57a786c2p1)); /*float64*/
  _x_x188 = sin(_x_x189); /*float64*/
  _x_x187 = ((0x1.4059d2d34dcfbp-20) * _x_x188); /*float64*/
  _x_x166 = (_x_x167 + _x_x187); /*float64*/
  _x_x141 = (_x_x142 + _x_x166); /*float64*/
  double _x_x191;
  double _x_x192;
  double _x_x193;
  double _x_x194;
  double _x_x195 = ((0x1.88b1367a0f909p12) * t); /*float64*/
  _x_x194 = (_x_x195 + (0x1.0fef9db22d0e5p2)); /*float64*/
  _x_x193 = sin(_x_x194); /*float64*/
  _x_x192 = ((0x1.ac79ebe055992p-14) * _x_x193); /*float64*/
  _x_x191 = (t * _x_x192); /*float64*/
  wf = (_x_x141 + _x_x191); /*float64*/
  double wj;
  double _x_x196;
  double _x_x197;
  double _x_x198;
  double _x_x199;
  double _x_x200;
  double _x_x201;
  double _x_x202 = ((0x1.7b5c6d959a30ap12) * t); /*float64*/
  _x_x201 = (_x_x202 + (0x1.015b3e1437c57p2)); /*float64*/
  _x_x200 = sin(_x_x201); /*float64*/
  _x_x199 = ((0x1.65575e0ff4a28p-31) * _x_x200); /*float64*/
  double _x_x203;
  double _x_x204;
  double _x_x205;
  double _x_x206 = ((0x1.aa9922fad6cb5p7) * t); /*float64*/
  _x_x205 = (_x_x206 + (0x1.62c2acb85a4fp2)); /*float64*/
  _x_x204 = sin(_x_x205); /*float64*/
  _x_x203 = ((0x1.6ad6be0852fbap-32) * _x_x204); /*float64*/
  _x_x198 = (_x_x199 + _x_x203); /*float64*/
  double _x_x207;
  double _x_x208 = (-(0x1.0d615e8a0f102p-29)); /*float64*/
  double _x_x209;
  double _x_x210;
  double _x_x211 = ((0x1.8404b540895d1p12) * t); /*float64*/
  _x_x210 = (_x_x211 + (0x1.6c96bfca85cabp2)); /*float64*/
  _x_x209 = sin(_x_x210); /*float64*/
  _x_x207 = (_x_x208 * _x_x209); /*float64*/
  _x_x197 = (_x_x198 + _x_x207); /*float64*/
  double _x_x212;
  double _x_x213 = (-(0x1.db89ed6be11f2p-30)); /*float64*/
  double _x_x214;
  double _x_x215;
  double _x_x216 = ((0x1.2b205b7cfe586p6) * t); /*float64*/
  _x_x215 = (_x_x216 + (0x1.37cb923a29c78p1)); /*float64*/
  _x_x214 = sin(_x_x215); /*float64*/
  _x_x212 = (_x_x213 * _x_x214); /*float64*/
  _x_x196 = (_x_x197 + _x_x212); /*float64*/
  double _x_x217;
  double _x_x218 = ((0x1.3880774e331b6p-25) * t); /*float64*/
  _x_x217 = (_x_x218 * t); /*float64*/
  wj = (_x_x196 + _x_x217); /*float64*/
  double d_10031;
  double _x_x219 = (wf + wj); /*float64*/
  d_10031 = (_x_x219 + (0x0p+0)); /*float64*/
  return kk_std_num_ddouble__new_Ddouble(d_10031, 0x0p+0, _ctx);
}
 
// From the ERFA routines

double kk_std_time_astro_tdb_topocentric(double t, kk_std_core_types__optional ut, kk_std_core_types__optional elong, kk_std_core_types__optional u, kk_std_core_types__optional v, kk_context_t* _ctx) { /* (t : float64, ut : ? float64, elong : ? float64, u : ? float64, v : ? float64) -> float64 */ 
  double tsol;
  double _x_x220;
  double _x_x221;
  double _x_x222;
  if (kk_std_core_types__is_Optional(ut, _ctx)) {
    kk_box_t _box_x7 = ut._cons._Optional.value;
    double _uniq_ut_565 = kk_double_unbox(_box_x7, KK_BORROWED, _ctx);
    _x_x222 = _uniq_ut_565; /*float64*/
  }
  else {
    _x_x222 = 0x0p+0; /*float64*/
  }
  double _x_x223;
  bool _match_x52;
  double _x_x224;
  if (kk_std_core_types__is_Optional(ut, _ctx)) {
    kk_box_t _box_x8 = ut._cons._Optional.value;
    double _uniq_ut_565_0 = kk_double_unbox(_box_x8, KK_BORROWED, _ctx);
    _x_x224 = _uniq_ut_565_0; /*float64*/
  }
  else {
    _x_x224 = 0x0p+0; /*float64*/
  }
  _match_x52 = (_x_x224 >= (0x0p+0)); /*bool*/
  if (_match_x52) {
    double _x_x225;
    if (kk_std_core_types__is_Optional(ut, _ctx)) {
      kk_box_t _box_x9 = ut._cons._Optional.value;
      double _uniq_ut_565_1 = kk_double_unbox(_box_x9, KK_BORROWED, _ctx);
      kk_std_core_types__optional_drop(ut, _ctx);
      _x_x225 = _uniq_ut_565_1; /*float64*/
    }
    else {
      kk_std_core_types__optional_drop(ut, _ctx);
      _x_x225 = 0x0p+0; /*float64*/
    }
    _x_x223 = floor(_x_x225); /*float64*/
  }
  else {
    double _x_x226;
    if (kk_std_core_types__is_Optional(ut, _ctx)) {
      kk_box_t _box_x10 = ut._cons._Optional.value;
      double _uniq_ut_565_2 = kk_double_unbox(_box_x10, KK_BORROWED, _ctx);
      kk_std_core_types__optional_drop(ut, _ctx);
      _x_x226 = _uniq_ut_565_2; /*float64*/
    }
    else {
      kk_std_core_types__optional_drop(ut, _ctx);
      _x_x226 = 0x0p+0; /*float64*/
    }
    _x_x223 = ceil(_x_x226); /*float64*/
  }
  _x_x221 = (_x_x222 - _x_x223); /*float64*/
  _x_x220 = (_x_x221 * (0x1.921fb54442d18p2)); /*float64*/
  double _x_x227;
  double _x_x228;
  if (kk_std_core_types__is_Optional(elong, _ctx)) {
    kk_box_t _box_x11 = elong._cons._Optional.value;
    double _uniq_elong_569 = kk_double_unbox(_box_x11, KK_BORROWED, _ctx);
    kk_std_core_types__optional_drop(elong, _ctx);
    _x_x228 = _uniq_elong_569; /*float64*/
  }
  else {
    kk_std_core_types__optional_drop(elong, _ctx);
    _x_x228 = 0x0p+0; /*float64*/
  }
  _x_x227 = (_x_x228 * (0x1.1df46a2529d39p-6)); /*float64*/
  tsol = (_x_x220 + _x_x227); /*float64*/
  double w = (t / (0x1.c2p11)); /*float64*/;
  double elsun;
  double _x_x229;
  double _x_x230;
  double _x_x231 = ((0x1.34ff40fc231cfp30) * w); /*float64*/
  _x_x230 = ((0x1.187769b6fdd89p8) + _x_x231); /*float64*/
  _x_x229 = fmod(_x_x230,(0x1.68p8)); /*float64*/
  elsun = (_x_x229 * (0x1.1df46a2529d39p-6)); /*float64*/
  double emsun;
  double _x_x232;
  double _x_x233;
  double _x_x234 = ((0x1.34fb79c9ec8b4p30) * w); /*float64*/
  _x_x233 = ((0x1.658773b3001dp8) + _x_x234); /*float64*/
  _x_x232 = fmod(_x_x233,(0x1.68p8)); /*float64*/
  emsun = (_x_x232 * (0x1.1df46a2529d39p-6)); /*float64*/
  double d_0;
  double _x_x235;
  double _x_x236;
  double _x_x237 = ((0x1.ddb843c60b852p33) * w); /*float64*/
  _x_x236 = ((0x1.29d9a6690adb8p8) + _x_x237); /*float64*/
  _x_x235 = fmod(_x_x236,(0x1.68p8)); /*float64*/
  d_0 = (_x_x235 * (0x1.1df46a2529d39p-6)); /*float64*/
  double elj;
  double _x_x238;
  double _x_x239;
  double _x_x240 = ((0x1.a0f904f93ffacp26) * w); /*float64*/
  _x_x239 = ((0x1.12cfe90ea1d96p5) + _x_x240); /*float64*/
  _x_x238 = fmod(_x_x239,(0x1.68p8)); /*float64*/
  elj = (_x_x238 * (0x1.1df46a2529d39p-6)); /*float64*/
  double els;
  double _x_x241;
  double _x_x242;
  double _x_x243 = ((0x1.500c1f3c35697p25) * w); /*float64*/
  _x_x242 = ((0x1.909e9b1dfe17dp5) + _x_x243); /*float64*/
  _x_x241 = fmod(_x_x242,(0x1.68p8)); /*float64*/
  els = (_x_x241 * (0x1.1df46a2529d39p-6)); /*float64*/
  double _x_x244;
  double _x_x245;
  double _x_x246;
  double _x_x247;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x12 = u._cons._Optional.value;
    double _uniq_u_573 = kk_double_unbox(_box_x12, KK_BORROWED, _ctx);
    _x_x247 = _uniq_u_573; /*float64*/
  }
  else {
    _x_x247 = 0x0p+0; /*float64*/
  }
  _x_x246 = ((0x1.053572801a604p-45) * _x_x247); /*float64*/
  double _x_x248;
  double _x_x249;
  double _x_x250 = (tsol + elsun); /*float64*/
  _x_x249 = (_x_x250 - els); /*float64*/
  _x_x248 = sin(_x_x249); /*float64*/
  _x_x245 = (_x_x246 * _x_x248); /*float64*/
  double _x_x251;
  double _x_x252;
  double _x_x253;
  double _x_x254;
  double _x_x255;
  double _x_x256;
  double _x_x257;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x13 = u._cons._Optional.value;
    double _uniq_u_573_0 = kk_double_unbox(_box_x13, KK_BORROWED, _ctx);
    _x_x257 = _uniq_u_573_0; /*float64*/
  }
  else {
    _x_x257 = 0x0p+0; /*float64*/
  }
  _x_x256 = ((0x1.c25c268497682p-44) * _x_x257); /*float64*/
  double _x_x258;
  double _x_x259;
  double _x_x260 = (0x1p1 * emsun); /*float64*/
  _x_x259 = (tsol - _x_x260); /*float64*/
  _x_x258 = sin(_x_x259); /*float64*/
  _x_x255 = (_x_x256 * _x_x258); /*float64*/
  double _x_x261;
  double _x_x262;
  double _x_x263;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x14 = u._cons._Optional.value;
    double _uniq_u_573_1 = kk_double_unbox(_box_x14, KK_BORROWED, _ctx);
    _x_x263 = _uniq_u_573_1; /*float64*/
  }
  else {
    _x_x263 = 0x0p+0; /*float64*/
  }
  _x_x262 = ((0x1.2b7d47b1c5f72p-43) * _x_x263); /*float64*/
  double _x_x264;
  double _x_x265 = (tsol - d_0); /*float64*/
  _x_x264 = sin(_x_x265); /*float64*/
  _x_x261 = (_x_x262 * _x_x264); /*float64*/
  _x_x254 = (_x_x255 + _x_x261); /*float64*/
  double _x_x266;
  double _x_x267;
  double _x_x268;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x15 = u._cons._Optional.value;
    double _uniq_u_573_2 = kk_double_unbox(_box_x15, KK_BORROWED, _ctx);
    _x_x268 = _uniq_u_573_2; /*float64*/
  }
  else {
    _x_x268 = 0x0p+0; /*float64*/
  }
  _x_x267 = ((0x1.2b7d47b1c5f72p-43) * _x_x268); /*float64*/
  double _x_x269;
  double _x_x270;
  double _x_x271 = (elsun - elj); /*float64*/
  _x_x270 = (tsol + _x_x271); /*float64*/
  _x_x269 = sin(_x_x270); /*float64*/
  _x_x266 = (_x_x267 * _x_x269); /*float64*/
  _x_x253 = (_x_x254 + _x_x266); /*float64*/
  double _x_x272;
  double _x_x273;
  double _x_x274;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x16 = u._cons._Optional.value;
    double _uniq_u_573_3 = kk_double_unbox(_box_x16, KK_BORROWED, _ctx);
    _x_x274 = _uniq_u_573_3; /*float64*/
  }
  else {
    _x_x274 = 0x0p+0; /*float64*/
  }
  _x_x273 = ((0x1.01d4c1924f001p-42) * _x_x274); /*float64*/
  double _x_x275;
  double _x_x276;
  double _x_x277;
  double _x_x278 = (0x1p1 * elsun); /*float64*/
  _x_x277 = (tsol + _x_x278); /*float64*/
  _x_x276 = (_x_x277 + emsun); /*float64*/
  _x_x275 = sin(_x_x276); /*float64*/
  _x_x272 = (_x_x273 * _x_x275); /*float64*/
  _x_x252 = (_x_x253 - _x_x272); /*float64*/
  double _x_x279;
  double _x_x280;
  double _x_x281;
  if (kk_std_core_types__is_Optional(v, _ctx)) {
    kk_box_t _box_x17 = v._cons._Optional.value;
    double _uniq_v_577 = kk_double_unbox(_box_x17, KK_BORROWED, _ctx);
    _x_x281 = _uniq_v_577; /*float64*/
  }
  else {
    _x_x281 = 0x0p+0; /*float64*/
  }
  _x_x280 = ((0x1.359f5a7b28179p-39) * _x_x281); /*float64*/
  double _x_x282;
  double _x_x283 = (elsun + emsun); /*float64*/
  _x_x282 = cos(_x_x283); /*float64*/
  _x_x279 = (_x_x280 * _x_x282); /*float64*/
  _x_x251 = (_x_x252 - _x_x279); /*float64*/
  _x_x244 = (_x_x245 + _x_x251); /*float64*/
  double _x_x284;
  double _x_x285;
  double _x_x286;
  double _x_x287;
  double _x_x288;
  double _x_x289;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x18 = u._cons._Optional.value;
    double _uniq_u_573_4 = kk_double_unbox(_box_x18, KK_BORROWED, _ctx);
    _x_x289 = _uniq_u_573_4; /*float64*/
  }
  else {
    _x_x289 = 0x0p+0; /*float64*/
  }
  _x_x288 = ((0x1.75cc7c21403a4p-38) * _x_x289); /*float64*/
  double _x_x290;
  double _x_x291 = (tsol - emsun); /*float64*/
  _x_x290 = sin(_x_x291); /*float64*/
  _x_x287 = (_x_x288 * _x_x290); /*float64*/
  double _x_x292;
  double _x_x293;
  double _x_x294;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x19 = u._cons._Optional.value;
    double _uniq_u_573_5 = kk_double_unbox(_box_x19, KK_BORROWED, _ctx);
    _x_x294 = _uniq_u_573_5; /*float64*/
  }
  else {
    _x_x294 = 0x0p+0; /*float64*/
  }
  _x_x293 = ((0x1.e13776d646a91p-37) * _x_x294); /*float64*/
  double _x_x295;
  double _x_x296;
  double _x_x297 = (0x1p1 * elsun); /*float64*/
  _x_x296 = (tsol + _x_x297); /*float64*/
  _x_x295 = sin(_x_x296); /*float64*/
  _x_x292 = (_x_x293 * _x_x295); /*float64*/
  _x_x286 = (_x_x287 - _x_x292); /*float64*/
  double _x_x298;
  double _x_x299;
  double _x_x300;
  if (kk_std_core_types__is_Optional(v, _ctx)) {
    kk_box_t _box_x20 = v._cons._Optional.value;
    double _uniq_v_577_0 = kk_double_unbox(_box_x20, KK_BORROWED, _ctx);
    kk_std_core_types__optional_drop(v, _ctx);
    _x_x300 = _uniq_v_577_0; /*float64*/
  }
  else {
    kk_std_core_types__optional_drop(v, _ctx);
    _x_x300 = 0x0p+0; /*float64*/
  }
  _x_x299 = ((0x1.21eb52655b117p-33) * _x_x300); /*float64*/
  double _x_x301 = cos(elsun); /*float64*/
  _x_x298 = (_x_x299 * _x_x301); /*float64*/
  _x_x285 = (_x_x286 - _x_x298); /*float64*/
  double _x_x302;
  double _x_x303;
  double _x_x304;
  if (kk_std_core_types__is_Optional(u, _ctx)) {
    kk_box_t _box_x21 = u._cons._Optional.value;
    double _uniq_u_573_6 = kk_double_unbox(_box_x21, KK_BORROWED, _ctx);
    kk_std_core_types__optional_drop(u, _ctx);
    _x_x304 = _uniq_u_573_6; /*float64*/
  }
  else {
    kk_std_core_types__optional_drop(u, _ctx);
    _x_x304 = 0x0p+0; /*float64*/
  }
  _x_x303 = ((0x1.5d4ab06a978bdp-32) * _x_x304); /*float64*/
  double _x_x305 = sin(tsol); /*float64*/
  _x_x302 = (_x_x303 * _x_x305); /*float64*/
  _x_x284 = (_x_x285 + _x_x302); /*float64*/
  return (_x_x244 + _x_x284);
}

kk_std_time_timestamp__timestamp kk_std_time_astro_tai_to_tdb(kk_std_time_duration__duration tai, kk_std_core_types__optional delta, kk_context_t* _ctx) { /* (tai : std/time/duration/duration, delta : ? ((std/time/timestamp/timestamp) -> std/time/timestamp/timespan)) -> std/time/timestamp/timestamp */ 
  kk_std_time_timestamp__timestamp tt;
  kk_std_time_instant__timescale _x_x306 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  tt = kk_std_time_instant_from_tai(_x_x306, tai, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble t_10034;
  if (kk_std_core_types__is_Optional(delta, _ctx)) {
    kk_box_t _fun_unbox_x25 = delta._cons._Optional.value;
    kk_box_dup(_fun_unbox_x25, _ctx);
    kk_std_core_types__optional_drop(delta, _ctx);
    kk_box_t _x_x307;
    kk_function_t _x_x310 = kk_function_unbox(_fun_unbox_x25, _ctx); /*(26) -> 27*/
    kk_box_t _x_x308;
    kk_std_time_timestamp__timestamp _x_x309 = kk_std_time_timestamp__timestamp_dup(tt, _ctx); /*std/time/timestamp/timestamp*/
    _x_x308 = kk_std_time_timestamp__timestamp_box(_x_x309, _ctx); /*26*/
    _x_x307 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x_x310, (_x_x310, _x_x308, _ctx), _ctx); /*27*/
    t_10034 = kk_std_num_ddouble__ddouble_unbox(_x_x307, KK_OWNED, _ctx); /*std/time/timestamp/timespan*/
  }
  else {
    kk_std_core_types__optional_drop(delta, _ctx);
    kk_std_time_timestamp__timestamp _x_x311 = kk_std_time_timestamp__timestamp_dup(tt, _ctx); /*std/time/timestamp/timestamp*/
    t_10034 = kk_std_time_astro_tdb_delta(_x_x311, _ctx); /*std/time/timestamp/timespan*/
  }
  kk_std_num_ddouble__ddouble _x_x312;
  kk_std_num_ddouble__ddouble _x_x313;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x314 = kk_std_time_timestamp__as_Timestamp(tt, _ctx);
    kk_std_num_ddouble__ddouble _x = _con_x314->since;
    _x_x313 = _x; /*std/time/timestamp/timespan*/
  }
  _x_x312 = kk_std_num_ddouble__lp__plus__rp_(_x_x313, t_10034, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x315;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x316 = kk_std_time_timestamp__as_Timestamp(tt, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_0 = _con_x316->since;
    int32_t _x_0 = _con_x316->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(tt, _ctx)) {
      kk_datatype_ptr_free(tt, _ctx);
    }
    else {
      kk_datatype_ptr_decref(tt, _ctx);
    }
    _x_x315 = _x_0; /*int32*/
  }
  return kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x312, _x_x315, _ctx);
}

kk_std_time_duration__duration kk_std_time_astro_tdb_to_tai(kk_std_time_timestamp__timestamp tdb, kk_std_core_types__optional delta, kk_context_t* _ctx) { /* (tdb : std/time/timestamp/timestamp, delta : ? ((std/time/timestamp/timestamp) -> std/time/timestamp/timespan)) -> std/time/duration/duration */ 
  kk_std_num_ddouble__ddouble t_0_10038;
  if (kk_std_core_types__is_Optional(delta, _ctx)) {
    kk_box_t _fun_unbox_x32 = delta._cons._Optional.value;
    kk_box_dup(_fun_unbox_x32, _ctx);
    kk_std_core_types__optional_drop(delta, _ctx);
    kk_box_t _x_x317;
    kk_function_t _x_x320 = kk_function_unbox(_fun_unbox_x32, _ctx); /*(33) -> 34*/
    kk_box_t _x_x318;
    kk_std_time_timestamp__timestamp _x_x319 = kk_std_time_timestamp__timestamp_dup(tdb, _ctx); /*std/time/timestamp/timestamp*/
    _x_x318 = kk_std_time_timestamp__timestamp_box(_x_x319, _ctx); /*33*/
    _x_x317 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x_x320, (_x_x320, _x_x318, _ctx), _ctx); /*34*/
    t_0_10038 = kk_std_num_ddouble__ddouble_unbox(_x_x317, KK_OWNED, _ctx); /*std/time/timestamp/timespan*/
  }
  else {
    kk_std_core_types__optional_drop(delta, _ctx);
    kk_std_time_timestamp__timestamp _x_x321 = kk_std_time_timestamp__timestamp_dup(tdb, _ctx); /*std/time/timestamp/timestamp*/
    t_0_10038 = kk_std_time_astro_tdb_delta(_x_x321, _ctx); /*std/time/timestamp/timespan*/
  }
  kk_std_time_timestamp__timestamp t_10036;
  kk_std_num_ddouble__ddouble _x_x322;
  kk_std_num_ddouble__ddouble _x_x323;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x324 = kk_std_time_timestamp__as_Timestamp(tdb, _ctx);
    kk_std_num_ddouble__ddouble _x_1 = _con_x324->since;
    _x_x323 = _x_1; /*std/time/timestamp/timespan*/
  }
  kk_std_num_ddouble__ddouble _x_x325;
  double _x_x326;
  double _x_x327;
  {
    double _x = t_0_10038.hi;
    _x_x327 = _x; /*float64*/
  }
  _x_x326 = (-_x_x327); /*float64*/
  double _x_x328;
  double _x_x329;
  {
    double _x_0 = t_0_10038.lo;
    _x_x329 = _x_0; /*float64*/
  }
  _x_x328 = (-_x_x329); /*float64*/
  _x_x325 = kk_std_num_ddouble__new_Ddouble(_x_x326, _x_x328, _ctx); /*std/num/ddouble/ddouble*/
  _x_x322 = kk_std_num_ddouble__lp__plus__rp_(_x_x323, _x_x325, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x330;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x331 = kk_std_time_timestamp__as_Timestamp(tdb, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_2 = _con_x331->since;
    int32_t _x_2 = _con_x331->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(tdb, _ctx)) {
      kk_datatype_ptr_free(tdb, _ctx);
    }
    else {
      kk_datatype_ptr_decref(tdb, _ctx);
    }
    _x_x330 = _x_2; /*int32*/
  }
  t_10036 = kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x322, _x_x330, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp t_0_10125;
  kk_std_time_instant__timescale _x_x332 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  kk_std_time_instant__timescale _x_x333 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tai, _ctx); /*std/time/instant/timescale*/
  t_0_10125 = kk_std_time_instant_convert(t_10036, _x_x332, _x_x333, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x334 = kk_std_time_timestamp_unsafe_timespan_withleap(t_0_10125, _ctx); /*std/time/timestamp/timespan*/
  return kk_std_time_duration__new_Duration(_x_x334, _ctx);
}
 
// Creates a new TDB timescale given a user provided function to calculate TDB-TT.
// The default function used for `ts-tdb` uses the Fairhead &amp; Bretagnon approximation
// corrected for JPL planetary masses but assumes the geo center. Use this function
// to create a new TDB timescale if you need more precision.


// lift anonymous function
struct kk_std_time_astro_ts_tdb_create_fun340__t {
  struct kk_function_s _base;
  kk_function_t tdb_minus_tt;
};
static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tdb_create_fun340(kk_function_t _fself, kk_std_time_duration__duration tai, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tdb_create_fun340(kk_function_t tdb_minus_tt, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tdb_create_fun340__t* _self = kk_function_alloc_as(struct kk_std_time_astro_ts_tdb_create_fun340__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_astro_ts_tdb_create_fun340, kk_context());
  _self->tdb_minus_tt = tdb_minus_tt;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tdb_create_fun340(kk_function_t _fself, kk_std_time_duration__duration tai, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tdb_create_fun340__t* _self = kk_function_as(struct kk_std_time_astro_ts_tdb_create_fun340__t*, _fself, _ctx);
  kk_function_t tdb_minus_tt = _self->tdb_minus_tt; /* (std/time/timestamp/timestamp) -> std/time/timestamp/timespan */
  kk_drop_match(_self, {kk_function_dup(tdb_minus_tt, _ctx);}, {}, _ctx)
  kk_std_time_timestamp__timestamp tt;
  kk_std_time_instant__timescale _x_x341 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  tt = kk_std_time_instant_from_tai(_x_x341, tai, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble t_10049;
  kk_std_time_timestamp__timestamp _x_x342 = kk_std_time_timestamp__timestamp_dup(tt, _ctx); /*std/time/timestamp/timestamp*/
  t_10049 = kk_function_call(kk_std_num_ddouble__ddouble, (kk_function_t, kk_std_time_timestamp__timestamp, kk_context_t*), tdb_minus_tt, (tdb_minus_tt, _x_x342, _ctx), _ctx); /*std/time/timestamp/timespan*/
  kk_std_num_ddouble__ddouble _x_x343;
  kk_std_num_ddouble__ddouble _x_x344;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x345 = kk_std_time_timestamp__as_Timestamp(tt, _ctx);
    kk_std_num_ddouble__ddouble _x = _con_x345->since;
    _x_x344 = _x; /*std/time/timestamp/timespan*/
  }
  _x_x343 = kk_std_num_ddouble__lp__plus__rp_(_x_x344, t_10049, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x346;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x347 = kk_std_time_timestamp__as_Timestamp(tt, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_0_0 = _con_x347->since;
    int32_t _x_0 = _con_x347->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(tt, _ctx)) {
      kk_datatype_ptr_free(tt, _ctx);
    }
    else {
      kk_datatype_ptr_decref(tt, _ctx);
    }
    _x_x346 = _x_0; /*int32*/
  }
  return kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x343, _x_x346, _ctx);
}


// lift anonymous function
struct kk_std_time_astro_ts_tdb_create_fun348__t {
  struct kk_function_s _base;
  kk_function_t tdb_minus_tt;
};
static kk_std_time_duration__duration kk_std_time_astro_ts_tdb_create_fun348(kk_function_t _fself, kk_std_time_timestamp__timestamp tdb, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tdb_create_fun348(kk_function_t tdb_minus_tt, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tdb_create_fun348__t* _self = kk_function_alloc_as(struct kk_std_time_astro_ts_tdb_create_fun348__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_astro_ts_tdb_create_fun348, kk_context());
  _self->tdb_minus_tt = tdb_minus_tt;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_time_duration__duration kk_std_time_astro_ts_tdb_create_fun348(kk_function_t _fself, kk_std_time_timestamp__timestamp tdb, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tdb_create_fun348__t* _self = kk_function_as(struct kk_std_time_astro_ts_tdb_create_fun348__t*, _fself, _ctx);
  kk_function_t tdb_minus_tt = _self->tdb_minus_tt; /* (std/time/timestamp/timestamp) -> std/time/timestamp/timespan */
  kk_drop_match(_self, {kk_function_dup(tdb_minus_tt, _ctx);}, {}, _ctx)
  kk_std_num_ddouble__ddouble t_1_10055;
  kk_std_time_timestamp__timestamp _x_x349 = kk_std_time_timestamp__timestamp_dup(tdb, _ctx); /*std/time/timestamp/timestamp*/
  t_1_10055 = kk_function_call(kk_std_num_ddouble__ddouble, (kk_function_t, kk_std_time_timestamp__timestamp, kk_context_t*), tdb_minus_tt, (tdb_minus_tt, _x_x349, _ctx), _ctx); /*std/time/timestamp/timespan*/
  kk_std_time_timestamp__timestamp t_0_10053;
  kk_std_num_ddouble__ddouble _x_x350;
  kk_std_num_ddouble__ddouble _x_x351;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x352 = kk_std_time_timestamp__as_Timestamp(tdb, _ctx);
    kk_std_num_ddouble__ddouble _x_1 = _con_x352->since;
    _x_x351 = _x_1; /*std/time/timestamp/timespan*/
  }
  kk_std_num_ddouble__ddouble _x_x353;
  double _x_x354;
  double _x_x355;
  {
    double _x_2 = t_1_10055.hi;
    _x_x355 = _x_2; /*float64*/
  }
  _x_x354 = (-_x_x355); /*float64*/
  double _x_x356;
  double _x_x357;
  {
    double _x_0_0 = t_1_10055.lo;
    _x_x357 = _x_0_0; /*float64*/
  }
  _x_x356 = (-_x_x357); /*float64*/
  _x_x353 = kk_std_num_ddouble__new_Ddouble(_x_x354, _x_x356, _ctx); /*std/num/ddouble/ddouble*/
  _x_x350 = kk_std_num_ddouble__lp__plus__rp_(_x_x351, _x_x353, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x358;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x359 = kk_std_time_timestamp__as_Timestamp(tdb, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_2_0 = _con_x359->since;
    int32_t _x_2_0 = _con_x359->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(tdb, _ctx)) {
      kk_datatype_ptr_free(tdb, _ctx);
    }
    else {
      kk_datatype_ptr_decref(tdb, _ctx);
    }
    _x_x358 = _x_2_0; /*int32*/
  }
  t_0_10053 = kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x350, _x_x358, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp t_0_10125;
  kk_std_time_instant__timescale _x_x360 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tt, _ctx); /*std/time/instant/timescale*/
  kk_std_time_instant__timescale _x_x361 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tai, _ctx); /*std/time/instant/timescale*/
  t_0_10125 = kk_std_time_instant_convert(t_0_10053, _x_x360, _x_x361, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x362 = kk_std_time_timestamp_unsafe_timespan_withleap(t_0_10125, _ctx); /*std/time/timestamp/timespan*/
  return kk_std_time_duration__new_Duration(_x_x362, _ctx);
}

kk_std_time_instant__timescale kk_std_time_astro_ts_tdb_create(kk_function_t tdb_minus_tt, kk_context_t* _ctx) { /* (tdb-minus-tt : (std/time/timestamp/timestamp) -> std/time/timestamp/timespan) -> std/time/instant/timescale */ 
  kk_string_t _x_x335;
  kk_define_string_literal(, _s_x336, 3, "TDB", _ctx)
  _x_x335 = kk_string_dup(_s_x336, _ctx); /*string*/
  kk_string_t _x_x337;
  kk_std_core_types__optional _match_x51 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x51, _ctx)) {
    kk_box_t _box_x36 = _match_x51._cons._Optional.value;
    kk_string_t _uniq_unit_342 = kk_string_unbox(_box_x36);
    kk_string_dup(_uniq_unit_342, _ctx);
    kk_std_core_types__optional_drop(_match_x51, _ctx);
    _x_x337 = _uniq_unit_342; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x51, _ctx);
    kk_define_string_literal(, _s_x338, 3, "TDB", _ctx)
    _x_x337 = kk_string_dup(_s_x338, _ctx); /*string*/
  }
  kk_function_t _x_x339;
  kk_function_dup(tdb_minus_tt, _ctx);
  _x_x339 = kk_std_time_astro_new_ts_tdb_create_fun340(tdb_minus_tt, _ctx); /*(tai : std/time/duration/duration) -> std/time/timestamp/timestamp*/
  kk_std_core_types__maybe _x_x363;
  kk_std_core_types__optional _match_x50 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x50, _ctx)) {
    kk_box_t _box_x37 = _match_x50._cons._Optional.value;
    kk_std_core_types__maybe _uniq_seconds_in_day_348 = kk_std_core_types__maybe_unbox(_box_x37, KK_BORROWED, _ctx);
    kk_std_core_types__maybe_dup(_uniq_seconds_in_day_348, _ctx);
    kk_std_core_types__optional_drop(_match_x50, _ctx);
    _x_x363 = _uniq_seconds_in_day_348; /*maybe<(std/time/timestamp/timestamp) -> std/time/timestamp/timespan>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x50, _ctx);
    _x_x363 = kk_std_core_types__new_Nothing(_ctx); /*maybe<(std/time/timestamp/timestamp) -> std/time/timestamp/timespan>*/
  }
  kk_std_core_types__maybe _x_x364;
  kk_std_core_types__optional _match_x49 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x49, _ctx)) {
    kk_box_t _box_x38 = _match_x49._cons._Optional.value;
    kk_std_core_types__maybe _uniq_to_mjd2000_354 = kk_std_core_types__maybe_unbox(_box_x38, KK_BORROWED, _ctx);
    kk_std_core_types__maybe_dup(_uniq_to_mjd2000_354, _ctx);
    kk_std_core_types__optional_drop(_match_x49, _ctx);
    _x_x364 = _uniq_to_mjd2000_354; /*maybe<(t : std/time/timestamp/timestamp, tzdelta : std/time/timestamp/timespan) -> std/num/ddouble/ddouble>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x49, _ctx);
    _x_x364 = kk_std_core_types__new_Nothing(_ctx); /*maybe<(t : std/time/timestamp/timestamp, tzdelta : std/time/timestamp/timespan) -> std/num/ddouble/ddouble>*/
  }
  kk_std_core_types__maybe _x_x365;
  kk_std_core_types__optional _match_x48 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x48, _ctx)) {
    kk_box_t _box_x39 = _match_x48._cons._Optional.value;
    kk_std_core_types__maybe _uniq_from_mjd2000_360 = kk_std_core_types__maybe_unbox(_box_x39, KK_BORROWED, _ctx);
    kk_std_core_types__maybe_dup(_uniq_from_mjd2000_360, _ctx);
    kk_std_core_types__optional_drop(_match_x48, _ctx);
    _x_x365 = _uniq_from_mjd2000_360; /*maybe<(days : int, frac : std/num/ddouble/ddouble) -> std/time/timestamp/timestamp>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x48, _ctx);
    _x_x365 = kk_std_core_types__new_Nothing(_ctx); /*maybe<(days : int, frac : std/num/ddouble/ddouble) -> std/time/timestamp/timestamp>*/
  }
  return kk_std_time_instant__new_Timescale(kk_reuse_null, 0, _x_x335, _x_x337, _x_x339, kk_std_time_astro_new_ts_tdb_create_fun348(tdb_minus_tt, _ctx), _x_x363, _x_x364, _x_x365, _ctx);
}
 
// The [TDB](https://en.wikipedia.org/wiki/Barycentric_Coordinate_Time) (Barycentric dynamical time) time scale
// (which can be considered equivalent T~eph~).
//
// TDB is approximated from TT using an initial set of coefficients by
// Fairhead &amp; Bretagnon [@Fairhead:tt] assuming the geo center (longitude and latitude of 0 degrees).
// See also USNO circular 179 ([@Kaplan:circ], equation 2.6).
// The approximation is within 10&mu;s precision in the time span 1600 to 2200 (and probably a bit less).


// lift anonymous function
struct kk_std_time_astro_ts_tdb_fun367__t {
  struct kk_function_s _base;
};
static kk_std_num_ddouble__ddouble kk_std_time_astro_ts_tdb_fun367(kk_function_t _fself, kk_std_time_timestamp__timestamp _x1_x366, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tdb_fun367(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_astro_ts_tdb_fun367, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_std_num_ddouble__ddouble kk_std_time_astro_ts_tdb_fun367(kk_function_t _fself, kk_std_time_timestamp__timestamp _x1_x366, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_std_time_astro_tdb_delta(_x1_x366, _ctx);
}

kk_std_time_instant__timescale kk_std_time_astro_ts_tdb;

kk_std_num_ddouble__ddouble kk_std_time_astro_lb;
 
// 1.55051976772e-8

kk_std_num_ddouble__ddouble kk_std_time_astro_tdb0;

kk_std_time_timestamp__timestamp kk_std_time_astro_tai_to_tcb(kk_std_time_duration__duration tai, kk_std_time_instant__timescale tstdb, kk_context_t* _ctx) { /* (tai : std/time/duration/duration, tstdb : std/time/instant/timescale) -> std/time/timestamp/timestamp */ 
  kk_std_time_timestamp__timestamp tdb = kk_std_time_instant_from_tai(tstdb, tai, _ctx); /*std/time/timestamp/timestamp*/;
  kk_std_time_timestamp__timestamp ts_10056;
  kk_std_time_timestamp__timestamp _x_x371 = kk_std_time_timestamp__timestamp_dup(tdb, _ctx); /*std/time/timestamp/timestamp*/
  ts_10056 = kk_std_time_timestamp__lp__dash__rp_(_x_x371, kk_std_time_astro_tcg_epoch_delta, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble adj;
  kk_std_num_ddouble__ddouble _x_x372;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x373 = kk_std_time_timestamp__as_Timestamp(ts_10056, _ctx);
    kk_std_num_ddouble__ddouble _x = _con_x373->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_10056, _ctx)) {
      kk_datatype_ptr_free(ts_10056, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_10056, _ctx);
    }
    _x_x372 = _x; /*std/time/timestamp/timespan*/
  }
  adj = kk_std_num_ddouble__lp__star__rp_(kk_std_time_astro_lb, _x_x372, _ctx); /*std/num/ddouble/ddouble*/
  kk_std_num_ddouble__ddouble t_10058;
  kk_std_num_ddouble__ddouble _x_x374;
  double _x_x375;
  double _x_x376;
  kk_std_num_ddouble__ddouble _x_x377 = kk_std_time_astro_tdb0; /*std/num/ddouble/ddouble*/
  {
    double _x_1 = _x_x377.hi;
    _x_x376 = _x_1; /*float64*/
  }
  _x_x375 = (-_x_x376); /*float64*/
  double _x_x378;
  double _x_x379;
  kk_std_num_ddouble__ddouble _x_x380 = kk_std_time_astro_tdb0; /*std/num/ddouble/ddouble*/
  {
    double _x_0_1 = _x_x380.lo;
    _x_x379 = _x_0_1; /*float64*/
  }
  _x_x378 = (-_x_x379); /*float64*/
  _x_x374 = kk_std_num_ddouble__new_Ddouble(_x_x375, _x_x378, _ctx); /*std/num/ddouble/ddouble*/
  t_10058 = kk_std_num_ddouble__lp__plus__rp_(adj, _x_x374, _ctx); /*std/num/ddouble/ddouble*/
  kk_std_num_ddouble__ddouble _x_x381;
  kk_std_num_ddouble__ddouble _x_x382;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x383 = kk_std_time_timestamp__as_Timestamp(tdb, _ctx);
    kk_std_num_ddouble__ddouble _x_0 = _con_x383->since;
    _x_x382 = _x_0; /*std/time/timestamp/timespan*/
  }
  _x_x381 = kk_std_num_ddouble__lp__plus__rp_(_x_x382, t_10058, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x384;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x385 = kk_std_time_timestamp__as_Timestamp(tdb, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_0_0 = _con_x385->since;
    int32_t _x_0_0 = _con_x385->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(tdb, _ctx)) {
      kk_datatype_ptr_free(tdb, _ctx);
    }
    else {
      kk_datatype_ptr_decref(tdb, _ctx);
    }
    _x_x384 = _x_0_0; /*int32*/
  }
  return kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x381, _x_x384, _ctx);
}

kk_std_time_duration__duration kk_std_time_astro_tcb_to_tai(kk_std_time_timestamp__timestamp tcb, kk_std_time_instant__timescale tstdb, kk_context_t* _ctx) { /* (tcb : std/time/timestamp/timestamp, tstdb : std/time/instant/timescale) -> std/time/duration/duration */ 
  kk_std_time_timestamp__timestamp ts_10061;
  kk_std_time_timestamp__timestamp _x_x386 = kk_std_time_timestamp__timestamp_dup(tcb, _ctx); /*std/time/timestamp/timestamp*/
  ts_10061 = kk_std_time_timestamp__lp__dash__rp_(_x_x386, kk_std_time_astro_tcg_epoch_delta, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble adj;
  kk_std_num_ddouble__ddouble _x_x387;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x388 = kk_std_time_timestamp__as_Timestamp(ts_10061, _ctx);
    kk_std_num_ddouble__ddouble _x = _con_x388->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts_10061, _ctx)) {
      kk_datatype_ptr_free(ts_10061, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts_10061, _ctx);
    }
    _x_x387 = _x; /*std/time/timestamp/timespan*/
  }
  adj = kk_std_num_ddouble__lp__star__rp_(kk_std_time_astro_lb, _x_x387, _ctx); /*std/num/ddouble/ddouble*/
  kk_std_num_ddouble__ddouble t_10063;
  kk_std_num_ddouble__ddouble _x_x389;
  double _x_x390;
  double _x_x391;
  kk_std_num_ddouble__ddouble _x_x392 = kk_std_time_astro_tdb0; /*std/num/ddouble/ddouble*/
  {
    double _x_3 = _x_x392.hi;
    _x_x391 = _x_3; /*float64*/
  }
  _x_x390 = (-_x_x391); /*float64*/
  double _x_x393;
  double _x_x394;
  kk_std_num_ddouble__ddouble _x_x395 = kk_std_time_astro_tdb0; /*std/num/ddouble/ddouble*/
  {
    double _x_0_1 = _x_x395.lo;
    _x_x394 = _x_0_1; /*float64*/
  }
  _x_x393 = (-_x_x394); /*float64*/
  _x_x389 = kk_std_num_ddouble__new_Ddouble(_x_x390, _x_x393, _ctx); /*std/num/ddouble/ddouble*/
  t_10063 = kk_std_num_ddouble__lp__plus__rp_(adj, _x_x389, _ctx); /*std/num/ddouble/ddouble*/
  kk_std_time_timestamp__timestamp tdb;
  kk_std_num_ddouble__ddouble _x_x396;
  kk_std_num_ddouble__ddouble _x_x397;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x398 = kk_std_time_timestamp__as_Timestamp(tcb, _ctx);
    kk_std_num_ddouble__ddouble _x_1 = _con_x398->since;
    _x_x397 = _x_1; /*std/time/timestamp/timespan*/
  }
  kk_std_num_ddouble__ddouble _x_x399;
  double _x_x400;
  double _x_x401;
  {
    double _x_0 = t_10063.hi;
    _x_x401 = _x_0; /*float64*/
  }
  _x_x400 = (-_x_x401); /*float64*/
  double _x_x402;
  double _x_x403;
  {
    double _x_0_0 = t_10063.lo;
    _x_x403 = _x_0_0; /*float64*/
  }
  _x_x402 = (-_x_x403); /*float64*/
  _x_x399 = kk_std_num_ddouble__new_Ddouble(_x_x400, _x_x402, _ctx); /*std/num/ddouble/ddouble*/
  _x_x396 = kk_std_num_ddouble__lp__plus__rp_(_x_x397, _x_x399, _ctx); /*std/num/ddouble/ddouble*/
  int32_t _x_x404;
  {
    struct kk_std_time_timestamp_Timestamp* _con_x405 = kk_std_time_timestamp__as_Timestamp(tcb, _ctx);
    kk_std_num_ddouble__ddouble _pat_0_2 = _con_x405->since;
    int32_t _x_2 = _con_x405->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(tcb, _ctx)) {
      kk_datatype_ptr_free(tcb, _ctx);
    }
    else {
      kk_datatype_ptr_decref(tcb, _ctx);
    }
    _x_x404 = _x_2; /*int32*/
  }
  tdb = kk_std_time_timestamp__new_Timestamp(kk_reuse_null, 0, _x_x396, _x_x404, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_time_timestamp__timestamp t_0_10125;
  kk_std_time_instant__timescale _x_x406 = kk_std_time_instant__timescale_dup(kk_std_time_instant_ts_tai, _ctx); /*std/time/instant/timescale*/
  t_0_10125 = kk_std_time_instant_convert(tdb, tstdb, _x_x406, _ctx); /*std/time/timestamp/timestamp*/
  kk_std_num_ddouble__ddouble _x_x407 = kk_std_time_timestamp_unsafe_timespan_withleap(t_0_10125, _ctx); /*std/time/timestamp/timespan*/
  return kk_std_time_duration__new_Duration(_x_x407, _ctx);
}
 
// Create a new TCB timescale given a TDB timescale (`tstdb`). The default
// `ts-tcb` uses the default `ts-tdb` timescale, but if you created
// a different TCB time scale (using `ts-tdb-create`) you can use
// this function to create a TCB time scale from it. It computes
// TCB from the provided TDB using the IAU 2006 resolution
// [B3](https://www.iau.org/static/resolutions/IAU2006_Resol3.pdf):\ TDB = TCB -
// L~b~ &times; (JD~TCB~ - T~0~) &times; 86400 + TDB~0~, with T~0~ =
// 2443144.5003725, L~b~ = 1.55051976772&times;10^-8^, TDB~0~ =
// -6.55&times;10^-5^.


// lift anonymous function
struct kk_std_time_astro_ts_tcb_create_fun413__t {
  struct kk_function_s _base;
  kk_std_time_instant__timescale tstdb;
};
static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tcb_create_fun413(kk_function_t _fself, kk_std_time_duration__duration tai, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tcb_create_fun413(kk_std_time_instant__timescale tstdb, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tcb_create_fun413__t* _self = kk_function_alloc_as(struct kk_std_time_astro_ts_tcb_create_fun413__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_astro_ts_tcb_create_fun413, kk_context());
  _self->tstdb = tstdb;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_time_timestamp__timestamp kk_std_time_astro_ts_tcb_create_fun413(kk_function_t _fself, kk_std_time_duration__duration tai, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tcb_create_fun413__t* _self = kk_function_as(struct kk_std_time_astro_ts_tcb_create_fun413__t*, _fself, _ctx);
  kk_std_time_instant__timescale tstdb = _self->tstdb; /* std/time/instant/timescale */
  kk_drop_match(_self, {kk_std_time_instant__timescale_dup(tstdb, _ctx);}, {}, _ctx)
  return kk_std_time_astro_tai_to_tcb(tai, tstdb, _ctx);
}


// lift anonymous function
struct kk_std_time_astro_ts_tcb_create_fun414__t {
  struct kk_function_s _base;
  kk_std_time_instant__timescale tstdb;
};
static kk_std_time_duration__duration kk_std_time_astro_ts_tcb_create_fun414(kk_function_t _fself, kk_std_time_timestamp__timestamp tcb, kk_context_t* _ctx);
static kk_function_t kk_std_time_astro_new_ts_tcb_create_fun414(kk_std_time_instant__timescale tstdb, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tcb_create_fun414__t* _self = kk_function_alloc_as(struct kk_std_time_astro_ts_tcb_create_fun414__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_astro_ts_tcb_create_fun414, kk_context());
  _self->tstdb = tstdb;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_time_duration__duration kk_std_time_astro_ts_tcb_create_fun414(kk_function_t _fself, kk_std_time_timestamp__timestamp tcb, kk_context_t* _ctx) {
  struct kk_std_time_astro_ts_tcb_create_fun414__t* _self = kk_function_as(struct kk_std_time_astro_ts_tcb_create_fun414__t*, _fself, _ctx);
  kk_std_time_instant__timescale tstdb = _self->tstdb; /* std/time/instant/timescale */
  kk_drop_match(_self, {kk_std_time_instant__timescale_dup(tstdb, _ctx);}, {}, _ctx)
  return kk_std_time_astro_tcb_to_tai(tcb, tstdb, _ctx);
}

kk_std_time_instant__timescale kk_std_time_astro_ts_tcb_create(kk_std_time_instant__timescale tstdb, kk_context_t* _ctx) { /* (tstdb : std/time/instant/timescale) -> std/time/instant/timescale */ 
  kk_string_t _x_x408;
  kk_define_string_literal(, _s_x409, 3, "TCB", _ctx)
  _x_x408 = kk_string_dup(_s_x409, _ctx); /*string*/
  kk_string_t _x_x410;
  kk_std_core_types__optional _match_x47 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x47, _ctx)) {
    kk_box_t _box_x40 = _match_x47._cons._Optional.value;
    kk_string_t _uniq_unit_342 = kk_string_unbox(_box_x40);
    kk_string_dup(_uniq_unit_342, _ctx);
    kk_std_core_types__optional_drop(_match_x47, _ctx);
    _x_x410 = _uniq_unit_342; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x47, _ctx);
    kk_define_string_literal(, _s_x411, 3, "TCB", _ctx)
    _x_x410 = kk_string_dup(_s_x411, _ctx); /*string*/
  }
  kk_function_t _x_x412;
  kk_std_time_instant__timescale_dup(tstdb, _ctx);
  _x_x412 = kk_std_time_astro_new_ts_tcb_create_fun413(tstdb, _ctx); /*(tai : std/time/duration/duration) -> std/time/timestamp/timestamp*/
  kk_std_core_types__maybe _x_x415;
  kk_std_core_types__optional _match_x46 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x46, _ctx)) {
    kk_box_t _box_x41 = _match_x46._cons._Optional.value;
    kk_std_core_types__maybe _uniq_seconds_in_day_348 = kk_std_core_types__maybe_unbox(_box_x41, KK_BORROWED, _ctx);
    kk_std_core_types__maybe_dup(_uniq_seconds_in_day_348, _ctx);
    kk_std_core_types__optional_drop(_match_x46, _ctx);
    _x_x415 = _uniq_seconds_in_day_348; /*maybe<(std/time/timestamp/timestamp) -> std/time/timestamp/timespan>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x46, _ctx);
    _x_x415 = kk_std_core_types__new_Nothing(_ctx); /*maybe<(std/time/timestamp/timestamp) -> std/time/timestamp/timespan>*/
  }
  kk_std_core_types__maybe _x_x416;
  kk_std_core_types__optional _match_x45 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x45, _ctx)) {
    kk_box_t _box_x42 = _match_x45._cons._Optional.value;
    kk_std_core_types__maybe _uniq_to_mjd2000_354 = kk_std_core_types__maybe_unbox(_box_x42, KK_BORROWED, _ctx);
    kk_std_core_types__maybe_dup(_uniq_to_mjd2000_354, _ctx);
    kk_std_core_types__optional_drop(_match_x45, _ctx);
    _x_x416 = _uniq_to_mjd2000_354; /*maybe<(t : std/time/timestamp/timestamp, tzdelta : std/time/timestamp/timespan) -> std/num/ddouble/ddouble>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x45, _ctx);
    _x_x416 = kk_std_core_types__new_Nothing(_ctx); /*maybe<(t : std/time/timestamp/timestamp, tzdelta : std/time/timestamp/timespan) -> std/num/ddouble/ddouble>*/
  }
  kk_std_core_types__maybe _x_x417;
  kk_std_core_types__optional _match_x44 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
  if (kk_std_core_types__is_Optional(_match_x44, _ctx)) {
    kk_box_t _box_x43 = _match_x44._cons._Optional.value;
    kk_std_core_types__maybe _uniq_from_mjd2000_360 = kk_std_core_types__maybe_unbox(_box_x43, KK_BORROWED, _ctx);
    kk_std_core_types__maybe_dup(_uniq_from_mjd2000_360, _ctx);
    kk_std_core_types__optional_drop(_match_x44, _ctx);
    _x_x417 = _uniq_from_mjd2000_360; /*maybe<(days : int, frac : std/num/ddouble/ddouble) -> std/time/timestamp/timestamp>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x44, _ctx);
    _x_x417 = kk_std_core_types__new_Nothing(_ctx); /*maybe<(days : int, frac : std/num/ddouble/ddouble) -> std/time/timestamp/timestamp>*/
  }
  return kk_std_time_instant__new_Timescale(kk_reuse_null, 0, _x_x408, _x_x410, _x_x412, kk_std_time_astro_new_ts_tcb_create_fun414(tstdb, _ctx), _x_x415, _x_x416, _x_x417, _ctx);
}
 
// The [TCB](https://en.wikipedia.org/wiki/Geocentric_Coordinate_Time)
// (Barycentric coordinate time) time scale.\ The unit of TCB is the SI
// second, but in a coordinate reference frame at the barycenter of the solar
// system.

kk_std_time_instant__timescale kk_std_time_astro_ts_tcb;

// initialization
void kk_std_time_astro__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core_exn__init(_ctx);
  kk_std_core_bool__init(_ctx);
  kk_std_core_order__init(_ctx);
  kk_std_core_char__init(_ctx);
  kk_std_core_int__init(_ctx);
  kk_std_core_vector__init(_ctx);
  kk_std_core_string__init(_ctx);
  kk_std_core_sslice__init(_ctx);
  kk_std_core_list__init(_ctx);
  kk_std_core_maybe__init(_ctx);
  kk_std_core_maybe2__init(_ctx);
  kk_std_core_either__init(_ctx);
  kk_std_core_tuple__init(_ctx);
  kk_std_core_lazy__init(_ctx);
  kk_std_core_show__init(_ctx);
  kk_std_core_debug__init(_ctx);
  kk_std_core_delayed__init(_ctx);
  kk_std_core_console__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_num_float64__init(_ctx);
  kk_std_num_ddouble__init(_ctx);
  kk_std_time_timestamp__init(_ctx);
  kk_std_time_duration__init(_ctx);
  kk_std_time_instant__init(_ctx);
  kk_std_time_calendar__init(_ctx);
  kk_std_time_utc__init(_ctx);
  kk_std_time_calendars__init(_ctx);
  kk_std_num_int32__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_time_astro_secs_per_day = kk_std_num_ddouble_ddouble_int_exp(kk_integer_from_int(86400, _ctx), kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_std_time_astro_offset_j2000 = kk_std_num_ddouble_ddouble_int_exp(kk_integer_from_int(43200, _ctx), kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_std_time_astro_epoch_j2000 = kk_std_time_astro_instant_at_j2000(kk_std_num_ddouble_zero, _ctx); /*std/time/instant/instant*/
  }
  {
    kk_integer_t _x_x95 = kk_integer_neg((kk_integer_from_small(19)),kk_context()); /*int*/
    kk_std_time_astro_lg = kk_std_num_ddouble_int_fs_ddouble_exp(kk_integer_from_str("6969290134", _ctx), _x_x95, _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_integer_t _x_x96 = kk_integer_neg((kk_integer_from_str("725759967816", _ctx)),kk_context()); /*int*/
    kk_integer_t _x_x97 = kk_integer_neg((kk_integer_from_small(3)),kk_context()); /*int*/
    kk_std_time_astro_tcg_epoch_delta = kk_std_num_ddouble_int_fs_ddouble_exp(_x_x96, _x_x97, _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_string_t _x_x123;
    kk_define_string_literal(, _s_x124, 3, "TCG", _ctx)
    _x_x123 = kk_string_dup(_s_x124, _ctx); /*string*/
    kk_string_t _x_x125;
    kk_std_core_types__optional _match_x59 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
    if (kk_std_core_types__is_Optional(_match_x59, _ctx)) {
      kk_box_t _box_x1 = _match_x59._cons._Optional.value;
      kk_string_t _uniq_unit_342 = kk_string_unbox(_box_x1);
      kk_string_dup(_uniq_unit_342, _ctx);
      kk_std_core_types__optional_drop(_match_x59, _ctx);
      _x_x125 = _uniq_unit_342; /*string*/
    }
    else {
      kk_std_core_types__optional_drop(_match_x59, _ctx);
      kk_define_string_literal(, _s_x126, 3, "TCG", _ctx)
      _x_x125 = kk_string_dup(_s_x126, _ctx); /*string*/
    }
    kk_std_core_types__maybe _x_x131;
    kk_std_core_types__optional _match_x58 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
    if (kk_std_core_types__is_Optional(_match_x58, _ctx)) {
      kk_box_t _box_x2 = _match_x58._cons._Optional.value;
      kk_std_core_types__maybe _uniq_seconds_in_day_348 = kk_std_core_types__maybe_unbox(_box_x2, KK_BORROWED, _ctx);
      kk_std_core_types__maybe_dup(_uniq_seconds_in_day_348, _ctx);
      kk_std_core_types__optional_drop(_match_x58, _ctx);
      _x_x131 = _uniq_seconds_in_day_348; /*maybe<(std/time/timestamp/timestamp) -> std/time/timestamp/timespan>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_x58, _ctx);
      _x_x131 = kk_std_core_types__new_Nothing(_ctx); /*maybe<(std/time/timestamp/timestamp) -> std/time/timestamp/timespan>*/
    }
    kk_std_core_types__maybe _x_x132;
    kk_std_core_types__optional _match_x57 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
    if (kk_std_core_types__is_Optional(_match_x57, _ctx)) {
      kk_box_t _box_x3 = _match_x57._cons._Optional.value;
      kk_std_core_types__maybe _uniq_to_mjd2000_354 = kk_std_core_types__maybe_unbox(_box_x3, KK_BORROWED, _ctx);
      kk_std_core_types__maybe_dup(_uniq_to_mjd2000_354, _ctx);
      kk_std_core_types__optional_drop(_match_x57, _ctx);
      _x_x132 = _uniq_to_mjd2000_354; /*maybe<(t : std/time/timestamp/timestamp, tzdelta : std/time/timestamp/timespan) -> std/num/ddouble/ddouble>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_x57, _ctx);
      _x_x132 = kk_std_core_types__new_Nothing(_ctx); /*maybe<(t : std/time/timestamp/timestamp, tzdelta : std/time/timestamp/timespan) -> std/num/ddouble/ddouble>*/
    }
    kk_std_core_types__maybe _x_x133;
    kk_std_core_types__optional _match_x56 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
    if (kk_std_core_types__is_Optional(_match_x56, _ctx)) {
      kk_box_t _box_x4 = _match_x56._cons._Optional.value;
      kk_std_core_types__maybe _uniq_from_mjd2000_360 = kk_std_core_types__maybe_unbox(_box_x4, KK_BORROWED, _ctx);
      kk_std_core_types__maybe_dup(_uniq_from_mjd2000_360, _ctx);
      kk_std_core_types__optional_drop(_match_x56, _ctx);
      _x_x133 = _uniq_from_mjd2000_360; /*maybe<(days : int, frac : std/num/ddouble/ddouble) -> std/time/timestamp/timestamp>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_x56, _ctx);
      _x_x133 = kk_std_core_types__new_Nothing(_ctx); /*maybe<(days : int, frac : std/num/ddouble/ddouble) -> std/time/timestamp/timestamp>*/
    }
    kk_std_time_astro_ts_tcg = kk_std_time_instant__new_Timescale(kk_reuse_null, 0, _x_x123, _x_x125, kk_std_time_astro_new_ts_tcg_fun128(_ctx), kk_std_time_astro_new_ts_tcg_fun130(_ctx), _x_x131, _x_x132, _x_x133, _ctx); /*std/time/instant/timescale*/
  }
  {
    bool _match_x53;
    double _x_x134;
    kk_std_core_types__optional _match_x55 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
    if (kk_std_core_types__is_Optional(_match_x55, _ctx)) {
      kk_box_t _box_x5 = _match_x55._cons._Optional.value;
      double _uniq_frac_614 = kk_double_unbox(_box_x5, KK_BORROWED, _ctx);
      kk_std_core_types__optional_drop(_match_x55, _ctx);
      _x_x134 = _uniq_frac_614; /*float64*/
    }
    else {
      kk_std_core_types__optional_drop(_match_x55, _ctx);
      _x_x134 = 0x0p+0; /*float64*/
    }
    _match_x53 = (_x_x134 == (0x0p+0)); /*bool*/
    if (_match_x53) {
      kk_std_time_astro_j2k_epoch = kk_std_num_ddouble_ddouble_int_exp(kk_integer_from_int(43200, _ctx), kk_integer_from_small(0), _ctx); /*std/time/timestamp/timespan*/
    }
    else {
      kk_std_num_ddouble__ddouble _x_x135 = kk_std_num_ddouble_ddouble_int_exp(kk_integer_from_int(43200, _ctx), kk_integer_from_small(0), _ctx); /*std/num/ddouble/ddouble*/
      kk_std_num_ddouble__ddouble _x_x136;
      double _x_x137;
      kk_std_core_types__optional _match_x54 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
      if (kk_std_core_types__is_Optional(_match_x54, _ctx)) {
        kk_box_t _box_x6 = _match_x54._cons._Optional.value;
        double _uniq_frac_614_0 = kk_double_unbox(_box_x6, KK_BORROWED, _ctx);
        kk_std_core_types__optional_drop(_match_x54, _ctx);
        _x_x137 = _uniq_frac_614_0; /*float64*/
      }
      else {
        kk_std_core_types__optional_drop(_match_x54, _ctx);
        _x_x137 = 0x0p+0; /*float64*/
      }
      _x_x136 = kk_std_num_ddouble__new_Ddouble(_x_x137, 0x0p+0, _ctx); /*std/num/ddouble/ddouble*/
      kk_std_time_astro_j2k_epoch = kk_std_num_ddouble__lp__plus__rp_(_x_x135, _x_x136, _ctx); /*std/time/timestamp/timespan*/
    }
  }
  {
    kk_std_time_astro_ts_tdb = kk_std_time_astro_ts_tdb_create(kk_std_time_astro_new_ts_tdb_fun367(_ctx), _ctx); /*std/time/instant/timescale*/
  }
  {
    kk_integer_t _x_x368 = kk_integer_neg((kk_integer_from_small(19)),kk_context()); /*int*/
    kk_std_time_astro_lb = kk_std_num_ddouble_int_fs_ddouble_exp(kk_integer_from_str("155051976772", _ctx), _x_x368, _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_integer_t _x_x369 = kk_integer_neg((kk_integer_from_small(655)),kk_context()); /*int*/
    kk_integer_t _x_x370 = kk_integer_neg((kk_integer_from_small(7)),kk_context()); /*int*/
    kk_std_time_astro_tdb0 = kk_std_num_ddouble_int_fs_ddouble_exp(_x_x369, _x_x370, _ctx); /*std/num/ddouble/ddouble*/
  }
  {
    kk_std_time_instant__timescale _x_x418 = kk_std_time_instant__timescale_dup(kk_std_time_astro_ts_tdb, _ctx); /*std/time/instant/timescale*/
    kk_std_time_astro_ts_tcb = kk_std_time_astro_ts_tcb_create(_x_x418, _ctx); /*std/time/instant/timescale*/
  }
}

// termination
void kk_std_time_astro__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_time_instant__timescale_drop(kk_std_time_astro_ts_tcb, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_tdb0, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_lb, _ctx);
  kk_std_time_instant__timescale_drop(kk_std_time_astro_ts_tdb, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_j2k_epoch, _ctx);
  kk_std_time_instant__timescale_drop(kk_std_time_astro_ts_tcg, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_tcg_epoch_delta, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_lg, _ctx);
  kk_std_time_instant__instant_drop(kk_std_time_astro_epoch_j2000, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_offset_j2000, _ctx);
  kk_std_num_ddouble__ddouble_drop(kk_std_time_astro_secs_per_day, _ctx);
  kk_std_num_int32__done(_ctx);
  kk_std_time_calendars__done(_ctx);
  kk_std_time_utc__done(_ctx);
  kk_std_time_calendar__done(_ctx);
  kk_std_time_instant__done(_ctx);
  kk_std_time_duration__done(_ctx);
  kk_std_time_timestamp__done(_ctx);
  kk_std_num_ddouble__done(_ctx);
  kk_std_num_float64__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_console__done(_ctx);
  kk_std_core_delayed__done(_ctx);
  kk_std_core_debug__done(_ctx);
  kk_std_core_show__done(_ctx);
  kk_std_core_lazy__done(_ctx);
  kk_std_core_tuple__done(_ctx);
  kk_std_core_either__done(_ctx);
  kk_std_core_maybe2__done(_ctx);
  kk_std_core_maybe__done(_ctx);
  kk_std_core_list__done(_ctx);
  kk_std_core_sslice__done(_ctx);
  kk_std_core_string__done(_ctx);
  kk_std_core_vector__done(_ctx);
  kk_std_core_int__done(_ctx);
  kk_std_core_char__done(_ctx);
  kk_std_core_order__done(_ctx);
  kk_std_core_bool__done(_ctx);
  kk_std_core_exn__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
