// Koka generated module: std/core/list, koka version: 3.1.3, platform: 64-bit
#include "std_core_list.h"
 
// Return the head of list if the list is not empty.

kk_std_core_types__maybe kk_std_core_list_maybe_fs_head(kk_std_core_types__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> maybe<a> */ 
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1189 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1189->head;
    kk_std_core_types__list _pat_0 = _con_x1189->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core_types__list_drop(_pat_0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return kk_std_core_types__new_Just(x, _ctx);
  }
  {
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Return the head of list with a default value in case the list is empty.

kk_box_t kk_std_core_list_default_fs_head(kk_std_core_types__list xs, kk_box_t kkloc_default, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, default : a) -> a */ 
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1190 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1190->head;
    kk_std_core_types__list _pat_0 = _con_x1190->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core_types__list_drop(_pat_0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_drop(kkloc_default, _ctx);
    return x;
  }
  {
    return kkloc_default;
  }
}
 
// Return the tail of list. Returns the empty list if `xs` is empty.

kk_std_core_types__list kk_std_core_list_tail(kk_std_core_types__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> list<a> */ 
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1191 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _pat_0 = _con_x1191->head;
    kk_std_core_types__list xx = _con_x1191->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_pat_0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return xx;
  }
  {
    return kk_std_core_types__new_Nil(_ctx);
  }
}
 
// lifted local: length, len

kk_integer_t kk_std_core_list__lift_length_5423(kk_std_core_types__list ys, kk_integer_t acc, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, acc : int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1192 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t _pat_0 = _con_x1192->head;
    kk_std_core_types__list yy = _con_x1192->tail;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_box_drop(_pat_0, _ctx);
      kk_datatype_ptr_free(ys, _ctx);
    }
    else {
      kk_std_core_types__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    { // tailcall
      kk_integer_t _x_x1193 = kk_integer_add_small_const(acc, 1, _ctx); /*int*/
      ys = yy;
      acc = _x_x1193;
      goto kk__tailcall;
    }
  }
  {
    return acc;
  }
}
 
// Element-wise list equality

bool kk_std_core_list__lp__eq__eq__rp_(kk_std_core_types__list xs, kk_std_core_types__list ys, kk_function_t _implicit_fs__lp__eq__eq__rp_, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>, ?(==) : (a, a) -> bool) -> bool */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1194 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1194->head;
    kk_std_core_types__list xx = _con_x1194->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Nil(ys, _ctx)) {
      kk_std_core_types__list_drop(xx, _ctx);
      kk_box_drop(x, _ctx);
      kk_function_drop(_implicit_fs__lp__eq__eq__rp_, _ctx);
      return false;
    }
    {
      struct kk_std_core_types_Cons* _con_x1195 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t y = _con_x1195->head;
      kk_std_core_types__list yy = _con_x1195->tail;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        kk_datatype_ptr_free(ys, _ctx);
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core_types__list_dup(yy, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      bool _match_x1113;
      kk_function_t _x_x1196 = kk_function_dup(_implicit_fs__lp__eq__eq__rp_, _ctx); /*(785, 785) -> bool*/
      _match_x1113 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x_x1196, (_x_x1196, x, y, _ctx), _ctx); /*bool*/
      if (_match_x1113) { // tailcall
                          xs = xx;
                          ys = yy;
                          goto kk__tailcall;
      }
      {
        kk_std_core_types__list_drop(yy, _ctx);
        kk_std_core_types__list_drop(xx, _ctx);
        kk_function_drop(_implicit_fs__lp__eq__eq__rp_, _ctx);
        return false;
      }
    }
  }
  {
    kk_function_drop(_implicit_fs__lp__eq__eq__rp_, _ctx);
    if (kk_std_core_types__is_Nil(ys, _ctx)) {
      return true;
    }
    {
      struct kk_std_core_types_Cons* _con_x1197 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t _pat_7 = _con_x1197->head;
      kk_std_core_types__list _pat_8 = _con_x1197->tail;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        kk_std_core_types__list_drop(_pat_8, _ctx);
        kk_box_drop(_pat_7, _ctx);
        kk_datatype_ptr_free(ys, _ctx);
      }
      else {
        kk_datatype_ptr_decref(ys, _ctx);
      }
      return false;
    }
  }
}
 
// Order on lists

kk_std_core_types__order kk_std_core_list_cmp(kk_std_core_types__list xs, kk_std_core_types__list ys, kk_function_t _implicit_fs_cmp, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>, ?cmp : (a, a) -> order) -> order */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1198 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1198->head;
    kk_std_core_types__list xx = _con_x1198->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Nil(ys, _ctx)) {
      kk_std_core_types__list_drop(xx, _ctx);
      kk_box_drop(x, _ctx);
      kk_function_drop(_implicit_fs_cmp, _ctx);
      return kk_std_core_types__new_Gt(_ctx);
    }
    {
      struct kk_std_core_types_Cons* _con_x1199 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t y = _con_x1199->head;
      kk_std_core_types__list yy = _con_x1199->tail;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        kk_datatype_ptr_free(ys, _ctx);
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core_types__list_dup(yy, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_std_core_types__order _match_x1112;
      kk_function_t _x_x1200 = kk_function_dup(_implicit_fs_cmp, _ctx); /*(867, 867) -> order*/
      _match_x1112 = kk_function_call(kk_std_core_types__order, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x_x1200, (_x_x1200, x, y, _ctx), _ctx); /*order*/
      if (kk_std_core_types__is_Eq(_match_x1112, _ctx)) { // tailcall
                                                          xs = xx;
                                                          ys = yy;
                                                          goto kk__tailcall;
      }
      {
        kk_std_core_types__list_drop(yy, _ctx);
        kk_std_core_types__list_drop(xx, _ctx);
        kk_function_drop(_implicit_fs_cmp, _ctx);
        return _match_x1112;
      }
    }
  }
  {
    kk_function_drop(_implicit_fs_cmp, _ctx);
    if (kk_std_core_types__is_Nil(ys, _ctx)) {
      return kk_std_core_types__new_Eq(_ctx);
    }
    {
      struct kk_std_core_types_Cons* _con_x1201 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t _pat_6 = _con_x1201->head;
      kk_std_core_types__list _pat_7 = _con_x1201->tail;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        kk_std_core_types__list_drop(_pat_7, _ctx);
        kk_box_drop(_pat_6, _ctx);
        kk_datatype_ptr_free(ys, _ctx);
      }
      else {
        kk_datatype_ptr_decref(ys, _ctx);
      }
      return kk_std_core_types__new_Lt(_ctx);
    }
  }
}
 
// Take the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core_types__list kk_std_core_list__trmc_take(kk_std_core_types__list xs, kk_integer_t n, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1202 = kk_std_core_types__as_Cons(xs, _ctx);
    if (kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context())) {
      kk_box_t x = _con_x1202->head;
      kk_std_core_types__list xx = _con_x1202->tail;
      kk_reuse_t _ru_x1124 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        _ru_x1124 = (kk_datatype_ptr_reuse(xs, _ctx));
      }
      else {
        kk_box_dup(x, _ctx);
        kk_std_core_types__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_std_core_types__list _trmc_x10048 = kk_datatype_null(); /*list<919>*/;
      kk_std_core_types__list _trmc_x10049 = kk_std_core_types__new_Cons(_ru_x1124, 0, x, _trmc_x10048, _ctx); /*list<919>*/;
      kk_field_addr_t _b_x5_10 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10049, _ctx)->tail, _ctx); /*@field-addr<list<919>>*/;
      { // tailcall
        kk_integer_t _x_x1203 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        kk_std_core_types__cctx _x_x1204 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10049, _ctx)),_b_x5_10,kk_context()); /*ctx<0>*/
        xs = xx;
        n = _x_x1203;
        _acc = _x_x1204;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_std_core_types__list_drop(xs, _ctx);
    kk_integer_drop(n, _ctx);
    kk_box_t _x_x1205 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1205, KK_OWNED, _ctx);
  }
}
 
// Take the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core_types__list kk_std_core_list_take(kk_std_core_types__list xs_0, kk_integer_t n_0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> list<a> */ 
  kk_std_core_types__cctx _x_x1206 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_take(xs_0, n_0, _x_x1206, _ctx);
}
 
// Drop the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core_types__list kk_std_core_list_drop(kk_std_core_types__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1207 = kk_std_core_types__as_Cons(xs, _ctx);
    if (kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context())) {
      kk_box_t _pat_0 = _con_x1207->head;
      kk_std_core_types__list xx = _con_x1207->tail;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_box_drop(_pat_0, _ctx);
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_std_core_types__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      { // tailcall
        kk_integer_t _x_x1208 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        xs = xx;
        n = _x_x1208;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(n, _ctx);
    return xs;
  }
}

kk_std_core_types__list kk_std_core_list_reverse_acc(kk_std_core_types__list acc, kk_std_core_types__list ys, kk_context_t* _ctx) { /* forall<a> (acc : list<a>, ys : list<a>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1209 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t x = _con_x1209->head;
    kk_std_core_types__list xx = _con_x1209->tail;
    kk_reuse_t _ru_x1126 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1126 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    { // tailcall
      kk_std_core_types__list _x_x1210 = kk_std_core_types__new_Cons(_ru_x1126, 0, x, acc, _ctx); /*list<82>*/
      acc = _x_x1210;
      ys = xx;
      goto kk__tailcall;
    }
  }
  {
    return acc;
  }
}
 
// Append two lists.

kk_std_core_types__list kk_std_core_list__trmc_append(kk_std_core_types__list xs, kk_std_core_types__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1211 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1211->head;
    kk_std_core_types__list xx = _con_x1211->tail;
    kk_reuse_t _ru_x1127 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1127 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__list _trmc_x10050 = kk_datatype_null(); /*list<1071>*/;
    kk_std_core_types__list _trmc_x10051 = kk_std_core_types__new_Cons(_ru_x1127, 0, x, _trmc_x10050, _ctx); /*list<1071>*/;
    kk_field_addr_t _b_x21_26 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10051, _ctx)->tail, _ctx); /*@field-addr<list<1071>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1212 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10051, _ctx)),_b_x21_26,kk_context()); /*ctx<0>*/
      xs = xx;
      _acc = _x_x1212;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x_x1213 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(ys, _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1213, KK_OWNED, _ctx);
  }
}
 
// Append two lists.

kk_std_core_types__list kk_std_core_list_append(kk_std_core_types__list xs_0, kk_std_core_types__list ys_0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x_x1214 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_append(xs_0, ys_0, _x_x1214, _ctx);
}
 
// monadic lift

kk_box_t kk_std_core_list__mlift_foldl_10268(kk_function_t f, kk_std_core_types__list xx, kk_box_t _y_x10104, kk_context_t* _ctx) { /* forall<a,b,e> (f : (b, a) -> e b, xx : list<a>, b) -> e b */ 
  return kk_std_core_list_foldl(xx, _y_x10104, f, _ctx);
}
 
// Fold a list from the left, i.e. `foldl([1,2],0,(+)) == (0+1)+2`
// Since `foldl` is tail recursive, it is preferred over `foldr` when using an associative function `f`


// lift anonymous function
struct kk_std_core_list_foldl_fun1218__t {
  struct kk_function_s _base;
  kk_function_t f_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list_foldl_fun1218(kk_function_t _fself, kk_box_t _y_x10104_0, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_foldl_fun1218(kk_function_t f_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list_foldl_fun1218__t* _self = kk_function_alloc_as(struct kk_std_core_list_foldl_fun1218__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_foldl_fun1218, kk_context());
  _self->f_0 = f_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_foldl_fun1218(kk_function_t _fself, kk_box_t _y_x10104_0, kk_context_t* _ctx) {
  struct kk_std_core_list_foldl_fun1218__t* _self = kk_function_as(struct kk_std_core_list_foldl_fun1218__t*, _fself, _ctx);
  kk_function_t f_0 = _self->f_0; /* (1139, 1138) -> 1140 1139 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<1138> */
  kk_drop_match(_self, {kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  return kk_std_core_list__mlift_foldl_10268(f_0, xx_0, _y_x10104_0, _ctx);
}

kk_box_t kk_std_core_list_foldl(kk_std_core_types__list xs, kk_box_t z, kk_function_t f_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, z : b, f : (b, a) -> e b) -> e b */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1216 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1216->head;
    kk_std_core_types__list xx_0 = _con_x1216->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t x_0_10300;
    kk_function_t _x_x1217 = kk_function_dup(f_0, _ctx); /*(1139, 1138) -> 1140 1139*/
    x_0_10300 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x_x1217, (_x_x1217, z, x, _ctx), _ctx); /*1139*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_0_10300, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core_list_new_foldl_fun1218(f_0, xx_0, _ctx), _ctx);
    }
    { // tailcall
      xs = xx_0;
      z = x_0_10300;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(f_0, _ctx);
    return z;
  }
}
extern kk_box_t kk_std_core_list_foldr_fun1220(kk_function_t _fself, kk_box_t x, kk_box_t y, kk_context_t* _ctx) {
  struct kk_std_core_list_foldr_fun1220__t* _self = kk_function_as(struct kk_std_core_list_foldr_fun1220__t*, _fself, _ctx);
  kk_function_t f = _self->f; /* (1188, 1189) -> 1190 1189 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);}, {}, _ctx)
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, y, x, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_list_foldl1_fun1223__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_foldl1_fun1223(kk_function_t _fself, kk_box_t _b_x36, kk_box_t _b_x37, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_foldl1_fun1223(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_foldl1_fun1223, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_foldl1_fun1223(kk_function_t _fself, kk_box_t _b_x36, kk_box_t _b_x37, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x1224 = kk_string_unbox(_b_x36); /*string*/
  kk_std_core_types__optional _x_x1225 = kk_std_core_types__optional_unbox(_b_x37, KK_OWNED, _ctx); /*? exception-info*/
  return kk_std_core_exn_throw(_x_x1224, _x_x1225, _ctx);
}

kk_box_t kk_std_core_list_foldl1(kk_std_core_types__list xs, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, f : (a, a) -> <exn|e> a) -> <exn|e> a */ 
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1221 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1221->head;
    kk_std_core_types__list xx = _con_x1221->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return kk_std_core_list_foldl(xx, x, f, _ctx);
  }
  {
    kk_function_drop(f, _ctx);
    kk_ssize_t _b_x32_38;
    kk_std_core_hnd__htag _x_x1222 = kk_std_core_hnd__htag_dup(kk_std_core_exn_exn_fs__tag, _ctx); /*hnd/htag<exn>*/
    _b_x32_38 = kk_std_core_hnd__evv_index(_x_x1222, _ctx); /*hnd/ev-index*/
    kk_box_t _x_x1226;
    kk_string_t _x_x1227;
    kk_define_string_literal(, _s_x1228, 33, "unexpected Nil in std/core/foldl1", _ctx)
    _x_x1227 = kk_string_dup(_s_x1228, _ctx); /*string*/
    _x_x1226 = kk_string_box(_x_x1227); /*10314*/
    return kk_std_core_hnd__open_at2(_b_x32_38, kk_std_core_list_new_foldl1_fun1223(_ctx), _x_x1226, kk_std_core_types__optional_box(kk_std_core_types__new_None(_ctx), _ctx), _ctx);
  }
}


// lift anonymous function
struct kk_std_core_list_foldr1_fun1231__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_foldr1_fun1231(kk_function_t _fself, kk_box_t _b_x46, kk_box_t _b_x47, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_foldr1_fun1231(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_foldr1_fun1231, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_foldr1_fun1231(kk_function_t _fself, kk_box_t _b_x46, kk_box_t _b_x47, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x1232 = kk_string_unbox(_b_x46); /*string*/
  kk_std_core_types__optional _x_x1233 = kk_std_core_types__optional_unbox(_b_x47, KK_OWNED, _ctx); /*? exception-info*/
  return kk_std_core_exn_throw(_x_x1232, _x_x1233, _ctx);
}

kk_box_t kk_std_core_list_foldr1(kk_std_core_types__list xs, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, f : (a, a) -> <exn|e> a) -> <exn|e> a */ 
  kk_std_core_types__list xs_0_10010 = kk_std_core_list_reverse_acc(kk_std_core_types__new_Nil(_ctx), xs, _ctx); /*list<1278>*/;
  if (kk_std_core_types__is_Cons(xs_0_10010, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1229 = kk_std_core_types__as_Cons(xs_0_10010, _ctx);
    kk_box_t x = _con_x1229->head;
    kk_std_core_types__list xx = _con_x1229->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs_0_10010, _ctx)) {
      kk_datatype_ptr_free(xs_0_10010, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs_0_10010, _ctx);
    }
    return kk_std_core_list_foldl(xx, x, f, _ctx);
  }
  {
    kk_function_drop(f, _ctx);
    kk_ssize_t _b_x42_48;
    kk_std_core_hnd__htag _x_x1230 = kk_std_core_hnd__htag_dup(kk_std_core_exn_exn_fs__tag, _ctx); /*hnd/htag<exn>*/
    _b_x42_48 = kk_std_core_hnd__evv_index(_x_x1230, _ctx); /*hnd/ev-index*/
    kk_box_t _x_x1234;
    kk_string_t _x_x1235;
    kk_define_string_literal(, _s_x1236, 33, "unexpected Nil in std/core/foldl1", _ctx)
    _x_x1235 = kk_string_dup(_s_x1236, _ctx); /*string*/
    _x_x1234 = kk_string_box(_x_x1235); /*10314*/
    return kk_std_core_hnd__open_at2(_b_x42_48, kk_std_core_list_new_foldr1_fun1231(_ctx), _x_x1234, kk_std_core_types__optional_box(kk_std_core_types__new_None(_ctx), _ctx), _ctx);
  }
}
 
// split a list at position `n`

kk_std_core_types__tuple2 kk_std_core_list_split(kk_std_core_types__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> (list<a>, list<a>) */ 
  kk_std_core_types__list _b_x52_54;
  kk_std_core_types__list _x_x1237 = kk_std_core_types__list_dup(xs, _ctx); /*list<1318>*/
  kk_integer_t _x_x1238 = kk_integer_dup(n, _ctx); /*int*/
  kk_std_core_types__cctx _x_x1239 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  _b_x52_54 = kk_std_core_list__trmc_take(_x_x1237, _x_x1238, _x_x1239, _ctx); /*list<1318>*/
  kk_std_core_types__list _b_x53_55 = kk_std_core_list_drop(xs, n, _ctx); /*list<1318>*/;
  return kk_std_core_types__new_Tuple2(kk_std_core_types__list_box(_b_x52_54, _ctx), kk_std_core_types__list_box(_b_x53_55, _ctx), _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_drop_while_10269(kk_function_t predicate, kk_std_core_types__list xs, kk_std_core_types__list xx, bool _y_x10115, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xs : list<a>, xx : list<a>, bool) -> e list<a> */ 
  if (_y_x10115) {
    kk_std_core_types__list_drop(xs, _ctx);
    return kk_std_core_list_drop_while(xx, predicate, _ctx);
  }
  {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return xs;
  }
}
 
// Drop all initial elements that satisfy `predicate`


// lift anonymous function
struct kk_std_core_list_drop_while_fun1243__t {
  struct kk_function_s _base;
  kk_function_t predicate_0;
  kk_std_core_types__list xs_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list_drop_while_fun1243(kk_function_t _fself, kk_box_t _b_x57, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_drop_while_fun1243(kk_function_t predicate_0, kk_std_core_types__list xs_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list_drop_while_fun1243__t* _self = kk_function_alloc_as(struct kk_std_core_list_drop_while_fun1243__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_drop_while_fun1243, kk_context());
  _self->predicate_0 = predicate_0;
  _self->xs_0 = xs_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_drop_while_fun1243(kk_function_t _fself, kk_box_t _b_x57, kk_context_t* _ctx) {
  struct kk_std_core_list_drop_while_fun1243__t* _self = kk_function_as(struct kk_std_core_list_drop_while_fun1243__t*, _fself, _ctx);
  kk_function_t predicate_0 = _self->predicate_0; /* (1362) -> 1363 bool */
  kk_std_core_types__list xs_0 = _self->xs_0; /* list<1362> */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<1362> */
  kk_drop_match(_self, {kk_function_dup(predicate_0, _ctx);kk_std_core_types__list_dup(xs_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10115_0_59 = kk_bool_unbox(_b_x57); /*bool*/;
  kk_std_core_types__list _x_x1244 = kk_std_core_list__mlift_drop_while_10269(predicate_0, xs_0, xx_0, _y_x10115_0_59, _ctx); /*list<1362>*/
  return kk_std_core_types__list_box(_x_x1244, _ctx);
}

kk_std_core_types__list kk_std_core_list_drop_while(kk_std_core_types__list xs_0, kk_function_t predicate_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs_0, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1240 = kk_std_core_types__as_Cons(xs_0, _ctx);
    kk_box_t x = _con_x1240->head;
    kk_std_core_types__list xx_0 = _con_x1240->tail;
    kk_box_dup(x, _ctx);
    kk_std_core_types__list_dup(xx_0, _ctx);
    bool x_0_10305;
    kk_function_t _x_x1241 = kk_function_dup(predicate_0, _ctx); /*(1362) -> 1363 bool*/
    x_0_10305 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1241, (_x_x1241, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1242 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_drop_while_fun1243(predicate_0, xs_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1242, KK_OWNED, _ctx);
    }
    if (x_0_10305) {
      if kk_likely(kk_datatype_ptr_is_unique(xs_0, _ctx)) {
        kk_std_core_types__list_drop(xx_0, _ctx);
        kk_box_drop(x, _ctx);
        kk_datatype_ptr_free(xs_0, _ctx);
      }
      else {
        kk_datatype_ptr_decref(xs_0, _ctx);
      }
      { // tailcall
        xs_0 = xx_0;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(predicate_0, _ctx);
      return xs_0;
    }
  }
  {
    kk_function_drop(predicate_0, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_filter_10270(kk_std_core_types__cctx _acc, kk_function_t pred, kk_box_t x, kk_std_core_types__list xx, bool _y_x10119, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, pred : (a) -> e bool, x : a, xx : list<a>, bool) -> e list<a> */ 
  if (_y_x10119) {
    kk_std_core_types__list _trmc_x10052 = kk_datatype_null(); /*list<1424>*/;
    kk_std_core_types__list _trmc_x10053 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _trmc_x10052, _ctx); /*list<1424>*/;
    kk_field_addr_t _b_x65_68 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10053, _ctx)->tail, _ctx); /*@field-addr<list<1424>>*/;
    kk_std_core_types__cctx _x_x1245 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10053, _ctx)),_b_x65_68,kk_context()); /*ctx<0>*/
    return kk_std_core_list__trmc_filter(xx, pred, _x_x1245, _ctx);
  }
  {
    kk_box_drop(x, _ctx);
    return kk_std_core_list__trmc_filter(xx, pred, _acc, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filter([1,2,3],odd?) == [1,3]`


// lift anonymous function
struct kk_std_core_list__trmc_filter_fun1250__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t pred_0;
  kk_box_t x_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_filter_fun1250(kk_function_t _fself, kk_box_t _b_x73, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_filter_fun1250(kk_std_core_types__cctx _acc_0, kk_function_t pred_0, kk_box_t x_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_filter_fun1250__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_filter_fun1250__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_filter_fun1250, kk_context());
  _self->_acc_0 = _acc_0;
  _self->pred_0 = pred_0;
  _self->x_0 = x_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_filter_fun1250(kk_function_t _fself, kk_box_t _b_x73, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_filter_fun1250__t* _self = kk_function_as(struct kk_std_core_list__trmc_filter_fun1250__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<1424>> */
  kk_function_t pred_0 = _self->pred_0; /* (1424) -> 1425 bool */
  kk_box_t x_0 = _self->x_0; /* 1424 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<1424> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(pred_0, _ctx);kk_box_dup(x_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10119_0_91 = kk_bool_unbox(_b_x73); /*bool*/;
  kk_std_core_types__list _x_x1251 = kk_std_core_list__mlift_trmc_filter_10270(_acc_0, pred_0, x_0, xx_0, _y_x10119_0_91, _ctx); /*list<1424>*/
  return kk_std_core_types__list_box(_x_x1251, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_filter(kk_std_core_types__list xs, kk_function_t pred_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1246 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x_0 = _con_x1246->head;
    kk_std_core_types__list xx_0 = _con_x1246->tail;
    kk_reuse_t _ru_x1132 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1132 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x_0, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_1_10308;
    kk_function_t _x_x1248 = kk_function_dup(pred_0, _ctx); /*(1424) -> 1425 bool*/
    kk_box_t _x_x1247 = kk_box_dup(x_0, _ctx); /*1424*/
    x_1_10308 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1248, (_x_x1248, _x_x1247, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1132,kk_context());
      kk_box_t _x_x1249 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_filter_fun1250(_acc_0, pred_0, x_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1249, KK_OWNED, _ctx);
    }
    if (x_1_10308) {
      kk_std_core_types__list _trmc_x10052_0 = kk_datatype_null(); /*list<1424>*/;
      kk_std_core_types__list _trmc_x10053_0 = kk_std_core_types__new_Cons(_ru_x1132, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0, _trmc_x10052_0, _ctx); /*list<1424>*/;
      kk_field_addr_t _b_x79_85 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10053_0, _ctx)->tail, _ctx); /*@field-addr<list<1424>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1252 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10053_0, _ctx)),_b_x79_85,kk_context()); /*ctx<0>*/
        xs = xx_0;
        _acc_0 = _x_x1252;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_x1132,kk_context());
      kk_box_drop(x_0, _ctx);
      { // tailcall
        xs = xx_0;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(pred_0, _ctx);
    kk_box_t _x_x1253 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1253, KK_OWNED, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filter([1,2,3],odd?) == [1,3]`

kk_std_core_types__list kk_std_core_list_filter(kk_std_core_types__list xs_0, kk_function_t pred_1, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool) -> e list<a> */ 
  kk_std_core_types__cctx _x_x1254 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_filter(xs_0, pred_1, _x_x1254, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_filter_map_10271(kk_std_core_types__cctx _acc, kk_function_t pred, kk_std_core_types__list xx, kk_std_core_types__maybe _y_x10125, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, pred : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Nothing(_y_x10125, _ctx)) {
    return kk_std_core_list__trmc_filter_map(xx, pred, _acc, _ctx);
  }
  {
    kk_box_t y = _y_x10125._cons.Just.value;
    kk_std_core_types__list _trmc_x10054 = kk_datatype_null(); /*list<1504>*/;
    kk_std_core_types__list _trmc_x10055 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _trmc_x10054, _ctx); /*list<1504>*/;
    kk_field_addr_t _b_x97_100 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10055, _ctx)->tail, _ctx); /*@field-addr<list<1504>>*/;
    kk_std_core_types__cctx _x_x1255 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10055, _ctx)),_b_x97_100,kk_context()); /*ctx<0>*/
    return kk_std_core_list__trmc_filter_map(xx, pred, _x_x1255, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filterMap([1,2,3],fn(i) { if i.odd? then Nothing else Just(i*i) }) == [4]`


// lift anonymous function
struct kk_std_core_list__trmc_filter_map_fun1260__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t pred_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_filter_map_fun1260(kk_function_t _fself, kk_box_t _b_x107, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_filter_map_fun1260(kk_std_core_types__cctx _acc_0, kk_function_t pred_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_filter_map_fun1260__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_filter_map_fun1260__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_filter_map_fun1260, kk_context());
  _self->_acc_0 = _acc_0;
  _self->pred_0 = pred_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_filter_map_fun1260(kk_function_t _fself, kk_box_t _b_x107, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_filter_map_fun1260__t* _self = kk_function_as(struct kk_std_core_list__trmc_filter_map_fun1260__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<1504>> */
  kk_function_t pred_0 = _self->pred_0; /* (1503) -> 1505 maybe<1504> */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<1503> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(pred_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_x10125_0_123 = kk_std_core_types__maybe_unbox(_b_x107, KK_OWNED, _ctx); /*maybe<1504>*/;
  kk_std_core_types__list _x_x1261 = kk_std_core_list__mlift_trmc_filter_map_10271(_acc_0, pred_0, xx_0, _y_x10125_0_123, _ctx); /*list<1504>*/
  return kk_std_core_types__list_box(_x_x1261, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_filter_map(kk_std_core_types__list xs, kk_function_t pred_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, pred : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_function_drop(pred_0, _ctx);
    kk_box_t _x_x1256 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1256, KK_OWNED, _ctx);
  }
  {
    struct kk_std_core_types_Cons* _con_x1257 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1257->head;
    kk_std_core_types__list xx_0 = _con_x1257->tail;
    kk_reuse_t _ru_x1133 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1133 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x_0_10311;
    kk_function_t _x_x1258 = kk_function_dup(pred_0, _ctx); /*(1503) -> 1505 maybe<1504>*/
    x_0_10311 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x_x1258, (_x_x1258, x, _ctx), _ctx); /*maybe<1504>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1133,kk_context());
      kk_std_core_types__maybe_drop(x_0_10311, _ctx);
      kk_box_t _x_x1259 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_filter_map_fun1260(_acc_0, pred_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1259, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x_0_10311, _ctx)) {
      kk_reuse_drop(_ru_x1133,kk_context());
      { // tailcall
        xs = xx_0;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t y_0 = x_0_10311._cons.Just.value;
      kk_std_core_types__list _trmc_x10054_0 = kk_datatype_null(); /*list<1504>*/;
      kk_std_core_types__list _trmc_x10055_0 = kk_std_core_types__new_Cons(_ru_x1133, kk_field_index_of(struct kk_std_core_types_Cons, tail), y_0, _trmc_x10054_0, _ctx); /*list<1504>*/;
      kk_field_addr_t _b_x113_119 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10055_0, _ctx)->tail, _ctx); /*@field-addr<list<1504>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1262 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10055_0, _ctx)),_b_x113_119,kk_context()); /*ctx<0>*/
        xs = xx_0;
        _acc_0 = _x_x1262;
        goto kk__tailcall;
      }
    }
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filterMap([1,2,3],fn(i) { if i.odd? then Nothing else Just(i*i) }) == [4]`

kk_std_core_types__list kk_std_core_list_filter_map(kk_std_core_types__list xs_0, kk_function_t pred_1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, pred : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1263 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_filter_map(xs_0, pred_1, _x_x1263, _ctx);
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core_list__mlift_foreach_while_10272(kk_function_t action, kk_std_core_types__list xx, kk_std_core_types__maybe _y_x10131, kk_context_t* _ctx) { /* forall<a,b,e> (action : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e maybe<b> */ 
  if (kk_std_core_types__is_Nothing(_y_x10131, _ctx)) {
    return kk_std_core_list_foreach_while(xx, action, _ctx);
  }
  {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(action, _ctx);
    return _y_x10131;
  }
}
 
// Invoke `action` for each element of a list while `action` return `Nothing`


// lift anonymous function
struct kk_std_core_list_foreach_while_fun1267__t {
  struct kk_function_s _base;
  kk_function_t action_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list_foreach_while_fun1267(kk_function_t _fself, kk_box_t _b_x125, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_foreach_while_fun1267(kk_function_t action_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list_foreach_while_fun1267__t* _self = kk_function_alloc_as(struct kk_std_core_list_foreach_while_fun1267__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_foreach_while_fun1267, kk_context());
  _self->action_0 = action_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_foreach_while_fun1267(kk_function_t _fself, kk_box_t _b_x125, kk_context_t* _ctx) {
  struct kk_std_core_list_foreach_while_fun1267__t* _self = kk_function_as(struct kk_std_core_list_foreach_while_fun1267__t*, _fself, _ctx);
  kk_function_t action_0 = _self->action_0; /* (1575) -> 1577 maybe<1576> */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<1575> */
  kk_drop_match(_self, {kk_function_dup(action_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_x10131_0_127 = kk_std_core_types__maybe_unbox(_b_x125, KK_OWNED, _ctx); /*maybe<1576>*/;
  kk_std_core_types__maybe _x_x1268 = kk_std_core_list__mlift_foreach_while_10272(action_0, xx_0, _y_x10131_0_127, _ctx); /*maybe<1576>*/
  return kk_std_core_types__maybe_box(_x_x1268, _ctx);
}

kk_std_core_types__maybe kk_std_core_list_foreach_while(kk_std_core_types__list xs, kk_function_t action_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>) -> e maybe<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_function_drop(action_0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    struct kk_std_core_types_Cons* _con_x1264 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1264->head;
    kk_std_core_types__list xx_0 = _con_x1264->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x_0_10314;
    kk_function_t _x_x1265 = kk_function_dup(action_0, _ctx); /*(1575) -> 1577 maybe<1576>*/
    x_0_10314 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x_x1265, (_x_x1265, x, _ctx), _ctx); /*maybe<1576>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x_0_10314, _ctx);
      kk_box_t _x_x1266 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_foreach_while_fun1267(action_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__maybe_unbox(_x_x1266, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x_0_10314, _ctx)) { // tailcall
                                                          xs = xx_0;
                                                          goto kk__tailcall;
    }
    {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(action_0, _ctx);
      return x_0_10314;
    }
  }
}
 
// Find the first element satisfying some predicate


// lift anonymous function
struct kk_std_core_list_find_fun1269__t {
  struct kk_function_s _base;
  kk_function_t pred;
};
static kk_std_core_types__maybe kk_std_core_list_find_fun1269(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_find_fun1269(kk_function_t pred, kk_context_t* _ctx) {
  struct kk_std_core_list_find_fun1269__t* _self = kk_function_alloc_as(struct kk_std_core_list_find_fun1269__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_find_fun1269, kk_context());
  _self->pred = pred;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_list_find_fun1272__t {
  struct kk_function_s _base;
  kk_box_t x;
};
static kk_box_t kk_std_core_list_find_fun1272(kk_function_t _fself, kk_box_t _b_x129, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_find_fun1272(kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_list_find_fun1272__t* _self = kk_function_alloc_as(struct kk_std_core_list_find_fun1272__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_find_fun1272, kk_context());
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_find_fun1272(kk_function_t _fself, kk_box_t _b_x129, kk_context_t* _ctx) {
  struct kk_std_core_list_find_fun1272__t* _self = kk_function_as(struct kk_std_core_list_find_fun1272__t*, _fself, _ctx);
  kk_box_t x = _self->x; /* 1641 */
  kk_drop_match(_self, {kk_box_dup(x, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _x_x1273;
  bool _y_x10135_131 = kk_bool_unbox(_b_x129); /*bool*/;
  if (_y_x10135_131) {
    _x_x1273 = kk_std_core_types__new_Just(x, _ctx); /*maybe<91>*/
  }
  else {
    kk_box_drop(x, _ctx);
    _x_x1273 = kk_std_core_types__new_Nothing(_ctx); /*maybe<91>*/
  }
  return kk_std_core_types__maybe_box(_x_x1273, _ctx);
}
static kk_std_core_types__maybe kk_std_core_list_find_fun1269(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_list_find_fun1269__t* _self = kk_function_as(struct kk_std_core_list_find_fun1269__t*, _fself, _ctx);
  kk_function_t pred = _self->pred; /* (1641) -> 1642 bool */
  kk_drop_match(_self, {kk_function_dup(pred, _ctx);}, {}, _ctx)
  bool x_0_10317;
  kk_box_t _x_x1270 = kk_box_dup(x, _ctx); /*1641*/
  x_0_10317 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), pred, (pred, _x_x1270, _ctx), _ctx); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1271 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_find_fun1272(x, _ctx), _ctx); /*2401*/
    return kk_std_core_types__maybe_unbox(_x_x1271, KK_OWNED, _ctx);
  }
  if (x_0_10317) {
    return kk_std_core_types__new_Just(x, _ctx);
  }
  {
    kk_box_drop(x, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}

kk_std_core_types__maybe kk_std_core_list_find(kk_std_core_types__list xs, kk_function_t pred, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool) -> e maybe<a> */ 
  return kk_std_core_list_foreach_while(xs, kk_std_core_list_new_find_fun1269(pred, _ctx), _ctx);
}
 
// Returns an integer list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_range_fs__trmc_list(kk_integer_t lo, kk_integer_t hi, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (lo : int, hi : int, ctx<list<int>>) -> list<int> */ 
  kk__tailcall: ;
  bool _match_x1105 = kk_integer_lte_borrow(lo,hi,kk_context()); /*bool*/;
  if (_match_x1105) {
    kk_std_core_types__list _trmc_x10056 = kk_datatype_null(); /*list<int>*/;
    kk_std_core_types__list _trmc_x10057;
    kk_box_t _x_x1274;
    kk_integer_t _x_x1275 = kk_integer_dup(lo, _ctx); /*int*/
    _x_x1274 = kk_integer_box(_x_x1275, _ctx); /*82*/
    _trmc_x10057 = kk_std_core_types__new_Cons(kk_reuse_null, 0, _x_x1274, _trmc_x10056, _ctx); /*list<int>*/
    kk_field_addr_t _b_x142_147 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10057, _ctx)->tail, _ctx); /*@field-addr<list<int>>*/;
    { // tailcall
      kk_integer_t _x_x1276 = kk_integer_add_small_const(lo, 1, _ctx); /*int*/
      kk_std_core_types__cctx _x_x1277 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10057, _ctx)),_b_x142_147,kk_context()); /*ctx<0>*/
      lo = _x_x1276;
      _acc = _x_x1277;
      goto kk__tailcall;
    }
  }
  {
    kk_integer_drop(lo, _ctx);
    kk_integer_drop(hi, _ctx);
    kk_box_t _x_x1278 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1278, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_range_fs_list(kk_integer_t lo_0, kk_integer_t hi_0, kk_context_t* _ctx) { /* (lo : int, hi : int) -> list<int> */ 
  kk_std_core_types__cctx _x_x1279 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list_range_fs__trmc_list(lo_0, hi_0, _x_x1279, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_map_10274(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core_types__list xx, kk_box_t _trmc_x10058, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e b, xx : list<a>, b) -> e list<b> */ 
  kk_std_core_types__list _trmc_x10059 = kk_datatype_null(); /*list<2106>*/;
  kk_std_core_types__list _trmc_x10060 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10058, _trmc_x10059, _ctx); /*list<2106>*/;
  kk_field_addr_t _b_x158_161 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10060, _ctx)->tail, _ctx); /*@field-addr<list<2106>>*/;
  kk_std_core_types__cctx _own_x1103 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10060, _ctx)),_b_x158_161,kk_context()); /*ctx<0>*/;
  kk_std_core_types__list _brw_x1104 = kk_std_core_list__trmc_map(xx, f, _own_x1103, _ctx); /*list<2106>*/;
  kk_function_drop(f, _ctx);
  return _brw_x1104;
}
 
// Apply a function `f` to each element of the input list in sequence.


// lift anonymous function
struct kk_std_core_list__trmc_map_fun1284__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_map_fun1284(kk_function_t _fself, kk_box_t _b_x166, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_map_fun1284(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_map_fun1284__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_map_fun1284__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_map_fun1284, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_map_fun1284(kk_function_t _fself, kk_box_t _b_x166, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_map_fun1284__t* _self = kk_function_as(struct kk_std_core_list__trmc_map_fun1284__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2106>> */
  kk_function_t f_0 = _self->f_0; /* (2105) -> 2107 2106 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<2105> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10058_0_184 = _b_x166; /*2106*/;
  kk_std_core_types__list _x_x1285 = kk_std_core_list__mlift_trmc_map_10274(_acc_0, f_0, xx_0, _trmc_x10058_0_184, _ctx); /*list<2106>*/
  return kk_std_core_types__list_box(_x_x1285, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_map(kk_std_core_types__list xs, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e b, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1280 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1280->head;
    kk_std_core_types__list xx_0 = _con_x1280->tail;
    kk_reuse_t _ru_x1135 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1135 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t x_0_10321;
    kk_function_t _x_x1281 = kk_function_dup(f_0, _ctx); /*(2105) -> 2107 2106*/
    x_0_10321 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x_x1281, (_x_x1281, x, _ctx), _ctx); /*2106*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1135,kk_context());
      kk_box_drop(x_0_10321, _ctx);
      kk_box_t _x_x1282;
      kk_function_t _x_x1283;
      kk_function_dup(f_0, _ctx);
      _x_x1283 = kk_std_core_list__new_trmc_map_fun1284(_acc_0, f_0, xx_0, _ctx); /*(2400) -> 2402 2401*/
      _x_x1282 = kk_std_core_hnd_yield_extend(_x_x1283, _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1282, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10059_0 = kk_datatype_null(); /*list<2106>*/;
      kk_std_core_types__list _trmc_x10060_0 = kk_std_core_types__new_Cons(_ru_x1135, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0_10321, _trmc_x10059_0, _ctx); /*list<2106>*/;
      kk_field_addr_t _b_x172_178 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10060_0, _ctx)->tail, _ctx); /*@field-addr<list<2106>>*/;
      kk_std_core_types__cctx _own_x1102 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10060_0, _ctx)),_b_x172_178,kk_context()); /*ctx<0>*/;
      { // tailcall
        xs = xx_0;
        _acc_0 = _own_x1102;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_box_t _x_x1286 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1286, KK_OWNED, _ctx);
  }
}
 
// Apply a function `f` to each element of the input list in sequence.

kk_std_core_types__list kk_std_core_list_map(kk_std_core_types__list xs_0, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e b) -> e list<b> */ 
  kk_std_core_types__cctx _own_x1100 = kk_cctx_empty(kk_context()); /*ctx<0>*/;
  return kk_std_core_list__trmc_map(xs_0, f_1, _own_x1100, _ctx);
}
 
// Create a list of characters from `lo`  to `hi`  (including `hi`).


// lift anonymous function
struct kk_std_core_list_char_fs_list_fun1288__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_char_fs_list_fun1288(kk_function_t _fself, kk_box_t _b_x188, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_char_fs_new_list_fun1288(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_char_fs_list_fun1288, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_char_fs_list_fun1288(kk_function_t _fself, kk_box_t _b_x188, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_char_t _x_x1289;
  kk_integer_t _x_x1290 = kk_integer_unbox(_b_x188, _ctx); /*int*/
  _x_x1289 = kk_integer_clamp32(_x_x1290,kk_context()); /*char*/
  return kk_char_box(_x_x1289, _ctx);
}

kk_std_core_types__list kk_std_core_list_char_fs_list(kk_char_t lo, kk_char_t hi, kk_context_t* _ctx) { /* (lo : char, hi : char) -> list<char> */ 
  kk_integer_t lo_0_10326 = kk_integer_from_int(lo,kk_context()); /*int*/;
  kk_integer_t hi_0_10327 = kk_integer_from_int(hi,kk_context()); /*int*/;
  kk_std_core_types__list xs_10324;
  kk_std_core_types__cctx _x_x1287 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  xs_10324 = kk_std_core_list_range_fs__trmc_list(lo_0_10326, hi_0_10327, _x_x1287, _ctx); /*list<int>*/
  kk_std_core_types__cctx _b_x187_191 = kk_cctx_empty(kk_context()); /*ctx<list<char>>*/;
  kk_function_t _brw_x1098 = kk_std_core_list_char_fs_new_list_fun1288(_ctx); /*(2105) -> 2107 2106*/;
  kk_std_core_types__list _brw_x1099 = kk_std_core_list__trmc_map(xs_10324, _brw_x1098, _b_x187_191, _ctx); /*list<2106>*/;
  kk_function_drop(_brw_x1098, _ctx);
  return _brw_x1099;
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list_function_fs__mlift_trmc_list_10275(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t hi, kk_integer_t lo, kk_box_t _trmc_x10061, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, f : (int) -> e a, hi : int, lo : int, a) -> e list<a> */ 
  kk_std_core_types__list _trmc_x10062 = kk_datatype_null(); /*list<1837>*/;
  kk_std_core_types__list _trmc_x10063 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10061, _trmc_x10062, _ctx); /*list<1837>*/;
  kk_field_addr_t _b_x197_200 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10063, _ctx)->tail, _ctx); /*@field-addr<list<1837>>*/;
  kk_integer_t _x_x1291 = kk_integer_add_small_const(lo, 1, _ctx); /*int*/
  kk_std_core_types__cctx _x_x1292 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10063, _ctx)),_b_x197_200,kk_context()); /*ctx<0>*/
  return kk_std_core_list_function_fs__trmc_list(_x_x1291, hi, f, _x_x1292, _ctx);
}
 
// Applies a function `f` to list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.


// lift anonymous function
struct kk_std_core_list_function_fs__trmc_list_fun1296__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_integer_t hi_0;
  kk_integer_t lo_0;
};
static kk_box_t kk_std_core_list_function_fs__trmc_list_fun1296(kk_function_t _fself, kk_box_t _b_x205, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_function_fs__new_trmc_list_fun1296(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_integer_t hi_0, kk_integer_t lo_0, kk_context_t* _ctx) {
  struct kk_std_core_list_function_fs__trmc_list_fun1296__t* _self = kk_function_alloc_as(struct kk_std_core_list_function_fs__trmc_list_fun1296__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_function_fs__trmc_list_fun1296, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->hi_0 = hi_0;
  _self->lo_0 = lo_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_function_fs__trmc_list_fun1296(kk_function_t _fself, kk_box_t _b_x205, kk_context_t* _ctx) {
  struct kk_std_core_list_function_fs__trmc_list_fun1296__t* _self = kk_function_as(struct kk_std_core_list_function_fs__trmc_list_fun1296__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<1837>> */
  kk_function_t f_0 = _self->f_0; /* (int) -> 1838 1837 */
  kk_integer_t hi_0 = _self->hi_0; /* int */
  kk_integer_t lo_0 = _self->lo_0; /* int */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_integer_dup(hi_0, _ctx);kk_integer_dup(lo_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10061_0_223 = _b_x205; /*1837*/;
  kk_std_core_types__list _x_x1297 = kk_std_core_list_function_fs__mlift_trmc_list_10275(_acc_0, f_0, hi_0, lo_0, _trmc_x10061_0_223, _ctx); /*list<1837>*/
  return kk_std_core_types__list_box(_x_x1297, _ctx);
}

kk_std_core_types__list kk_std_core_list_function_fs__trmc_list(kk_integer_t lo_0, kk_integer_t hi_0, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, f : (int) -> e a, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  bool _match_x1096 = kk_integer_lte_borrow(lo_0,hi_0,kk_context()); /*bool*/;
  if (_match_x1096) {
    kk_box_t x_10328;
    kk_function_t _x_x1294 = kk_function_dup(f_0, _ctx); /*(int) -> 1838 1837*/
    kk_integer_t _x_x1293 = kk_integer_dup(lo_0, _ctx); /*int*/
    x_10328 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_context_t*), _x_x1294, (_x_x1294, _x_x1293, _ctx), _ctx); /*1837*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_10328, _ctx);
      kk_box_t _x_x1295 = kk_std_core_hnd_yield_extend(kk_std_core_list_function_fs__new_trmc_list_fun1296(_acc_0, f_0, hi_0, lo_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1295, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10062_0 = kk_datatype_null(); /*list<1837>*/;
      kk_std_core_types__list _trmc_x10063_0 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_10328, _trmc_x10062_0, _ctx); /*list<1837>*/;
      kk_field_addr_t _b_x211_217 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10063_0, _ctx)->tail, _ctx); /*@field-addr<list<1837>>*/;
      { // tailcall
        kk_integer_t _x_x1298 = kk_integer_add_small_const(lo_0, 1, _ctx); /*int*/
        kk_std_core_types__cctx _x_x1299 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10063_0, _ctx)),_b_x211_217,kk_context()); /*ctx<0>*/
        lo_0 = _x_x1298;
        _acc_0 = _x_x1299;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(lo_0, _ctx);
    kk_integer_drop(hi_0, _ctx);
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1300 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1300, KK_OWNED, _ctx);
  }
}
 
// Applies a function `f` to list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_function_fs_list(kk_integer_t lo_1, kk_integer_t hi_1, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, f : (int) -> e a) -> e list<a> */ 
  kk_std_core_types__cctx _x_x1301 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list_function_fs__trmc_list(lo_1, hi_1, f_1, _x_x1301, _ctx);
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_stride_fs__trmc_list(kk_integer_t lo, kk_integer_t hi, kk_integer_t stride, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (lo : int, hi : int, stride : int, ctx<list<int>>) -> list<int> */ 
  kk__tailcall: ;
  bool _match_x1095 = kk_integer_lte_borrow(lo,hi,kk_context()); /*bool*/;
  if (_match_x1095) {
    kk_std_core_types__list _trmc_x10064 = kk_datatype_null(); /*list<int>*/;
    kk_std_core_types__list _trmc_x10065;
    kk_box_t _x_x1302;
    kk_integer_t _x_x1303 = kk_integer_dup(lo, _ctx); /*int*/
    _x_x1302 = kk_integer_box(_x_x1303, _ctx); /*82*/
    _trmc_x10065 = kk_std_core_types__new_Cons(kk_reuse_null, 0, _x_x1302, _trmc_x10064, _ctx); /*list<int>*/
    kk_field_addr_t _b_x233_238 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10065, _ctx)->tail, _ctx); /*@field-addr<list<int>>*/;
    { // tailcall
      kk_integer_t _x_x1304;
      kk_integer_t _x_x1305 = kk_integer_dup(stride, _ctx); /*int*/
      _x_x1304 = kk_integer_add(lo,_x_x1305,kk_context()); /*int*/
      kk_std_core_types__cctx _x_x1306 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10065, _ctx)),_b_x233_238,kk_context()); /*ctx<0>*/
      lo = _x_x1304;
      _acc = _x_x1306;
      goto kk__tailcall;
    }
  }
  {
    kk_integer_drop(stride, _ctx);
    kk_integer_drop(lo, _ctx);
    kk_integer_drop(hi, _ctx);
    kk_box_t _x_x1307 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1307, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_stride_fs_list(kk_integer_t lo_0, kk_integer_t hi_0, kk_integer_t stride_0, kk_context_t* _ctx) { /* (lo : int, hi : int, stride : int) -> list<int> */ 
  kk_std_core_types__cctx _x_x1308 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list_stride_fs__trmc_list(lo_0, hi_0, stride_0, _x_x1308, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list_stridefunction_fs__mlift_trmc_list_10276(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t hi, kk_integer_t lo, kk_integer_t stride, kk_box_t _trmc_x10066, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, f : (int) -> e a, hi : int, lo : int, stride : int, a) -> e list<a> */ 
  kk_std_core_types__list _trmc_x10067 = kk_datatype_null(); /*list<2001>*/;
  kk_std_core_types__list _trmc_x10068 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10066, _trmc_x10067, _ctx); /*list<2001>*/;
  kk_field_addr_t _b_x249_252 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10068, _ctx)->tail, _ctx); /*@field-addr<list<2001>>*/;
  kk_integer_t _x_x1309;
  kk_integer_t _x_x1310 = kk_integer_dup(stride, _ctx); /*int*/
  _x_x1309 = kk_integer_add(lo,_x_x1310,kk_context()); /*int*/
  kk_std_core_types__cctx _x_x1311 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10068, _ctx)),_b_x249_252,kk_context()); /*ctx<0>*/
  return kk_std_core_list_stridefunction_fs__trmc_list(_x_x1309, hi, stride, f, _x_x1311, _ctx);
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.


// lift anonymous function
struct kk_std_core_list_stridefunction_fs__trmc_list_fun1315__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_integer_t hi_0;
  kk_integer_t lo_0;
  kk_integer_t stride_0;
};
static kk_box_t kk_std_core_list_stridefunction_fs__trmc_list_fun1315(kk_function_t _fself, kk_box_t _b_x257, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_stridefunction_fs__new_trmc_list_fun1315(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_integer_t hi_0, kk_integer_t lo_0, kk_integer_t stride_0, kk_context_t* _ctx) {
  struct kk_std_core_list_stridefunction_fs__trmc_list_fun1315__t* _self = kk_function_alloc_as(struct kk_std_core_list_stridefunction_fs__trmc_list_fun1315__t, 7, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_stridefunction_fs__trmc_list_fun1315, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->hi_0 = hi_0;
  _self->lo_0 = lo_0;
  _self->stride_0 = stride_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_stridefunction_fs__trmc_list_fun1315(kk_function_t _fself, kk_box_t _b_x257, kk_context_t* _ctx) {
  struct kk_std_core_list_stridefunction_fs__trmc_list_fun1315__t* _self = kk_function_as(struct kk_std_core_list_stridefunction_fs__trmc_list_fun1315__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2001>> */
  kk_function_t f_0 = _self->f_0; /* (int) -> 2002 2001 */
  kk_integer_t hi_0 = _self->hi_0; /* int */
  kk_integer_t lo_0 = _self->lo_0; /* int */
  kk_integer_t stride_0 = _self->stride_0; /* int */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_integer_dup(hi_0, _ctx);kk_integer_dup(lo_0, _ctx);kk_integer_dup(stride_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10066_0_275 = _b_x257; /*2001*/;
  kk_std_core_types__list _x_x1316 = kk_std_core_list_stridefunction_fs__mlift_trmc_list_10276(_acc_0, f_0, hi_0, lo_0, stride_0, _trmc_x10066_0_275, _ctx); /*list<2001>*/
  return kk_std_core_types__list_box(_x_x1316, _ctx);
}

kk_std_core_types__list kk_std_core_list_stridefunction_fs__trmc_list(kk_integer_t lo_0, kk_integer_t hi_0, kk_integer_t stride_0, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, stride : int, f : (int) -> e a, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  bool _match_x1093 = kk_integer_lte_borrow(lo_0,hi_0,kk_context()); /*bool*/;
  if (_match_x1093) {
    kk_box_t x_10331;
    kk_function_t _x_x1313 = kk_function_dup(f_0, _ctx); /*(int) -> 2002 2001*/
    kk_integer_t _x_x1312 = kk_integer_dup(lo_0, _ctx); /*int*/
    x_10331 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_context_t*), _x_x1313, (_x_x1313, _x_x1312, _ctx), _ctx); /*2001*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_10331, _ctx);
      kk_box_t _x_x1314 = kk_std_core_hnd_yield_extend(kk_std_core_list_stridefunction_fs__new_trmc_list_fun1315(_acc_0, f_0, hi_0, lo_0, stride_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1314, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10067_0 = kk_datatype_null(); /*list<2001>*/;
      kk_std_core_types__list _trmc_x10068_0 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_10331, _trmc_x10067_0, _ctx); /*list<2001>*/;
      kk_field_addr_t _b_x263_269 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10068_0, _ctx)->tail, _ctx); /*@field-addr<list<2001>>*/;
      { // tailcall
        kk_integer_t _x_x1317;
        kk_integer_t _x_x1318 = kk_integer_dup(stride_0, _ctx); /*int*/
        _x_x1317 = kk_integer_add(lo_0,_x_x1318,kk_context()); /*int*/
        kk_std_core_types__cctx _x_x1319 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10068_0, _ctx)),_b_x263_269,kk_context()); /*ctx<0>*/
        lo_0 = _x_x1317;
        _acc_0 = _x_x1319;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(stride_0, _ctx);
    kk_integer_drop(lo_0, _ctx);
    kk_integer_drop(hi_0, _ctx);
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1320 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1320, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_stridefunction_fs_list(kk_integer_t lo_1, kk_integer_t hi_1, kk_integer_t stride_1, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, stride : int, f : (int) -> e a) -> e list<a> */ 
  kk_std_core_types__cctx _x_x1321 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list_stridefunction_fs__trmc_list(lo_1, hi_1, stride_1, f_1, _x_x1321, _ctx);
}
 
// Apply a function `f` to each character in a string


// lift anonymous function
struct kk_std_core_list_string_fs_map_fun1322__t {
  struct kk_function_s _base;
  kk_function_t f;
};
static kk_box_t kk_std_core_list_string_fs_map_fun1322(kk_function_t _fself, kk_box_t _b_x279, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_string_fs_new_map_fun1322(kk_function_t f, kk_context_t* _ctx) {
  struct kk_std_core_list_string_fs_map_fun1322__t* _self = kk_function_alloc_as(struct kk_std_core_list_string_fs_map_fun1322__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_string_fs_map_fun1322, kk_context());
  _self->f = f;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_string_fs_map_fun1322(kk_function_t _fself, kk_box_t _b_x279, kk_context_t* _ctx) {
  struct kk_std_core_list_string_fs_map_fun1322__t* _self = kk_function_as(struct kk_std_core_list_string_fs_map_fun1322__t*, _fself, _ctx);
  kk_function_t f = _self->f; /* (char) -> 2051 char */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);}, {}, _ctx)
  kk_char_t _x_x1323;
  kk_char_t _x_x1324 = kk_char_unbox(_b_x279, KK_OWNED, _ctx); /*char*/
  _x_x1323 = kk_function_call(kk_char_t, (kk_function_t, kk_char_t, kk_context_t*), f, (f, _x_x1324, _ctx), _ctx); /*char*/
  return kk_char_box(_x_x1323, _ctx);
}


// lift anonymous function
struct kk_std_core_list_string_fs_map_fun1326__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_string_fs_map_fun1326(kk_function_t _fself, kk_box_t _b_x284, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_string_fs_new_map_fun1326(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_string_fs_map_fun1326, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_string_fs_map_fun1326(kk_function_t _fself, kk_box_t _b_x284, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x1327;
  kk_std_core_types__list _x_x1328 = kk_std_core_types__list_unbox(_b_x284, KK_OWNED, _ctx); /*list<char>*/
  _x_x1327 = kk_std_core_string_listchar_fs_string(_x_x1328, _ctx); /*string*/
  return kk_string_box(_x_x1327);
}

kk_string_t kk_std_core_list_string_fs_map(kk_string_t s, kk_function_t f, kk_context_t* _ctx) { /* forall<e> (s : string, f : (char) -> e char) -> e string */ 
  kk_std_core_types__list xs_10336 = kk_std_core_string_list(s, _ctx); /*list<char>*/;
  kk_std_core_types__cctx _b_x278_282 = kk_cctx_empty(kk_context()); /*ctx<list<char>>*/;
  kk_std_core_types__list x_10334;
  kk_function_t _brw_x1091 = kk_std_core_list_string_fs_new_map_fun1322(f, _ctx); /*(2105) -> 2107 2106*/;
  kk_std_core_types__list _brw_x1092 = kk_std_core_list__trmc_map(xs_10336, _brw_x1091, _b_x278_282, _ctx); /*list<2106>*/;
  kk_function_drop(_brw_x1091, _ctx);
  x_10334 = _brw_x1092; /*list<char>*/
  if (kk_yielding(kk_context())) {
    kk_std_core_types__list_drop(x_10334, _ctx);
    kk_box_t _x_x1325 = kk_std_core_hnd_yield_extend(kk_std_core_list_string_fs_new_map_fun1326(_ctx), _ctx); /*2401*/
    return kk_string_unbox(_x_x1325);
  }
  {
    return kk_std_core_string_listchar_fs_string(x_10334, _ctx);
  }
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_lift_map_indexed_5424_10277(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i_0_10018, kk_std_core_types__list yy, kk_box_t _trmc_x10069, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (idx : int, value : a) -> e b, i@0@10018 : int, yy : list<a>, b) -> e list<b> */ 
  kk_std_core_types__list _trmc_x10070 = kk_datatype_null(); /*list<2199>*/;
  kk_std_core_types__list _trmc_x10071 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10069, _trmc_x10070, _ctx); /*list<2199>*/;
  kk_field_addr_t _b_x291_294 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10071, _ctx)->tail, _ctx); /*@field-addr<list<2199>>*/;
  kk_std_core_types__cctx _x_x1329 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10071, _ctx)),_b_x291_294,kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_map_indexed_5424(f, yy, i_0_10018, _x_x1329, _ctx);
}
 
// lifted local: map-indexed, map-idx


// lift anonymous function
struct kk_std_core_list__trmc_lift_map_indexed_5424_fun1334__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_integer_t i_0_10018_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__trmc_lift_map_indexed_5424_fun1334(kk_function_t _fself, kk_box_t _b_x299, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_lift_map_indexed_5424_fun1334(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_integer_t i_0_10018_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_map_indexed_5424_fun1334__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_lift_map_indexed_5424_fun1334__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_lift_map_indexed_5424_fun1334, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->i_0_10018_0 = i_0_10018_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_lift_map_indexed_5424_fun1334(kk_function_t _fself, kk_box_t _b_x299, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_map_indexed_5424_fun1334__t* _self = kk_function_as(struct kk_std_core_list__trmc_lift_map_indexed_5424_fun1334__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2199>> */
  kk_function_t f_0 = _self->f_0; /* (idx : int, value : 2198) -> 2200 2199 */
  kk_integer_t i_0_10018_0 = _self->i_0_10018_0; /* int */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<2198> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_integer_dup(i_0_10018_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10069_0_317 = _b_x299; /*2199*/;
  kk_std_core_types__list _x_x1335 = kk_std_core_list__mlift_trmc_lift_map_indexed_5424_10277(_acc_0, f_0, i_0_10018_0, yy_0, _trmc_x10069_0_317, _ctx); /*list<2199>*/
  return kk_std_core_types__list_box(_x_x1335, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_lift_map_indexed_5424(kk_function_t f_0, kk_std_core_types__list ys, kk_integer_t i, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a) -> e b, ys : list<a>, i : int, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1330 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1330->head;
    kk_std_core_types__list yy_0 = _con_x1330->tail;
    kk_reuse_t _ru_x1136 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1136 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy_0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_integer_t i_0_10018_0;
    kk_integer_t _x_x1331 = kk_integer_dup(i, _ctx); /*int*/
    i_0_10018_0 = kk_integer_add_small_const(_x_x1331, 1, _ctx); /*int*/
    kk_box_t x_10338;
    kk_function_t _x_x1332 = kk_function_dup(f_0, _ctx); /*(idx : int, value : 2198) -> 2200 2199*/
    x_10338 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x_x1332, (_x_x1332, i, y, _ctx), _ctx); /*2199*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1136,kk_context());
      kk_box_drop(x_10338, _ctx);
      kk_box_t _x_x1333 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_lift_map_indexed_5424_fun1334(_acc_0, f_0, i_0_10018_0, yy_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1333, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10070_0 = kk_datatype_null(); /*list<2199>*/;
      kk_std_core_types__list _trmc_x10071_0 = kk_std_core_types__new_Cons(_ru_x1136, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_10338, _trmc_x10070_0, _ctx); /*list<2199>*/;
      kk_field_addr_t _b_x305_311 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10071_0, _ctx)->tail, _ctx); /*@field-addr<list<2199>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1336 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10071_0, _ctx)),_b_x305_311,kk_context()); /*ctx<0>*/
        ys = yy_0;
        i = i_0_10018_0;
        _acc_0 = _x_x1336;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(i, _ctx);
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1337 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1337, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-indexed, map-idx

kk_std_core_types__list kk_std_core_list__lift_map_indexed_5424(kk_function_t f_1, kk_std_core_types__list ys_0, kk_integer_t i_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a) -> e b, ys : list<a>, i : int) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1338 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_map_indexed_5424(f_1, ys_0, i_0, _x_x1338, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_lift_map_peek_5425_10278(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core_types__list yy, kk_box_t _trmc_x10072, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (value : a, rest : list<a>) -> e b, yy : list<a>, b) -> e list<b> */ 
  kk_std_core_types__list _trmc_x10073 = kk_datatype_null(); /*list<2257>*/;
  kk_std_core_types__list _trmc_x10074 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10072, _trmc_x10073, _ctx); /*list<2257>*/;
  kk_field_addr_t _b_x323_326 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10074, _ctx)->tail, _ctx); /*@field-addr<list<2257>>*/;
  kk_std_core_types__cctx _x_x1340 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10074, _ctx)),_b_x323_326,kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_map_peek_5425(f, yy, _x_x1340, _ctx);
}
 
// lifted local: map-peek, mappeek


// lift anonymous function
struct kk_std_core_list__trmc_lift_map_peek_5425_fun1345__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__trmc_lift_map_peek_5425_fun1345(kk_function_t _fself, kk_box_t _b_x331, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_lift_map_peek_5425_fun1345(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_map_peek_5425_fun1345__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_lift_map_peek_5425_fun1345__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_lift_map_peek_5425_fun1345, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_lift_map_peek_5425_fun1345(kk_function_t _fself, kk_box_t _b_x331, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_map_peek_5425_fun1345__t* _self = kk_function_as(struct kk_std_core_list__trmc_lift_map_peek_5425_fun1345__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2257>> */
  kk_function_t f_0 = _self->f_0; /* (value : 2256, rest : list<2256>) -> 2258 2257 */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<2256> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10072_0_349 = _b_x331; /*2257*/;
  kk_std_core_types__list _x_x1346 = kk_std_core_list__mlift_trmc_lift_map_peek_5425_10278(_acc_0, f_0, yy_0, _trmc_x10072_0_349, _ctx); /*list<2257>*/
  return kk_std_core_types__list_box(_x_x1346, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_lift_map_peek_5425(kk_function_t f_0, kk_std_core_types__list ys, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (value : a, rest : list<a>) -> e b, ys : list<a>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1341 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1341->head;
    kk_std_core_types__list yy_0 = _con_x1341->tail;
    kk_reuse_t _ru_x1137 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1137 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy_0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_box_t x_10344;
    kk_function_t _x_x1343 = kk_function_dup(f_0, _ctx); /*(value : 2256, rest : list<2256>) -> 2258 2257*/
    kk_std_core_types__list _x_x1342 = kk_std_core_types__list_dup(yy_0, _ctx); /*list<2256>*/
    x_10344 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_std_core_types__list, kk_context_t*), _x_x1343, (_x_x1343, y, _x_x1342, _ctx), _ctx); /*2257*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1137,kk_context());
      kk_box_drop(x_10344, _ctx);
      kk_box_t _x_x1344 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_lift_map_peek_5425_fun1345(_acc_0, f_0, yy_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1344, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10073_0 = kk_datatype_null(); /*list<2257>*/;
      kk_std_core_types__list _trmc_x10074_0 = kk_std_core_types__new_Cons(_ru_x1137, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_10344, _trmc_x10073_0, _ctx); /*list<2257>*/;
      kk_field_addr_t _b_x337_343 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10074_0, _ctx)->tail, _ctx); /*@field-addr<list<2257>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1347 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10074_0, _ctx)),_b_x337_343,kk_context()); /*ctx<0>*/
        ys = yy_0;
        _acc_0 = _x_x1347;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1348 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1348, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-peek, mappeek

kk_std_core_types__list kk_std_core_list__lift_map_peek_5425(kk_function_t f_1, kk_std_core_types__list ys_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (value : a, rest : list<a>) -> e b, ys : list<a>) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1349 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_map_peek_5425(f_1, ys_0, _x_x1349, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_lift_map_indexed_peek_5426_10279(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i_0_10021, kk_std_core_types__list yy, kk_box_t _trmc_x10075, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (idx : int, value : a, rest : list<a>) -> e b, i@0@10021 : int, yy : list<a>, b) -> e list<b> */ 
  kk_std_core_types__list _trmc_x10076 = kk_datatype_null(); /*list<2323>*/;
  kk_std_core_types__list _trmc_x10077 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10075, _trmc_x10076, _ctx); /*list<2323>*/;
  kk_field_addr_t _b_x355_358 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10077, _ctx)->tail, _ctx); /*@field-addr<list<2323>>*/;
  kk_std_core_types__cctx _x_x1351 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10077, _ctx)),_b_x355_358,kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_map_indexed_peek_5426(f, yy, i_0_10021, _x_x1351, _ctx);
}
 
// lifted local: map-indexed-peek, mapidx


// lift anonymous function
struct kk_std_core_list__trmc_lift_map_indexed_peek_5426_fun1357__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_integer_t i_0_10021_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__trmc_lift_map_indexed_peek_5426_fun1357(kk_function_t _fself, kk_box_t _b_x363, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_lift_map_indexed_peek_5426_fun1357(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_integer_t i_0_10021_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_map_indexed_peek_5426_fun1357__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_lift_map_indexed_peek_5426_fun1357__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_lift_map_indexed_peek_5426_fun1357, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->i_0_10021_0 = i_0_10021_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_lift_map_indexed_peek_5426_fun1357(kk_function_t _fself, kk_box_t _b_x363, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_map_indexed_peek_5426_fun1357__t* _self = kk_function_as(struct kk_std_core_list__trmc_lift_map_indexed_peek_5426_fun1357__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2323>> */
  kk_function_t f_0 = _self->f_0; /* (idx : int, value : 2322, rest : list<2322>) -> 2324 2323 */
  kk_integer_t i_0_10021_0 = _self->i_0_10021_0; /* int */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<2322> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_integer_dup(i_0_10021_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10075_0_381 = _b_x363; /*2323*/;
  kk_std_core_types__list _x_x1358 = kk_std_core_list__mlift_trmc_lift_map_indexed_peek_5426_10279(_acc_0, f_0, i_0_10021_0, yy_0, _trmc_x10075_0_381, _ctx); /*list<2323>*/
  return kk_std_core_types__list_box(_x_x1358, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_lift_map_indexed_peek_5426(kk_function_t f_0, kk_std_core_types__list ys, kk_integer_t i, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a, rest : list<a>) -> e b, ys : list<a>, i : int, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1352 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1352->head;
    kk_std_core_types__list yy_0 = _con_x1352->tail;
    kk_reuse_t _ru_x1138 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1138 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy_0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_integer_t i_0_10021_0;
    kk_integer_t _x_x1353 = kk_integer_dup(i, _ctx); /*int*/
    i_0_10021_0 = kk_integer_add_small_const(_x_x1353, 1, _ctx); /*int*/
    kk_box_t x_10349;
    kk_function_t _x_x1355 = kk_function_dup(f_0, _ctx); /*(idx : int, value : 2322, rest : list<2322>) -> 2324 2323*/
    kk_std_core_types__list _x_x1354 = kk_std_core_types__list_dup(yy_0, _ctx); /*list<2322>*/
    x_10349 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_std_core_types__list, kk_context_t*), _x_x1355, (_x_x1355, i, y, _x_x1354, _ctx), _ctx); /*2323*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1138,kk_context());
      kk_box_drop(x_10349, _ctx);
      kk_box_t _x_x1356 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_lift_map_indexed_peek_5426_fun1357(_acc_0, f_0, i_0_10021_0, yy_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1356, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10076_0 = kk_datatype_null(); /*list<2323>*/;
      kk_std_core_types__list _trmc_x10077_0 = kk_std_core_types__new_Cons(_ru_x1138, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_10349, _trmc_x10076_0, _ctx); /*list<2323>*/;
      kk_field_addr_t _b_x369_375 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10077_0, _ctx)->tail, _ctx); /*@field-addr<list<2323>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1359 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10077_0, _ctx)),_b_x369_375,kk_context()); /*ctx<0>*/
        ys = yy_0;
        i = i_0_10021_0;
        _acc_0 = _x_x1359;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(i, _ctx);
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1360 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1360, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-indexed-peek, mapidx

kk_std_core_types__list kk_std_core_list__lift_map_indexed_peek_5426(kk_function_t f_1, kk_std_core_types__list ys_0, kk_integer_t i_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a, rest : list<a>) -> e b, ys : list<a>, i : int) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1361 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_map_indexed_peek_5426(f_1, ys_0, i_0, _x_x1361, _ctx);
}
 
// Create a list of `n` repeated elements `x`

kk_std_core_types__list kk_std_core_list__trmc_replicate(kk_box_t x, kk_integer_t n, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (x : a, n : int, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  bool _match_x1086 = kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_x1086) {
    kk_std_core_types__list _trmc_x10078 = kk_datatype_null(); /*list<2377>*/;
    kk_std_core_types__list _trmc_x10079;
    kk_box_t _x_x1363 = kk_box_dup(x, _ctx); /*2377*/
    _trmc_x10079 = kk_std_core_types__new_Cons(kk_reuse_null, 0, _x_x1363, _trmc_x10078, _ctx); /*list<2377>*/
    kk_field_addr_t _b_x387_392 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10079, _ctx)->tail, _ctx); /*@field-addr<list<2377>>*/;
    { // tailcall
      kk_integer_t _x_x1364 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
      kk_std_core_types__cctx _x_x1365 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10079, _ctx)),_b_x387_392,kk_context()); /*ctx<0>*/
      n = _x_x1364;
      _acc = _x_x1365;
      goto kk__tailcall;
    }
  }
  {
    kk_box_drop(x, _ctx);
    kk_integer_drop(n, _ctx);
    kk_box_t _x_x1366 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1366, KK_OWNED, _ctx);
  }
}
 
// Create a list of `n` repeated elements `x`

kk_std_core_types__list kk_std_core_list_replicate(kk_box_t x_0, kk_integer_t n_0, kk_context_t* _ctx) { /* forall<a> (x : a, n : int) -> list<a> */ 
  kk_std_core_types__cctx _x_x1367 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_replicate(x_0, n_0, _x_x1367, _ctx);
}
 
// Remove those elements of a list that satisfy the given predicate `pred`.
// For example: `remove([1,2,3],odd?) == [2]`


// lift anonymous function
struct kk_std_core_list_remove_fun1368__t {
  struct kk_function_s _base;
  kk_function_t pred;
};
static bool kk_std_core_list_remove_fun1368(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_remove_fun1368(kk_function_t pred, kk_context_t* _ctx) {
  struct kk_std_core_list_remove_fun1368__t* _self = kk_function_alloc_as(struct kk_std_core_list_remove_fun1368__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_remove_fun1368, kk_context());
  _self->pred = pred;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_list_remove_fun1370__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_remove_fun1370(kk_function_t _fself, kk_box_t _b_x399, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_remove_fun1370(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_remove_fun1370, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_remove_fun1370(kk_function_t _fself, kk_box_t _b_x399, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  bool _y_x10166_401 = kk_bool_unbox(_b_x399); /*bool*/;
  bool _x_x1371;
  if (_y_x10166_401) {
    _x_x1371 = false; /*bool*/
  }
  else {
    _x_x1371 = true; /*bool*/
  }
  return kk_bool_box(_x_x1371);
}
static bool kk_std_core_list_remove_fun1368(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_list_remove_fun1368__t* _self = kk_function_as(struct kk_std_core_list_remove_fun1368__t*, _fself, _ctx);
  kk_function_t pred = _self->pred; /* (2415) -> 2416 bool */
  kk_drop_match(_self, {kk_function_dup(pred, _ctx);}, {}, _ctx)
  bool x_0_10357 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), pred, (pred, x, _ctx), _ctx); /*bool*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1369 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_remove_fun1370(_ctx), _ctx); /*2401*/
    return kk_bool_unbox(_x_x1369);
  }
  if (x_0_10357) {
    return false;
  }
  {
    return true;
  }
}

kk_std_core_types__list kk_std_core_list_remove(kk_std_core_types__list xs, kk_function_t pred, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool) -> e list<a> */ 
  kk_std_core_types__cctx _x_x1372 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_filter(xs, kk_std_core_list_new_remove_fun1368(pred, _ctx), _x_x1372, _ctx);
}
 
// monadic lift

kk_std_core_types__tuple2 kk_std_core_list__mlift_partition_acc_10281(kk_std_core_types__cctx acc1, kk_std_core_types__cctx acc2, kk_function_t pred, kk_box_t x, kk_std_core_types__list xx, bool _y_x10168, kk_context_t* _ctx) { /* forall<a,e> (acc1 : ctx<list<a>>, acc2 : ctx<list<a>>, pred : (a) -> e bool, x : a, xx : list<a>, bool) -> e (list<a>, list<a>) */ 
  if (_y_x10168) {
    kk_std_core_types__list _cctx_x2510;
    kk_std_core_types__list _x_x1373 = kk_datatype_null(); /*list<2566>*/
    _cctx_x2510 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _x_x1373, _ctx); /*list<2566>*/
    kk_field_addr_t _cctx_x2511 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x2510, _ctx)->tail, _ctx); /*@field-addr<list<2566>>*/;
    kk_std_core_types__list _b_x408_418 = _cctx_x2510; /*list<2566>*/;
    kk_field_addr_t _b_x409_419 = _cctx_x2511; /*@field-addr<list<2566>>*/;
    kk_std_core_types__cctx _own_x1083;
    kk_std_core_types__cctx _x_x1374 = kk_cctx_create((kk_std_core_types__list_box(_b_x408_418, _ctx)),_b_x409_419,kk_context()); /*cctx<0,1>*/
    _own_x1083 = kk_cctx_compose(acc1,_x_x1374,kk_context()); /*cctx<398,400>*/
    kk_std_core_types__tuple2 _brw_x1084 = kk_std_core_list_partition_acc(xx, pred, _own_x1083, acc2, _ctx); /*(list<2566>, list<2566>)*/;
    kk_function_drop(pred, _ctx);
    return _brw_x1084;
  }
  {
    kk_std_core_types__list _cctx_x2553;
    kk_std_core_types__list _x_x1375 = kk_datatype_null(); /*list<2566>*/
    _cctx_x2553 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _x_x1375, _ctx); /*list<2566>*/
    kk_field_addr_t _cctx_x2554 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x2553, _ctx)->tail, _ctx); /*@field-addr<list<2566>>*/;
    kk_std_core_types__list _b_x416_420 = _cctx_x2553; /*list<2566>*/;
    kk_field_addr_t _b_x417_421 = _cctx_x2554; /*@field-addr<list<2566>>*/;
    kk_std_core_types__cctx _own_x1081;
    kk_std_core_types__cctx _x_x1376 = kk_cctx_create((kk_std_core_types__list_box(_b_x416_420, _ctx)),_b_x417_421,kk_context()); /*cctx<0,1>*/
    _own_x1081 = kk_cctx_compose(acc2,_x_x1376,kk_context()); /*cctx<398,400>*/
    kk_std_core_types__tuple2 _brw_x1082 = kk_std_core_list_partition_acc(xx, pred, acc1, _own_x1081, _ctx); /*(list<2566>, list<2566>)*/;
    kk_function_drop(pred, _ctx);
    return _brw_x1082;
  }
}


// lift anonymous function
struct kk_std_core_list_partition_acc_fun1384__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx acc1_0;
  kk_std_core_types__cctx acc2_0;
  kk_function_t pred_0;
  kk_box_t x_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list_partition_acc_fun1384(kk_function_t _fself, kk_box_t _b_x429, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_partition_acc_fun1384(kk_std_core_types__cctx acc1_0, kk_std_core_types__cctx acc2_0, kk_function_t pred_0, kk_box_t x_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list_partition_acc_fun1384__t* _self = kk_function_alloc_as(struct kk_std_core_list_partition_acc_fun1384__t, 8, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_partition_acc_fun1384, kk_context());
  _self->acc1_0 = acc1_0;
  _self->acc2_0 = acc2_0;
  _self->pred_0 = pred_0;
  _self->x_0 = x_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_partition_acc_fun1384(kk_function_t _fself, kk_box_t _b_x429, kk_context_t* _ctx) {
  struct kk_std_core_list_partition_acc_fun1384__t* _self = kk_function_as(struct kk_std_core_list_partition_acc_fun1384__t*, _fself, _ctx);
  kk_std_core_types__cctx acc1_0 = _self->acc1_0; /* ctx<list<2566>> */
  kk_std_core_types__cctx acc2_0 = _self->acc2_0; /* ctx<list<2566>> */
  kk_function_t pred_0 = _self->pred_0; /* (2566) -> 2567 bool */
  kk_box_t x_0 = _self->x_0; /* 2566 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<2566> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(acc1_0, _ctx);kk_std_core_types__cctx_dup(acc2_0, _ctx);kk_function_dup(pred_0, _ctx);kk_box_dup(x_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10168_0_457 = kk_bool_unbox(_b_x429); /*bool*/;
  kk_std_core_types__tuple2 _x_x1385 = kk_std_core_list__mlift_partition_acc_10281(acc1_0, acc2_0, pred_0, x_0, xx_0, _y_x10168_0_457, _ctx); /*(list<2566>, list<2566>)*/
  return kk_std_core_types__tuple2_box(_x_x1385, _ctx);
}

kk_std_core_types__tuple2 kk_std_core_list_partition_acc(kk_std_core_types__list xs, kk_function_t pred_0, kk_std_core_types__cctx acc1_0, kk_std_core_types__cctx acc2_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool, acc1 : ctx<list<a>>, acc2 : ctx<list<a>>) -> e (list<a>, list<a>) */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_std_core_types__list _b_x426_446;
    kk_box_t _x_x1377 = kk_cctx_apply(acc1_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x426_446 = kk_std_core_types__list_unbox(_x_x1377, KK_OWNED, _ctx); /*list<2566>*/
    kk_std_core_types__list _b_x427_447;
    kk_box_t _x_x1378 = kk_cctx_apply(acc2_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x427_447 = kk_std_core_types__list_unbox(_x_x1378, KK_OWNED, _ctx); /*list<2566>*/
    return kk_std_core_types__new_Tuple2(kk_std_core_types__list_box(_b_x426_446, _ctx), kk_std_core_types__list_box(_b_x427_447, _ctx), _ctx);
  }
  {
    struct kk_std_core_types_Cons* _con_x1379 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x_0 = _con_x1379->head;
    kk_std_core_types__list xx_0 = _con_x1379->tail;
    kk_reuse_t _ru_x1139 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1139 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x_0, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_1_10360;
    kk_function_t _x_x1381 = kk_function_dup(pred_0, _ctx); /*(2566) -> 2567 bool*/
    kk_box_t _x_x1380 = kk_box_dup(x_0, _ctx); /*2566*/
    x_1_10360 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1381, (_x_x1381, _x_x1380, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1139,kk_context());
      kk_box_t _x_x1382;
      kk_function_t _x_x1383;
      kk_function_dup(pred_0, _ctx);
      _x_x1383 = kk_std_core_list_new_partition_acc_fun1384(acc1_0, acc2_0, pred_0, x_0, xx_0, _ctx); /*(2400) -> 2402 2401*/
      _x_x1382 = kk_std_core_hnd_yield_extend(_x_x1383, _ctx); /*2401*/
      return kk_std_core_types__tuple2_unbox(_x_x1382, KK_OWNED, _ctx);
    }
    if (x_1_10360) {
      kk_std_core_types__list _cctx_x2510_0;
      kk_std_core_types__list _x_x1386 = kk_datatype_null(); /*list<2566>*/
      _cctx_x2510_0 = kk_std_core_types__new_Cons(_ru_x1139, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0, _x_x1386, _ctx); /*list<2566>*/
      kk_field_addr_t _cctx_x2511_0 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x2510_0, _ctx)->tail, _ctx); /*@field-addr<list<2566>>*/;
      kk_std_core_types__list _b_x436_453 = _cctx_x2510_0; /*list<2566>*/;
      kk_field_addr_t _b_x437_454 = _cctx_x2511_0; /*@field-addr<list<2566>>*/;
      kk_std_core_types__cctx _own_x1080;
      kk_std_core_types__cctx _x_x1387 = kk_cctx_create((kk_std_core_types__list_box(_b_x436_453, _ctx)),_b_x437_454,kk_context()); /*cctx<0,1>*/
      _own_x1080 = kk_cctx_compose(acc1_0,_x_x1387,kk_context()); /*cctx<398,400>*/
      { // tailcall
        xs = xx_0;
        acc1_0 = _own_x1080;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core_types__list _cctx_x2553_0;
      kk_std_core_types__list _x_x1388 = kk_datatype_null(); /*list<2566>*/
      _cctx_x2553_0 = kk_std_core_types__new_Cons(_ru_x1139, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0, _x_x1388, _ctx); /*list<2566>*/
      kk_field_addr_t _cctx_x2554_0 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x2553_0, _ctx)->tail, _ctx); /*@field-addr<list<2566>>*/;
      kk_std_core_types__list _b_x444_455 = _cctx_x2553_0; /*list<2566>*/;
      kk_field_addr_t _b_x445_456 = _cctx_x2554_0; /*@field-addr<list<2566>>*/;
      kk_std_core_types__cctx _own_x1079;
      kk_std_core_types__cctx _x_x1389 = kk_cctx_create((kk_std_core_types__list_box(_b_x444_455, _ctx)),_b_x445_456,kk_context()); /*cctx<0,1>*/
      _own_x1079 = kk_cctx_compose(acc2_0,_x_x1389,kk_context()); /*cctx<398,400>*/
      { // tailcall
        xs = xx_0;
        acc2_0 = _own_x1079;
        goto kk__tailcall;
      }
    }
  }
}
 
// Lookup the first element satisfying some predicate


// lift anonymous function
struct kk_std_core_list_lookup_fun1391__t {
  struct kk_function_s _base;
  kk_function_t pred;
};
static kk_std_core_types__maybe kk_std_core_list_lookup_fun1391(kk_function_t _fself, kk_box_t _b_x462, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_lookup_fun1391(kk_function_t pred, kk_context_t* _ctx) {
  struct kk_std_core_list_lookup_fun1391__t* _self = kk_function_alloc_as(struct kk_std_core_list_lookup_fun1391__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_lookup_fun1391, kk_context());
  _self->pred = pred;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_list_lookup_fun1394__t {
  struct kk_function_s _base;
  kk_box_t _b_x462;
};
static kk_std_core_types__maybe kk_std_core_list_lookup_fun1394(kk_function_t _fself, bool _y_x10174, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_lookup_fun1394(kk_box_t _b_x462, kk_context_t* _ctx) {
  struct kk_std_core_list_lookup_fun1394__t* _self = kk_function_alloc_as(struct kk_std_core_list_lookup_fun1394__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_lookup_fun1394, kk_context());
  _self->_b_x462 = _b_x462;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_core_types__maybe kk_std_core_list_lookup_fun1394(kk_function_t _fself, bool _y_x10174, kk_context_t* _ctx) {
  struct kk_std_core_list_lookup_fun1394__t* _self = kk_function_as(struct kk_std_core_list_lookup_fun1394__t*, _fself, _ctx);
  kk_box_t _b_x462 = _self->_b_x462; /* 1575 */
  kk_drop_match(_self, {kk_box_dup(_b_x462, _ctx);}, {}, _ctx)
  if (_y_x10174) {
    kk_box_t _x_x1395;
    kk_std_core_types__tuple2 _match_x1074 = kk_std_core_types__tuple2_unbox(_b_x462, KK_OWNED, _ctx); /*(2741, 2742)*/;
    {
      kk_box_t _x_0 = _match_x1074.snd;
      kk_box_dup(_x_0, _ctx);
      kk_std_core_types__tuple2_drop(_match_x1074, _ctx);
      _x_x1395 = _x_0; /*2742*/
    }
    return kk_std_core_types__new_Just(_x_x1395, _ctx);
  }
  {
    kk_box_drop(_b_x462, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}


// lift anonymous function
struct kk_std_core_list_lookup_fun1397__t {
  struct kk_function_s _base;
  kk_function_t next_10364;
};
static kk_box_t kk_std_core_list_lookup_fun1397(kk_function_t _fself, kk_box_t _b_x459, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_lookup_fun1397(kk_function_t next_10364, kk_context_t* _ctx) {
  struct kk_std_core_list_lookup_fun1397__t* _self = kk_function_alloc_as(struct kk_std_core_list_lookup_fun1397__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_lookup_fun1397, kk_context());
  _self->next_10364 = next_10364;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_lookup_fun1397(kk_function_t _fself, kk_box_t _b_x459, kk_context_t* _ctx) {
  struct kk_std_core_list_lookup_fun1397__t* _self = kk_function_as(struct kk_std_core_list_lookup_fun1397__t*, _fself, _ctx);
  kk_function_t next_10364 = _self->next_10364; /* (bool) -> 2743 maybe<2742> */
  kk_drop_match(_self, {kk_function_dup(next_10364, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _x_x1398;
  bool _x_x1399 = kk_bool_unbox(_b_x459); /*bool*/
  _x_x1398 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, bool, kk_context_t*), next_10364, (next_10364, _x_x1399, _ctx), _ctx); /*maybe<2742>*/
  return kk_std_core_types__maybe_box(_x_x1398, _ctx);
}
static kk_std_core_types__maybe kk_std_core_list_lookup_fun1391(kk_function_t _fself, kk_box_t _b_x462, kk_context_t* _ctx) {
  struct kk_std_core_list_lookup_fun1391__t* _self = kk_function_as(struct kk_std_core_list_lookup_fun1391__t*, _fself, _ctx);
  kk_function_t pred = _self->pred; /* (2741) -> 2743 bool */
  kk_drop_match(_self, {kk_function_dup(pred, _ctx);}, {}, _ctx)
  bool x_10363;
  kk_box_t _x_x1392;
  kk_std_core_types__tuple2 _match_x1075;
  kk_box_t _x_x1393 = kk_box_dup(_b_x462, _ctx); /*1575*/
  _match_x1075 = kk_std_core_types__tuple2_unbox(_x_x1393, KK_OWNED, _ctx); /*(2741, 2742)*/
  {
    kk_box_t _x = _match_x1075.fst;
    kk_box_dup(_x, _ctx);
    kk_std_core_types__tuple2_drop(_match_x1075, _ctx);
    _x_x1392 = _x; /*2741*/
  }
  x_10363 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), pred, (pred, _x_x1392, _ctx), _ctx); /*bool*/
  kk_function_t next_10364 = kk_std_core_list_new_lookup_fun1394(_b_x462, _ctx); /*(bool) -> 2743 maybe<2742>*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1396 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_lookup_fun1397(next_10364, _ctx), _ctx); /*2401*/
    return kk_std_core_types__maybe_unbox(_x_x1396, KK_OWNED, _ctx);
  }
  {
    return kk_function_call(kk_std_core_types__maybe, (kk_function_t, bool, kk_context_t*), next_10364, (next_10364, x_10363, _ctx), _ctx);
  }
}

kk_std_core_types__maybe kk_std_core_list_lookup(kk_std_core_types__list xs, kk_function_t pred, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<(a, b)>, pred : (a) -> e bool) -> e maybe<b> */ 
  return kk_std_core_list_foreach_while(xs, kk_std_core_list_new_lookup_fun1391(pred, _ctx), _ctx);
}
 
// monadic lift

kk_integer_t kk_std_core_list__mlift_index_of_acc_10283(kk_integer_t idx, kk_function_t pred, kk_std_core_types__list xx, bool _y_x10177, kk_context_t* _ctx) { /* forall<a,e> (idx : int, pred : (a) -> e bool, xx : list<a>, bool) -> e int */ 
  if (_y_x10177) {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(pred, _ctx);
    return idx;
  }
  {
    kk_integer_t _x_x1400 = kk_integer_add_small_const(idx, 1, _ctx); /*int*/
    return kk_std_core_list_index_of_acc(xx, pred, _x_x1400, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_list_index_of_acc_fun1404__t {
  struct kk_function_s _base;
  kk_integer_t idx_0;
  kk_function_t pred_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list_index_of_acc_fun1404(kk_function_t _fself, kk_box_t _b_x468, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_index_of_acc_fun1404(kk_integer_t idx_0, kk_function_t pred_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list_index_of_acc_fun1404__t* _self = kk_function_alloc_as(struct kk_std_core_list_index_of_acc_fun1404__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_index_of_acc_fun1404, kk_context());
  _self->idx_0 = idx_0;
  _self->pred_0 = pred_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_index_of_acc_fun1404(kk_function_t _fself, kk_box_t _b_x468, kk_context_t* _ctx) {
  struct kk_std_core_list_index_of_acc_fun1404__t* _self = kk_function_as(struct kk_std_core_list_index_of_acc_fun1404__t*, _fself, _ctx);
  kk_integer_t idx_0 = _self->idx_0; /* int */
  kk_function_t pred_0 = _self->pred_0; /* (2795) -> 2796 bool */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<2795> */
  kk_drop_match(_self, {kk_integer_dup(idx_0, _ctx);kk_function_dup(pred_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10177_0_470 = kk_bool_unbox(_b_x468); /*bool*/;
  kk_integer_t _x_x1405 = kk_std_core_list__mlift_index_of_acc_10283(idx_0, pred_0, xx_0, _y_x10177_0_470, _ctx); /*int*/
  return kk_integer_box(_x_x1405, _ctx);
}

kk_integer_t kk_std_core_list_index_of_acc(kk_std_core_types__list xs, kk_function_t pred_0, kk_integer_t idx_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool, idx : int) -> e int */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1401 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1401->head;
    kk_std_core_types__list xx_0 = _con_x1401->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_0_10367;
    kk_function_t _x_x1402 = kk_function_dup(pred_0, _ctx); /*(2795) -> 2796 bool*/
    x_0_10367 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1402, (_x_x1402, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1403 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_index_of_acc_fun1404(idx_0, pred_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_integer_unbox(_x_x1403, _ctx);
    }
    if (x_0_10367) {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(pred_0, _ctx);
      return idx_0;
    }
    { // tailcall
      kk_integer_t _x_x1406 = kk_integer_add_small_const(idx_0, 1, _ctx); /*int*/
      xs = xx_0;
      idx_0 = _x_x1406;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(pred_0, _ctx);
    kk_integer_drop(idx_0, _ctx);
    return kk_integer_from_small(-1);
  }
}
 
// monadic lift

kk_unit_t kk_std_core_list__mlift_foreach_10284(kk_function_t action, kk_std_core_types__list xx, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<a,e> (action : (a) -> e (), xx : list<a>, wild_ : ()) -> e () */ 
  kk_std_core_list_foreach(xx, action, _ctx); return kk_Unit;
}
 
// Invoke `action` for each element of a list


// lift anonymous function
struct kk_std_core_list_foreach_fun1410__t {
  struct kk_function_s _base;
  kk_function_t action_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list_foreach_fun1410(kk_function_t _fself, kk_box_t _b_x472, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_foreach_fun1410(kk_function_t action_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list_foreach_fun1410__t* _self = kk_function_alloc_as(struct kk_std_core_list_foreach_fun1410__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_foreach_fun1410, kk_context());
  _self->action_0 = action_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_foreach_fun1410(kk_function_t _fself, kk_box_t _b_x472, kk_context_t* _ctx) {
  struct kk_std_core_list_foreach_fun1410__t* _self = kk_function_as(struct kk_std_core_list_foreach_fun1410__t*, _fself, _ctx);
  kk_function_t action_0 = _self->action_0; /* (2872) -> 2873 () */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<2872> */
  kk_drop_match(_self, {kk_function_dup(action_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_unit_t wild___0_474 = kk_Unit;
  kk_unit_unbox(_b_x472);
  kk_unit_t _x_x1411 = kk_Unit;
  kk_std_core_list__mlift_foreach_10284(action_0, xx_0, wild___0_474, _ctx);
  return kk_unit_box(_x_x1411);
}

kk_unit_t kk_std_core_list_foreach(kk_std_core_types__list xs, kk_function_t action_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, action : (a) -> e ()) -> e () */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1407 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1407->head;
    kk_std_core_types__list xx_0 = _con_x1407->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_unit_t x_0_10370 = kk_Unit;
    kk_function_t _x_x1408 = kk_function_dup(action_0, _ctx); /*(2872) -> 2873 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_box_t, kk_context_t*), _x_x1408, (_x_x1408, x, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1409 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_foreach_fun1410(action_0, xx_0, _ctx), _ctx); /*2401*/
      kk_unit_unbox(_x_x1409); return kk_Unit;
    }
    { // tailcall
      xs = xx_0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(action_0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_map_while_10285(kk_std_core_types__cctx _acc, kk_function_t action, kk_std_core_types__list xx, kk_std_core_types__maybe _y_x10185, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, action : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Just(_y_x10185, _ctx)) {
    kk_box_t y = _y_x10185._cons.Just.value;
    kk_std_core_types__list _trmc_x10080 = kk_datatype_null(); /*list<2947>*/;
    kk_std_core_types__list _trmc_x10081 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _trmc_x10080, _ctx); /*list<2947>*/;
    kk_field_addr_t _b_x480_485 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10081, _ctx)->tail, _ctx); /*@field-addr<list<2947>>*/;
    kk_std_core_types__cctx _x_x1412 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10081, _ctx)),_b_x480_485,kk_context()); /*ctx<0>*/
    return kk_std_core_list__trmc_map_while(xx, action, _x_x1412, _ctx);
  }
  {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(action, _ctx);
    kk_box_t _x_x1413 = kk_cctx_apply(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1413, KK_OWNED, _ctx);
  }
}
 
// Invoke `action` on each element of a list while `action` returns `Just`


// lift anonymous function
struct kk_std_core_list__trmc_map_while_fun1418__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t action_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_map_while_fun1418(kk_function_t _fself, kk_box_t _b_x494, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_map_while_fun1418(kk_std_core_types__cctx _acc_0, kk_function_t action_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_map_while_fun1418__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_map_while_fun1418__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_map_while_fun1418, kk_context());
  _self->_acc_0 = _acc_0;
  _self->action_0 = action_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_map_while_fun1418(kk_function_t _fself, kk_box_t _b_x494, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_map_while_fun1418__t* _self = kk_function_as(struct kk_std_core_list__trmc_map_while_fun1418__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2947>> */
  kk_function_t action_0 = _self->action_0; /* (2946) -> 2948 maybe<2947> */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<2946> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(action_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_x10185_0_514 = kk_std_core_types__maybe_unbox(_b_x494, KK_OWNED, _ctx); /*maybe<2947>*/;
  kk_std_core_types__list _x_x1419 = kk_std_core_list__mlift_trmc_map_while_10285(_acc_0, action_0, xx_0, _y_x10185_0_514, _ctx); /*list<2947>*/
  return kk_std_core_types__list_box(_x_x1419, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_map_while(kk_std_core_types__list xs, kk_function_t action_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_function_drop(action_0, _ctx);
    kk_box_t _x_x1414 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1414, KK_OWNED, _ctx);
  }
  {
    struct kk_std_core_types_Cons* _con_x1415 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1415->head;
    kk_std_core_types__list xx_0 = _con_x1415->tail;
    kk_reuse_t _ru_x1142 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1142 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x_0_10373;
    kk_function_t _x_x1416 = kk_function_dup(action_0, _ctx); /*(2946) -> 2948 maybe<2947>*/
    x_0_10373 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x_x1416, (_x_x1416, x, _ctx), _ctx); /*maybe<2947>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1142,kk_context());
      kk_std_core_types__maybe_drop(x_0_10373, _ctx);
      kk_box_t _x_x1417 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_map_while_fun1418(_acc_0, action_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1417, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Just(x_0_10373, _ctx)) {
      kk_box_t y_0 = x_0_10373._cons.Just.value;
      kk_std_core_types__list _trmc_x10080_0 = kk_datatype_null(); /*list<2947>*/;
      kk_std_core_types__list _trmc_x10081_0 = kk_std_core_types__new_Cons(_ru_x1142, kk_field_index_of(struct kk_std_core_types_Cons, tail), y_0, _trmc_x10080_0, _ctx); /*list<2947>*/;
      kk_field_addr_t _b_x500_508 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10081_0, _ctx)->tail, _ctx); /*@field-addr<list<2947>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1420 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10081_0, _ctx)),_b_x500_508,kk_context()); /*ctx<0>*/
        xs = xx_0;
        _acc_0 = _x_x1420;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_x1142,kk_context());
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(action_0, _ctx);
      kk_box_t _x_x1421 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
      return kk_std_core_types__list_unbox(_x_x1421, KK_OWNED, _ctx);
    }
  }
}
 
// Invoke `action` on each element of a list while `action` returns `Just`

kk_std_core_types__list kk_std_core_list_map_while(kk_std_core_types__list xs_0, kk_function_t action_1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1422 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_map_while(xs_0, action_1, _x_x1422, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_core_list__mlift_foreach_indexed_10287_fun1425__t {
  struct kk_function_s _base;
  kk_ref_t i;
};
static kk_unit_t kk_std_core_list__mlift_foreach_indexed_10287_fun1425(kk_function_t _fself, kk_integer_t _y_x10193, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_mlift_foreach_indexed_10287_fun1425(kk_ref_t i, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_foreach_indexed_10287_fun1425__t* _self = kk_function_alloc_as(struct kk_std_core_list__mlift_foreach_indexed_10287_fun1425__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__mlift_foreach_indexed_10287_fun1425, kk_context());
  _self->i = i;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_unit_t kk_std_core_list__mlift_foreach_indexed_10287_fun1425(kk_function_t _fself, kk_integer_t _y_x10193, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_foreach_indexed_10287_fun1425__t* _self = kk_function_as(struct kk_std_core_list__mlift_foreach_indexed_10287_fun1425__t*, _fself, _ctx);
  kk_ref_t i = _self->i; /* local-var<3068,int> */
  kk_drop_match(_self, {kk_ref_dup(i, _ctx);}, {}, _ctx)
  kk_integer_t _b_x522_524 = kk_integer_add_small_const(_y_x10193, 1, _ctx); /*int*/;
  kk_unit_t _brw_x1068 = kk_Unit;
  kk_ref_set_borrow(i,(kk_integer_box(_b_x522_524, _ctx)),kk_context());
  kk_ref_drop(i, _ctx);
  _brw_x1068; return kk_Unit;
}


// lift anonymous function
struct kk_std_core_list__mlift_foreach_indexed_10287_fun1427__t {
  struct kk_function_s _base;
  kk_function_t next_10377;
};
static kk_box_t kk_std_core_list__mlift_foreach_indexed_10287_fun1427(kk_function_t _fself, kk_box_t _b_x526, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_mlift_foreach_indexed_10287_fun1427(kk_function_t next_10377, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_foreach_indexed_10287_fun1427__t* _self = kk_function_alloc_as(struct kk_std_core_list__mlift_foreach_indexed_10287_fun1427__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__mlift_foreach_indexed_10287_fun1427, kk_context());
  _self->next_10377 = next_10377;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__mlift_foreach_indexed_10287_fun1427(kk_function_t _fself, kk_box_t _b_x526, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_foreach_indexed_10287_fun1427__t* _self = kk_function_as(struct kk_std_core_list__mlift_foreach_indexed_10287_fun1427__t*, _fself, _ctx);
  kk_function_t next_10377 = _self->next_10377; /* (int) -> <local<3068>|3079> () */
  kk_drop_match(_self, {kk_function_dup(next_10377, _ctx);}, {}, _ctx)
  kk_unit_t _x_x1428 = kk_Unit;
  kk_integer_t _x_x1429 = kk_integer_unbox(_b_x526, _ctx); /*int*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_context_t*), next_10377, (next_10377, _x_x1429, _ctx), _ctx);
  return kk_unit_box(_x_x1428);
}

kk_unit_t kk_std_core_list__mlift_foreach_indexed_10287(kk_ref_t i, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<h,e> (i : local-var<h,int>, wild_ : ()) -> <local<h>|e> () */ 
  kk_integer_t x_10376;
  kk_box_t _x_x1423;
  kk_ref_t _x_x1424 = kk_ref_dup(i, _ctx); /*local-var<3068,int>*/
  _x_x1423 = kk_ref_get(_x_x1424,kk_context()); /*302*/
  x_10376 = kk_integer_unbox(_x_x1423, _ctx); /*int*/
  kk_function_t next_10377 = kk_std_core_list__new_mlift_foreach_indexed_10287_fun1425(i, _ctx); /*(int) -> <local<3068>|3079> ()*/;
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_10376, _ctx);
    kk_box_t _x_x1426 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_mlift_foreach_indexed_10287_fun1427(next_10377, _ctx), _ctx); /*2401*/
    kk_unit_unbox(_x_x1426); return kk_Unit;
  }
  {
    kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_context_t*), next_10377, (next_10377, x_10376, _ctx), _ctx); return kk_Unit;
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core_list__mlift_foreach_indexed_10288_fun1431__t {
  struct kk_function_s _base;
  kk_ref_t i;
};
static kk_box_t kk_std_core_list__mlift_foreach_indexed_10288_fun1431(kk_function_t _fself, kk_box_t _b_x529, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_mlift_foreach_indexed_10288_fun1431(kk_ref_t i, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_foreach_indexed_10288_fun1431__t* _self = kk_function_alloc_as(struct kk_std_core_list__mlift_foreach_indexed_10288_fun1431__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__mlift_foreach_indexed_10288_fun1431, kk_context());
  _self->i = i;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__mlift_foreach_indexed_10288_fun1431(kk_function_t _fself, kk_box_t _b_x529, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_foreach_indexed_10288_fun1431__t* _self = kk_function_as(struct kk_std_core_list__mlift_foreach_indexed_10288_fun1431__t*, _fself, _ctx);
  kk_ref_t i = _self->i; /* local-var<3068,int> */
  kk_drop_match(_self, {kk_ref_dup(i, _ctx);}, {}, _ctx)
  kk_unit_t wild___531 = kk_Unit;
  kk_unit_unbox(_b_x529);
  kk_unit_t _x_x1432 = kk_Unit;
  kk_std_core_list__mlift_foreach_indexed_10287(i, wild___531, _ctx);
  return kk_unit_box(_x_x1432);
}

kk_unit_t kk_std_core_list__mlift_foreach_indexed_10288(kk_function_t action, kk_ref_t i, kk_box_t x, kk_integer_t j, kk_context_t* _ctx) { /* forall<h,a,e> (action : (int, a) -> e (), i : local-var<h,int>, x : a, j : int) -> <local<h>|e> () */ 
  kk_unit_t x_0_10380 = kk_Unit;
  kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), action, (action, j, x, _ctx), _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1430 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_mlift_foreach_indexed_10288_fun1431(i, _ctx), _ctx); /*2401*/
    kk_unit_unbox(_x_x1430); return kk_Unit;
  }
  {
    kk_std_core_list__mlift_foreach_indexed_10287(i, x_0_10380, _ctx); return kk_Unit;
  }
}
 
// Invoke `action` for each element of a list, passing also the position of the element.


// lift anonymous function
struct kk_std_core_list_foreach_indexed_fun1434__t {
  struct kk_function_s _base;
  kk_function_t action;
  kk_ref_t loc;
};
static kk_unit_t kk_std_core_list_foreach_indexed_fun1434(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_foreach_indexed_fun1434(kk_function_t action, kk_ref_t loc, kk_context_t* _ctx) {
  struct kk_std_core_list_foreach_indexed_fun1434__t* _self = kk_function_alloc_as(struct kk_std_core_list_foreach_indexed_fun1434__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_foreach_indexed_fun1434, kk_context());
  _self->action = action;
  _self->loc = loc;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_list_foreach_indexed_fun1438__t {
  struct kk_function_s _base;
  kk_function_t action;
  kk_ref_t loc;
  kk_box_t x;
};
static kk_box_t kk_std_core_list_foreach_indexed_fun1438(kk_function_t _fself, kk_box_t _b_x537, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_foreach_indexed_fun1438(kk_function_t action, kk_ref_t loc, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_list_foreach_indexed_fun1438__t* _self = kk_function_alloc_as(struct kk_std_core_list_foreach_indexed_fun1438__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_foreach_indexed_fun1438, kk_context());
  _self->action = action;
  _self->loc = loc;
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_foreach_indexed_fun1438(kk_function_t _fself, kk_box_t _b_x537, kk_context_t* _ctx) {
  struct kk_std_core_list_foreach_indexed_fun1438__t* _self = kk_function_as(struct kk_std_core_list_foreach_indexed_fun1438__t*, _fself, _ctx);
  kk_function_t action = _self->action; /* (int, 3078) -> 3079 () */
  kk_ref_t loc = _self->loc; /* local-var<3068,int> */
  kk_box_t x = _self->x; /* 3078 */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);kk_ref_dup(loc, _ctx);kk_box_dup(x, _ctx);}, {}, _ctx)
  kk_unit_t _x_x1439 = kk_Unit;
  kk_integer_t _x_x1440 = kk_integer_unbox(_b_x537, _ctx); /*int*/
  kk_std_core_list__mlift_foreach_indexed_10288(action, loc, x, _x_x1440, _ctx);
  return kk_unit_box(_x_x1439);
}
static kk_unit_t kk_std_core_list_foreach_indexed_fun1434(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_list_foreach_indexed_fun1434__t* _self = kk_function_as(struct kk_std_core_list_foreach_indexed_fun1434__t*, _fself, _ctx);
  kk_function_t action = _self->action; /* (int, 3078) -> 3079 () */
  kk_ref_t loc = _self->loc; /* local-var<3068,int> */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);kk_ref_dup(loc, _ctx);}, {}, _ctx)
  kk_integer_t x_0_10385;
  kk_box_t _x_x1435;
  kk_ref_t _x_x1436 = kk_ref_dup(loc, _ctx); /*local-var<3068,int>*/
  _x_x1435 = kk_ref_get(_x_x1436,kk_context()); /*302*/
  x_0_10385 = kk_integer_unbox(_x_x1435, _ctx); /*int*/
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_0_10385, _ctx);
    kk_box_t _x_x1437 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_foreach_indexed_fun1438(action, loc, x, _ctx), _ctx); /*2401*/
    kk_unit_unbox(_x_x1437); return kk_Unit;
  }
  {
    kk_std_core_list__mlift_foreach_indexed_10288(action, loc, x, x_0_10385, _ctx); return kk_Unit;
  }
}

kk_unit_t kk_std_core_list_foreach_indexed(kk_std_core_types__list xs, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, action : (int, a) -> e ()) -> e () */ 
  kk_ref_t loc = kk_ref_alloc((kk_integer_box(kk_integer_from_small(0), _ctx)),kk_context()); /*local-var<3068,int>*/;
  kk_unit_t res = kk_Unit;
  kk_function_t _x_x1433;
  kk_ref_dup(loc, _ctx);
  _x_x1433 = kk_std_core_list_new_foreach_indexed_fun1434(action, loc, _ctx); /*(x : 3078) -> <local<3068>|3079> ()*/
  kk_std_core_list_foreach(xs, _x_x1433, _ctx);
  kk_box_t _x_x1441 = kk_std_core_hnd_prompt_local_var(loc, kk_unit_box(res), _ctx); /*4063*/
  kk_unit_unbox(_x_x1441); return kk_Unit;
}
 
// lifted local: intersperse, before

kk_std_core_types__list kk_std_core_list__trmc_lift_intersperse_5427(kk_box_t sep, kk_std_core_types__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (sep : a, ys : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1442 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1442->head;
    kk_std_core_types__list yy = _con_x1442->tail;
    kk_reuse_t _ru_x1143 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1143 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _trmc_x10082;
    kk_std_core_types__list _x_x1443 = kk_datatype_null(); /*list<3150>*/
    _trmc_x10082 = kk_std_core_types__new_Cons(_ru_x1143, 0, y, _x_x1443, _ctx); /*list<3150>*/
    kk_field_addr_t _b_x549_554 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10082, _ctx)->tail, _ctx); /*@field-addr<list<3150>>*/;
    { // tailcall
      kk_box_t _x_x1444 = kk_box_dup(sep, _ctx); /*3150*/
      kk_std_core_types__cctx _x_x1445;
      kk_box_t _x_x1446;
      kk_std_core_types__list _x_x1447 = kk_std_core_types__new_Cons(kk_reuse_null, 0, sep, _trmc_x10082, _ctx); /*list<82>*/
      _x_x1446 = kk_std_core_types__list_box(_x_x1447, _ctx); /*0*/
      _x_x1445 = kk_cctx_extend_linear(_acc,_x_x1446,_b_x549_554,kk_context()); /*ctx<0>*/
      sep = _x_x1444;
      ys = yy;
      _acc = _x_x1445;
      goto kk__tailcall;
    }
  }
  {
    kk_box_drop(sep, _ctx);
    kk_box_t _x_x1448 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1448, KK_OWNED, _ctx);
  }
}
 
// lifted local: intersperse, before

kk_std_core_types__list kk_std_core_list__lift_intersperse_5427(kk_box_t sep_0, kk_std_core_types__list ys_0, kk_context_t* _ctx) { /* forall<a> (sep : a, ys : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x_x1449 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_intersperse_5427(sep_0, ys_0, _x_x1449, _ctx);
}
 
// Insert a separator `sep`  between all elements of a list `xs` .

kk_std_core_types__list kk_std_core_list_intersperse(kk_std_core_types__list xs, kk_box_t sep, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, sep : a) -> list<a> */ 
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1450 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1450->head;
    kk_std_core_types__list xx = _con_x1450->tail;
    kk_reuse_t _ru_x1144 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1144 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__list _x_x1451;
    kk_std_core_types__cctx _x_x1452 = kk_cctx_empty(kk_context()); /*ctx<0>*/
    _x_x1451 = kk_std_core_list__trmc_lift_intersperse_5427(sep, xx, _x_x1452, _ctx); /*list<3150>*/
    return kk_std_core_types__new_Cons(_ru_x1144, 0, x, _x_x1451, _ctx);
  }
  {
    kk_box_drop(sep, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
}
 
// Concatenate all strings in a list

kk_string_t kk_std_core_list_joinsep(kk_std_core_types__list xs, kk_string_t sep, kk_context_t* _ctx) { /* (xs : list<string>, sep : string) -> string */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_string_drop(sep, _ctx);
    return kk_string_empty();
  }
  {
    struct kk_std_core_types_Cons* _con_x1454 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x560 = _con_x1454->head;
    kk_std_core_types__list _pat_1 = _con_x1454->tail;
    if (kk_std_core_types__is_Nil(_pat_1, _ctx)) {
      kk_string_t x = kk_string_unbox(_box_x560);
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_string_drop(sep, _ctx);
      return x;
    }
  }
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1455 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x561 = _con_x1455->head;
    kk_std_core_types__list _pat_3 = _con_x1455->tail;
    if (kk_std_core_types__is_Cons(_pat_3, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1456 = kk_std_core_types__as_Cons(_pat_3, _ctx);
      kk_box_t _box_x562 = _con_x1456->head;
      kk_std_core_types__list _pat_4 = _con_x1456->tail;
      if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
        kk_string_t _x_x1457 = kk_string_dup(sep, _ctx); /*string*/
        kk_string_t _x_x1458 = kk_string_empty(); /*string*/
        if (kk_string_is_eq(_x_x1457,_x_x1458,kk_context())) {
          kk_string_t x_0 = kk_string_unbox(_box_x561);
          kk_string_t y = kk_string_unbox(_box_x562);
          if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
            if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
              kk_datatype_ptr_free(_pat_3, _ctx);
            }
            else {
              kk_string_dup(y, _ctx);
              kk_datatype_ptr_decref(_pat_3, _ctx);
            }
            kk_datatype_ptr_free(xs, _ctx);
          }
          else {
            kk_string_dup(x_0, _ctx);
            kk_string_dup(y, _ctx);
            kk_datatype_ptr_decref(xs, _ctx);
          }
          kk_string_drop(sep, _ctx);
          return kk_std_core_types__lp__plus__plus__rp_(x_0, y, _ctx);
        }
      }
    }
  }
  {
    kk_vector_t _x_x1460 = kk_std_core_vector_unvlist(xs, _ctx); /*vector<911>*/
    return kk_string_join_with(_x_x1460,sep,kk_context());
  }
}
 
// Concatenate all strings in a list

kk_string_t kk_std_core_list_concat_fs_join(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_types_Cons* _con_x1462 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x563 = _con_x1462->head;
    kk_std_core_types__list _pat_1 = _con_x1462->tail;
    if (kk_std_core_types__is_Nil(_pat_1, _ctx)) {
      kk_string_t x = kk_string_unbox(_box_x563);
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      return x;
    }
  }
  {
    struct kk_std_core_types_Cons* _con_x1463 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x564 = _con_x1463->head;
    kk_std_core_types__list _pat_3 = _con_x1463->tail;
    struct kk_std_core_types_Cons* _con_x1464 = kk_std_core_types__as_Cons(_pat_3, _ctx);
    kk_box_t _box_x565 = _con_x1464->head;
    kk_std_core_types__list _pat_4 = _con_x1464->tail;
    if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
      kk_string_t x_0 = kk_string_unbox(_box_x564);
      kk_string_t y = kk_string_unbox(_box_x565);
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
          kk_datatype_ptr_free(_pat_3, _ctx);
        }
        else {
          kk_string_dup(y, _ctx);
          kk_datatype_ptr_decref(_pat_3, _ctx);
        }
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_string_dup(x_0, _ctx);
        kk_string_dup(y, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      return kk_std_core_types__lp__plus__plus__rp_(x_0, y, _ctx);
    }
  }
  {
    kk_vector_t _x_x1465 = kk_std_core_vector_unvlist(xs, _ctx); /*vector<911>*/
    return kk_string_join(_x_x1465,kk_context());
  }
}
 
// monadic lift

kk_string_t kk_std_core_list__mlift_show_10289(kk_std_core_types__list _y_x10198, kk_context_t* _ctx) { /* forall<e> (list<string>) -> e string */ 
  kk_string_t _x_x1466;
  kk_define_string_literal(, _s_x1467, 1, "[", _ctx)
  _x_x1466 = kk_string_dup(_s_x1467, _ctx); /*string*/
  kk_string_t _x_x1468;
  kk_string_t _x_x1469;
  if (kk_std_core_types__is_Nil(_y_x10198, _ctx)) {
    _x_x1469 = kk_string_empty(); /*string*/
    goto _match_x1470;
  }
  {
    struct kk_std_core_types_Cons* _con_x1472 = kk_std_core_types__as_Cons(_y_x10198, _ctx);
    kk_box_t _box_x566 = _con_x1472->head;
    kk_std_core_types__list _pat_1 = _con_x1472->tail;
    if (kk_std_core_types__is_Nil(_pat_1, _ctx)) {
      kk_string_t x = kk_string_unbox(_box_x566);
      if kk_likely(kk_datatype_ptr_is_unique(_y_x10198, _ctx)) {
        kk_datatype_ptr_free(_y_x10198, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_datatype_ptr_decref(_y_x10198, _ctx);
      }
      _x_x1469 = x; /*string*/
      goto _match_x1470;
    }
  }
  if (kk_std_core_types__is_Cons(_y_x10198, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1473 = kk_std_core_types__as_Cons(_y_x10198, _ctx);
    kk_box_t _box_x567 = _con_x1473->head;
    kk_std_core_types__list _pat_3 = _con_x1473->tail;
    if (kk_std_core_types__is_Cons(_pat_3, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1474 = kk_std_core_types__as_Cons(_pat_3, _ctx);
      kk_box_t _box_x568 = _con_x1474->head;
      kk_std_core_types__list _pat_4 = _con_x1474->tail;
      if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
        kk_string_t _x_x1475;
        kk_define_string_literal(, _s_x1476, 1, ",", _ctx)
        _x_x1475 = kk_string_dup(_s_x1476, _ctx); /*string*/
        kk_string_t _x_x1477 = kk_string_empty(); /*string*/
        if (kk_string_is_eq(_x_x1475,_x_x1477,kk_context())) {
          kk_string_t x_0 = kk_string_unbox(_box_x567);
          kk_string_t y = kk_string_unbox(_box_x568);
          if kk_likely(kk_datatype_ptr_is_unique(_y_x10198, _ctx)) {
            if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
              kk_datatype_ptr_free(_pat_3, _ctx);
            }
            else {
              kk_string_dup(y, _ctx);
              kk_datatype_ptr_decref(_pat_3, _ctx);
            }
            kk_datatype_ptr_free(_y_x10198, _ctx);
          }
          else {
            kk_string_dup(x_0, _ctx);
            kk_string_dup(y, _ctx);
            kk_datatype_ptr_decref(_y_x10198, _ctx);
          }
          _x_x1469 = kk_std_core_types__lp__plus__plus__rp_(x_0, y, _ctx); /*string*/
          goto _match_x1470;
        }
      }
    }
  }
  {
    kk_vector_t _x_x1479 = kk_std_core_vector_unvlist(_y_x10198, _ctx); /*vector<911>*/
    kk_string_t _x_x1480;
    kk_define_string_literal(, _s_x1481, 1, ",", _ctx)
    _x_x1480 = kk_string_dup(_s_x1481, _ctx); /*string*/
    _x_x1469 = kk_string_join_with(_x_x1479,_x_x1480,kk_context()); /*string*/
  }
  _match_x1470: ;
  kk_string_t _x_x1482;
  kk_define_string_literal(, _s_x1483, 1, "]", _ctx)
  _x_x1482 = kk_string_dup(_s_x1483, _ctx); /*string*/
  _x_x1468 = kk_std_core_types__lp__plus__plus__rp_(_x_x1469, _x_x1482, _ctx); /*string*/
  return kk_std_core_types__lp__plus__plus__rp_(_x_x1466, _x_x1468, _ctx);
}
 
// Show a list


// lift anonymous function
struct kk_std_core_list_show_fun1484__t {
  struct kk_function_s _base;
  kk_function_t _implicit_fs_show;
};
static kk_box_t kk_std_core_list_show_fun1484(kk_function_t _fself, kk_box_t _b_x572, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_show_fun1484(kk_function_t _implicit_fs_show, kk_context_t* _ctx) {
  struct kk_std_core_list_show_fun1484__t* _self = kk_function_alloc_as(struct kk_std_core_list_show_fun1484__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_show_fun1484, kk_context());
  _self->_implicit_fs_show = _implicit_fs_show;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_show_fun1484(kk_function_t _fself, kk_box_t _b_x572, kk_context_t* _ctx) {
  struct kk_std_core_list_show_fun1484__t* _self = kk_function_as(struct kk_std_core_list_show_fun1484__t*, _fself, _ctx);
  kk_function_t _implicit_fs_show = _self->_implicit_fs_show; /* (3341) -> 3342 string */
  kk_drop_match(_self, {kk_function_dup(_implicit_fs_show, _ctx);}, {}, _ctx)
  kk_string_t _x_x1485 = kk_function_call(kk_string_t, (kk_function_t, kk_box_t, kk_context_t*), _implicit_fs_show, (_implicit_fs_show, _b_x572, _ctx), _ctx); /*string*/
  return kk_string_box(_x_x1485);
}


// lift anonymous function
struct kk_std_core_list_show_fun1487__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_show_fun1487(kk_function_t _fself, kk_box_t _b_x577, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_show_fun1487(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_show_fun1487, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_show_fun1487(kk_function_t _fself, kk_box_t _b_x577, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _y_x10198_582 = kk_std_core_types__list_unbox(_b_x577, KK_OWNED, _ctx); /*list<string>*/;
  kk_string_t _x_x1488 = kk_std_core_list__mlift_show_10289(_y_x10198_582, _ctx); /*string*/
  return kk_string_box(_x_x1488);
}

kk_string_t kk_std_core_list_show(kk_std_core_types__list xs, kk_function_t _implicit_fs_show, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, ?show : (a) -> e string) -> e string */ 
  kk_std_core_types__cctx _b_x571_575 = kk_cctx_empty(kk_context()); /*ctx<list<string>>*/;
  kk_std_core_types__list x_10389;
  kk_function_t _brw_x1063 = kk_std_core_list_new_show_fun1484(_implicit_fs_show, _ctx); /*(2105) -> 2107 2106*/;
  kk_std_core_types__list _brw_x1064 = kk_std_core_list__trmc_map(xs, _brw_x1063, _b_x571_575, _ctx); /*list<2106>*/;
  kk_function_drop(_brw_x1063, _ctx);
  x_10389 = _brw_x1064; /*list<string>*/
  if (kk_yielding(kk_context())) {
    kk_std_core_types__list_drop(x_10389, _ctx);
    kk_box_t _x_x1486 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_show_fun1487(_ctx), _ctx); /*2401*/
    return kk_string_unbox(_x_x1486);
  }
  {
    kk_string_t _x_x1489;
    kk_define_string_literal(, _s_x1490, 1, "[", _ctx)
    _x_x1489 = kk_string_dup(_s_x1490, _ctx); /*string*/
    kk_string_t _x_x1491;
    kk_string_t _x_x1492;
    if (kk_std_core_types__is_Nil(x_10389, _ctx)) {
      _x_x1492 = kk_string_empty(); /*string*/
      goto _match_x1493;
    }
    {
      struct kk_std_core_types_Cons* _con_x1495 = kk_std_core_types__as_Cons(x_10389, _ctx);
      kk_box_t _box_x578 = _con_x1495->head;
      kk_std_core_types__list _pat_1_0 = _con_x1495->tail;
      if (kk_std_core_types__is_Nil(_pat_1_0, _ctx)) {
        kk_string_t x_0 = kk_string_unbox(_box_x578);
        if kk_likely(kk_datatype_ptr_is_unique(x_10389, _ctx)) {
          kk_datatype_ptr_free(x_10389, _ctx);
        }
        else {
          kk_string_dup(x_0, _ctx);
          kk_datatype_ptr_decref(x_10389, _ctx);
        }
        _x_x1492 = x_0; /*string*/
        goto _match_x1493;
      }
    }
    if (kk_std_core_types__is_Cons(x_10389, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1496 = kk_std_core_types__as_Cons(x_10389, _ctx);
      kk_box_t _box_x579 = _con_x1496->head;
      kk_std_core_types__list _pat_3 = _con_x1496->tail;
      if (kk_std_core_types__is_Cons(_pat_3, _ctx)) {
        struct kk_std_core_types_Cons* _con_x1497 = kk_std_core_types__as_Cons(_pat_3, _ctx);
        kk_box_t _box_x580 = _con_x1497->head;
        kk_std_core_types__list _pat_4 = _con_x1497->tail;
        if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
          kk_string_t _x_x1498;
          kk_define_string_literal(, _s_x1499, 1, ",", _ctx)
          _x_x1498 = kk_string_dup(_s_x1499, _ctx); /*string*/
          kk_string_t _x_x1500 = kk_string_empty(); /*string*/
          if (kk_string_is_eq(_x_x1498,_x_x1500,kk_context())) {
            kk_string_t x_0_0 = kk_string_unbox(_box_x579);
            kk_string_t y = kk_string_unbox(_box_x580);
            if kk_likely(kk_datatype_ptr_is_unique(x_10389, _ctx)) {
              if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
                kk_datatype_ptr_free(_pat_3, _ctx);
              }
              else {
                kk_string_dup(y, _ctx);
                kk_datatype_ptr_decref(_pat_3, _ctx);
              }
              kk_datatype_ptr_free(x_10389, _ctx);
            }
            else {
              kk_string_dup(x_0_0, _ctx);
              kk_string_dup(y, _ctx);
              kk_datatype_ptr_decref(x_10389, _ctx);
            }
            _x_x1492 = kk_std_core_types__lp__plus__plus__rp_(x_0_0, y, _ctx); /*string*/
            goto _match_x1493;
          }
        }
      }
    }
    {
      kk_vector_t _x_x1502 = kk_std_core_vector_unvlist(x_10389, _ctx); /*vector<911>*/
      kk_string_t _x_x1503;
      kk_define_string_literal(, _s_x1504, 1, ",", _ctx)
      _x_x1503 = kk_string_dup(_s_x1504, _ctx); /*string*/
      _x_x1492 = kk_string_join_with(_x_x1502,_x_x1503,kk_context()); /*string*/
    }
    _match_x1493: ;
    kk_string_t _x_x1505;
    kk_define_string_literal(, _s_x1506, 1, "]", _ctx)
    _x_x1505 = kk_string_dup(_s_x1506, _ctx); /*string*/
    _x_x1491 = kk_std_core_types__lp__plus__plus__rp_(_x_x1492, _x_x1505, _ctx); /*string*/
    return kk_std_core_types__lp__plus__plus__rp_(_x_x1489, _x_x1491, _ctx);
  }
}
 
// Zip two lists together by pairing the corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core_types__list kk_std_core_list__trmc_zip(kk_std_core_types__list xs, kk_std_core_types__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a,b> (xs : list<a>, ys : list<b>, ctx<list<(a, b)>>) -> list<(a, b)> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1507 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1507->head;
    kk_std_core_types__list xx = _con_x1507->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Cons(ys, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1508 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t y = _con_x1508->head;
      kk_std_core_types__list yy = _con_x1508->tail;
      kk_reuse_t _ru_x1158 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_x1158 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core_types__list_dup(yy, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_std_core_types__list _trmc_x10084 = kk_datatype_null(); /*list<(3454, 3455)>*/;
      kk_std_core_types__list _trmc_x10085;
      kk_box_t _x_x1509;
      kk_std_core_types__tuple2 _x_x1510 = kk_std_core_types__new_Tuple2(x, y, _ctx); /*(137, 138)*/
      _x_x1509 = kk_std_core_types__tuple2_box(_x_x1510, _ctx); /*82*/
      _trmc_x10085 = kk_std_core_types__new_Cons(_ru_x1158, 0, _x_x1509, _trmc_x10084, _ctx); /*list<(3454, 3455)>*/
      kk_field_addr_t _b_x592_599 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10085, _ctx)->tail, _ctx); /*@field-addr<list<(3454, 3455)>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1511 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10085, _ctx)),_b_x592_599,kk_context()); /*ctx<0>*/
        xs = xx;
        ys = yy;
        _acc = _x_x1511;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core_types__list_drop(xx, _ctx);
      kk_box_drop(x, _ctx);
      kk_box_t _x_x1512 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
      return kk_std_core_types__list_unbox(_x_x1512, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core_types__list_drop(ys, _ctx);
    kk_box_t _x_x1513 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1513, KK_OWNED, _ctx);
  }
}
 
// Zip two lists together by pairing the corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core_types__list kk_std_core_list_zip(kk_std_core_types__list xs_0, kk_std_core_types__list ys_0, kk_context_t* _ctx) { /* forall<a,b> (xs : list<a>, ys : list<b>) -> list<(a, b)> */ 
  kk_std_core_types__cctx _x_x1514 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_zip(xs_0, ys_0, _x_x1514, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_zipwith_10290(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core_types__list xx, kk_std_core_types__list yy, kk_box_t _trmc_x10086, kk_context_t* _ctx) { /* forall<a,b,c,e> (ctx<list<c>>, f : (a, b) -> e c, xx : list<a>, yy : list<b>, c) -> e list<c> */ 
  kk_std_core_types__list _trmc_x10087 = kk_datatype_null(); /*list<3534>*/;
  kk_std_core_types__list _trmc_x10088 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10086, _trmc_x10087, _ctx); /*list<3534>*/;
  kk_field_addr_t _b_x612_615 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10088, _ctx)->tail, _ctx); /*@field-addr<list<3534>>*/;
  kk_std_core_types__cctx _own_x1060 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10088, _ctx)),_b_x612_615,kk_context()); /*ctx<0>*/;
  kk_std_core_types__list _brw_x1061 = kk_std_core_list__trmc_zipwith(xx, yy, f, _own_x1060, _ctx); /*list<3534>*/;
  kk_function_drop(f, _ctx);
  return _brw_x1061;
}
 
// Zip two lists together by apply a function `f` to all corresponding elements.
// The returned list is only as long as the smallest input list.


// lift anonymous function
struct kk_std_core_list__trmc_zipwith_fun1520__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_std_core_types__list xx_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__trmc_zipwith_fun1520(kk_function_t _fself, kk_box_t _b_x620, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_zipwith_fun1520(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_std_core_types__list xx_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_zipwith_fun1520__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_zipwith_fun1520__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_zipwith_fun1520, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->xx_0 = xx_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_zipwith_fun1520(kk_function_t _fself, kk_box_t _b_x620, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_zipwith_fun1520__t* _self = kk_function_as(struct kk_std_core_list__trmc_zipwith_fun1520__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<3534>> */
  kk_function_t f_0 = _self->f_0; /* (3532, 3533) -> 3535 3534 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<3532> */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<3533> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10086_0_642 = _b_x620; /*3534*/;
  kk_std_core_types__list _x_x1521 = kk_std_core_list__mlift_trmc_zipwith_10290(_acc_0, f_0, xx_0, yy_0, _trmc_x10086_0_642, _ctx); /*list<3534>*/
  return kk_std_core_types__list_box(_x_x1521, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_zipwith(kk_std_core_types__list xs, kk_std_core_types__list ys, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,c,e> (xs : list<a>, ys : list<b>, f : (a, b) -> e c, ctx<list<c>>) -> e list<c> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1515 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1515->head;
    kk_std_core_types__list xx_0 = _con_x1515->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Cons(ys, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1516 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t y = _con_x1516->head;
      kk_std_core_types__list yy_0 = _con_x1516->tail;
      kk_reuse_t _ru_x1160 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_x1160 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core_types__list_dup(yy_0, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_box_t x_0_10394;
      kk_function_t _x_x1517 = kk_function_dup(f_0, _ctx); /*(3532, 3533) -> 3535 3534*/
      x_0_10394 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x_x1517, (_x_x1517, x, y, _ctx), _ctx); /*3534*/
      if (kk_yielding(kk_context())) {
        kk_reuse_drop(_ru_x1160,kk_context());
        kk_box_drop(x_0_10394, _ctx);
        kk_box_t _x_x1518;
        kk_function_t _x_x1519;
        kk_function_dup(f_0, _ctx);
        _x_x1519 = kk_std_core_list__new_trmc_zipwith_fun1520(_acc_0, f_0, xx_0, yy_0, _ctx); /*(2400) -> 2402 2401*/
        _x_x1518 = kk_std_core_hnd_yield_extend(_x_x1519, _ctx); /*2401*/
        return kk_std_core_types__list_unbox(_x_x1518, KK_OWNED, _ctx);
      }
      {
        kk_std_core_types__list _trmc_x10087_0 = kk_datatype_null(); /*list<3534>*/;
        kk_std_core_types__list _trmc_x10088_0 = kk_std_core_types__new_Cons(_ru_x1160, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0_10394, _trmc_x10087_0, _ctx); /*list<3534>*/;
        kk_field_addr_t _b_x626_634 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10088_0, _ctx)->tail, _ctx); /*@field-addr<list<3534>>*/;
        kk_std_core_types__cctx _own_x1059 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10088_0, _ctx)),_b_x626_634,kk_context()); /*ctx<0>*/;
        { // tailcall
          xs = xx_0;
          ys = yy_0;
          _acc_0 = _own_x1059;
          goto kk__tailcall;
        }
      }
    }
    {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_box_drop(x, _ctx);
      kk_box_t _x_x1522 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
      return kk_std_core_types__list_unbox(_x_x1522, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core_types__list_drop(ys, _ctx);
    kk_box_t _x_x1523 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1523, KK_OWNED, _ctx);
  }
}
 
// Zip two lists together by apply a function `f` to all corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core_types__list kk_std_core_list_zipwith(kk_std_core_types__list xs_0, kk_std_core_types__list ys_0, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,b,c,e> (xs : list<a>, ys : list<b>, f : (a, b) -> e c) -> e list<c> */ 
  kk_std_core_types__cctx _own_x1057 = kk_cctx_empty(kk_context()); /*ctx<0>*/;
  return kk_std_core_list__trmc_zipwith(xs_0, ys_0, f_1, _own_x1057, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_zipwith_iter_10291(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i, kk_std_core_types__list xx, kk_std_core_types__list yy, kk_box_t _trmc_x10089, kk_context_t* _ctx) { /* forall<a,b,c,d,e> (ctx<list<a>>, f : (int, b, c) -> e d, i : int, xx : list<b>, yy : list<c>, d) -> e list<d> */ 
  kk_std_core_types__list _trmc_x10090 = kk_datatype_null(); /*list<3616>*/;
  kk_std_core_types__list _trmc_x10091 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10089, _trmc_x10090, _ctx); /*list<3616>*/;
  kk_field_addr_t _b_x648_651 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10091, _ctx)->tail, _ctx); /*@field-addr<list<3616>>*/;
  kk_integer_t _own_x1055 = kk_integer_add_small_const(i, 1, _ctx); /*int*/;
  kk_std_core_types__cctx _own_x1054 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10091, _ctx)),_b_x648_651,kk_context()); /*ctx<0>*/;
  kk_std_core_types__list _brw_x1056 = kk_std_core_list__trmc_zipwith_iter(_own_x1055, xx, yy, f, _own_x1054, _ctx); /*list<3612>*/;
  kk_function_drop(f, _ctx);
  return _brw_x1056;
}


// lift anonymous function
struct kk_std_core_list__trmc_zipwith_iter_fun1530__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_integer_t i_0;
  kk_std_core_types__list xx_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__trmc_zipwith_iter_fun1530(kk_function_t _fself, kk_box_t _b_x656, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_zipwith_iter_fun1530(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_integer_t i_0, kk_std_core_types__list xx_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_zipwith_iter_fun1530__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_zipwith_iter_fun1530__t, 7, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_zipwith_iter_fun1530, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->i_0 = i_0;
  _self->xx_0 = xx_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_zipwith_iter_fun1530(kk_function_t _fself, kk_box_t _b_x656, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_zipwith_iter_fun1530__t* _self = kk_function_as(struct kk_std_core_list__trmc_zipwith_iter_fun1530__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<3612>> */
  kk_function_t f_0 = _self->f_0; /* (int, 3614, 3615) -> 3617 3616 */
  kk_integer_t i_0 = _self->i_0; /* int */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<3614> */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<3615> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_integer_dup(i_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10089_0_678 = _b_x656; /*3616*/;
  kk_std_core_types__list _x_x1531 = kk_std_core_list__mlift_trmc_zipwith_iter_10291(_acc_0, f_0, i_0, xx_0, yy_0, _trmc_x10089_0_678, _ctx); /*list<3616>*/
  return kk_std_core_types__list_box(_x_x1531, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_zipwith_iter(kk_integer_t i_0, kk_std_core_types__list xs, kk_std_core_types__list ys, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,c,e> (i : int, xs : list<a>, ys : list<b>, f : (int, a, b) -> e c, ctx<list<c>>) -> e list<c> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1524 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1524->head;
    kk_std_core_types__list xx_0 = _con_x1524->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Cons(ys, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1525 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t y = _con_x1525->head;
      kk_std_core_types__list yy_0 = _con_x1525->tail;
      kk_reuse_t _ru_x1162 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_x1162 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core_types__list_dup(yy_0, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_box_t x_0_10397;
      kk_function_t _x_x1527 = kk_function_dup(f_0, _ctx); /*(int, 3614, 3615) -> 3617 3616*/
      kk_integer_t _x_x1526 = kk_integer_dup(i_0, _ctx); /*int*/
      x_0_10397 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_box_t, kk_context_t*), _x_x1527, (_x_x1527, _x_x1526, x, y, _ctx), _ctx); /*3616*/
      if (kk_yielding(kk_context())) {
        kk_reuse_drop(_ru_x1162,kk_context());
        kk_box_drop(x_0_10397, _ctx);
        kk_box_t _x_x1528;
        kk_function_t _x_x1529;
        kk_function_dup(f_0, _ctx);
        _x_x1529 = kk_std_core_list__new_trmc_zipwith_iter_fun1530(_acc_0, f_0, i_0, xx_0, yy_0, _ctx); /*(2400) -> 2402 2401*/
        _x_x1528 = kk_std_core_hnd_yield_extend(_x_x1529, _ctx); /*2401*/
        return kk_std_core_types__list_unbox(_x_x1528, KK_OWNED, _ctx);
      }
      {
        kk_std_core_types__list _trmc_x10090_0 = kk_datatype_null(); /*list<3616>*/;
        kk_std_core_types__list _trmc_x10091_0 = kk_std_core_types__new_Cons(_ru_x1162, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0_10397, _trmc_x10090_0, _ctx); /*list<3616>*/;
        kk_field_addr_t _b_x662_670 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10091_0, _ctx)->tail, _ctx); /*@field-addr<list<3616>>*/;
        kk_integer_t _own_x1053 = kk_integer_add_small_const(i_0, 1, _ctx); /*int*/;
        kk_std_core_types__cctx _own_x1052 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10091_0, _ctx)),_b_x662_670,kk_context()); /*ctx<0>*/;
        { // tailcall
          i_0 = _own_x1053;
          xs = xx_0;
          ys = yy_0;
          _acc_0 = _own_x1052;
          goto kk__tailcall;
        }
      }
    }
    {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_box_drop(x, _ctx);
      kk_integer_drop(i_0, _ctx);
      kk_box_t _x_x1532 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
      return kk_std_core_types__list_unbox(_x_x1532, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core_types__list_drop(ys, _ctx);
    kk_integer_drop(i_0, _ctx);
    kk_box_t _x_x1533 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1533, KK_OWNED, _ctx);
  }
}

kk_std_core_types__list kk_std_core_list_zipwith_iter(kk_integer_t i_1, kk_std_core_types__list xs_0, kk_std_core_types__list ys_0, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,b,c,e> (i : int, xs : list<a>, ys : list<b>, f : (int, a, b) -> e c) -> e list<c> */ 
  kk_std_core_types__cctx _own_x1050 = kk_cctx_empty(kk_context()); /*ctx<0>*/;
  return kk_std_core_list__trmc_zipwith_iter(i_1, xs_0, ys_0, f_1, _own_x1050, _ctx);
}
 
// lifted local: unzip, iter

kk_std_core_types__tuple2 kk_std_core_list__lift_unzip_5428(kk_std_core_types__list ys, kk_std_core_types__cctx acc1, kk_std_core_types__cctx acc2, kk_context_t* _ctx) { /* forall<a,b,c,d> (ys : list<(a, b)>, acc1 : cctx<c,list<a>>, acc2 : cctx<d,list<b>>) -> (c, d) */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1534 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t _box_x679 = _con_x1534->head;
    kk_std_core_types__tuple2 _pat_0 = kk_std_core_types__tuple2_unbox(_box_x679, KK_BORROWED, _ctx);
    kk_std_core_types__list xx = _con_x1534->tail;
    kk_box_t x = _pat_0.fst;
    kk_box_t y = _pat_0.snd;
    kk_reuse_t _ru_x1163 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_box_dup(x, _ctx);
      kk_box_dup(y, _ctx);
      kk_box_drop(_box_x679, _ctx);
      _ru_x1163 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_box_dup(y, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _cctx_x3716;
    kk_std_core_types__list _x_x1535 = kk_datatype_null(); /*list<3816>*/
    _cctx_x3716 = kk_std_core_types__new_Cons(_ru_x1163, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _x_x1535, _ctx); /*list<3816>*/
    kk_field_addr_t _cctx_x3717 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x3716, _ctx)->tail, _ctx); /*@field-addr<list<3816>>*/;
    kk_std_core_types__list _cctx_x3756;
    kk_std_core_types__list _x_x1536 = kk_datatype_null(); /*list<3817>*/
    _cctx_x3756 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _x_x1536, _ctx); /*list<3817>*/
    kk_field_addr_t _cctx_x3757 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x3756, _ctx)->tail, _ctx); /*@field-addr<list<3817>>*/;
    kk_std_core_types__list _b_x692_700 = _cctx_x3716; /*list<3816>*/;
    kk_field_addr_t _b_x693_701 = _cctx_x3717; /*@field-addr<list<3816>>*/;
    kk_std_core_types__list _b_x694_702 = _cctx_x3756; /*list<3817>*/;
    kk_field_addr_t _b_x695_703 = _cctx_x3757; /*@field-addr<list<3817>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1537;
      kk_std_core_types__cctx _x_x1538 = kk_cctx_create((kk_std_core_types__list_box(_b_x692_700, _ctx)),_b_x693_701,kk_context()); /*cctx<0,1>*/
      _x_x1537 = kk_cctx_compose(acc1,_x_x1538,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1539;
      kk_std_core_types__cctx _x_x1540 = kk_cctx_create((kk_std_core_types__list_box(_b_x694_702, _ctx)),_b_x695_703,kk_context()); /*cctx<0,1>*/
      _x_x1539 = kk_cctx_compose(acc2,_x_x1540,kk_context()); /*cctx<398,400>*/
      ys = xx;
      acc1 = _x_x1537;
      acc2 = _x_x1539;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x_x1541 = kk_cctx_apply(acc1,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1542 = kk_cctx_apply(acc2,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    return kk_std_core_types__new_Tuple2(_x_x1541, _x_x1542, _ctx);
  }
}
 
// lifted local: unzip3, iter

kk_std_core_types__tuple3 kk_std_core_list__lift_unzip3_5429(kk_std_core_types__list ys, kk_std_core_types__cctx acc1, kk_std_core_types__cctx acc2, kk_std_core_types__cctx acc3, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,b1> (ys : list<(a, b, c)>, acc1 : cctx<d,list<a>>, acc2 : cctx<a1,list<b>>, acc3 : cctx<b1,list<c>>) -> (d, a1, b1) */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1545 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t _box_x708 = _con_x1545->head;
    kk_std_core_types__tuple3 _pat_0 = kk_std_core_types__tuple3_unbox(_box_x708, KK_BORROWED, _ctx);
    kk_std_core_types__list xx = _con_x1545->tail;
    kk_box_t x = _pat_0.fst;
    kk_box_t y = _pat_0.snd;
    kk_box_t z = _pat_0.thd;
    kk_reuse_t _ru_x1164 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_box_dup(x, _ctx);
      kk_box_dup(y, _ctx);
      kk_box_dup(z, _ctx);
      kk_box_drop(_box_x708, _ctx);
      _ru_x1164 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_box_dup(y, _ctx);
      kk_box_dup(z, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _cctx_x3919;
    kk_std_core_types__list _x_x1546 = kk_datatype_null(); /*list<4077>*/
    _cctx_x3919 = kk_std_core_types__new_Cons(_ru_x1164, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _x_x1546, _ctx); /*list<4077>*/
    kk_field_addr_t _cctx_x3920 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x3919, _ctx)->tail, _ctx); /*@field-addr<list<4077>>*/;
    kk_std_core_types__list _cctx_x3959;
    kk_std_core_types__list _x_x1547 = kk_datatype_null(); /*list<4078>*/
    _cctx_x3959 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _x_x1547, _ctx); /*list<4078>*/
    kk_field_addr_t _cctx_x3960 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x3959, _ctx)->tail, _ctx); /*@field-addr<list<4078>>*/;
    kk_std_core_types__list _cctx_x3999;
    kk_std_core_types__list _x_x1548 = kk_datatype_null(); /*list<4079>*/
    _cctx_x3999 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), z, _x_x1548, _ctx); /*list<4079>*/
    kk_field_addr_t _cctx_x4000 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x3999, _ctx)->tail, _ctx); /*@field-addr<list<4079>>*/;
    kk_std_core_types__list _b_x727_739 = _cctx_x3919; /*list<4077>*/;
    kk_field_addr_t _b_x728_740 = _cctx_x3920; /*@field-addr<list<4077>>*/;
    kk_std_core_types__list _b_x729_741 = _cctx_x3959; /*list<4078>*/;
    kk_field_addr_t _b_x730_742 = _cctx_x3960; /*@field-addr<list<4078>>*/;
    kk_std_core_types__list _b_x731_743 = _cctx_x3999; /*list<4079>*/;
    kk_field_addr_t _b_x732_744 = _cctx_x4000; /*@field-addr<list<4079>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1549;
      kk_std_core_types__cctx _x_x1550 = kk_cctx_create((kk_std_core_types__list_box(_b_x727_739, _ctx)),_b_x728_740,kk_context()); /*cctx<0,1>*/
      _x_x1549 = kk_cctx_compose(acc1,_x_x1550,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1551;
      kk_std_core_types__cctx _x_x1552 = kk_cctx_create((kk_std_core_types__list_box(_b_x729_741, _ctx)),_b_x730_742,kk_context()); /*cctx<0,1>*/
      _x_x1551 = kk_cctx_compose(acc2,_x_x1552,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1553;
      kk_std_core_types__cctx _x_x1554 = kk_cctx_create((kk_std_core_types__list_box(_b_x731_743, _ctx)),_b_x732_744,kk_context()); /*cctx<0,1>*/
      _x_x1553 = kk_cctx_compose(acc3,_x_x1554,kk_context()); /*cctx<398,400>*/
      ys = xx;
      acc1 = _x_x1549;
      acc2 = _x_x1551;
      acc3 = _x_x1553;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x_x1555 = kk_cctx_apply(acc1,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1556 = kk_cctx_apply(acc2,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1557 = kk_cctx_apply(acc3,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    return kk_std_core_types__new_Tuple3(_x_x1555, _x_x1556, _x_x1557, _ctx);
  }
}
 
// lifted local: unzip4, iter

kk_std_core_types__tuple4 kk_std_core_list__lift_unzip4_5430(kk_std_core_types__list ys, kk_std_core_types__cctx acc1, kk_std_core_types__cctx acc2, kk_std_core_types__cctx acc3, kk_std_core_types__cctx acc4, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,b1,c1,d1> (ys : list<(a, b, c, d)>, acc1 : cctx<a1,list<a>>, acc2 : cctx<b1,list<b>>, acc3 : cctx<c1,list<c>>, acc4 : cctx<d1,list<d>>) -> (a1, b1, c1, d1) */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1561 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t _box_x751 = _con_x1561->head;
    kk_std_core_types__tuple4 _pat_0 = kk_std_core_types__tuple4_unbox(_box_x751, KK_BORROWED, _ctx);
    struct kk_std_core_types_Tuple4* _con_x1562 = kk_std_core_types__as_Tuple4(_pat_0, _ctx);
    kk_std_core_types__list xx = _con_x1561->tail;
    kk_box_t x = _con_x1562->fst;
    kk_box_t y = _con_x1562->snd;
    kk_box_t z = _con_x1562->thd;
    kk_box_t w = _con_x1562->field4;
    kk_reuse_t _ru_x1166 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      if kk_likely(kk_datatype_ptr_is_unique(_pat_0, _ctx)) {
        kk_datatype_ptr_free(_pat_0, _ctx);
      }
      else {
        kk_box_dup(w, _ctx);
        kk_box_dup(x, _ctx);
        kk_box_dup(y, _ctx);
        kk_box_dup(z, _ctx);
        kk_datatype_ptr_decref(_pat_0, _ctx);
      }
      _ru_x1166 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(w, _ctx);
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_box_dup(y, _ctx);
      kk_box_dup(z, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _cctx_x4208;
    kk_std_core_types__list _x_x1563 = kk_datatype_null(); /*list<4424>*/
    _cctx_x4208 = kk_std_core_types__new_Cons(_ru_x1166, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _x_x1563, _ctx); /*list<4424>*/
    kk_field_addr_t _cctx_x4209 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4208, _ctx)->tail, _ctx); /*@field-addr<list<4424>>*/;
    kk_std_core_types__list _cctx_x4248;
    kk_std_core_types__list _x_x1564 = kk_datatype_null(); /*list<4425>*/
    _cctx_x4248 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _x_x1564, _ctx); /*list<4425>*/
    kk_field_addr_t _cctx_x4249 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4248, _ctx)->tail, _ctx); /*@field-addr<list<4425>>*/;
    kk_std_core_types__list _cctx_x4288;
    kk_std_core_types__list _x_x1565 = kk_datatype_null(); /*list<4426>*/
    _cctx_x4288 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), z, _x_x1565, _ctx); /*list<4426>*/
    kk_field_addr_t _cctx_x4289 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4288, _ctx)->tail, _ctx); /*@field-addr<list<4426>>*/;
    kk_std_core_types__list _cctx_x4328;
    kk_std_core_types__list _x_x1566 = kk_datatype_null(); /*list<4427>*/
    _cctx_x4328 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), w, _x_x1566, _ctx); /*list<4427>*/
    kk_field_addr_t _cctx_x4329 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4328, _ctx)->tail, _ctx); /*@field-addr<list<4427>>*/;
    kk_std_core_types__list _b_x776_792 = _cctx_x4208; /*list<4424>*/;
    kk_field_addr_t _b_x777_793 = _cctx_x4209; /*@field-addr<list<4424>>*/;
    kk_std_core_types__list _b_x778_794 = _cctx_x4248; /*list<4425>*/;
    kk_field_addr_t _b_x779_795 = _cctx_x4249; /*@field-addr<list<4425>>*/;
    kk_std_core_types__list _b_x780_796 = _cctx_x4288; /*list<4426>*/;
    kk_field_addr_t _b_x781_797 = _cctx_x4289; /*@field-addr<list<4426>>*/;
    kk_std_core_types__list _b_x782_798 = _cctx_x4328; /*list<4427>*/;
    kk_field_addr_t _b_x783_799 = _cctx_x4329; /*@field-addr<list<4427>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1567;
      kk_std_core_types__cctx _x_x1568 = kk_cctx_create((kk_std_core_types__list_box(_b_x776_792, _ctx)),_b_x777_793,kk_context()); /*cctx<0,1>*/
      _x_x1567 = kk_cctx_compose(acc1,_x_x1568,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1569;
      kk_std_core_types__cctx _x_x1570 = kk_cctx_create((kk_std_core_types__list_box(_b_x778_794, _ctx)),_b_x779_795,kk_context()); /*cctx<0,1>*/
      _x_x1569 = kk_cctx_compose(acc2,_x_x1570,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1571;
      kk_std_core_types__cctx _x_x1572 = kk_cctx_create((kk_std_core_types__list_box(_b_x780_796, _ctx)),_b_x781_797,kk_context()); /*cctx<0,1>*/
      _x_x1571 = kk_cctx_compose(acc3,_x_x1572,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1573;
      kk_std_core_types__cctx _x_x1574 = kk_cctx_create((kk_std_core_types__list_box(_b_x782_798, _ctx)),_b_x783_799,kk_context()); /*cctx<0,1>*/
      _x_x1573 = kk_cctx_compose(acc4,_x_x1574,kk_context()); /*cctx<398,400>*/
      ys = xx;
      acc1 = _x_x1567;
      acc2 = _x_x1569;
      acc3 = _x_x1571;
      acc4 = _x_x1573;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x_x1575 = kk_cctx_apply(acc1,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1576 = kk_cctx_apply(acc2,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1577 = kk_cctx_apply(acc3,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1578 = kk_cctx_apply(acc4,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    return kk_std_core_types__new_Tuple4(kk_reuse_null, 0, _x_x1575, _x_x1576, _x_x1577, _x_x1578, _ctx);
  }
}
 
// monadic lift

kk_std_core_types__tuple2 kk_std_core_list__mlift_lift_span_5431_10292(kk_std_core_types__cctx acc, kk_function_t predicate, kk_box_t y, kk_std_core_types__list ys, kk_std_core_types__list yy, bool _y_x10211, kk_context_t* _ctx) { /* forall<a,b,e> (acc : cctx<a,list<b>>, predicate : (b) -> e bool, y : b, ys : list<b>, yy : list<b>, bool) -> e (a, list<b>) */ 
  if (_y_x10211) {
    kk_std_core_types__list_drop(ys, _ctx);
    kk_std_core_types__list _cctx_x4568;
    kk_std_core_types__list _x_x1583 = kk_datatype_null(); /*list<4658>*/
    _cctx_x4568 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _x_x1583, _ctx); /*list<4658>*/
    kk_field_addr_t _cctx_x4569 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4568, _ctx)->tail, _ctx); /*@field-addr<list<4658>>*/;
    kk_std_core_types__cctx acc_0_10030;
    kk_std_core_types__cctx _x_x1584 = kk_cctx_create((kk_std_core_types__list_box(_cctx_x4568, _ctx)),_cctx_x4569,kk_context()); /*cctx<0,1>*/
    acc_0_10030 = kk_cctx_compose(acc,_x_x1584,kk_context()); /*cctx<4635,list<4658>>*/
    return kk_std_core_list__lift_span_5431(predicate, yy, acc_0_10030, _ctx);
  }
  {
    kk_std_core_types__list_drop(yy, _ctx);
    kk_box_drop(y, _ctx);
    kk_function_drop(predicate, _ctx);
    kk_box_t _b_x820_822 = kk_cctx_apply(acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*4635*/;
    return kk_std_core_types__new_Tuple2(_b_x820_822, kk_std_core_types__list_box(ys, _ctx), _ctx);
  }
}
 
// lifted local: span, span-acc


// lift anonymous function
struct kk_std_core_list__lift_span_5431_fun1589__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx acc_0;
  kk_function_t predicate_0;
  kk_box_t y_0;
  kk_std_core_types__list ys_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__lift_span_5431_fun1589(kk_function_t _fself, kk_box_t _b_x827, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_lift_span_5431_fun1589(kk_std_core_types__cctx acc_0, kk_function_t predicate_0, kk_box_t y_0, kk_std_core_types__list ys_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_span_5431_fun1589__t* _self = kk_function_alloc_as(struct kk_std_core_list__lift_span_5431_fun1589__t, 7, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__lift_span_5431_fun1589, kk_context());
  _self->acc_0 = acc_0;
  _self->predicate_0 = predicate_0;
  _self->y_0 = y_0;
  _self->ys_0 = ys_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__lift_span_5431_fun1589(kk_function_t _fself, kk_box_t _b_x827, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_span_5431_fun1589__t* _self = kk_function_as(struct kk_std_core_list__lift_span_5431_fun1589__t*, _fself, _ctx);
  kk_std_core_types__cctx acc_0 = _self->acc_0; /* cctx<4635,list<4658>> */
  kk_function_t predicate_0 = _self->predicate_0; /* (4658) -> 4659 bool */
  kk_box_t y_0 = _self->y_0; /* 4658 */
  kk_std_core_types__list ys_0 = _self->ys_0; /* list<4658> */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<4658> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(acc_0, _ctx);kk_function_dup(predicate_0, _ctx);kk_box_dup(y_0, _ctx);kk_std_core_types__list_dup(ys_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  bool _y_x10211_0_855 = kk_bool_unbox(_b_x827); /*bool*/;
  kk_std_core_types__tuple2 _x_x1590 = kk_std_core_list__mlift_lift_span_5431_10292(acc_0, predicate_0, y_0, ys_0, yy_0, _y_x10211_0_855, _ctx); /*(4635, list<4658>)*/
  return kk_std_core_types__tuple2_box(_x_x1590, _ctx);
}

kk_std_core_types__tuple2 kk_std_core_list__lift_span_5431(kk_function_t predicate_0, kk_std_core_types__list ys_0, kk_std_core_types__cctx acc_0, kk_context_t* _ctx) { /* forall<a,e,b> (predicate : (a) -> e bool, ys : list<a>, acc : cctx<b,list<a>>) -> e (b, list<a>) */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys_0, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1585 = kk_std_core_types__as_Cons(ys_0, _ctx);
    kk_box_t y_0 = _con_x1585->head;
    kk_std_core_types__list yy_0 = _con_x1585->tail;
    kk_box_dup(y_0, _ctx);
    kk_std_core_types__list_dup(yy_0, _ctx);
    bool x_10404;
    kk_function_t _x_x1587 = kk_function_dup(predicate_0, _ctx); /*(4658) -> 4659 bool*/
    kk_box_t _x_x1586 = kk_box_dup(y_0, _ctx); /*4658*/
    x_10404 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1587, (_x_x1587, _x_x1586, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1588 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_lift_span_5431_fun1589(acc_0, predicate_0, y_0, ys_0, yy_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__tuple2_unbox(_x_x1588, KK_OWNED, _ctx);
    }
    if (x_10404) {
      kk_reuse_t _ru_x1167 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys_0, _ctx)) {
        kk_std_core_types__list_drop(yy_0, _ctx);
        kk_box_drop(y_0, _ctx);
        _ru_x1167 = (kk_datatype_ptr_reuse(ys_0, _ctx));
      }
      else {
        kk_datatype_ptr_decref(ys_0, _ctx);
      }
      kk_std_core_types__list _cctx_x4568_0;
      kk_std_core_types__list _x_x1591 = kk_datatype_null(); /*list<4658>*/
      _cctx_x4568_0 = kk_std_core_types__new_Cons(_ru_x1167, kk_field_index_of(struct kk_std_core_types_Cons, tail), y_0, _x_x1591, _ctx); /*list<4658>*/
      kk_field_addr_t _cctx_x4569_0 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4568_0, _ctx)->tail, _ctx); /*@field-addr<list<4658>>*/;
      kk_std_core_types__cctx acc_0_10030_0;
      kk_std_core_types__cctx _x_x1592 = kk_cctx_create((kk_std_core_types__list_box(_cctx_x4568_0, _ctx)),_cctx_x4569_0,kk_context()); /*cctx<0,1>*/
      acc_0_10030_0 = kk_cctx_compose(acc_0,_x_x1592,kk_context()); /*cctx<4635,list<4658>>*/
      { // tailcall
        ys_0 = yy_0;
        acc_0 = acc_0_10030_0;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core_types__list_drop(yy_0, _ctx);
      kk_box_drop(y_0, _ctx);
      kk_function_drop(predicate_0, _ctx);
      kk_box_t _b_x840_847 = kk_cctx_apply(acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*4635*/;
      return kk_std_core_types__new_Tuple2(_b_x840_847, kk_std_core_types__list_box(ys_0, _ctx), _ctx);
    }
  }
  {
    kk_function_drop(predicate_0, _ctx);
    kk_box_t _b_x844_851 = kk_cctx_apply(acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*4635*/;
    return kk_std_core_types__new_Tuple2(_b_x844_851, kk_std_core_types__list_box(ys_0, _ctx), _ctx);
  }
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_take_while_10293(kk_std_core_types__cctx _acc, kk_function_t predicate, kk_box_t x, kk_std_core_types__list xx, bool _y_x10216, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, predicate : (a) -> e bool, x : a, xx : list<a>, bool) -> e list<a> */ 
  if (_y_x10216) {
    kk_std_core_types__list _trmc_x10092 = kk_datatype_null(); /*list<4714>*/;
    kk_std_core_types__list _trmc_x10093 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _trmc_x10092, _ctx); /*list<4714>*/;
    kk_field_addr_t _b_x861_866 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10093, _ctx)->tail, _ctx); /*@field-addr<list<4714>>*/;
    kk_std_core_types__cctx _x_x1593 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10093, _ctx)),_b_x861_866,kk_context()); /*ctx<0>*/
    return kk_std_core_list__trmc_take_while(xx, predicate, _x_x1593, _ctx);
  }
  {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_box_drop(x, _ctx);
    kk_function_drop(predicate, _ctx);
    kk_box_t _x_x1594 = kk_cctx_apply(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1594, KK_OWNED, _ctx);
  }
}
 
// Keep only those initial elements that satisfy `predicate`


// lift anonymous function
struct kk_std_core_list__trmc_take_while_fun1599__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t predicate_0;
  kk_box_t x_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_take_while_fun1599(kk_function_t _fself, kk_box_t _b_x873, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_take_while_fun1599(kk_std_core_types__cctx _acc_0, kk_function_t predicate_0, kk_box_t x_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_take_while_fun1599__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_take_while_fun1599__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_take_while_fun1599, kk_context());
  _self->_acc_0 = _acc_0;
  _self->predicate_0 = predicate_0;
  _self->x_0 = x_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_take_while_fun1599(kk_function_t _fself, kk_box_t _b_x873, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_take_while_fun1599__t* _self = kk_function_as(struct kk_std_core_list__trmc_take_while_fun1599__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<4714>> */
  kk_function_t predicate_0 = _self->predicate_0; /* (4714) -> 4715 bool */
  kk_box_t x_0 = _self->x_0; /* 4714 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<4714> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(predicate_0, _ctx);kk_box_dup(x_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10216_0_895 = kk_bool_unbox(_b_x873); /*bool*/;
  kk_std_core_types__list _x_x1600 = kk_std_core_list__mlift_trmc_take_while_10293(_acc_0, predicate_0, x_0, xx_0, _y_x10216_0_895, _ctx); /*list<4714>*/
  return kk_std_core_types__list_box(_x_x1600, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_take_while(kk_std_core_types__list xs, kk_function_t predicate_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1595 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x_0 = _con_x1595->head;
    kk_std_core_types__list xx_0 = _con_x1595->tail;
    kk_reuse_t _ru_x1168 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1168 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x_0, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_1_10407;
    kk_function_t _x_x1597 = kk_function_dup(predicate_0, _ctx); /*(4714) -> 4715 bool*/
    kk_box_t _x_x1596 = kk_box_dup(x_0, _ctx); /*4714*/
    x_1_10407 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1597, (_x_x1597, _x_x1596, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1168,kk_context());
      kk_box_t _x_x1598 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_take_while_fun1599(_acc_0, predicate_0, x_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1598, KK_OWNED, _ctx);
    }
    if (x_1_10407) {
      kk_std_core_types__list _trmc_x10092_0 = kk_datatype_null(); /*list<4714>*/;
      kk_std_core_types__list _trmc_x10093_0 = kk_std_core_types__new_Cons(_ru_x1168, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0, _trmc_x10092_0, _ctx); /*list<4714>*/;
      kk_field_addr_t _b_x879_887 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10093_0, _ctx)->tail, _ctx); /*@field-addr<list<4714>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1601 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10093_0, _ctx)),_b_x879_887,kk_context()); /*ctx<0>*/
        xs = xx_0;
        _acc_0 = _x_x1601;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_x1168,kk_context());
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_box_drop(x_0, _ctx);
      kk_function_drop(predicate_0, _ctx);
      kk_box_t _x_x1602 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
      return kk_std_core_types__list_unbox(_x_x1602, KK_OWNED, _ctx);
    }
  }
  {
    kk_function_drop(predicate_0, _ctx);
    kk_box_t _x_x1603 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1603, KK_OWNED, _ctx);
  }
}
 
// Keep only those initial elements that satisfy `predicate`

kk_std_core_types__list kk_std_core_list_take_while(kk_std_core_types__list xs_0, kk_function_t predicate_1, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e list<a> */ 
  kk_std_core_types__cctx _x_x1604 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_take_while(xs_0, predicate_1, _x_x1604, _ctx);
}
 
// Concatenate all strings in a list in reverse order

kk_string_t kk_std_core_list_reverse_join(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  kk_std_core_types__list xs_0_10031 = kk_std_core_list_reverse_acc(kk_std_core_types__new_Nil(_ctx), xs, _ctx); /*list<string>*/;
  if (kk_std_core_types__is_Nil(xs_0_10031, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_types_Cons* _con_x1606 = kk_std_core_types__as_Cons(xs_0_10031, _ctx);
    kk_box_t _box_x896 = _con_x1606->head;
    kk_std_core_types__list _pat_1 = _con_x1606->tail;
    if (kk_std_core_types__is_Nil(_pat_1, _ctx)) {
      kk_string_t x = kk_string_unbox(_box_x896);
      if kk_likely(kk_datatype_ptr_is_unique(xs_0_10031, _ctx)) {
        kk_datatype_ptr_free(xs_0_10031, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_datatype_ptr_decref(xs_0_10031, _ctx);
      }
      return x;
    }
  }
  {
    struct kk_std_core_types_Cons* _con_x1607 = kk_std_core_types__as_Cons(xs_0_10031, _ctx);
    kk_box_t _box_x897 = _con_x1607->head;
    kk_std_core_types__list _pat_3 = _con_x1607->tail;
    struct kk_std_core_types_Cons* _con_x1608 = kk_std_core_types__as_Cons(_pat_3, _ctx);
    kk_box_t _box_x898 = _con_x1608->head;
    kk_std_core_types__list _pat_4 = _con_x1608->tail;
    if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
      kk_string_t x_0 = kk_string_unbox(_box_x897);
      kk_string_t y = kk_string_unbox(_box_x898);
      if kk_likely(kk_datatype_ptr_is_unique(xs_0_10031, _ctx)) {
        if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
          kk_datatype_ptr_free(_pat_3, _ctx);
        }
        else {
          kk_string_dup(y, _ctx);
          kk_datatype_ptr_decref(_pat_3, _ctx);
        }
        kk_datatype_ptr_free(xs_0_10031, _ctx);
      }
      else {
        kk_string_dup(x_0, _ctx);
        kk_string_dup(y, _ctx);
        kk_datatype_ptr_decref(xs_0_10031, _ctx);
      }
      return kk_std_core_types__lp__plus__plus__rp_(x_0, y, _ctx);
    }
  }
  {
    kk_vector_t _x_x1609 = kk_std_core_vector_unvlist(xs_0_10031, _ctx); /*vector<911>*/
    return kk_string_join(_x_x1609,kk_context());
  }
}
 
// lifted local: concat, concat-pre

kk_std_core_types__list kk_std_core_list__trmc_lift_concat_5432(kk_std_core_types__list ys, kk_std_core_types__list zss, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, zss : list<list<a>>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1613 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1613->head;
    kk_std_core_types__list yy = _con_x1613->tail;
    kk_reuse_t _ru_x1172 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1172 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _trmc_x10094 = kk_datatype_null(); /*list<4817>*/;
    kk_std_core_types__list _trmc_x10095 = kk_std_core_types__new_Cons(_ru_x1172, 0, y, _trmc_x10094, _ctx); /*list<4817>*/;
    kk_field_addr_t _b_x904_910 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10095, _ctx)->tail, _ctx); /*@field-addr<list<4817>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1614 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10095, _ctx)),_b_x904_910,kk_context()); /*ctx<0>*/
      ys = yy;
      _acc = _x_x1614;
      goto kk__tailcall;
    }
  }
  if (kk_std_core_types__is_Cons(zss, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1615 = kk_std_core_types__as_Cons(zss, _ctx);
    kk_box_t _box_x905 = _con_x1615->head;
    kk_std_core_types__list zzs = _con_x1615->tail;
    kk_std_core_types__list zs = kk_std_core_types__list_unbox(_box_x905, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(zss, _ctx)) {
      kk_datatype_ptr_free(zss, _ctx);
    }
    else {
      kk_std_core_types__list_dup(zs, _ctx);
      kk_std_core_types__list_dup(zzs, _ctx);
      kk_datatype_ptr_decref(zss, _ctx);
    }
    { // tailcall
      ys = zs;
      zss = zzs;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x_x1616 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1616, KK_OWNED, _ctx);
  }
}
 
// lifted local: concat, concat-pre

kk_std_core_types__list kk_std_core_list__lift_concat_5432(kk_std_core_types__list ys_0, kk_std_core_types__list zss_0, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, zss : list<list<a>>) -> list<a> */ 
  kk_std_core_types__cctx _x_x1617 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_concat_5432(ys_0, zss_0, _x_x1617, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_lift_flatmap_5433_10294(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core_types__list zz, kk_std_core_types__list ys_1_10038, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e list<b>, zz : list<a>, ys@1@10038 : list<b>) -> e list<b> */ 
  return kk_std_core_list__trmc_lift_flatmap_5433(f, ys_1_10038, zz, _acc, _ctx);
}
 
// lifted local: flatmap, flatmap-pre


// lift anonymous function
struct kk_std_core_list__trmc_lift_flatmap_5433_fun1624__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_std_core_types__list zz_0;
};
static kk_box_t kk_std_core_list__trmc_lift_flatmap_5433_fun1624(kk_function_t _fself, kk_box_t _b_x923, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_lift_flatmap_5433_fun1624(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_std_core_types__list zz_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_flatmap_5433_fun1624__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_lift_flatmap_5433_fun1624__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_lift_flatmap_5433_fun1624, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->zz_0 = zz_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_lift_flatmap_5433_fun1624(kk_function_t _fself, kk_box_t _b_x923, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_flatmap_5433_fun1624__t* _self = kk_function_as(struct kk_std_core_list__trmc_lift_flatmap_5433_fun1624__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<4903>> */
  kk_function_t f_0 = _self->f_0; /* (4902) -> 4904 list<4903> */
  kk_std_core_types__list zz_0 = _self->zz_0; /* list<4902> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(zz_0, _ctx);}, {}, _ctx)
  kk_std_core_types__list ys_1_10038_0_935 = kk_std_core_types__list_unbox(_b_x923, KK_OWNED, _ctx); /*list<4903>*/;
  kk_std_core_types__list _x_x1625 = kk_std_core_list__mlift_trmc_lift_flatmap_5433_10294(_acc_0, f_0, zz_0, ys_1_10038_0_935, _ctx); /*list<4903>*/
  return kk_std_core_types__list_box(_x_x1625, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_lift_flatmap_5433(kk_function_t f_0, kk_std_core_types__list ys, kk_std_core_types__list zs, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e list<b>, ys : list<b>, zs : list<a>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1619 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1619->head;
    kk_std_core_types__list yy = _con_x1619->tail;
    kk_reuse_t _ru_x1174 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1174 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _trmc_x10096 = kk_datatype_null(); /*list<4903>*/;
    kk_std_core_types__list _trmc_x10097 = kk_std_core_types__new_Cons(_ru_x1174, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _trmc_x10096, _ctx); /*list<4903>*/;
    kk_field_addr_t _b_x921_928 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10097, _ctx)->tail, _ctx); /*@field-addr<list<4903>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1620 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10097, _ctx)),_b_x921_928,kk_context()); /*ctx<0>*/
      ys = yy;
      _acc_0 = _x_x1620;
      goto kk__tailcall;
    }
  }
  if (kk_std_core_types__is_Cons(zs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1621 = kk_std_core_types__as_Cons(zs, _ctx);
    kk_box_t z = _con_x1621->head;
    kk_std_core_types__list zz_0 = _con_x1621->tail;
    if kk_likely(kk_datatype_ptr_is_unique(zs, _ctx)) {
      kk_datatype_ptr_free(zs, _ctx);
    }
    else {
      kk_box_dup(z, _ctx);
      kk_std_core_types__list_dup(zz_0, _ctx);
      kk_datatype_ptr_decref(zs, _ctx);
    }
    kk_std_core_types__list x_10412;
    kk_function_t _x_x1622 = kk_function_dup(f_0, _ctx); /*(4902) -> 4904 list<4903>*/
    x_10412 = kk_function_call(kk_std_core_types__list, (kk_function_t, kk_box_t, kk_context_t*), _x_x1622, (_x_x1622, z, _ctx), _ctx); /*list<4903>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__list_drop(x_10412, _ctx);
      kk_box_t _x_x1623 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_lift_flatmap_5433_fun1624(_acc_0, f_0, zz_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1623, KK_OWNED, _ctx);
    }
    { // tailcall
      ys = x_10412;
      zs = zz_0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1626 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1626, KK_OWNED, _ctx);
  }
}
 
// lifted local: flatmap, flatmap-pre

kk_std_core_types__list kk_std_core_list__lift_flatmap_5433(kk_function_t f_1, kk_std_core_types__list ys_0, kk_std_core_types__list zs_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e list<b>, ys : list<b>, zs : list<a>) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1627 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_flatmap_5433(f_1, ys_0, zs_0, _x_x1627, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_flatmap_maybe_10295(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core_types__list xx, kk_std_core_types__maybe _y_x10228, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Just(_y_x10228, _ctx)) {
    kk_box_t y = _y_x10228._cons.Just.value;
    kk_std_core_types__list _trmc_x10098 = kk_datatype_null(); /*list<4986>*/;
    kk_std_core_types__list _trmc_x10099 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _trmc_x10098, _ctx); /*list<4986>*/;
    kk_field_addr_t _b_x941_944 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10099, _ctx)->tail, _ctx); /*@field-addr<list<4986>>*/;
    kk_std_core_types__cctx _x_x1629 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10099, _ctx)),_b_x941_944,kk_context()); /*ctx<0>*/
    return kk_std_core_list__trmc_flatmap_maybe(xx, f, _x_x1629, _ctx);
  }
  {
    return kk_std_core_list__trmc_flatmap_maybe(xx, f, _acc, _ctx);
  }
}
 
// Concatenate the `Just` result elements from applying a function to all elements.


// lift anonymous function
struct kk_std_core_list__trmc_flatmap_maybe_fun1633__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_flatmap_maybe_fun1633(kk_function_t _fself, kk_box_t _b_x949, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_flatmap_maybe_fun1633(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_flatmap_maybe_fun1633__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_flatmap_maybe_fun1633__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_flatmap_maybe_fun1633, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_flatmap_maybe_fun1633(kk_function_t _fself, kk_box_t _b_x949, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_flatmap_maybe_fun1633__t* _self = kk_function_as(struct kk_std_core_list__trmc_flatmap_maybe_fun1633__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<4986>> */
  kk_function_t f_0 = _self->f_0; /* (4985) -> 4987 maybe<4986> */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<4985> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_x10228_0_967 = kk_std_core_types__maybe_unbox(_b_x949, KK_OWNED, _ctx); /*maybe<4986>*/;
  kk_std_core_types__list _x_x1634 = kk_std_core_list__mlift_trmc_flatmap_maybe_10295(_acc_0, f_0, xx_0, _y_x10228_0_967, _ctx); /*list<4986>*/
  return kk_std_core_types__list_box(_x_x1634, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_flatmap_maybe(kk_std_core_types__list xs, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1630 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1630->head;
    kk_std_core_types__list xx_0 = _con_x1630->tail;
    kk_reuse_t _ru_x1176 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1176 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x_0_10418;
    kk_function_t _x_x1631 = kk_function_dup(f_0, _ctx); /*(4985) -> 4987 maybe<4986>*/
    x_0_10418 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x_x1631, (_x_x1631, x, _ctx), _ctx); /*maybe<4986>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1176,kk_context());
      kk_std_core_types__maybe_drop(x_0_10418, _ctx);
      kk_box_t _x_x1632 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_flatmap_maybe_fun1633(_acc_0, f_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1632, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Just(x_0_10418, _ctx)) {
      kk_box_t y_0 = x_0_10418._cons.Just.value;
      kk_std_core_types__list _trmc_x10098_0 = kk_datatype_null(); /*list<4986>*/;
      kk_std_core_types__list _trmc_x10099_0 = kk_std_core_types__new_Cons(_ru_x1176, kk_field_index_of(struct kk_std_core_types_Cons, tail), y_0, _trmc_x10098_0, _ctx); /*list<4986>*/;
      kk_field_addr_t _b_x955_961 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10099_0, _ctx)->tail, _ctx); /*@field-addr<list<4986>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1635 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10099_0, _ctx)),_b_x955_961,kk_context()); /*ctx<0>*/
        xs = xx_0;
        _acc_0 = _x_x1635;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_x1176,kk_context());
      { // tailcall
        xs = xx_0;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1636 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1636, KK_OWNED, _ctx);
  }
}
 
// Concatenate the `Just` result elements from applying a function to all elements.

kk_std_core_types__list kk_std_core_list_flatmap_maybe(kk_std_core_types__list xs_0, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1637 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_flatmap_maybe(xs_0, f_1, _x_x1637, _ctx);
}
 
// Concatenate a list of `:maybe` values

kk_std_core_types__list kk_std_core_list__trmc_concat_maybe(kk_std_core_types__list xs, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<maybe<a>>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1638 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x968 = _con_x1638->head;
    kk_std_core_types__list xx = _con_x1638->tail;
    kk_std_core_types__maybe x = kk_std_core_types__maybe_unbox(_box_x968, KK_BORROWED, _ctx);
    kk_reuse_t _ru_x1177 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core_types__maybe_dup(x, _ctx);
      kk_box_drop(_box_x968, _ctx);
      _ru_x1177 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_std_core_types__maybe_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Just(x, _ctx)) {
      kk_box_t y = x._cons.Just.value;
      kk_std_core_types__list _trmc_x10100 = kk_datatype_null(); /*list<5048>*/;
      kk_std_core_types__list _trmc_x10101 = kk_std_core_types__new_Cons(_ru_x1177, 0, y, _trmc_x10100, _ctx); /*list<5048>*/;
      kk_field_addr_t _b_x974_979 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10101, _ctx)->tail, _ctx); /*@field-addr<list<5048>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1639 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10101, _ctx)),_b_x974_979,kk_context()); /*ctx<0>*/
        xs = xx;
        _acc = _x_x1639;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_x1177,kk_context());
      { // tailcall
        xs = xx;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_box_t _x_x1640 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1640, KK_OWNED, _ctx);
  }
}
 
// Concatenate a list of `:maybe` values

kk_std_core_types__list kk_std_core_list_concat_maybe(kk_std_core_types__list xs_0, kk_context_t* _ctx) { /* forall<a> (xs : list<maybe<a>>) -> list<a> */ 
  kk_std_core_types__cctx _x_x1641 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_concat_maybe(xs_0, _x_x1641, _ctx);
}
 
// Return the last element of a list (or `Nothing` for the empty list)

kk_std_core_types__maybe kk_std_core_list_last(kk_std_core_types__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> maybe<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1642 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_std_core_types__list _pat_0 = _con_x1642->tail;
    if (kk_std_core_types__is_Nil(_pat_0, _ctx)) {
      kk_box_t x = _con_x1642->head;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_box_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      return kk_std_core_types__new_Just(x, _ctx);
    }
  }
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1643 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _pat_2 = _con_x1643->head;
    kk_std_core_types__list xx = _con_x1643->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_pat_2, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    { // tailcall
      xs = xx;
      goto kk__tailcall;
    }
  }
  {
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Return the list without its last element.
// Return an empty list for an empty list.

kk_std_core_types__list kk_std_core_list__trmc_init(kk_std_core_types__list xs, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1644 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_std_core_types__list xx = _con_x1644->tail;
    if (kk_std_core_types__is_Cons(xx, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1645 = kk_std_core_types__as_Cons(xx, _ctx);
      kk_box_t x = _con_x1644->head;
      kk_reuse_t _ru_x1180 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        _ru_x1180 = (kk_datatype_ptr_reuse(xs, _ctx));
      }
      else {
        kk_box_dup(x, _ctx);
        kk_std_core_types__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_std_core_types__list _trmc_x10102 = kk_datatype_null(); /*list<5135>*/;
      kk_std_core_types__list _trmc_x10103 = kk_std_core_types__new_Cons(_ru_x1180, 0, x, _trmc_x10102, _ctx); /*list<5135>*/;
      kk_field_addr_t _b_x990_995 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10103, _ctx)->tail, _ctx); /*@field-addr<list<5135>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1646 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10103, _ctx)),_b_x990_995,kk_context()); /*ctx<0>*/
        xs = xx;
        _acc = _x_x1646;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_std_core_types__list_drop(xs, _ctx);
    kk_box_t _x_x1647 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1647, KK_OWNED, _ctx);
  }
}
 
// Return the list without its last element.
// Return an empty list for an empty list.

kk_std_core_types__list kk_std_core_list_init(kk_std_core_types__list xs_0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x_x1648 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_init(xs_0, _x_x1648, _ctx);
}
 
// Get (zero-based) element `n`  of a list. Return a `:maybe` type.

kk_std_core_types__maybe kk_std_core_list__index(kk_std_core_types__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> maybe<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1649 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1649->head;
    kk_std_core_types__list xx = _con_x1649->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool _match_x1042 = kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
    if (_match_x1042) {
      kk_box_drop(x, _ctx);
      { // tailcall
        kk_integer_t _x_x1650 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        xs = xx;
        n = _x_x1650;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core_types__list_drop(xx, _ctx);
      bool _match_x1043;
      bool _brw_x1044 = kk_integer_eq_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
      kk_integer_drop(n, _ctx);
      _match_x1043 = _brw_x1044; /*bool*/
      if (_match_x1043) {
        return kk_std_core_types__new_Just(x, _ctx);
      }
      {
        kk_box_drop(x, _ctx);
        return kk_std_core_types__new_Nothing(_ctx);
      }
    }
  }
  {
    kk_integer_drop(n, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// monadic lift

bool kk_std_core_list__mlift_all_10296(kk_function_t predicate, kk_std_core_types__list xx, bool _y_x10234, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xx : list<a>, bool) -> e bool */ 
  if (_y_x10234) {
    return kk_std_core_list_all(xx, predicate, _ctx);
  }
  {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return false;
  }
}
 
// Do all elements satisfy a predicate ?


// lift anonymous function
struct kk_std_core_list_all_fun1654__t {
  struct kk_function_s _base;
  kk_function_t predicate_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list_all_fun1654(kk_function_t _fself, kk_box_t _b_x1002, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_all_fun1654(kk_function_t predicate_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list_all_fun1654__t* _self = kk_function_alloc_as(struct kk_std_core_list_all_fun1654__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_all_fun1654, kk_context());
  _self->predicate_0 = predicate_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_all_fun1654(kk_function_t _fself, kk_box_t _b_x1002, kk_context_t* _ctx) {
  struct kk_std_core_list_all_fun1654__t* _self = kk_function_as(struct kk_std_core_list_all_fun1654__t*, _fself, _ctx);
  kk_function_t predicate_0 = _self->predicate_0; /* (5263) -> 5264 bool */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<5263> */
  kk_drop_match(_self, {kk_function_dup(predicate_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10234_0_1004 = kk_bool_unbox(_b_x1002); /*bool*/;
  bool _x_x1655 = kk_std_core_list__mlift_all_10296(predicate_0, xx_0, _y_x10234_0_1004, _ctx); /*bool*/
  return kk_bool_box(_x_x1655);
}

bool kk_std_core_list_all(kk_std_core_types__list xs, kk_function_t predicate_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e bool */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1651 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1651->head;
    kk_std_core_types__list xx_0 = _con_x1651->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_0_10421;
    kk_function_t _x_x1652 = kk_function_dup(predicate_0, _ctx); /*(5263) -> 5264 bool*/
    x_0_10421 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1652, (_x_x1652, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1653 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_all_fun1654(predicate_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_bool_unbox(_x_x1653);
    }
    if (x_0_10421) { // tailcall
                     xs = xx_0;
                     goto kk__tailcall;
    }
    {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(predicate_0, _ctx);
      return false;
    }
  }
  {
    kk_function_drop(predicate_0, _ctx);
    return true;
  }
}
 
// monadic lift

bool kk_std_core_list__mlift_any_10297(kk_function_t predicate, kk_std_core_types__list xx, bool _y_x10238, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xx : list<a>, bool) -> e bool */ 
  if (_y_x10238) {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return true;
  }
  {
    return kk_std_core_list_any(xx, predicate, _ctx);
  }
}
 
// Are there any elements in a list that satisfy a predicate ?


// lift anonymous function
struct kk_std_core_list_any_fun1659__t {
  struct kk_function_s _base;
  kk_function_t predicate_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list_any_fun1659(kk_function_t _fself, kk_box_t _b_x1006, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_any_fun1659(kk_function_t predicate_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list_any_fun1659__t* _self = kk_function_alloc_as(struct kk_std_core_list_any_fun1659__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_any_fun1659, kk_context());
  _self->predicate_0 = predicate_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_any_fun1659(kk_function_t _fself, kk_box_t _b_x1006, kk_context_t* _ctx) {
  struct kk_std_core_list_any_fun1659__t* _self = kk_function_as(struct kk_std_core_list_any_fun1659__t*, _fself, _ctx);
  kk_function_t predicate_0 = _self->predicate_0; /* (5308) -> 5309 bool */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<5308> */
  kk_drop_match(_self, {kk_function_dup(predicate_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10238_0_1008 = kk_bool_unbox(_b_x1006); /*bool*/;
  bool _x_x1660 = kk_std_core_list__mlift_any_10297(predicate_0, xx_0, _y_x10238_0_1008, _ctx); /*bool*/
  return kk_bool_box(_x_x1660);
}

bool kk_std_core_list_any(kk_std_core_types__list xs, kk_function_t predicate_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e bool */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1656 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1656->head;
    kk_std_core_types__list xx_0 = _con_x1656->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_0_10424;
    kk_function_t _x_x1657 = kk_function_dup(predicate_0, _ctx); /*(5308) -> 5309 bool*/
    x_0_10424 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1657, (_x_x1657, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1658 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_any_fun1659(predicate_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_bool_unbox(_x_x1658);
    }
    if (x_0_10424) {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(predicate_0, _ctx);
      return true;
    }
    { // tailcall
      xs = xx_0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(predicate_0, _ctx);
    return false;
  }
}
 
// Return the sum of a list of integers


// lift anonymous function
struct kk_std_core_list_sum_fun1662__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_sum_fun1662(kk_function_t _fself, kk_box_t _b_x1012, kk_box_t _b_x1013, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_sum_fun1662(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_sum_fun1662, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_sum_fun1662(kk_function_t _fself, kk_box_t _b_x1012, kk_box_t _b_x1013, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_integer_t _x_x1663;
  kk_integer_t _x_x1664 = kk_integer_unbox(_b_x1012, _ctx); /*int*/
  kk_integer_t _x_x1665 = kk_integer_unbox(_b_x1013, _ctx); /*int*/
  _x_x1663 = kk_std_core_int__lp__plus__rp_(_x_x1664, _x_x1665, _ctx); /*int*/
  return kk_integer_box(_x_x1663, _ctx);
}

kk_integer_t kk_std_core_list_sum(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<int>) -> int */ 
  kk_box_t _x_x1661 = kk_std_core_list_foldl(xs, kk_integer_box(kk_integer_from_small(0), _ctx), kk_std_core_list_new_sum_fun1662(_ctx), _ctx); /*1139*/
  return kk_integer_unbox(_x_x1661, _ctx);
}
 
// Returns the smallest element of a list of integers (or `default` (=`0`) for the empty list)


// lift anonymous function
struct kk_std_core_list_minimum_fun1668__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_minimum_fun1668(kk_function_t _fself, kk_box_t _b_x1022, kk_box_t _b_x1023, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_minimum_fun1668(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_minimum_fun1668, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_minimum_fun1668(kk_function_t _fself, kk_box_t _b_x1022, kk_box_t _b_x1023, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_integer_t _x_x1669;
  kk_integer_t _x_x1670 = kk_integer_unbox(_b_x1022, _ctx); /*int*/
  kk_integer_t _x_x1671 = kk_integer_unbox(_b_x1023, _ctx); /*int*/
  _x_x1669 = kk_std_core_int_min(_x_x1670, _x_x1671, _ctx); /*int*/
  return kk_integer_box(_x_x1669, _ctx);
}

kk_integer_t kk_std_core_list_minimum(kk_std_core_types__list xs, kk_std_core_types__optional kkloc_default, kk_context_t* _ctx) { /* (xs : list<int>, default : ? int) -> int */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    if (kk_std_core_types__is_Optional(kkloc_default, _ctx)) {
      kk_box_t _box_x1017 = kkloc_default._cons._Optional.value;
      kk_integer_t _uniq_default_5340 = kk_integer_unbox(_box_x1017, _ctx);
      kk_integer_dup(_uniq_default_5340, _ctx);
      kk_std_core_types__optional_drop(kkloc_default, _ctx);
      return _uniq_default_5340;
    }
    {
      kk_std_core_types__optional_drop(kkloc_default, _ctx);
      return kk_integer_from_small(0);
    }
  }
  {
    struct kk_std_core_types_Cons* _con_x1666 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x1018 = _con_x1666->head;
    kk_std_core_types__list xx = _con_x1666->tail;
    kk_integer_t x = kk_integer_unbox(_box_x1018, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_integer_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__optional_drop(kkloc_default, _ctx);
    kk_box_t _x_x1667 = kk_std_core_list_foldl(xx, kk_integer_box(x, _ctx), kk_std_core_list_new_minimum_fun1668(_ctx), _ctx); /*1139*/
    return kk_integer_unbox(_x_x1667, _ctx);
  }
}
 
// Returns the largest element of a list of integers (or `default` (=`0`) for the empty list)


// lift anonymous function
struct kk_std_core_list_maximum_fun1674__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_maximum_fun1674(kk_function_t _fself, kk_box_t _b_x1032, kk_box_t _b_x1033, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_maximum_fun1674(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_maximum_fun1674, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_maximum_fun1674(kk_function_t _fself, kk_box_t _b_x1032, kk_box_t _b_x1033, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_integer_t _x_x1675;
  kk_integer_t _x_x1676 = kk_integer_unbox(_b_x1032, _ctx); /*int*/
  kk_integer_t _x_x1677 = kk_integer_unbox(_b_x1033, _ctx); /*int*/
  _x_x1675 = kk_std_core_int_max(_x_x1676, _x_x1677, _ctx); /*int*/
  return kk_integer_box(_x_x1675, _ctx);
}

kk_integer_t kk_std_core_list_maximum(kk_std_core_types__list xs, kk_std_core_types__optional kkloc_default, kk_context_t* _ctx) { /* (xs : list<int>, default : ? int) -> int */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    if (kk_std_core_types__is_Optional(kkloc_default, _ctx)) {
      kk_box_t _box_x1027 = kkloc_default._cons._Optional.value;
      kk_integer_t _uniq_default_5373 = kk_integer_unbox(_box_x1027, _ctx);
      kk_integer_dup(_uniq_default_5373, _ctx);
      kk_std_core_types__optional_drop(kkloc_default, _ctx);
      return _uniq_default_5373;
    }
    {
      kk_std_core_types__optional_drop(kkloc_default, _ctx);
      return kk_integer_from_small(0);
    }
  }
  {
    struct kk_std_core_types_Cons* _con_x1672 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x1028 = _con_x1672->head;
    kk_std_core_types__list xx = _con_x1672->tail;
    kk_integer_t x = kk_integer_unbox(_box_x1028, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_integer_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__optional_drop(kkloc_default, _ctx);
    kk_box_t _x_x1673 = kk_std_core_list_foldl(xx, kk_integer_box(x, _ctx), kk_std_core_list_new_maximum_fun1674(_ctx), _ctx); /*1139*/
    return kk_integer_unbox(_x_x1673, _ctx);
  }
}
 
// Join a list of strings with newlines

kk_string_t kk_std_core_list_unlines(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_types_Cons* _con_x1681 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x1037 = _con_x1681->head;
    kk_std_core_types__list _pat_1 = _con_x1681->tail;
    if (kk_std_core_types__is_Nil(_pat_1, _ctx)) {
      kk_string_t x = kk_string_unbox(_box_x1037);
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      return x;
    }
  }
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1682 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x1038 = _con_x1682->head;
    kk_std_core_types__list _pat_3 = _con_x1682->tail;
    if (kk_std_core_types__is_Cons(_pat_3, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1683 = kk_std_core_types__as_Cons(_pat_3, _ctx);
      kk_box_t _box_x1039 = _con_x1683->head;
      kk_std_core_types__list _pat_4 = _con_x1683->tail;
      if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
        kk_string_t _x_x1684;
        kk_define_string_literal(, _s_x1685, 1, "\n", _ctx)
        _x_x1684 = kk_string_dup(_s_x1685, _ctx); /*string*/
        kk_string_t _x_x1686 = kk_string_empty(); /*string*/
        if (kk_string_is_eq(_x_x1684,_x_x1686,kk_context())) {
          kk_string_t x_0 = kk_string_unbox(_box_x1038);
          kk_string_t y = kk_string_unbox(_box_x1039);
          if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
            if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
              kk_datatype_ptr_free(_pat_3, _ctx);
            }
            else {
              kk_string_dup(y, _ctx);
              kk_datatype_ptr_decref(_pat_3, _ctx);
            }
            kk_datatype_ptr_free(xs, _ctx);
          }
          else {
            kk_string_dup(x_0, _ctx);
            kk_string_dup(y, _ctx);
            kk_datatype_ptr_decref(xs, _ctx);
          }
          return kk_std_core_types__lp__plus__plus__rp_(x_0, y, _ctx);
        }
      }
    }
  }
  {
    kk_vector_t _x_x1688 = kk_std_core_vector_unvlist(xs, _ctx); /*vector<911>*/
    kk_string_t _x_x1689;
    kk_define_string_literal(, _s_x1690, 1, "\n", _ctx)
    _x_x1689 = kk_string_dup(_s_x1690, _ctx); /*string*/
    return kk_string_join_with(_x_x1688,_x_x1689,kk_context());
  }
}

// initialization
void kk_std_core_list__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_undiv__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core_exn__init(_ctx);
  kk_std_core_char__init(_ctx);
  kk_std_core_string__init(_ctx);
  kk_std_core_int__init(_ctx);
  kk_std_core_vector__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_core_list__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_core_vector__done(_ctx);
  kk_std_core_int__done(_ctx);
  kk_std_core_string__done(_ctx);
  kk_std_core_char__done(_ctx);
  kk_std_core_exn__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_undiv__done(_ctx);
  kk_std_core_types__done(_ctx);
}
