// Koka generated module: std/num/float64, koka version: 3.1.3, platform: 64-bit
#include "std_num_float64.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static int64_t kk_double_to_bits( double d, kk_context_t* ctx ) {
  kk_unused(ctx);
  return (int64_t)kk_bits_from_double(d);
}

static double kk_double_from_bits( int64_t i, kk_context_t* ctx ) {
  kk_unused(ctx);
  return kk_bits_to_double((uint64_t)i);
}

static double kk_prim_parse_double( kk_string_t str, kk_context_t* ctx) {
  const char* s = kk_string_cbuf_borrow(str,NULL,ctx);
  char* end;
  double d = strtod(s,&end);
  kk_string_drop(str,ctx);
  return d;
}


kk_integer_t kk_std_num_float64_flt_max_prec;
 
// Extend a `:float32` to a `:float64`

double kk_std_num_float64_float32_fs_float64(float f, kk_context_t* _ctx) { /* (f : float32) -> float64 */ 
  return (double)(f);
}

double kk_std_num_float64_make_neginf(kk_context_t* _ctx) { /* () -> float64 */ 
  return -HUGE_VAL;
}
 
// Negative infinity

double kk_std_num_float64_neginf;

double kk_std_num_float64_make_posinf(kk_context_t* _ctx) { /* () -> float64 */ 
  return HUGE_VAL;
}
 
// Positive infinity

double kk_std_num_float64_posinf;
 
// Returns the smallest element of a list of floats (or `0` for the empty list)


// lift anonymous function
struct kk_std_num_float64_minimum_fun655__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_minimum_fun655(kk_function_t _fself, kk_box_t _b_x4, kk_box_t _b_x5, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_minimum_fun655(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_minimum_fun655, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_minimum_fun655(kk_function_t _fself, kk_box_t _b_x4, kk_box_t _b_x5, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x656;
  double _x_x657 = kk_double_unbox(_b_x4, KK_OWNED, _ctx); /*float64*/
  double _x_x658 = kk_double_unbox(_b_x5, KK_OWNED, _ctx); /*float64*/
  _x_x656 = kk_std_num_float64_min(_x_x657, _x_x658, _ctx); /*float64*/
  return kk_double_box(_x_x656, _ctx);
}

double kk_std_num_float64_minimum(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    return 0x0p+0;
  }
  {
    struct kk_std_core_types_Cons* _con_x653 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x0 = _con_x653->head;
    kk_std_core_types__list xx = _con_x653->tail;
    double x = kk_double_unbox(_box_x0, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_box_x0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t _x_x654 = kk_std_core_list_foldl(xx, kk_double_box(x, _ctx), kk_std_num_float64_new_minimum_fun655(_ctx), _ctx); /*1139*/
    return kk_double_unbox(_x_x654, KK_OWNED, _ctx);
  }
}
 
// Returns the largest element of a list of floats (or `0` for the empty list)


// lift anonymous function
struct kk_std_num_float64_maximum_fun661__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_maximum_fun661(kk_function_t _fself, kk_box_t _b_x13, kk_box_t _b_x14, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_maximum_fun661(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_maximum_fun661, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_maximum_fun661(kk_function_t _fself, kk_box_t _b_x13, kk_box_t _b_x14, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x662;
  double _x_x663 = kk_double_unbox(_b_x13, KK_OWNED, _ctx); /*float64*/
  double _x_x664 = kk_double_unbox(_b_x14, KK_OWNED, _ctx); /*float64*/
  _x_x662 = kk_std_num_float64_max(_x_x663, _x_x664, _ctx); /*float64*/
  return kk_double_box(_x_x662, _ctx);
}

double kk_std_num_float64_maximum(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    return 0x0p+0;
  }
  {
    struct kk_std_core_types_Cons* _con_x659 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x9 = _con_x659->head;
    kk_std_core_types__list xx = _con_x659->tail;
    double x = kk_double_unbox(_box_x9, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_box_x9, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t _x_x660 = kk_std_core_list_foldl(xx, kk_double_box(x, _ctx), kk_std_num_float64_new_maximum_fun661(_ctx), _ctx); /*1139*/
    return kk_double_unbox(_x_x660, KK_OWNED, _ctx);
  }
}

double kk_std_num_float64_make_nan(kk_context_t* _ctx) { /* () -> float64 */ 
  return (double)NAN;
}
 
// Represents a value that is _not a number_ (NaN)

double kk_std_num_float64_nan;

kk_string_t kk_std_num_float64_show_fixedx(double d, int32_t prec, kk_context_t* _ctx) { /* (d : float64, prec : int32) -> string */ 
  return kk_double_show_fixed(d,prec,kk_context());
}

kk_string_t kk_std_num_float64_show_expx(double d, int32_t prec, kk_context_t* _ctx) { /* (d : float64, prec : int32) -> string */ 
  return kk_double_show_exp(d,prec,kk_context());
}
 
// Show a `:float64` in exponential (scientific) notation.
// The optional `precision` (= `-17`) specifies the precision.
// If `>=0` it specifies the number of digits behind the dot (up to `17` max).
// If negative, then at most the absolute value of `precision` digits behind the dot are used.

kk_string_t kk_std_num_float64_show_exp(double d, kk_std_core_types__optional precision, kk_context_t* _ctx) { /* (d : float64, precision : ? int) -> string */ 
  int32_t _x_x665;
  kk_integer_t _x_x666;
  if (kk_std_core_types__is_Optional(precision, _ctx)) {
    kk_box_t _box_x18 = precision._cons._Optional.value;
    kk_integer_t _uniq_precision_533 = kk_integer_unbox(_box_x18, _ctx);
    kk_integer_dup(_uniq_precision_533, _ctx);
    kk_std_core_types__optional_drop(precision, _ctx);
    _x_x666 = _uniq_precision_533; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(precision, _ctx);
    _x_x666 = kk_integer_from_small(-17); /*int*/
  }
  _x_x665 = kk_integer_clamp32(_x_x666,kk_context()); /*int32*/
  return kk_std_num_float64_show_expx(d, _x_x665, _ctx);
}
 
// Show a `:float64` fixed-point notation.
// The optional `precision` (= `-2`) specifies the maximum precision.
// If `>=0` it specifies the number of digits behind the dot (up to `20` max).
// If negative, then at most the absolute value of `precision` digits behind the dot are used.
// This may still show a number in exponential notation if the it is too small or large,
// in particular, for  a `d` where `d > 1.0e21` or `d < 1.0e-15`, or if
// `precision.abs > 17`, the `show-exp` routine is used.

kk_string_t kk_std_num_float64_show_fixed(double d, kk_std_core_types__optional precision, kk_context_t* _ctx) { /* (d : float64, precision : ? int) -> string */ 
  double dabs = kk_double_abs(d); /*float64*/;
  bool _match_x639 = (dabs < (0x1.203af9ee75616p-50)); /*bool*/;
  if (_match_x639) {
    int32_t _x_x667;
    kk_integer_t _x_x668;
    if (kk_std_core_types__is_Optional(precision, _ctx)) {
      kk_box_t _box_x19 = precision._cons._Optional.value;
      kk_integer_t _uniq_precision_547 = kk_integer_unbox(_box_x19, _ctx);
      kk_integer_dup(_uniq_precision_547, _ctx);
      kk_std_core_types__optional_drop(precision, _ctx);
      _x_x668 = _uniq_precision_547; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(precision, _ctx);
      _x_x668 = kk_integer_from_small(-2); /*int*/
    }
    _x_x667 = kk_integer_clamp32(_x_x668,kk_context()); /*int32*/
    return kk_std_num_float64_show_expx(d, _x_x667, _ctx);
  }
  {
    bool _match_x640 = (dabs > (0x1.b1ae4d6e2ef5p69)); /*bool*/;
    if (_match_x640) {
      int32_t _x_x669;
      kk_integer_t _x_x670;
      if (kk_std_core_types__is_Optional(precision, _ctx)) {
        kk_box_t _box_x20 = precision._cons._Optional.value;
        kk_integer_t _uniq_precision_547_0 = kk_integer_unbox(_box_x20, _ctx);
        kk_integer_dup(_uniq_precision_547_0, _ctx);
        kk_std_core_types__optional_drop(precision, _ctx);
        _x_x670 = _uniq_precision_547_0; /*int*/
      }
      else {
        kk_std_core_types__optional_drop(precision, _ctx);
        _x_x670 = kk_integer_from_small(-2); /*int*/
      }
      _x_x669 = kk_integer_clamp32(_x_x670,kk_context()); /*int32*/
      return kk_std_num_float64_show_expx(d, _x_x669, _ctx);
    }
    {
      int32_t _x_x671;
      kk_integer_t _x_x672;
      if (kk_std_core_types__is_Optional(precision, _ctx)) {
        kk_box_t _box_x21 = precision._cons._Optional.value;
        kk_integer_t _uniq_precision_547_1 = kk_integer_unbox(_box_x21, _ctx);
        kk_integer_dup(_uniq_precision_547_1, _ctx);
        kk_std_core_types__optional_drop(precision, _ctx);
        _x_x672 = _uniq_precision_547_1; /*int*/
      }
      else {
        kk_std_core_types__optional_drop(precision, _ctx);
        _x_x672 = kk_integer_from_small(-2); /*int*/
      }
      _x_x671 = kk_integer_clamp32(_x_x672,kk_context()); /*int32*/
      return kk_std_num_float64_show_fixedx(d, _x_x671, _ctx);
    }
  }
}
 
// Show a `:float64` as a string.
// If `d >= 1.0e-5` and `d < 1.0e+21`, `show-fixed` is used and otherwise `show-exp`.
// Default `precision` is `-17`.

kk_string_t kk_std_num_float64_show(double d, kk_std_core_types__optional precision, kk_context_t* _ctx) { /* (d : float64, precision : ? int) -> string */ 
  double dabs = kk_double_abs(d); /*float64*/;
  bool _match_x637 = (dabs >= (0x1.4f8b588e368f1p-17)); /*bool*/;
  if (_match_x637) {
    bool _match_x638 = (dabs < (0x1.b1ae4d6e2ef5p69)); /*bool*/;
    if (_match_x638) {
      kk_std_core_types__optional _x_x673;
      kk_box_t _x_x674;
      kk_integer_t _x_x675;
      if (kk_std_core_types__is_Optional(precision, _ctx)) {
        kk_box_t _box_x22 = precision._cons._Optional.value;
        kk_integer_t _uniq_precision_628 = kk_integer_unbox(_box_x22, _ctx);
        kk_integer_dup(_uniq_precision_628, _ctx);
        kk_std_core_types__optional_drop(precision, _ctx);
        _x_x675 = _uniq_precision_628; /*int*/
      }
      else {
        kk_std_core_types__optional_drop(precision, _ctx);
        _x_x675 = kk_integer_from_small(-17); /*int*/
      }
      _x_x674 = kk_integer_box(_x_x675, _ctx); /*7*/
      _x_x673 = kk_std_core_types__new_Optional(_x_x674, _ctx); /*? 7*/
      return kk_std_num_float64_show_fixed(d, _x_x673, _ctx);
    }
    {
      int32_t _x_x676;
      kk_integer_t _x_x677;
      if (kk_std_core_types__is_Optional(precision, _ctx)) {
        kk_box_t _box_x24 = precision._cons._Optional.value;
        kk_integer_t _uniq_precision_628_0 = kk_integer_unbox(_box_x24, _ctx);
        kk_integer_dup(_uniq_precision_628_0, _ctx);
        kk_std_core_types__optional_drop(precision, _ctx);
        _x_x677 = _uniq_precision_628_0; /*int*/
      }
      else {
        kk_std_core_types__optional_drop(precision, _ctx);
        _x_x677 = kk_integer_from_small(-17); /*int*/
      }
      _x_x676 = kk_integer_clamp32(_x_x677,kk_context()); /*int32*/
      return kk_std_num_float64_show_expx(d, _x_x676, _ctx);
    }
  }
  {
    int32_t _x_x678;
    kk_integer_t _x_x679;
    if (kk_std_core_types__is_Optional(precision, _ctx)) {
      kk_box_t _box_x25 = precision._cons._Optional.value;
      kk_integer_t _uniq_precision_628_1 = kk_integer_unbox(_box_x25, _ctx);
      kk_integer_dup(_uniq_precision_628_1, _ctx);
      kk_std_core_types__optional_drop(precision, _ctx);
      _x_x679 = _uniq_precision_628_1; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(precision, _ctx);
      _x_x679 = kk_integer_from_small(-17); /*int*/
    }
    _x_x678 = kk_integer_clamp32(_x_x679,kk_context()); /*int32*/
    return kk_std_num_float64_show_expx(d, _x_x678, _ctx);
  }
}
 
// Is this value equal to negative or positive infinity ?

bool kk_std_num_float64_is_inf(double d, kk_context_t* _ctx) { /* (d : float64) -> bool */ 
  return isinf(d);
}
 
// fused multiply-add. Computes `(x*y)+z` as if to infinite precision
// with only the final result rounded back to a `:float64`.

double kk_std_num_float64_fmadd(double x, double y, double z, kk_context_t* _ctx) { /* (x : float64, y : float64, z : float64) -> float64 */ 
  return fma(x,y,z);
}
 
// Round a float64 to a specified precision. Rounds to the  even number in case of a tie.
// `123.456.round-to-prec(2) == 123.46`
// `123.456.round-to-prec(-1) == 120.0`

double kk_std_num_float64_round_to_prec(double d, kk_integer_t prec, kk_context_t* _ctx) { /* (d : float64, prec : int) -> float64 */ 
  bool _match_x633 = kk_integer_lte_borrow(prec,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_x633) {
    kk_integer_drop(prec, _ctx);
    return kk_double_round_even(d,kk_context());
  }
  {
    double p;
    double _x_x683 = kk_integer_as_double(prec,kk_context()); /*float64*/
    p = pow(10.0,_x_x683); /*float64*/
    double _x_x684;
    double _x_x685 = (d * p); /*float64*/
    _x_x684 = kk_double_round_even(_x_x685,kk_context()); /*float64*/
    return (_x_x684 / p);
  }
}
 
// Round a `:float64` to a `:float32`

float kk_std_num_float64_float64_fs_float32(double f, kk_context_t* _ctx) { /* (f : float64) -> float32 */ 
  return (float)(f);
}
 
// Returns `ln(exp(x) + exp(y))`.
// Avoids overlow/underflow errors.

double kk_std_num_float64_lnaddexp(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  bool _match_x631 = (x == y); /*bool*/;
  if (_match_x631) {
    return (x + (0x1.62e42fefa39efp-1));
  }
  {
    double z = (x - y); /*float64*/;
    bool _match_x632 = (z > (0x0p+0)); /*bool*/;
    if (_match_x632) {
      double _x_x690;
      double _x_x691;
      double _x_x692 = (-z); /*float64*/
      _x_x691 = exp(_x_x692); /*float64*/
      _x_x690 = log1p(_x_x691); /*float64*/
      return (x + _x_x690);
    }
    {
      double _x_x693;
      double _x_x694 = exp(z); /*float64*/
      _x_x693 = log1p(_x_x694); /*float64*/
      return (y + _x_x693);
    }
  }
}
 
// Returns `log2( exp2(x) + exp2(y) )`.
// Avoids overlow/underflow errors.

double kk_std_num_float64_logaddexp2(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  bool _match_x629 = (x == y); /*bool*/;
  if (_match_x629) {
    return (x + 0x1p0);
  }
  {
    double z = (x - y); /*float64*/;
    bool _match_x630 = (z > (0x0p+0)); /*bool*/;
    if (_match_x630) {
      double x_0_10009;
      double _x_x695 = (-z); /*float64*/
      x_0_10009 = exp2(_x_x695); /*float64*/
      double _x_x696;
      double _x_x697 = log1p(x_0_10009); /*float64*/
      _x_x696 = ((0x1.71547652b82fep0) * _x_x697); /*float64*/
      return (x + _x_x696);
    }
    {
      double x_1_10010 = exp2(z); /*float64*/;
      double _x_x698;
      double _x_x699 = log1p(x_1_10010); /*float64*/
      _x_x698 = ((0x1.71547652b82fep0) * _x_x699); /*float64*/
      return (y + _x_x698);
    }
  }
}
 
// Return if two floats are nearly equal with respect to some `epsilon` (=`8*flt-epsilon`).
// The epsilon is the nearest difference for numbers around 1.0. The routine automatically
// scales the epsilon for larger and smaller numbers, and for subnormal numbers.

bool kk_std_num_float64_nearly_eq(double x, double y, kk_std_core_types__optional epsilon, kk_context_t* _ctx) { /* (x : float64, y : float64, epsilon : ? float64) -> bool */ 
  double _uniq_epsilon_1118;
  if (kk_std_core_types__is_Optional(epsilon, _ctx)) {
    kk_box_t _box_x27 = epsilon._cons._Optional.value;
    double _uniq_epsilon_1119 = kk_double_unbox(_box_x27, KK_BORROWED, _ctx);
    kk_std_core_types__optional_drop(epsilon, _ctx);
    _uniq_epsilon_1118 = _uniq_epsilon_1119; /*float64*/
  }
  else {
    kk_std_core_types__optional_drop(epsilon, _ctx);
    _uniq_epsilon_1118 = (0x1p3 * (0x1p-52)); /*float64*/
  }
  bool _match_x624 = (x == y); /*bool*/;
  if (_match_x624) {
    return true;
  }
  {
    double diff;
    double _x_x700 = (x - y); /*float64*/
    diff = kk_double_abs(_x_x700); /*float64*/
    bool _match_x625 = (x == (0x0p+0)); /*bool*/;
    if (_match_x625) {
      double _x_x701 = (0x1p1 * diff); /*float64*/
      double _x_x702 = (_uniq_epsilon_1118 * (0x1p-1022)); /*float64*/
      return (_x_x701 < _x_x702);
    }
    {
      bool _match_x626 = (y == (0x0p+0)); /*bool*/;
      if (_match_x626) {
        double _x_x703 = (0x1p1 * diff); /*float64*/
        double _x_x704 = (_uniq_epsilon_1118 * (0x1p-1022)); /*float64*/
        return (_x_x703 < _x_x704);
      }
      {
        bool _match_x627 = (diff < (0x1p-1022)); /*bool*/;
        if (_match_x627) {
          double _x_x705 = (0x1p1 * diff); /*float64*/
          double _x_x706 = (_uniq_epsilon_1118 * (0x1p-1022)); /*float64*/
          return (_x_x705 < _x_x706);
        }
        {
          double sum_0;
          double _x_x707 = kk_double_abs(x); /*float64*/
          double _x_x708 = kk_double_abs(y); /*float64*/
          sum_0 = (_x_x707 + _x_x708); /*float64*/
          double _x_x709;
          double _x_x710 = (0x1p1 * diff); /*float64*/
          double _x_x711;
          bool _match_x628 = (sum_0 > (0x1.fffffffffffffp1023)); /*bool*/;
          if (_match_x628) {
            _x_x711 = 0x1.fffffffffffffp1023; /*float64*/
          }
          else {
            _x_x711 = sum_0; /*float64*/
          }
          _x_x709 = (_x_x710 / _x_x711); /*float64*/
          return (_x_x709 < _uniq_epsilon_1118);
        }
      }
    }
  }
}
 
// Low-level: return the bits of a 64-bit `:float64` as in `:int64`

int64_t kk_std_num_float64_float64_to_bits(double d, kk_context_t* _ctx) { /* (d : float64) -> int64 */ 
  return kk_double_to_bits(d,kk_context());
}
 
// Low-level: create a `:float64` from the given 64-bit integer.

double kk_std_num_float64_float64_from_bits(int64_t i, kk_context_t* _ctx) { /* (i : int64) -> float64 */ 
  return kk_double_from_bits(i,kk_context());
}
 
// Calculate 2&middot;^`e`^ for an integer `e`.
// Uses efficient bit conversion for exponents between  -1022 and 1023 and
// otherwise falls back to the regular `exp2` function converting `e` to a float64.

double kk_std_num_float64_exp2i(kk_integer_t e, kk_context_t* _ctx) { /* (e : int) -> float64 */ 
  bool _match_x622 = kk_integer_gte_borrow(e,(kk_integer_from_small(-1022)),kk_context()); /*bool*/;
  if (_match_x622) {
    bool _match_x623 = kk_integer_lte_borrow(e,(kk_integer_from_small(1023)),kk_context()); /*bool*/;
    if (_match_x623) {
      int64_t i_10011;
      kk_integer_t _x_x712 = kk_integer_add_small_const(e, 1023, _ctx); /*int*/
      i_10011 = kk_std_num_int64_int64(_x_x712, _ctx); /*int64*/
      int64_t _x_x713;
      int64_t _x_x714 = (KK_I64(52)); /*int64*/
      _x_x713 = kk_shl64(i_10011,_x_x714); /*int64*/
      return kk_std_num_float64_float64_from_bits(_x_x713, _ctx);
    }
    {
      double _x_x715 = kk_integer_as_double(e,kk_context()); /*float64*/
      return exp2(_x_x715);
    }
  }
  {
    double _x_x716 = kk_integer_as_double(e,kk_context()); /*float64*/
    return exp2(_x_x716);
  }
}
 
// 'Load exponent': returns `x`&middot;2^`e`^ for a `is-finite` `x` and
// otherwise `x` itself. See also `encode` which loads an integer mantissa.

double kk_std_num_float64_ldexp(double x, kk_integer_t e, kk_context_t* _ctx) { /* (x : float64, e : int) -> float64 */ 
  bool b_10015 = isfinite(x); /*bool*/;
  if (b_10015) {
    bool _match_x614 = kk_integer_gte_borrow(e,(kk_integer_from_small(-1022)),kk_context()); /*bool*/;
    if (_match_x614) {
      bool _match_x618 = kk_integer_lte_borrow(e,(kk_integer_from_small(1023)),kk_context()); /*bool*/;
      if (_match_x618) {
        double _x_x718 = kk_std_num_float64_exp2i(e, _ctx); /*float64*/
        return (x * _x_x718);
      }
      {
        bool _match_x619 = kk_integer_lte_borrow(e,(kk_integer_from_small(2046)),kk_context()); /*bool*/;
        if (_match_x619) {
          double x_1_10018 = (x * 0x1p1023); /*float64*/;
          kk_integer_t e_1_10019 = kk_integer_add_small_const(e, -1023, _ctx); /*int*/;
          double _x_x719 = kk_std_num_float64_exp2i(e_1_10019, _ctx); /*float64*/
          return (x_1_10018 * _x_x719);
        }
        {
          bool _match_x620 = kk_integer_lte_borrow(e,(kk_integer_from_small(3069)),kk_context()); /*bool*/;
          if (_match_x620) {
            double x_3_10022;
            double _x_x720 = (x * 0x1p1023); /*float64*/
            x_3_10022 = (_x_x720 * 0x1p1023); /*float64*/
            kk_integer_t e_2_10023 = kk_integer_add_small_const(e, -2046, _ctx); /*int*/;
            double _x_x721 = kk_std_num_float64_exp2i(e_2_10023, _ctx); /*float64*/
            return (x_3_10022 * _x_x721);
          }
          {
            kk_integer_drop(e, _ctx);
            bool _match_x621 = (x < (0x0p+0)); /*bool*/;
            if (_match_x621) {
              return kk_std_num_float64_neginf;
            }
            {
              return kk_std_num_float64_posinf;
            }
          }
        }
      }
    }
    {
      bool _match_x615 = kk_integer_gte_borrow(e,(kk_integer_from_small(-2044)),kk_context()); /*bool*/;
      if (_match_x615) {
        double x_5_10026 = (x * (0x1p-1022)); /*float64*/;
        kk_integer_t e_3_10027 = kk_integer_add_small_const(e, 1022, _ctx); /*int*/;
        double _x_x722 = kk_std_num_float64_exp2i(e_3_10027, _ctx); /*float64*/
        return (x_5_10026 * _x_x722);
      }
      {
        bool _match_x616 = kk_integer_gte_borrow(e,(kk_integer_from_small(-3066)),kk_context()); /*bool*/;
        if (_match_x616) {
          double x_7_10030;
          double _x_x723 = (x * (0x1p-1022)); /*float64*/
          x_7_10030 = (_x_x723 * (0x1p-1022)); /*float64*/
          kk_integer_t e_4_10031 = kk_integer_add_small_const(e, 2044, _ctx); /*int*/;
          double _x_x724 = kk_std_num_float64_exp2i(e_4_10031, _ctx); /*float64*/
          return (x_7_10030 * _x_x724);
        }
        {
          kk_integer_drop(e, _ctx);
          bool _match_x617 = (x < (0x0p+0)); /*bool*/;
          if (_match_x617) {
            return -0x0p+0;
          }
          {
            return 0x0p+0;
          }
        }
      }
    }
  }
  {
    kk_integer_drop(e, _ctx);
    return x;
  }
}
 
// decode a normalized float64 (i.e. not subnormal)

kk_std_core_types__tuple2 kk_std_num_float64_decode_normalized(double d, kk_std_core_types__optional e_adjust, kk_context_t* _ctx) { /* (d : float64, e-adjust : ? int) -> (int, int) */ 
  int64_t i = kk_std_num_float64_float64_to_bits(d, _ctx); /*int64*/;
  int64_t exp;
  int64_t _x_x726;
  int64_t _x_x727;
  int64_t _x_x728 = (KK_I64(52)); /*int64*/
  _x_x727 = (int64_t)kk_shr64(i,_x_x728); /*int64*/
  int64_t _x_x729 = (KK_I64(2047)); /*int64*/
  _x_x726 = _x_x727 & _x_x729; /*int64*/
  int64_t _x_x730 = (KK_I64(1043)); /*int64*/
  exp = (int64_t)((uint64_t)_x_x726 - (uint64_t)_x_x730); /*int64*/
  int64_t man;
  int64_t _x_x731;
  int64_t _x_x732 = (KK_I64(4503599627370495)); /*int64*/
  _x_x731 = i & _x_x732; /*int64*/
  int64_t _x_x733 = (KK_I64(4503599627370496)); /*int64*/
  man = (int64_t)((uint64_t)_x_x731 + (uint64_t)_x_x733); /*int64*/
  kk_integer_t x_0_10039 = kk_integer_from_int64(exp,kk_context()); /*int*/;
  kk_integer_t x_10037 = kk_integer_add_small_const(x_0_10039, -32, _ctx); /*int*/;
  kk_integer_t _b_x29_31;
  int64_t _x_x734;
  bool _match_x613 = 0 > i; /*bool*/;
  if (_match_x613) {
    int64_t _x_x735 = (KK_I64(0)); /*int64*/
    _x_x734 = (int64_t)((uint64_t)_x_x735 - (uint64_t)man); /*int64*/
  }
  else {
    _x_x734 = man; /*int64*/
  }
  _b_x29_31 = kk_integer_from_int64(_x_x734,kk_context()); /*int*/
  kk_integer_t _b_x30_32;
  kk_integer_t _x_x736;
  if (kk_std_core_types__is_Optional(e_adjust, _ctx)) {
    kk_box_t _box_x28 = e_adjust._cons._Optional.value;
    kk_integer_t _uniq_e_adjust_1752 = kk_integer_unbox(_box_x28, _ctx);
    kk_integer_dup(_uniq_e_adjust_1752, _ctx);
    kk_std_core_types__optional_drop(e_adjust, _ctx);
    _x_x736 = _uniq_e_adjust_1752; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(e_adjust, _ctx);
    _x_x736 = kk_integer_from_small(0); /*int*/
  }
  _b_x30_32 = kk_integer_add(x_10037,_x_x736,kk_context()); /*int*/
  return kk_std_core_types__new_Tuple2(kk_integer_box(_b_x29_31, _ctx), kk_integer_box(_b_x30_32, _ctx), _ctx);
}
 
// Decode a float64 `d` into a tuple `(m,e)` of a mantissa `m` and exponent `e`
// such that `m`&middot;2^`e`^ =  `d` exactly. The mantissa `m` is
// always either 0 or in the range [2^52^, 2^53^). See also `frexp`.

kk_std_core_types__tuple2 kk_std_num_float64_decode(double d, kk_context_t* _ctx) { /* (d : float64) -> (int, int) */ 
  bool _match_x610 = (d == (0x0p+0)); /*bool*/;
  if (_match_x610) {
    return kk_std_core_types__new_Tuple2(kk_integer_box(kk_integer_from_small(0), _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx);
  }
  {
    bool _match_x611 = (d != (0x0p+0)); /*bool*/;
    if (_match_x611) {
      bool _match_x612;
      double _x_x737 = kk_double_abs(d); /*float64*/
      _match_x612 = (_x_x737 < (0x1p-1022)); /*bool*/
      if (_match_x612) {
        double _x_x738 = (d * 0x1p54); /*float64*/
        kk_std_core_types__optional _x_x739 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(-54), _ctx), _ctx); /*? 7*/
        return kk_std_num_float64_decode_normalized(_x_x738, _x_x739, _ctx);
      }
      {
        kk_std_core_types__optional _x_x740 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(0), _ctx), _ctx); /*? 7*/
        return kk_std_num_float64_decode_normalized(d, _x_x740, _ctx);
      }
    }
    {
      kk_std_core_types__optional _x_x741 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(0), _ctx), _ctx); /*? 7*/
      return kk_std_num_float64_decode_normalized(d, _x_x741, _ctx);
    }
  }
}
 
// 'Fraction/exponent': return the normalized fraction `f` and exponent `exp`
// for a number `x` such that `x == f`&middot;2^`exp`^.
// The absolute value of the fraction `f` is always in the range [0.5, 1.0), or
// one of `0.0`, `-0.0`, `neginf`, `posinf`, or `nan`.
// See also `decode` which  decodes to an integer mantissa.

kk_std_core_types__tuple2 kk_std_num_float64_frexp(double x, kk_context_t* _ctx) { /* (x : float64) -> (float64, int) */ 
  bool b_10042 = isfinite(x); /*bool*/;
  if (b_10042) {
    bool _match_x606 = (x == (0x0p+0)); /*bool*/;
    if (_match_x606) {
      bool _match_x608;
      double _x_x742 = (0x1p0 / x); /*float64*/
      _match_x608 = (isinf(_x_x742) && signbit(_x_x742)); /*bool*/
      if (_match_x608) {
        return kk_std_core_types__new_Tuple2(kk_double_box(x, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx);
      }
      {
        kk_std_core_types__tuple2 _match_x609 = kk_std_num_float64_decode(x, _ctx); /*(int, int)*/;
        {
          kk_box_t _box_x45 = _match_x609.fst;
          kk_box_t _box_x46 = _match_x609.snd;
          kk_integer_t m = kk_integer_unbox(_box_x45, _ctx);
          kk_integer_t e = kk_integer_unbox(_box_x46, _ctx);
          kk_integer_dup(e, _ctx);
          kk_integer_dup(m, _ctx);
          kk_std_core_types__tuple2_drop(_match_x609, _ctx);
          double _b_x47_57;
          double _x_x743 = kk_integer_as_double(m,kk_context()); /*float64*/
          _b_x47_57 = (_x_x743 * (0x1p-53)); /*float64*/
          kk_integer_t _b_x48_58 = kk_integer_add_small_const(e, 53, _ctx); /*int*/;
          return kk_std_core_types__new_Tuple2(kk_double_box(_b_x47_57, _ctx), kk_integer_box(_b_x48_58, _ctx), _ctx);
        }
      }
    }
    {
      kk_std_core_types__tuple2 _match_x607 = kk_std_num_float64_decode(x, _ctx); /*(int, int)*/;
      {
        kk_box_t _box_x49 = _match_x607.fst;
        kk_box_t _box_x50 = _match_x607.snd;
        kk_integer_t m_0 = kk_integer_unbox(_box_x49, _ctx);
        kk_integer_t e_0 = kk_integer_unbox(_box_x50, _ctx);
        kk_integer_dup(e_0, _ctx);
        kk_integer_dup(m_0, _ctx);
        kk_std_core_types__tuple2_drop(_match_x607, _ctx);
        double _b_x51_59;
        double _x_x744 = kk_integer_as_double(m_0,kk_context()); /*float64*/
        _b_x51_59 = (_x_x744 * (0x1p-53)); /*float64*/
        kk_integer_t _b_x52_60 = kk_integer_add_small_const(e_0, 53, _ctx); /*int*/;
        return kk_std_core_types__new_Tuple2(kk_double_box(_b_x51_59, _ctx), kk_integer_box(_b_x52_60, _ctx), _ctx);
      }
    }
  }
  {
    return kk_std_core_types__new_Tuple2(kk_double_box(x, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx);
  }
}
 
// Returns the greatest `:float64` less than `x`.
// This behaves exactly as `nextDown` in the IEEE 754-2008 standard.
// The identity `x.next-down == ~next-down(~x)` holds for all `x`.
// When `x` is finite `x == x.next-down.next-up` also holds.

double kk_std_num_float64_next_down(double x, kk_context_t* _ctx) { /* (x : float64) -> float64 */ 
  bool _match_x602 = isnan(x); /*bool*/;
  if (_match_x602) {
    return x;
  }
  {
    bool _match_x603 = (isinf(x) && signbit(x)); /*bool*/;
    if (_match_x603) {
      return x;
    }
    {
      bool _match_x604 = (x == (0x0p+0)); /*bool*/;
      if (_match_x604) {
        return (-(0x1p-1074));
      }
      {
        int64_t i = kk_std_num_float64_float64_to_bits(x, _ctx); /*int64*/;
        int64_t next;
        bool _match_x605 = 0 > i; /*bool*/;
        if (_match_x605) {
          int64_t _x_x745 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i + (uint64_t)_x_x745); /*int64*/
        }
        else {
          int64_t _x_x746 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i - (uint64_t)_x_x746); /*int64*/
        }
        return kk_std_num_float64_float64_from_bits(next, _ctx);
      }
    }
  }
}
 
// Returns the least `:float64` greater than `x`.
// This behaves exactly as `nextUp` in the IEEE 754-2008 standard.
// The identity `x.next-up == ~next-down(~x)` holds for all `x`.
// When `x` is finite `x == x.next-up.next-down` also holds.

double kk_std_num_float64_next_up(double x, kk_context_t* _ctx) { /* (x : float64) -> float64 */ 
  bool _match_x598 = isnan(x); /*bool*/;
  if (_match_x598) {
    return x;
  }
  {
    bool _match_x599 = (isinf(x) && !signbit(x)); /*bool*/;
    if (_match_x599) {
      return x;
    }
    {
      bool _match_x600 = (x == (0x0p+0)); /*bool*/;
      if (_match_x600) {
        return 0x1p-1074;
      }
      {
        int64_t i = kk_std_num_float64_float64_to_bits(x, _ctx); /*int64*/;
        int64_t next;
        bool _match_x601 = 0 > i; /*bool*/;
        if (_match_x601) {
          int64_t _x_x747 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i - (uint64_t)_x_x747); /*int64*/
        }
        else {
          int64_t _x_x748 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i + (uint64_t)_x_x748); /*int64*/
        }
        return kk_std_num_float64_float64_from_bits(next, _ctx);
      }
    }
  }
}
 
// Compare floats using a total ordering on the `:float64`.
// The ordering follows the `totalOrder` predicate as defined in IEEE 754-2008 exactly.
// The values are ordered in following order:
// negative quiet nan,
// negative signaling nan,
// `neginf`,
// -finite,
// -0.0,
// +0.0,
// finite,
// `posinf`,
// signaling nan,
// and quiet nan.

kk_std_core_types__order kk_std_num_float64_cmp(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> order */ 
  int64_t bx = kk_std_num_float64_float64_to_bits(x, _ctx); /*int64*/;
  int64_t by = kk_std_num_float64_float64_to_bits(y, _ctx); /*int64*/;
  int64_t i_10052;
  int64_t _x_x749 = (KK_I64(63)); /*int64*/
  i_10052 = kk_sar64(bx,_x_x749); /*int64*/
  int64_t ix;
  int64_t _x_x750;
  int64_t _x_x751 = (KK_I64(1)); /*int64*/
  _x_x750 = (int64_t)kk_shr64(i_10052,_x_x751); /*int64*/
  ix = _x_x750 ^ bx; /*int64*/
  int64_t i_1_10056;
  int64_t _x_x752 = (KK_I64(63)); /*int64*/
  i_1_10056 = kk_sar64(by,_x_x752); /*int64*/
  int64_t iy;
  int64_t _x_x753;
  int64_t _x_x754 = (KK_I64(1)); /*int64*/
  _x_x753 = (int64_t)kk_shr64(i_1_10056,_x_x754); /*int64*/
  iy = _x_x753 ^ by; /*int64*/
  bool _match_x596 = (ix < iy); /*bool*/;
  if (_match_x596) {
    return kk_std_core_types__new_Lt(_ctx);
  }
  {
    bool _match_x597 = (ix > iy); /*bool*/;
    if (_match_x597) {
      return kk_std_core_types__new_Gt(_ctx);
    }
    {
      return kk_std_core_types__new_Eq(_ctx);
    }
  }
}
 
// The midpoint is the average of `x` and `y`.
// Avoids overflow on large numbers.

double kk_std_num_float64_midpoint(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  bool _match_x590 = (x != (0x0p+0)); /*bool*/;
  if (_match_x590) {
    bool _match_x593;
    double _x_x755 = kk_double_abs(x); /*float64*/
    _match_x593 = (_x_x755 < (0x1p-1022)); /*bool*/
    if (_match_x593) {
      double _x_x756 = (x + y); /*float64*/
      return (_x_x756 / 0x1p1);
    }
    {
      bool _match_x594 = (y != (0x0p+0)); /*bool*/;
      if (_match_x594) {
        bool _match_x595;
        double _x_x757 = kk_double_abs(y); /*float64*/
        _match_x595 = (_x_x757 < (0x1p-1022)); /*bool*/
        if (_match_x595) {
          double _x_x758 = (x + y); /*float64*/
          return (_x_x758 / 0x1p1);
        }
        {
          double _x_x759 = (x / 0x1p1); /*float64*/
          double _x_x760 = (y / 0x1p1); /*float64*/
          return (_x_x759 + _x_x760);
        }
      }
      {
        double _x_x761 = (x / 0x1p1); /*float64*/
        double _x_x762 = (y / 0x1p1); /*float64*/
        return (_x_x761 + _x_x762);
      }
    }
  }
  {
    bool _match_x591 = (y != (0x0p+0)); /*bool*/;
    if (_match_x591) {
      bool _match_x592;
      double _x_x763 = kk_double_abs(y); /*float64*/
      _match_x592 = (_x_x763 < (0x1p-1022)); /*bool*/
      if (_match_x592) {
        double _x_x764 = (x + y); /*float64*/
        return (_x_x764 / 0x1p1);
      }
      {
        double _x_x765 = (x / 0x1p1); /*float64*/
        double _x_x766 = (y / 0x1p1); /*float64*/
        return (_x_x765 + _x_x766);
      }
    }
    {
      double _x_x767 = (x / 0x1p1); /*float64*/
      double _x_x768 = (y / 0x1p1); /*float64*/
      return (_x_x767 + _x_x768);
    }
  }
}
 
// Linear interpolation, calculating `x + t*(y - x)` but avoids troublesome edge cases.
// Follows the C++20 [specification](https://www.open-std.org/jtc1/sc22/wg21/docs/papers/2019/p0811r3.html).
// In particular, if `x.is-finite && y.is-finite`, then:
// - exact: `lerp(x,y,0.0) == x` and  `lerp(x,y,1.0) == y`
// - monotonic: if `x <= y` and `t1 <= t2`, then `cmp( lerp(x,y,t1), lerp(x,y,t2) ) <= Eq` (and other cases)
// - deterministic: only `lerp(x,x,flt-inf)` results in `nan`
// - bounded: `t<0.0 || t>1.0 || is-finite(lerp(x,y,t))`
// - consistent: `lerp(x,x,t) == x`

double kk_std_num_float64_lerp(double x, double y, double t, kk_context_t* _ctx) { /* (x : float64, y : float64, t : float64) -> float64 */ 
  bool _match_x568 = (x <= (0x0p+0)); /*bool*/;
  if (_match_x568) {
    bool _match_x579 = (y >= (0x0p+0)); /*bool*/;
    if (_match_x579) {
      double _x_x769 = (t * y); /*float64*/
      double _x_x770;
      double _x_x771 = (0x1p0 - t); /*float64*/
      _x_x770 = (_x_x771 * x); /*float64*/
      return (_x_x769 + _x_x770);
    }
    {
      bool _match_x580 = (x >= (0x0p+0)); /*bool*/;
      if (_match_x580) {
        bool _match_x585 = (y <= (0x0p+0)); /*bool*/;
        if (_match_x585) {
          double _x_x772 = (t * y); /*float64*/
          double _x_x773;
          double _x_x774 = (0x1p0 - t); /*float64*/
          _x_x773 = (_x_x774 * x); /*float64*/
          return (_x_x772 + _x_x773);
        }
        {
          bool _match_x586 = (t == 0x1p0); /*bool*/;
          if (_match_x586) {
            return y;
          }
          {
            double z;
            double _x_x775;
            double _x_x776 = (y - x); /*float64*/
            _x_x775 = (t * _x_x776); /*float64*/
            z = (x + _x_x775); /*float64*/
            bool x_0_10064 = (t > 0x1p0); /*bool*/;
            bool y_0_10065 = (y > x); /*bool*/;
            bool _match_x587;
            if (x_0_10064) {
              _match_x587 = y_0_10065; /*bool*/
            }
            else {
              if (y_0_10065) {
                _match_x587 = false; /*bool*/
              }
              else {
                _match_x587 = true; /*bool*/
              }
            }
            if (_match_x587) {
              bool _match_x589 = (y >= z); /*bool*/;
              if (_match_x589) {
                return y;
              }
              {
                return z;
              }
            }
            {
              bool _match_x588 = (y <= z); /*bool*/;
              if (_match_x588) {
                return y;
              }
              {
                return z;
              }
            }
          }
        }
      }
      {
        bool _match_x581 = (t == 0x1p0); /*bool*/;
        if (_match_x581) {
          return y;
        }
        {
          double z_0;
          double _x_x777;
          double _x_x778 = (y - x); /*float64*/
          _x_x777 = (t * _x_x778); /*float64*/
          z_0 = (x + _x_x777); /*float64*/
          bool x_3_10070 = (t > 0x1p0); /*bool*/;
          bool y_3_10071 = (y > x); /*bool*/;
          bool _match_x582;
          if (x_3_10070) {
            _match_x582 = y_3_10071; /*bool*/
          }
          else {
            if (y_3_10071) {
              _match_x582 = false; /*bool*/
            }
            else {
              _match_x582 = true; /*bool*/
            }
          }
          if (_match_x582) {
            bool _match_x584 = (y >= z_0); /*bool*/;
            if (_match_x584) {
              return y;
            }
            {
              return z_0;
            }
          }
          {
            bool _match_x583 = (y <= z_0); /*bool*/;
            if (_match_x583) {
              return y;
            }
            {
              return z_0;
            }
          }
        }
      }
    }
  }
  {
    bool _match_x569 = (x >= (0x0p+0)); /*bool*/;
    if (_match_x569) {
      bool _match_x574 = (y <= (0x0p+0)); /*bool*/;
      if (_match_x574) {
        double _x_x779 = (t * y); /*float64*/
        double _x_x780;
        double _x_x781 = (0x1p0 - t); /*float64*/
        _x_x780 = (_x_x781 * x); /*float64*/
        return (_x_x779 + _x_x780);
      }
      {
        bool _match_x575 = (t == 0x1p0); /*bool*/;
        if (_match_x575) {
          return y;
        }
        {
          double z_1;
          double _x_x782;
          double _x_x783 = (y - x); /*float64*/
          _x_x782 = (t * _x_x783); /*float64*/
          z_1 = (x + _x_x782); /*float64*/
          bool x_6_10076 = (t > 0x1p0); /*bool*/;
          bool y_6_10077 = (y > x); /*bool*/;
          bool _match_x576;
          if (x_6_10076) {
            _match_x576 = y_6_10077; /*bool*/
          }
          else {
            if (y_6_10077) {
              _match_x576 = false; /*bool*/
            }
            else {
              _match_x576 = true; /*bool*/
            }
          }
          if (_match_x576) {
            bool _match_x578 = (y >= z_1); /*bool*/;
            if (_match_x578) {
              return y;
            }
            {
              return z_1;
            }
          }
          {
            bool _match_x577 = (y <= z_1); /*bool*/;
            if (_match_x577) {
              return y;
            }
            {
              return z_1;
            }
          }
        }
      }
    }
    {
      bool _match_x570 = (t == 0x1p0); /*bool*/;
      if (_match_x570) {
        return y;
      }
      {
        double z_0_0;
        double _x_x784;
        double _x_x785 = (y - x); /*float64*/
        _x_x784 = (t * _x_x785); /*float64*/
        z_0_0 = (x + _x_x784); /*float64*/
        bool x_9_10082 = (t > 0x1p0); /*bool*/;
        bool y_9_10083 = (y > x); /*bool*/;
        bool _match_x571;
        if (x_9_10082) {
          _match_x571 = y_9_10083; /*bool*/
        }
        else {
          if (y_9_10083) {
            _match_x571 = false; /*bool*/
          }
          else {
            _match_x571 = true; /*bool*/
          }
        }
        if (_match_x571) {
          bool _match_x573 = (y >= z_0_0); /*bool*/;
          if (_match_x573) {
            return y;
          }
          {
            return z_0_0;
          }
        }
        {
          bool _match_x572 = (y <= z_0_0); /*bool*/;
          if (_match_x572) {
            return y;
          }
          {
            return z_0_0;
          }
        }
      }
    }
  }
}
 
// /* Show a float64 in [hexadecimal notation](https://books.google.com/books?id=FgMsCwAAQBAJ&pg=PA41).
// An advantage of this format is that it precisely represents the `:float64` and can
// reliably (and efficiently) be parsed back, i.e. `d.show-hex.parse-float64 == Just(d)`.
// The significant is the _hexadecimal_ fraction while the
// exponent after the `p` is the _decimal_ power of 2.
//  For example, ``0xA.Fp-10`` = (10 + 15/16)&middot;2^-10^  (not 2^-16^!) = 0.01068115234375.
//  Equivalently, ``0xA.Fp-10 == 0x5.78p-9 == 0x2.BCp-8 == 0x1.5Ep-7``.
// ```
// > flt-min.show-hex
// "0x1.0p-1022"
// > 0.1.show-hex
// "0x1.999999999999Ap-4"
// > flt-max.show-hex
// "0x1.FFFFFFFFFFFFFp+1023"
// > -0.0.show-hex
// "-0x0.0p+0"
// > nan.show-hex
// "NaN"
// > 0.01068115234375.show-hex
// "0x1.5Ep-7"
// ```
// .
// */

kk_string_t kk_std_num_float64_show_hex(double d, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (d : float64, width : ? int, use-capitals : ? bool, pre : ? string) -> string */ 
  bool b_10088 = isfinite(d); /*bool*/;
  if (b_10088) {
    kk_std_core_types__tuple2 _match_x557 = kk_std_num_float64_decode(d, _ctx); /*(int, int)*/;
    {
      kk_box_t _box_x63 = _match_x557.fst;
      kk_box_t _box_x64 = _match_x557.snd;
      kk_integer_t m = kk_integer_unbox(_box_x63, _ctx);
      kk_integer_t e = kk_integer_unbox(_box_x64, _ctx);
      kk_integer_dup(e, _ctx);
      kk_integer_dup(m, _ctx);
      kk_std_core_types__tuple2_drop(_match_x557, _ctx);
      kk_string_t man;
      kk_integer_t _x_x786 = kk_integer_abs(m,kk_context()); /*int*/
      kk_std_core_types__optional _x_x787 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(1), _ctx), _ctx); /*? 7*/
      kk_std_core_types__optional _x_x788;
      kk_box_t _x_x789;
      bool _x_x790;
      if (kk_std_core_types__is_Optional(use_capitals, _ctx)) {
        kk_box_t _box_x66 = use_capitals._cons._Optional.value;
        bool _uniq_use_capitals_2526 = kk_bool_unbox(_box_x66);
        kk_std_core_types__optional_drop(use_capitals, _ctx);
        _x_x790 = _uniq_use_capitals_2526; /*bool*/
      }
      else {
        kk_std_core_types__optional_drop(use_capitals, _ctx);
        _x_x790 = true; /*bool*/
      }
      _x_x789 = kk_bool_box(_x_x790); /*7*/
      _x_x788 = kk_std_core_types__new_Optional(_x_x789, _ctx); /*? 7*/
      kk_std_core_types__optional _x_x791;
      kk_box_t _x_x792;
      kk_string_t _x_x793 = kk_string_empty(); /*string*/
      _x_x792 = kk_string_box(_x_x793); /*7*/
      _x_x791 = kk_std_core_types__new_Optional(_x_x792, _ctx); /*? 7*/
      man = kk_std_core_show_show_hex(_x_x786, _x_x787, _x_x788, _x_x791, _ctx); /*string*/
      kk_integer_t x_0_10091;
      kk_string_t _x_x795 = kk_string_dup(man, _ctx); /*string*/
      x_0_10091 = kk_std_core_string_chars_fs_count(_x_x795, _ctx); /*int*/
      kk_integer_t y_10090;
      kk_integer_t _x_x796 = kk_integer_add_small_const(x_0_10091, -1, _ctx); /*int*/
      y_10090 = kk_integer_mul((kk_integer_from_small(4)),_x_x796,kk_context()); /*int*/
      kk_integer_t exp0 = kk_integer_add(e,y_10090,kk_context()); /*int*/;
      kk_string_t exp;
      kk_string_t _x_x797;
      bool _match_x567 = kk_integer_gte_borrow(exp0,(kk_integer_from_small(0)),kk_context()); /*bool*/;
      if (_match_x567) {
        kk_define_string_literal(, _s_x798, 1, "+", _ctx)
        _x_x797 = kk_string_dup(_s_x798, _ctx); /*string*/
      }
      else {
        _x_x797 = kk_string_empty(); /*string*/
      }
      kk_string_t _x_x800 = kk_std_core_int_show(exp0, _ctx); /*string*/
      exp = kk_std_core_types__lp__plus__plus__rp_(_x_x797, _x_x800, _ctx); /*string*/
      kk_string_t frac;
      kk_string_t _own_x565;
      kk_string_t _x_x801;
      kk_string_t _x_x802 = kk_string_dup(man, _ctx); /*string*/
      _x_x801 = kk_std_core_sslice_tail(_x_x802, _ctx); /*string*/
      kk_string_t _x_x803;
      kk_define_string_literal(, _s_x804, 1, "0", _ctx)
      _x_x803 = kk_string_dup(_s_x804, _ctx); /*string*/
      _own_x565 = kk_std_core_sslice_trim_right(_x_x801, _x_x803, _ctx); /*string*/
      kk_integer_t _brw_x564;
      bool _match_x561;
      kk_integer_t _brw_x562;
      if (kk_std_core_types__is_Optional(width, _ctx)) {
        kk_box_t _box_x72 = width._cons._Optional.value;
        kk_integer_t _uniq_width_2522 = kk_integer_unbox(_box_x72, _ctx);
        kk_integer_dup(_uniq_width_2522, _ctx);
        _brw_x562 = _uniq_width_2522; /*int*/
      }
      else {
        _brw_x562 = kk_integer_from_small(1); /*int*/
      }
      bool _brw_x563 = kk_integer_gte_borrow((kk_integer_from_small(1)),_brw_x562,kk_context()); /*bool*/;
      kk_integer_drop(_brw_x562, _ctx);
      _match_x561 = _brw_x563; /*bool*/
      if (_match_x561) {
        kk_std_core_types__optional_drop(width, _ctx);
        _brw_x564 = kk_integer_from_small(1); /*int*/
      }
      else {
        if (kk_std_core_types__is_Optional(width, _ctx)) {
          kk_box_t _box_x73 = width._cons._Optional.value;
          kk_integer_t _uniq_width_2522_0 = kk_integer_unbox(_box_x73, _ctx);
          kk_integer_dup(_uniq_width_2522_0, _ctx);
          kk_std_core_types__optional_drop(width, _ctx);
          _brw_x564 = _uniq_width_2522_0; /*int*/
        }
        else {
          kk_std_core_types__optional_drop(width, _ctx);
          _brw_x564 = kk_integer_from_small(1); /*int*/
        }
      }
      kk_string_t _brw_x566;
      kk_std_core_types__optional _x_x805 = kk_std_core_types__new_Optional(kk_char_box('0', _ctx), _ctx); /*? 7*/
      _brw_x566 = kk_std_core_string_pad_right(_own_x565, _brw_x564, _x_x805, _ctx); /*string*/
      kk_integer_drop(_brw_x564, _ctx);
      frac = _brw_x566; /*string*/
      kk_string_t sign_0;
      bool _match_x558 = (d < (0x0p+0)); /*bool*/;
      if (_match_x558) {
        kk_define_string_literal(, _s_x806, 1, "-", _ctx)
        sign_0 = kk_string_dup(_s_x806, _ctx); /*string*/
      }
      else {
        bool _match_x559 = (d == (0x0p+0)); /*bool*/;
        if (_match_x559) {
          bool _match_x560;
          double _x_x807 = (0x1p0 / d); /*float64*/
          _match_x560 = (isinf(_x_x807) && signbit(_x_x807)); /*bool*/
          if (_match_x560) {
            kk_define_string_literal(, _s_x808, 1, "-", _ctx)
            sign_0 = kk_string_dup(_s_x808, _ctx); /*string*/
          }
          else {
            sign_0 = kk_string_empty(); /*string*/
          }
        }
        else {
          sign_0 = kk_string_empty(); /*string*/
        }
      }
      kk_string_t _x_x811;
      kk_string_t _x_x812;
      if (kk_std_core_types__is_Optional(pre, _ctx)) {
        kk_box_t _box_x76 = pre._cons._Optional.value;
        kk_string_t _uniq_pre_2530 = kk_string_unbox(_box_x76);
        kk_string_dup(_uniq_pre_2530, _ctx);
        kk_std_core_types__optional_drop(pre, _ctx);
        _x_x812 = _uniq_pre_2530; /*string*/
      }
      else {
        kk_std_core_types__optional_drop(pre, _ctx);
        kk_define_string_literal(, _s_x813, 2, "0x", _ctx)
        _x_x812 = kk_string_dup(_s_x813, _ctx); /*string*/
      }
      kk_string_t _x_x814;
      kk_string_t _x_x815 = kk_std_core_sslice_head(man, _ctx); /*string*/
      kk_string_t _x_x816;
      kk_string_t _x_x817;
      kk_define_string_literal(, _s_x818, 1, ".", _ctx)
      _x_x817 = kk_string_dup(_s_x818, _ctx); /*string*/
      kk_string_t _x_x819;
      kk_string_t _x_x820;
      kk_string_t _x_x821;
      kk_define_string_literal(, _s_x822, 1, "p", _ctx)
      _x_x821 = kk_string_dup(_s_x822, _ctx); /*string*/
      _x_x820 = kk_std_core_types__lp__plus__plus__rp_(_x_x821, exp, _ctx); /*string*/
      _x_x819 = kk_std_core_types__lp__plus__plus__rp_(frac, _x_x820, _ctx); /*string*/
      _x_x816 = kk_std_core_types__lp__plus__plus__rp_(_x_x817, _x_x819, _ctx); /*string*/
      _x_x814 = kk_std_core_types__lp__plus__plus__rp_(_x_x815, _x_x816, _ctx); /*string*/
      _x_x811 = kk_std_core_types__lp__plus__plus__rp_(_x_x812, _x_x814, _ctx); /*string*/
      return kk_std_core_types__lp__plus__plus__rp_(sign_0, _x_x811, _ctx);
    }
  }
  {
    kk_std_core_types__optional_drop(width, _ctx);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    kk_std_core_types__optional_drop(pre, _ctx);
    return kk_std_num_float64_show(d, kk_std_core_types__new_None(_ctx), _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10172_fun825__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10172_fun825(kk_function_t _fself, kk_box_t _b_x82, kk_box_t _b_x83, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10172_fun825(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_phexdouble_10172_fun825, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_phexdouble_10172_fun825(kk_function_t _fself, kk_box_t _b_x82, kk_box_t _b_x83, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__maybe _x_x826;
  kk_string_t _x_x827 = kk_string_unbox(_b_x82); /*string*/
  bool _x_x828;
  kk_std_core_types__optional _match_x556 = kk_std_core_types__optional_unbox(_b_x83, KK_OWNED, _ctx); /*? bool*/;
  if (kk_std_core_types__is_Optional(_match_x556, _ctx)) {
    kk_box_t _box_x77 = _match_x556._cons._Optional.value;
    bool _uniq_hex_533 = kk_bool_unbox(_box_x77);
    kk_std_core_types__optional_drop(_match_x556, _ctx);
    _x_x828 = _uniq_hex_533; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x556, _ctx);
    _x_x828 = false; /*bool*/
  }
  _x_x826 = kk_std_core_int_xparse(_x_x827, _x_x828, _ctx); /*maybe<int>*/
  return kk_std_core_types__maybe_box(_x_x826, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10172_fun832__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10172_fun832(kk_function_t _fself, kk_box_t _b_x94, kk_box_t _b_x95, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10172_fun832(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_phexdouble_10172_fun832, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_phexdouble_10172_fun832(kk_function_t _fself, kk_box_t _b_x94, kk_box_t _b_x95, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_integer_t _x_x833;
  kk_std_core_types__maybe _match_x555 = kk_std_core_types__maybe_unbox(_b_x94, KK_OWNED, _ctx); /*maybe<int>*/;
  if (kk_std_core_types__is_Nothing(_match_x555, _ctx)) {
    _x_x833 = kk_integer_unbox(_b_x95, _ctx); /*int*/
  }
  else {
    kk_box_t _box_x90 = _match_x555._cons.Just.value;
    kk_integer_t x = kk_integer_unbox(_box_x90, _ctx);
    kk_integer_dup(x, _ctx);
    kk_std_core_types__maybe_drop(_match_x555, _ctx);
    kk_box_drop(_b_x95, _ctx);
    _x_x833 = x; /*int*/
  }
  return kk_integer_box(_x_x833, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10172_fun836__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10172_fun836(kk_function_t _fself, kk_box_t _b_x104, kk_box_t _b_x105, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10172_fun836(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_phexdouble_10172_fun836, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_phexdouble_10172_fun836(kk_function_t _fself, kk_box_t _b_x104, kk_box_t _b_x105, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_integer_t man_0_109 = kk_integer_unbox(_b_x104, _ctx); /*int*/;
  kk_integer_t exp_0_110 = kk_integer_unbox(_b_x105, _ctx); /*int*/;
  double _x_x837;
  double _x_x838 = kk_integer_as_double(man_0_109,kk_context()); /*float64*/
  _x_x837 = kk_std_num_float64_ldexp(_x_x838, exp_0_110, _ctx); /*float64*/
  return kk_double_box(_x_x837, _ctx);
}

double kk_std_num_float64__mlift_phexdouble_10172(kk_string_t frac, kk_string_t man, kk_integer_t exp, kk_context_t* _ctx) { /* (frac : string, man : string, exp : int) -> std/text/parse/parse float64 */ 
  kk_string_t _x_x1_0_10166;
  kk_string_t _x_x823 = kk_string_dup(frac, _ctx); /*string*/
  _x_x1_0_10166 = kk_std_core_types__lp__plus__plus__rp_(man, _x_x823, _ctx); /*string*/
  kk_std_core_types__maybe _x_x1_10164;
  kk_box_t _x_x824;
  kk_box_t _x_x829;
  kk_std_core_types__optional _x_x830 = kk_std_core_types__new_Optional(kk_bool_box(true), _ctx); /*? 7*/
  _x_x829 = kk_std_core_types__optional_box(_x_x830, _ctx); /*9662*/
  _x_x824 = kk_std_core_hnd__open_none2(kk_std_num_float64__new_mlift_phexdouble_10172_fun825(_ctx), kk_string_box(_x_x1_0_10166), _x_x829, _ctx); /*9663*/
  _x_x1_10164 = kk_std_core_types__maybe_unbox(_x_x824, KK_OWNED, _ctx); /*maybe<int>*/
  kk_integer_t m_0;
  kk_box_t _x_x831 = kk_std_core_hnd__open_none2(kk_std_num_float64__new_mlift_phexdouble_10172_fun832(_ctx), kk_std_core_types__maybe_box(_x_x1_10164, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx); /*9663*/
  m_0 = kk_integer_unbox(_x_x831, _ctx); /*int*/
  kk_integer_t y_10161;
  kk_integer_t _x_x834 = kk_std_core_string_chars_fs_count(frac, _ctx); /*int*/
  y_10161 = kk_integer_mul((kk_integer_from_small(4)),_x_x834,kk_context()); /*int*/
  kk_integer_t e = kk_integer_sub(exp,y_10161,kk_context()); /*int*/;
  kk_box_t _x_x835 = kk_std_core_hnd__open_none2(kk_std_num_float64__new_mlift_phexdouble_10172_fun836(_ctx), kk_integer_box(m_0, _ctx), kk_integer_box(e, _ctx), _ctx); /*9663*/
  return kk_double_unbox(_x_x835, KK_OWNED, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10174_fun842__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10174_fun842(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10174_fun842(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_phexdouble_10174_fun842, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10174_fun847__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10174_fun847(kk_function_t _fself, kk_box_t _b_x112, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10174_fun847(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_phexdouble_10174_fun847, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_phexdouble_10174_fun847(kk_function_t _fself, kk_box_t _b_x112, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_integer_t _x_x848;
  kk_char_t _x_x849 = kk_char_unbox(_b_x112, KK_OWNED, _ctx); /*char*/
  _x_x848 = kk_std_num_float64__mlift_phexdouble_10171(_x_x849, _ctx); /*int*/
  return kk_integer_box(_x_x848, _ctx);
}
static kk_box_t kk_std_num_float64__mlift_phexdouble_10174_fun842(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_char_t x_0_10196;
  kk_string_t _x_x843;
  kk_define_string_literal(, _s_x844, 2, "pP", _ctx)
  _x_x843 = kk_string_dup(_s_x844, _ctx); /*string*/
  x_0_10196 = kk_std_text_parse_one_of(_x_x843, _ctx); /*char*/
  kk_integer_t _x_x845;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x846 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_phexdouble_10174_fun847(_ctx), _ctx); /*2401*/
    _x_x845 = kk_integer_unbox(_x_x846, _ctx); /*int*/
  }
  else {
    _x_x845 = kk_std_text_parse_pint(_ctx); /*int*/
  }
  return kk_integer_box(_x_x845, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10174_fun850__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10174_fun850(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10174_fun850(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_phexdouble_10174_fun850, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_phexdouble_10174_fun850(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_integer_box(kk_integer_from_small(0), _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10174_fun852__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t man;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10174_fun852(kk_function_t _fself, kk_box_t _b_x119, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10174_fun852(kk_string_t frac, kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_phexdouble_10174_fun852__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift_phexdouble_10174_fun852__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift_phexdouble_10174_fun852, kk_context());
  _self->frac = frac;
  _self->man = man;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift_phexdouble_10174_fun852(kk_function_t _fself, kk_box_t _b_x119, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_phexdouble_10174_fun852__t* _self = kk_function_as(struct kk_std_num_float64__mlift_phexdouble_10174_fun852__t*, _fself, _ctx);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(frac, _ctx);kk_string_dup(man, _ctx);}, {}, _ctx)
  kk_integer_t exp_121 = kk_integer_unbox(_b_x119, _ctx); /*int*/;
  double _x_x853 = kk_std_num_float64__mlift_phexdouble_10172(frac, man, exp_121, _ctx); /*float64*/
  return kk_double_box(_x_x853, _ctx);
}

double kk_std_num_float64__mlift_phexdouble_10174(kk_string_t man, kk_string_t _y_x10133, kk_context_t* _ctx) { /* (man : string, string) -> std/text/parse/parse float64 */ 
  kk_string_t frac;
  kk_string_t _x_x839;
  kk_define_string_literal(, _s_x840, 1, "0", _ctx)
  _x_x839 = kk_string_dup(_s_x840, _ctx); /*string*/
  frac = kk_std_core_sslice_trim_right(_y_x10133, _x_x839, _ctx); /*string*/
  kk_integer_t x_10194;
  kk_box_t _x_x841 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64__new_mlift_phexdouble_10174_fun842(_ctx), kk_std_num_float64__new_mlift_phexdouble_10174_fun850(_ctx), _ctx); /*1503*/
  x_10194 = kk_integer_unbox(_x_x841, _ctx); /*int*/
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_10194, _ctx);
    kk_box_t _x_x851 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_phexdouble_10174_fun852(frac, man, _ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x851, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift_phexdouble_10172(frac, man, x_10194, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10175_fun855__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10175_fun855(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10175_fun855(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_phexdouble_10175_fun855, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10175_fun858__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10175_fun858(kk_function_t _fself, kk_box_t _b_x123, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10175_fun858(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_phexdouble_10175_fun858, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_phexdouble_10175_fun858(kk_function_t _fself, kk_box_t _b_x123, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x859;
  kk_char_t _x_x860 = kk_char_unbox(_b_x123, KK_OWNED, _ctx); /*char*/
  _x_x859 = kk_std_num_float64__mlift_phexdouble_10173(_x_x860, _ctx); /*string*/
  return kk_string_box(_x_x859);
}
static kk_box_t kk_std_num_float64__mlift_phexdouble_10175_fun855(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_char_t x_0_10200 = kk_std_text_parse_char('.', _ctx); /*char*/;
  kk_string_t _x_x856;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x857 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_phexdouble_10175_fun858(_ctx), _ctx); /*2401*/
    _x_x856 = kk_string_unbox(_x_x857); /*string*/
  }
  else {
    _x_x856 = kk_std_text_parse_hex_digits(_ctx); /*string*/
  }
  return kk_string_box(_x_x856);
}


// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10175_fun861__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10175_fun861(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10175_fun861(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_phexdouble_10175_fun861, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_phexdouble_10175_fun861(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x862 = kk_string_empty(); /*string*/
  return kk_string_box(_x_x862);
}


// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10175_fun865__t {
  struct kk_function_s _base;
  kk_string_t man;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10175_fun865(kk_function_t _fself, kk_box_t _b_x130, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10175_fun865(kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_phexdouble_10175_fun865__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift_phexdouble_10175_fun865__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift_phexdouble_10175_fun865, kk_context());
  _self->man = man;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift_phexdouble_10175_fun865(kk_function_t _fself, kk_box_t _b_x130, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_phexdouble_10175_fun865__t* _self = kk_function_as(struct kk_std_num_float64__mlift_phexdouble_10175_fun865__t*, _fself, _ctx);
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(man, _ctx);}, {}, _ctx)
  kk_string_t _y_x10133_132 = kk_string_unbox(_b_x130); /*string*/;
  double _x_x866 = kk_std_num_float64__mlift_phexdouble_10174(man, _y_x10133_132, _ctx); /*float64*/
  return kk_double_box(_x_x866, _ctx);
}

double kk_std_num_float64__mlift_phexdouble_10175(kk_string_t man, kk_context_t* _ctx) { /* (man : string) -> std/text/parse/parse float64 */ 
  kk_string_t x_10198;
  kk_box_t _x_x854 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64__new_mlift_phexdouble_10175_fun855(_ctx), kk_std_num_float64__new_mlift_phexdouble_10175_fun861(_ctx), _ctx); /*1503*/
  x_10198 = kk_string_unbox(_x_x854); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_10198, _ctx);
    kk_box_t _x_x864 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_phexdouble_10175_fun865(man, _ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x864, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift_phexdouble_10174(man, x_10198, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10176_fun868__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10176_fun868(kk_function_t _fself, kk_box_t _b_x134, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10176_fun868(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_phexdouble_10176_fun868, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_phexdouble_10176_fun868(kk_function_t _fself, kk_box_t _b_x134, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x869;
  kk_string_t _x_x870 = kk_string_unbox(_b_x134); /*string*/
  _x_x869 = kk_std_num_float64__mlift_phexdouble_10175(_x_x870, _ctx); /*float64*/
  return kk_double_box(_x_x869, _ctx);
}

double kk_std_num_float64__mlift_phexdouble_10176(kk_char_t wild___0, kk_context_t* _ctx) { /* (wild_@0 : char) -> std/text/parse/parse float64 */ 
  kk_string_t x_10202 = kk_std_text_parse_hex_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_10202, _ctx);
    kk_box_t _x_x867 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_phexdouble_10176_fun868(_ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x867, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift_phexdouble_10175(x_10202, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift_phexdouble_10177_fun874__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_phexdouble_10177_fun874(kk_function_t _fself, kk_box_t _b_x137, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_phexdouble_10177_fun874(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_phexdouble_10177_fun874, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_phexdouble_10177_fun874(kk_function_t _fself, kk_box_t _b_x137, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x875;
  kk_char_t _x_x876 = kk_char_unbox(_b_x137, KK_OWNED, _ctx); /*char*/
  _x_x875 = kk_std_num_float64__mlift_phexdouble_10176(_x_x876, _ctx); /*float64*/
  return kk_double_box(_x_x875, _ctx);
}

double kk_std_num_float64__mlift_phexdouble_10177(kk_char_t wild__, kk_context_t* _ctx) { /* (wild_ : char) -> std/text/parse/parse float64 */ 
  kk_char_t x_10204;
  kk_string_t _x_x871;
  kk_define_string_literal(, _s_x872, 2, "xX", _ctx)
  _x_x871 = kk_string_dup(_s_x872, _ctx); /*string*/
  x_10204 = kk_std_text_parse_one_of(_x_x871, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x873 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_phexdouble_10177_fun874(_ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x873, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift_phexdouble_10176(x_10204, _ctx);
  }
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun878__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun878(kk_function_t _fself, kk_box_t _b_x140, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun878(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun878, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun878(kk_function_t _fself, kk_box_t _b_x140, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x879;
  kk_char_t _x_x880 = kk_char_unbox(_b_x140, KK_OWNED, _ctx); /*char*/
  _x_x879 = kk_std_num_float64__mlift_phexdouble_10177(_x_x880, _ctx); /*float64*/
  return kk_double_box(_x_x879, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun884__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun884(kk_function_t _fself, kk_box_t _b_x142, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun884(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun884, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun884(kk_function_t _fself, kk_box_t _b_x142, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x885;
  kk_char_t _x_x886 = kk_char_unbox(_b_x142, KK_OWNED, _ctx); /*char*/
  _x_x885 = kk_std_num_float64__mlift_phexdouble_10176(_x_x886, _ctx); /*float64*/
  return kk_double_box(_x_x885, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun888__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun888(kk_function_t _fself, kk_box_t _b_x144, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun888(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun888, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun888(kk_function_t _fself, kk_box_t _b_x144, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x889;
  kk_string_t _x_x890 = kk_string_unbox(_b_x144); /*string*/
  _x_x889 = kk_std_num_float64__mlift_phexdouble_10175(_x_x890, _ctx); /*float64*/
  return kk_double_box(_x_x889, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun892__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun892(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun892(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun892, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_phexdouble_fun895__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun895(kk_function_t _fself, kk_box_t _b_x146, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun895(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun895, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun895(kk_function_t _fself, kk_box_t _b_x146, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x896;
  kk_char_t _x_x897 = kk_char_unbox(_b_x146, KK_OWNED, _ctx); /*char*/
  _x_x896 = kk_std_num_float64__mlift_phexdouble_10173(_x_x897, _ctx); /*string*/
  return kk_string_box(_x_x896);
}
static kk_box_t kk_std_num_float64_phexdouble_fun892(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_char_t x_3_10218 = kk_std_text_parse_char('.', _ctx); /*char*/;
  kk_string_t _x_x893;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x894 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun895(_ctx), _ctx); /*2401*/
    _x_x893 = kk_string_unbox(_x_x894); /*string*/
  }
  else {
    _x_x893 = kk_std_text_parse_hex_digits(_ctx); /*string*/
  }
  return kk_string_box(_x_x893);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun898__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun898(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun898(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun898, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun898(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x899 = kk_string_empty(); /*string*/
  return kk_string_box(_x_x899);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun902__t {
  struct kk_function_s _base;
  kk_string_t x_1_10212;
};
static kk_box_t kk_std_num_float64_phexdouble_fun902(kk_function_t _fself, kk_box_t _b_x153, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun902(kk_string_t x_1_10212, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun902__t* _self = kk_function_alloc_as(struct kk_std_num_float64_phexdouble_fun902__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_phexdouble_fun902, kk_context());
  _self->x_1_10212 = x_1_10212;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun902(kk_function_t _fself, kk_box_t _b_x153, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun902__t* _self = kk_function_as(struct kk_std_num_float64_phexdouble_fun902__t*, _fself, _ctx);
  kk_string_t x_1_10212 = _self->x_1_10212; /* string */
  kk_drop_match(_self, {kk_string_dup(x_1_10212, _ctx);}, {}, _ctx)
  kk_string_t _y_x10133_200 = kk_string_unbox(_b_x153); /*string*/;
  double _x_x903 = kk_std_num_float64__mlift_phexdouble_10174(x_1_10212, _y_x10133_200, _ctx); /*float64*/
  return kk_double_box(_x_x903, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun907__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun907(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun907(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun907, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_phexdouble_fun912__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun912(kk_function_t _fself, kk_box_t _b_x155, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun912(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun912, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun912(kk_function_t _fself, kk_box_t _b_x155, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_integer_t _x_x913;
  kk_char_t _x_x914 = kk_char_unbox(_b_x155, KK_OWNED, _ctx); /*char*/
  _x_x913 = kk_std_num_float64__mlift_phexdouble_10171(_x_x914, _ctx); /*int*/
  return kk_integer_box(_x_x913, _ctx);
}
static kk_box_t kk_std_num_float64_phexdouble_fun907(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_char_t x_5_10223;
  kk_string_t _x_x908;
  kk_define_string_literal(, _s_x909, 2, "pP", _ctx)
  _x_x908 = kk_string_dup(_s_x909, _ctx); /*string*/
  x_5_10223 = kk_std_text_parse_one_of(_x_x908, _ctx); /*char*/
  kk_integer_t _x_x910;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x911 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun912(_ctx), _ctx); /*2401*/
    _x_x910 = kk_integer_unbox(_x_x911, _ctx); /*int*/
  }
  else {
    _x_x910 = kk_std_text_parse_pint(_ctx); /*int*/
  }
  return kk_integer_box(_x_x910, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun915__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun915(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun915(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun915, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun915(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_integer_box(kk_integer_from_small(0), _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun917__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t x_1_10212;
};
static kk_box_t kk_std_num_float64_phexdouble_fun917(kk_function_t _fself, kk_box_t _b_x162, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun917(kk_string_t frac, kk_string_t x_1_10212, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun917__t* _self = kk_function_alloc_as(struct kk_std_num_float64_phexdouble_fun917__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_phexdouble_fun917, kk_context());
  _self->frac = frac;
  _self->x_1_10212 = x_1_10212;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun917(kk_function_t _fself, kk_box_t _b_x162, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun917__t* _self = kk_function_as(struct kk_std_num_float64_phexdouble_fun917__t*, _fself, _ctx);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t x_1_10212 = _self->x_1_10212; /* string */
  kk_drop_match(_self, {kk_string_dup(frac, _ctx);kk_string_dup(x_1_10212, _ctx);}, {}, _ctx)
  kk_integer_t exp_201 = kk_integer_unbox(_b_x162, _ctx); /*int*/;
  double _x_x918 = kk_std_num_float64__mlift_phexdouble_10172(frac, x_1_10212, exp_201, _ctx); /*float64*/
  return kk_double_box(_x_x918, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun921__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun921(kk_function_t _fself, kk_box_t _b_x168, kk_box_t _b_x169, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun921(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun921, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun921(kk_function_t _fself, kk_box_t _b_x168, kk_box_t _b_x169, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__maybe _x_x922;
  kk_string_t _x_x923 = kk_string_unbox(_b_x168); /*string*/
  bool _x_x924;
  kk_std_core_types__optional _match_x546 = kk_std_core_types__optional_unbox(_b_x169, KK_OWNED, _ctx); /*? bool*/;
  if (kk_std_core_types__is_Optional(_match_x546, _ctx)) {
    kk_box_t _box_x163 = _match_x546._cons._Optional.value;
    bool _uniq_hex_533 = kk_bool_unbox(_box_x163);
    kk_std_core_types__optional_drop(_match_x546, _ctx);
    _x_x924 = _uniq_hex_533; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x546, _ctx);
    _x_x924 = false; /*bool*/
  }
  _x_x922 = kk_std_core_int_xparse(_x_x923, _x_x924, _ctx); /*maybe<int>*/
  return kk_std_core_types__maybe_box(_x_x922, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun928__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun928(kk_function_t _fself, kk_box_t _b_x180, kk_box_t _b_x181, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun928(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun928, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun928(kk_function_t _fself, kk_box_t _b_x180, kk_box_t _b_x181, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_integer_t _x_x929;
  kk_std_core_types__maybe _match_x545 = kk_std_core_types__maybe_unbox(_b_x180, KK_OWNED, _ctx); /*maybe<int>*/;
  if (kk_std_core_types__is_Nothing(_match_x545, _ctx)) {
    _x_x929 = kk_integer_unbox(_b_x181, _ctx); /*int*/
  }
  else {
    kk_box_t _box_x176 = _match_x545._cons.Just.value;
    kk_integer_t x_6 = kk_integer_unbox(_box_x176, _ctx);
    kk_integer_dup(x_6, _ctx);
    kk_std_core_types__maybe_drop(_match_x545, _ctx);
    kk_box_drop(_b_x181, _ctx);
    _x_x929 = x_6; /*int*/
  }
  return kk_integer_box(_x_x929, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun932__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun932(kk_function_t _fself, kk_box_t _b_x190, kk_box_t _b_x191, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun932(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun932, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun932(kk_function_t _fself, kk_box_t _b_x190, kk_box_t _b_x191, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_integer_t man_0_202 = kk_integer_unbox(_b_x190, _ctx); /*int*/;
  kk_integer_t exp_0_0_203 = kk_integer_unbox(_b_x191, _ctx); /*int*/;
  double _x_x933;
  double _x_x934 = kk_integer_as_double(man_0_202,kk_context()); /*float64*/
  _x_x933 = kk_std_num_float64_ldexp(_x_x934, exp_0_0_203, _ctx); /*float64*/
  return kk_double_box(_x_x933, _ctx);
}

double kk_std_num_float64_phexdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  kk_char_t x_10206 = kk_std_text_parse_char('0', _ctx); /*char*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x877 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun878(_ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x877, KK_OWNED, _ctx);
  }
  {
    kk_char_t x_0_10209;
    kk_string_t _x_x881;
    kk_define_string_literal(, _s_x882, 2, "xX", _ctx)
    _x_x881 = kk_string_dup(_s_x882, _ctx); /*string*/
    x_0_10209 = kk_std_text_parse_one_of(_x_x881, _ctx); /*char*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x883 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun884(_ctx), _ctx); /*2401*/
      return kk_double_unbox(_x_x883, KK_OWNED, _ctx);
    }
    {
      kk_string_t x_1_10212 = kk_std_text_parse_hex_digits(_ctx); /*string*/;
      if (kk_yielding(kk_context())) {
        kk_string_drop(x_1_10212, _ctx);
        kk_box_t _x_x887 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun888(_ctx), _ctx); /*2401*/
        return kk_double_unbox(_x_x887, KK_OWNED, _ctx);
      }
      {
        kk_string_t x_2_10215;
        kk_box_t _x_x891 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64_new_phexdouble_fun892(_ctx), kk_std_num_float64_new_phexdouble_fun898(_ctx), _ctx); /*1503*/
        x_2_10215 = kk_string_unbox(_x_x891); /*string*/
        if (kk_yielding(kk_context())) {
          kk_string_drop(x_2_10215, _ctx);
          kk_box_t _x_x901 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun902(x_1_10212, _ctx), _ctx); /*2401*/
          return kk_double_unbox(_x_x901, KK_OWNED, _ctx);
        }
        {
          kk_string_t frac;
          kk_string_t _x_x904;
          kk_define_string_literal(, _s_x905, 1, "0", _ctx)
          _x_x904 = kk_string_dup(_s_x905, _ctx); /*string*/
          frac = kk_std_core_sslice_trim_right(x_2_10215, _x_x904, _ctx); /*string*/
          kk_integer_t x_4_10220;
          kk_box_t _x_x906 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64_new_phexdouble_fun907(_ctx), kk_std_num_float64_new_phexdouble_fun915(_ctx), _ctx); /*1503*/
          x_4_10220 = kk_integer_unbox(_x_x906, _ctx); /*int*/
          if (kk_yielding(kk_context())) {
            kk_integer_drop(x_4_10220, _ctx);
            kk_box_t _x_x916 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun917(frac, x_1_10212, _ctx), _ctx); /*2401*/
            return kk_double_unbox(_x_x916, KK_OWNED, _ctx);
          }
          {
            kk_string_t _x_x1_0_10166;
            kk_string_t _x_x919 = kk_string_dup(frac, _ctx); /*string*/
            _x_x1_0_10166 = kk_std_core_types__lp__plus__plus__rp_(x_1_10212, _x_x919, _ctx); /*string*/
            kk_std_core_types__maybe _x_x1_10164;
            kk_box_t _x_x920;
            kk_box_t _x_x925;
            kk_std_core_types__optional _x_x926 = kk_std_core_types__new_Optional(kk_bool_box(true), _ctx); /*? 7*/
            _x_x925 = kk_std_core_types__optional_box(_x_x926, _ctx); /*9662*/
            _x_x920 = kk_std_core_hnd__open_none2(kk_std_num_float64_new_phexdouble_fun921(_ctx), kk_string_box(_x_x1_0_10166), _x_x925, _ctx); /*9663*/
            _x_x1_10164 = kk_std_core_types__maybe_unbox(_x_x920, KK_OWNED, _ctx); /*maybe<int>*/
            kk_integer_t m_0;
            kk_box_t _x_x927 = kk_std_core_hnd__open_none2(kk_std_num_float64_new_phexdouble_fun928(_ctx), kk_std_core_types__maybe_box(_x_x1_10164, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx); /*9663*/
            m_0 = kk_integer_unbox(_x_x927, _ctx); /*int*/
            kk_integer_t y_10161;
            kk_integer_t _x_x930 = kk_std_core_string_chars_fs_count(frac, _ctx); /*int*/
            y_10161 = kk_integer_mul((kk_integer_from_small(4)),_x_x930,kk_context()); /*int*/
            kk_integer_t e = kk_integer_sub(x_4_10220,y_10161,kk_context()); /*int*/;
            kk_box_t _x_x931 = kk_std_core_hnd__open_none2(kk_std_num_float64_new_phexdouble_fun932(_ctx), kk_integer_box(m_0, _ctx), kk_integer_box(e, _ctx), _ctx); /*9663*/
            return kk_double_unbox(_x_x931, KK_OWNED, _ctx);
          }
        }
      }
    }
  }
}
 
// Return `nan` on failure

double kk_std_num_float64_prim_parse_float64(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> float64 */ 
  return kk_prim_parse_double(s,kk_context());
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10179_fun936__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10179_fun936(kk_function_t _fself, kk_box_t _b_x206, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10179_fun936(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdecdouble_10179_fun936, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdecdouble_10179_fun936(kk_function_t _fself, kk_box_t _b_x206, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x937;
  kk_string_t _x_x938 = kk_string_unbox(_b_x206); /*string*/
  _x_x937 = kk_std_num_float64_prim_parse_float64(_x_x938, _ctx); /*float64*/
  return kk_double_box(_x_x937, _ctx);
}

double kk_std_num_float64__mlift_pdecdouble_10179(kk_std_core_sslice__sslice cur, kk_integer_t exp, kk_context_t* _ctx) { /* (cur : sslice/sslice, exp : int) -> std/text/parse/parse float64 */ 
  kk_integer_drop(exp, _ctx);
  kk_string_t _x_x1_10170 = kk_std_core_sslice_string(cur, _ctx); /*string*/;
  kk_box_t _x_x935 = kk_std_core_hnd__open_none1(kk_std_num_float64__new_mlift_pdecdouble_10179_fun936(_ctx), kk_string_box(_x_x1_10170), _ctx); /*9586*/
  return kk_double_unbox(_x_x935, KK_OWNED, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10181_fun942__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10181_fun942(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10181_fun942(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdecdouble_10181_fun942, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10181_fun947__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10181_fun947(kk_function_t _fself, kk_box_t _b_x210, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10181_fun947(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdecdouble_10181_fun947, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdecdouble_10181_fun947(kk_function_t _fself, kk_box_t _b_x210, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_integer_t _x_x948;
  kk_char_t _x_x949 = kk_char_unbox(_b_x210, KK_OWNED, _ctx); /*char*/
  _x_x948 = kk_std_num_float64__mlift_pdecdouble_10178(_x_x949, _ctx); /*int*/
  return kk_integer_box(_x_x948, _ctx);
}
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10181_fun942(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_char_t x_0_10227;
  kk_string_t _x_x943;
  kk_define_string_literal(, _s_x944, 2, "eE", _ctx)
  _x_x943 = kk_string_dup(_s_x944, _ctx); /*string*/
  x_0_10227 = kk_std_text_parse_one_of(_x_x943, _ctx); /*char*/
  kk_integer_t _x_x945;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x946 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_pdecdouble_10181_fun947(_ctx), _ctx); /*2401*/
    _x_x945 = kk_integer_unbox(_x_x946, _ctx); /*int*/
  }
  else {
    _x_x945 = kk_std_text_parse_pint(_ctx); /*int*/
  }
  return kk_integer_box(_x_x945, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10181_fun950__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10181_fun950(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10181_fun950(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdecdouble_10181_fun950, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdecdouble_10181_fun950(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_integer_box(kk_integer_from_small(0), _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10181_fun951__t {
  struct kk_function_s _base;
  kk_std_core_sslice__sslice cur;
};
static double kk_std_num_float64__mlift_pdecdouble_10181_fun951(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10181_fun951(kk_std_core_sslice__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_pdecdouble_10181_fun951__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift_pdecdouble_10181_fun951__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift_pdecdouble_10181_fun951, kk_context());
  _self->cur = cur;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10181_fun953__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10181_fun953(kk_function_t _fself, kk_box_t _b_x218, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10181_fun953(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdecdouble_10181_fun953, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdecdouble_10181_fun953(kk_function_t _fself, kk_box_t _b_x218, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x954;
  kk_string_t _x_x955 = kk_string_unbox(_b_x218); /*string*/
  _x_x954 = kk_std_num_float64_prim_parse_float64(_x_x955, _ctx); /*float64*/
  return kk_double_box(_x_x954, _ctx);
}
static double kk_std_num_float64__mlift_pdecdouble_10181_fun951(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_pdecdouble_10181_fun951__t* _self = kk_function_as(struct kk_std_num_float64__mlift_pdecdouble_10181_fun951__t*, _fself, _ctx);
  kk_std_core_sslice__sslice cur = _self->cur; /* sslice/sslice */
  kk_drop_match(_self, {kk_std_core_sslice__sslice_dup(cur, _ctx);}, {}, _ctx)
  kk_integer_drop(exp, _ctx);
  kk_string_t _x_x1_10170 = kk_std_core_sslice_string(cur, _ctx); /*string*/;
  kk_box_t _x_x952 = kk_std_core_hnd__open_none1(kk_std_num_float64__new_mlift_pdecdouble_10181_fun953(_ctx), kk_string_box(_x_x1_10170), _ctx); /*9586*/
  return kk_double_unbox(_x_x952, KK_OWNED, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10181_fun957__t {
  struct kk_function_s _base;
  kk_function_t next_10226;
};
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10181_fun957(kk_function_t _fself, kk_box_t _b_x222, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10181_fun957(kk_function_t next_10226, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_pdecdouble_10181_fun957__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift_pdecdouble_10181_fun957__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift_pdecdouble_10181_fun957, kk_context());
  _self->next_10226 = next_10226;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdecdouble_10181_fun957(kk_function_t _fself, kk_box_t _b_x222, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_pdecdouble_10181_fun957__t* _self = kk_function_as(struct kk_std_num_float64__mlift_pdecdouble_10181_fun957__t*, _fself, _ctx);
  kk_function_t next_10226 = _self->next_10226; /* (int) -> std/text/parse/parse float64 */
  kk_drop_match(_self, {kk_function_dup(next_10226, _ctx);}, {}, _ctx)
  double _x_x958;
  kk_integer_t _x_x959 = kk_integer_unbox(_b_x222, _ctx); /*int*/
  _x_x958 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), next_10226, (next_10226, _x_x959, _ctx), _ctx); /*float64*/
  return kk_double_box(_x_x958, _ctx);
}

double kk_std_num_float64__mlift_pdecdouble_10181(kk_std_core_sslice__sslice cur, kk_string_t _y_x10141, kk_context_t* _ctx) { /* (cur : sslice/sslice, string) -> std/text/parse/parse float64 */ 
  kk_string_t frac;
  kk_string_t _x_x939;
  kk_define_string_literal(, _s_x940, 1, "0", _ctx)
  _x_x939 = kk_string_dup(_s_x940, _ctx); /*string*/
  frac = kk_std_core_sslice_trim_right(_y_x10141, _x_x939, _ctx); /*string*/
  kk_string_drop(frac, _ctx);
  kk_integer_t x_10225;
  kk_box_t _x_x941 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64__new_mlift_pdecdouble_10181_fun942(_ctx), kk_std_num_float64__new_mlift_pdecdouble_10181_fun950(_ctx), _ctx); /*1503*/
  x_10225 = kk_integer_unbox(_x_x941, _ctx); /*int*/
  kk_function_t next_10226 = kk_std_num_float64__new_mlift_pdecdouble_10181_fun951(cur, _ctx); /*(int) -> std/text/parse/parse float64*/;
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_10225, _ctx);
    kk_box_t _x_x956 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_pdecdouble_10181_fun957(next_10226, _ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x956, KK_OWNED, _ctx);
  }
  {
    return kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), next_10226, (next_10226, x_10225, _ctx), _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10182_fun961__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10182_fun961(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10182_fun961(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdecdouble_10182_fun961, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10182_fun964__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10182_fun964(kk_function_t _fself, kk_box_t _b_x225, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10182_fun964(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdecdouble_10182_fun964, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdecdouble_10182_fun964(kk_function_t _fself, kk_box_t _b_x225, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x965;
  kk_char_t _x_x966 = kk_char_unbox(_b_x225, KK_OWNED, _ctx); /*char*/
  _x_x965 = kk_std_num_float64__mlift_pdecdouble_10180(_x_x966, _ctx); /*string*/
  return kk_string_box(_x_x965);
}
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10182_fun961(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_char_t x_0_10233 = kk_std_text_parse_char('.', _ctx); /*char*/;
  kk_string_t _x_x962;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x963 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_pdecdouble_10182_fun964(_ctx), _ctx); /*2401*/
    _x_x962 = kk_string_unbox(_x_x963); /*string*/
  }
  else {
    _x_x962 = kk_std_text_parse_digits0(_ctx); /*string*/
  }
  return kk_string_box(_x_x962);
}


// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10182_fun967__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10182_fun967(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10182_fun967(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdecdouble_10182_fun967, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdecdouble_10182_fun967(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x968 = kk_string_empty(); /*string*/
  return kk_string_box(_x_x968);
}


// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10182_fun971__t {
  struct kk_function_s _base;
  kk_std_core_sslice__sslice cur;
};
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10182_fun971(kk_function_t _fself, kk_box_t _b_x232, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10182_fun971(kk_std_core_sslice__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_pdecdouble_10182_fun971__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift_pdecdouble_10182_fun971__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift_pdecdouble_10182_fun971, kk_context());
  _self->cur = cur;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdecdouble_10182_fun971(kk_function_t _fself, kk_box_t _b_x232, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_pdecdouble_10182_fun971__t* _self = kk_function_as(struct kk_std_num_float64__mlift_pdecdouble_10182_fun971__t*, _fself, _ctx);
  kk_std_core_sslice__sslice cur = _self->cur; /* sslice/sslice */
  kk_drop_match(_self, {kk_std_core_sslice__sslice_dup(cur, _ctx);}, {}, _ctx)
  kk_string_t _y_x10141_234 = kk_string_unbox(_b_x232); /*string*/;
  double _x_x972 = kk_std_num_float64__mlift_pdecdouble_10181(cur, _y_x10141_234, _ctx); /*float64*/
  return kk_double_box(_x_x972, _ctx);
}

double kk_std_num_float64__mlift_pdecdouble_10182(kk_std_core_sslice__sslice cur, kk_string_t man, kk_context_t* _ctx) { /* (cur : sslice/sslice, man : string) -> std/text/parse/parse float64 */ 
  kk_string_drop(man, _ctx);
  kk_string_t x_10231;
  kk_box_t _x_x960 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64__new_mlift_pdecdouble_10182_fun961(_ctx), kk_std_num_float64__new_mlift_pdecdouble_10182_fun967(_ctx), _ctx); /*1503*/
  x_10231 = kk_string_unbox(_x_x960); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_10231, _ctx);
    kk_box_t _x_x970 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_pdecdouble_10182_fun971(cur, _ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x970, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift_pdecdouble_10181(cur, x_10231, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift_pdecdouble_10183_fun974__t {
  struct kk_function_s _base;
  kk_std_core_sslice__sslice cur;
};
static kk_box_t kk_std_num_float64__mlift_pdecdouble_10183_fun974(kk_function_t _fself, kk_box_t _b_x236, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdecdouble_10183_fun974(kk_std_core_sslice__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_pdecdouble_10183_fun974__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift_pdecdouble_10183_fun974__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift_pdecdouble_10183_fun974, kk_context());
  _self->cur = cur;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdecdouble_10183_fun974(kk_function_t _fself, kk_box_t _b_x236, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_pdecdouble_10183_fun974__t* _self = kk_function_as(struct kk_std_num_float64__mlift_pdecdouble_10183_fun974__t*, _fself, _ctx);
  kk_std_core_sslice__sslice cur = _self->cur; /* sslice/sslice */
  kk_drop_match(_self, {kk_std_core_sslice__sslice_dup(cur, _ctx);}, {}, _ctx)
  kk_string_t man_238 = kk_string_unbox(_b_x236); /*string*/;
  double _x_x975 = kk_std_num_float64__mlift_pdecdouble_10182(cur, man_238, _ctx); /*float64*/
  return kk_double_box(_x_x975, _ctx);
}

double kk_std_num_float64__mlift_pdecdouble_10183(kk_std_core_sslice__sslice cur, kk_context_t* _ctx) { /* (cur : sslice/sslice) -> std/text/parse/parse float64 */ 
  kk_string_t x_10235 = kk_std_text_parse_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_10235, _ctx);
    kk_box_t _x_x973 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_pdecdouble_10183_fun974(cur, _ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x973, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift_pdecdouble_10182(cur, x_10235, _ctx);
  }
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun979__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun979(kk_function_t _fself, kk_box_t _b_x246, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun979(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun979, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun979(kk_function_t _fself, kk_box_t _b_x246, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x980;
  kk_std_core_sslice__sslice _x_x981 = kk_std_core_sslice__sslice_unbox(_b_x246, KK_OWNED, _ctx); /*sslice/sslice*/
  _x_x980 = kk_std_num_float64__mlift_pdecdouble_10183(_x_x981, _ctx); /*float64*/
  return kk_double_box(_x_x980, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun983__t {
  struct kk_function_s _base;
  kk_std_core_sslice__sslice x_10237;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun983(kk_function_t _fself, kk_box_t _b_x248, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun983(kk_std_core_sslice__sslice x_10237, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun983__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdecdouble_fun983__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdecdouble_fun983, kk_context());
  _self->x_10237 = x_10237;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun983(kk_function_t _fself, kk_box_t _b_x248, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun983__t* _self = kk_function_as(struct kk_std_num_float64_pdecdouble_fun983__t*, _fself, _ctx);
  kk_std_core_sslice__sslice x_10237 = _self->x_10237; /* sslice/sslice */
  kk_drop_match(_self, {kk_std_core_sslice__sslice_dup(x_10237, _ctx);}, {}, _ctx)
  kk_string_t man_281 = kk_string_unbox(_b_x248); /*string*/;
  double _x_x984 = kk_std_num_float64__mlift_pdecdouble_10182(x_10237, man_281, _ctx); /*float64*/
  return kk_double_box(_x_x984, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun986__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun986(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun986(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun986, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun989__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun989(kk_function_t _fself, kk_box_t _b_x250, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun989(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun989, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun989(kk_function_t _fself, kk_box_t _b_x250, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x990;
  kk_char_t _x_x991 = kk_char_unbox(_b_x250, KK_OWNED, _ctx); /*char*/
  _x_x990 = kk_std_num_float64__mlift_pdecdouble_10180(_x_x991, _ctx); /*string*/
  return kk_string_box(_x_x990);
}
static kk_box_t kk_std_num_float64_pdecdouble_fun986(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_char_t x_2_10248 = kk_std_text_parse_char('.', _ctx); /*char*/;
  kk_string_t _x_x987;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x988 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun989(_ctx), _ctx); /*2401*/
    _x_x987 = kk_string_unbox(_x_x988); /*string*/
  }
  else {
    _x_x987 = kk_std_text_parse_digits0(_ctx); /*string*/
  }
  return kk_string_box(_x_x987);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun992__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun992(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun992(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun992, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun992(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x993 = kk_string_empty(); /*string*/
  return kk_string_box(_x_x993);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun996__t {
  struct kk_function_s _base;
  kk_std_core_sslice__sslice x_10237;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun996(kk_function_t _fself, kk_box_t _b_x257, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun996(kk_std_core_sslice__sslice x_10237, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun996__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdecdouble_fun996__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdecdouble_fun996, kk_context());
  _self->x_10237 = x_10237;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun996(kk_function_t _fself, kk_box_t _b_x257, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun996__t* _self = kk_function_as(struct kk_std_num_float64_pdecdouble_fun996__t*, _fself, _ctx);
  kk_std_core_sslice__sslice x_10237 = _self->x_10237; /* sslice/sslice */
  kk_drop_match(_self, {kk_std_core_sslice__sslice_dup(x_10237, _ctx);}, {}, _ctx)
  kk_string_t _y_x10141_282 = kk_string_unbox(_b_x257); /*string*/;
  double _x_x997 = kk_std_num_float64__mlift_pdecdouble_10181(x_10237, _y_x10141_282, _ctx); /*float64*/
  return kk_double_box(_x_x997, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun1001__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun1001(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun1001(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun1001, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun1006__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun1006(kk_function_t _fself, kk_box_t _b_x259, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun1006(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun1006, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun1006(kk_function_t _fself, kk_box_t _b_x259, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_integer_t _x_x1007;
  kk_char_t _x_x1008 = kk_char_unbox(_b_x259, KK_OWNED, _ctx); /*char*/
  _x_x1007 = kk_std_num_float64__mlift_pdecdouble_10178(_x_x1008, _ctx); /*int*/
  return kk_integer_box(_x_x1007, _ctx);
}
static kk_box_t kk_std_num_float64_pdecdouble_fun1001(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_char_t x_4_10253;
  kk_string_t _x_x1002;
  kk_define_string_literal(, _s_x1003, 2, "eE", _ctx)
  _x_x1002 = kk_string_dup(_s_x1003, _ctx); /*string*/
  x_4_10253 = kk_std_text_parse_one_of(_x_x1002, _ctx); /*char*/
  kk_integer_t _x_x1004;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1005 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun1006(_ctx), _ctx); /*2401*/
    _x_x1004 = kk_integer_unbox(_x_x1005, _ctx); /*int*/
  }
  else {
    _x_x1004 = kk_std_text_parse_pint(_ctx); /*int*/
  }
  return kk_integer_box(_x_x1004, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun1009__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun1009(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun1009(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun1009, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun1009(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_integer_box(kk_integer_from_small(0), _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun1011__t {
  struct kk_function_s _base;
  kk_std_core_sslice__sslice x_10237;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun1011(kk_function_t _fself, kk_box_t _b_x269, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun1011(kk_std_core_sslice__sslice x_10237, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun1011__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdecdouble_fun1011__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdecdouble_fun1011, kk_context());
  _self->x_10237 = x_10237;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun1012__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun1012(kk_function_t _fself, kk_box_t _b_x267, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun1012(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun1012, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun1012(kk_function_t _fself, kk_box_t _b_x267, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1013;
  kk_string_t _x_x1014 = kk_string_unbox(_b_x267); /*string*/
  _x_x1013 = kk_std_num_float64_prim_parse_float64(_x_x1014, _ctx); /*float64*/
  return kk_double_box(_x_x1013, _ctx);
}
static kk_box_t kk_std_num_float64_pdecdouble_fun1011(kk_function_t _fself, kk_box_t _b_x269, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun1011__t* _self = kk_function_as(struct kk_std_num_float64_pdecdouble_fun1011__t*, _fself, _ctx);
  kk_std_core_sslice__sslice x_10237 = _self->x_10237; /* sslice/sslice */
  kk_drop_match(_self, {kk_std_core_sslice__sslice_dup(x_10237, _ctx);}, {}, _ctx)
  kk_integer_t exp_283 = kk_integer_unbox(_b_x269, _ctx); /*int*/;
  kk_integer_drop(exp_283, _ctx);
  kk_string_t _x_x1_10170 = kk_std_core_sslice_string(x_10237, _ctx); /*string*/;
  return kk_std_core_hnd__open_none1(kk_std_num_float64_new_pdecdouble_fun1012(_ctx), kk_string_box(_x_x1_10170), _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun1016__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun1016(kk_function_t _fself, kk_box_t _b_x272, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun1016(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun1016, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun1016(kk_function_t _fself, kk_box_t _b_x272, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1017;
  kk_string_t _x_x1018 = kk_string_unbox(_b_x272); /*string*/
  _x_x1017 = kk_std_num_float64_prim_parse_float64(_x_x1018, _ctx); /*float64*/
  return kk_double_box(_x_x1017, _ctx);
}

double kk_std_num_float64_pdecdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  kk_std_core_hnd__ev ev_10240 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<std/text/parse/parse>*/;
  kk_std_core_sslice__sslice x_10237;
  kk_box_t _x_x976;
  {
    struct kk_std_core_hnd_Ev* _con_x977 = kk_std_core_hnd__as_Ev(ev_10240, _ctx);
    kk_box_t _box_x239 = _con_x977->hnd;
    int32_t m = _con_x977->marker;
    kk_std_text_parse__parse h = kk_std_text_parse__parse_unbox(_box_x239, KK_BORROWED, _ctx);
    kk_std_text_parse__parse_dup(h, _ctx);
    kk_std_core_hnd__clause0 _match_x533;
    kk_std_core_hnd__clause0 _brw_x534 = kk_std_text_parse_current_input_fs__select(h, _ctx); /*hnd/clause0<sslice/sslice,std/text/parse/parse,821,822>*/;
    kk_datatype_ptr_dropn(h, (KK_I32(5)), _ctx);
    _match_x533 = _brw_x534; /*hnd/clause0<sslice/sslice,std/text/parse/parse,821,822>*/
    {
      kk_function_t _fun_unbox_x242 = _match_x533.clause;
      _x_x976 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x242, (_fun_unbox_x242, m, ev_10240, _ctx), _ctx); /*35*/
    }
  }
  x_10237 = kk_std_core_sslice__sslice_unbox(_x_x976, KK_OWNED, _ctx); /*sslice/sslice*/
  if (kk_yielding(kk_context())) {
    kk_std_core_sslice__sslice_drop(x_10237, _ctx);
    kk_box_t _x_x978 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun979(_ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x978, KK_OWNED, _ctx);
  }
  {
    kk_string_t x_0_10242 = kk_std_text_parse_digits(_ctx); /*string*/;
    kk_string_drop(x_0_10242, _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x982 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun983(x_10237, _ctx), _ctx); /*2401*/
      return kk_double_unbox(_x_x982, KK_OWNED, _ctx);
    }
    {
      kk_string_t x_1_10245;
      kk_box_t _x_x985 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64_new_pdecdouble_fun986(_ctx), kk_std_num_float64_new_pdecdouble_fun992(_ctx), _ctx); /*1503*/
      x_1_10245 = kk_string_unbox(_x_x985); /*string*/
      if (kk_yielding(kk_context())) {
        kk_string_drop(x_1_10245, _ctx);
        kk_box_t _x_x995 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun996(x_10237, _ctx), _ctx); /*2401*/
        return kk_double_unbox(_x_x995, KK_OWNED, _ctx);
      }
      {
        kk_string_t frac;
        kk_string_t _x_x998;
        kk_define_string_literal(, _s_x999, 1, "0", _ctx)
        _x_x998 = kk_string_dup(_s_x999, _ctx); /*string*/
        frac = kk_std_core_sslice_trim_right(x_1_10245, _x_x998, _ctx); /*string*/
        kk_string_drop(frac, _ctx);
        kk_integer_t x_3_10250;
        kk_box_t _x_x1000 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64_new_pdecdouble_fun1001(_ctx), kk_std_num_float64_new_pdecdouble_fun1009(_ctx), _ctx); /*1503*/
        x_3_10250 = kk_integer_unbox(_x_x1000, _ctx); /*int*/
        kk_integer_drop(x_3_10250, _ctx);
        if (kk_yielding(kk_context())) {
          kk_box_t _x_x1010 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun1011(x_10237, _ctx), _ctx); /*2401*/
          return kk_double_unbox(_x_x1010, KK_OWNED, _ctx);
        }
        {
          kk_string_t _x_x1_10170_0 = kk_std_core_sslice_string(x_10237, _ctx); /*string*/;
          kk_box_t _x_x1015 = kk_std_core_hnd__open_none1(kk_std_num_float64_new_pdecdouble_fun1016(_ctx), kk_string_box(_x_x1_10170_0), _ctx); /*9586*/
          return kk_double_unbox(_x_x1015, KK_OWNED, _ctx);
        }
      }
    }
  }
}


// lift anonymous function
struct kk_std_num_float64_pspecial_fun1021__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun1021(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun1021(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun1021, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pspecial_fun1026__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun1026(kk_function_t _fself, kk_box_t _b_x285, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun1026(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun1026, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pspecial_fun1026(kk_function_t _fself, kk_box_t _b_x285, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1027;
  kk_string_t _x_x1028 = kk_string_unbox(_b_x285); /*string*/
  _x_x1027 = kk_std_num_float64__mlift_pspecial_10184(_x_x1028, _ctx); /*float64*/
  return kk_double_box(_x_x1027, _ctx);
}
static kk_box_t kk_std_num_float64_pspecial_fun1021(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t x_10257;
  kk_string_t _x_x1022;
  kk_define_string_literal(, _s_x1023, 3, "nan", _ctx)
  _x_x1022 = kk_string_dup(_s_x1023, _ctx); /*string*/
  x_10257 = kk_std_text_parse_pstring(_x_x1022, _ctx); /*string*/
  kk_string_drop(x_10257, _ctx);
  double _x_x1024;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1025 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pspecial_fun1026(_ctx), _ctx); /*2401*/
    _x_x1024 = kk_double_unbox(_x_x1025, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x_x1024 = kk_std_num_float64_nan; /*float64*/
  }
  return kk_double_box(_x_x1024, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pspecial_fun1030__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun1030(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun1030(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun1030, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pspecial_fun1035__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun1035(kk_function_t _fself, kk_box_t _b_x287, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun1035(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun1035, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pspecial_fun1035(kk_function_t _fself, kk_box_t _b_x287, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1036;
  kk_string_t _x_x1037 = kk_string_unbox(_b_x287); /*string*/
  _x_x1036 = kk_std_num_float64__mlift_pspecial_10185(_x_x1037, _ctx); /*float64*/
  return kk_double_box(_x_x1036, _ctx);
}
static kk_box_t kk_std_num_float64_pspecial_fun1030(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t x_0_10259;
  kk_string_t _x_x1031;
  kk_define_string_literal(, _s_x1032, 8, "infinity", _ctx)
  _x_x1031 = kk_string_dup(_s_x1032, _ctx); /*string*/
  x_0_10259 = kk_std_text_parse_pstring(_x_x1031, _ctx); /*string*/
  kk_string_drop(x_0_10259, _ctx);
  double _x_x1033;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1034 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pspecial_fun1035(_ctx), _ctx); /*2401*/
    _x_x1033 = kk_double_unbox(_x_x1034, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x_x1033 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x_x1033, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pspecial_fun1039__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun1039(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun1039(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun1039, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pspecial_fun1044__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun1044(kk_function_t _fself, kk_box_t _b_x289, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun1044(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun1044, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pspecial_fun1044(kk_function_t _fself, kk_box_t _b_x289, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1045;
  kk_string_t _x_x1046 = kk_string_unbox(_b_x289); /*string*/
  _x_x1045 = kk_std_num_float64__mlift_pspecial_10186(_x_x1046, _ctx); /*float64*/
  return kk_double_box(_x_x1045, _ctx);
}
static kk_box_t kk_std_num_float64_pspecial_fun1039(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t x_1_10261;
  kk_string_t _x_x1040;
  kk_define_string_literal(, _s_x1041, 3, "inf", _ctx)
  _x_x1040 = kk_string_dup(_s_x1041, _ctx); /*string*/
  x_1_10261 = kk_std_text_parse_pstring(_x_x1040, _ctx); /*string*/
  kk_string_drop(x_1_10261, _ctx);
  double _x_x1042;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1043 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pspecial_fun1044(_ctx), _ctx); /*2401*/
    _x_x1042 = kk_double_unbox(_x_x1043, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x_x1042 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x_x1042, _ctx);
}

double kk_std_num_float64_pspecial(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  kk_box_t _x_x1019;
  kk_std_core_types__list _x_x1020;
  kk_std_core_types__list _x_x1029;
  kk_std_core_types__list _x_x1038 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pspecial_fun1039(_ctx), _ctx), kk_std_core_types__new_Nil(_ctx), _ctx); /*list<82>*/
  _x_x1029 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pspecial_fun1030(_ctx), _ctx), _x_x1038, _ctx); /*list<82>*/
  _x_x1020 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pspecial_fun1021(_ctx), _ctx), _x_x1029, _ctx); /*list<82>*/
  _x_x1019 = kk_std_text_parse_choose(_x_x1020, _ctx); /*1594*/
  return kk_double_unbox(_x_x1019, KK_OWNED, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift_pdouble_10191_fun1049__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1049(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdouble_10191_fun1049(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdouble_10191_fun1049, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1049(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1050 = kk_std_num_float64_phexdouble(_ctx); /*float64*/
  return kk_double_box(_x_x1050, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_pdouble_10191_fun1052__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1052(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdouble_10191_fun1052(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdouble_10191_fun1052, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1052(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1053 = kk_std_num_float64_pdecdouble(_ctx); /*float64*/
  return kk_double_box(_x_x1053, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_pdouble_10191_fun1055__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1055(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdouble_10191_fun1055(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdouble_10191_fun1055, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift_pdouble_10191_fun1057__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1057(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdouble_10191_fun1057(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdouble_10191_fun1057, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift_pdouble_10191_fun1062__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1062(kk_function_t _fself, kk_box_t _b_x311, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdouble_10191_fun1062(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdouble_10191_fun1062, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1062(kk_function_t _fself, kk_box_t _b_x311, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1063;
  kk_string_t _x_x1064 = kk_string_unbox(_b_x311); /*string*/
  _x_x1063 = kk_std_num_float64__mlift_pdouble_10187(_x_x1064, _ctx); /*float64*/
  return kk_double_box(_x_x1063, _ctx);
}
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1057(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t x_0_10265;
  kk_string_t _x_x1058;
  kk_define_string_literal(, _s_x1059, 3, "nan", _ctx)
  _x_x1058 = kk_string_dup(_s_x1059, _ctx); /*string*/
  x_0_10265 = kk_std_text_parse_pstring(_x_x1058, _ctx); /*string*/
  kk_string_drop(x_0_10265, _ctx);
  double _x_x1060;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1061 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_pdouble_10191_fun1062(_ctx), _ctx); /*2401*/
    _x_x1060 = kk_double_unbox(_x_x1061, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x_x1060 = kk_std_num_float64_nan; /*float64*/
  }
  return kk_double_box(_x_x1060, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_pdouble_10191_fun1066__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1066(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdouble_10191_fun1066(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdouble_10191_fun1066, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift_pdouble_10191_fun1071__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1071(kk_function_t _fself, kk_box_t _b_x313, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdouble_10191_fun1071(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdouble_10191_fun1071, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1071(kk_function_t _fself, kk_box_t _b_x313, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1072;
  kk_string_t _x_x1073 = kk_string_unbox(_b_x313); /*string*/
  _x_x1072 = kk_std_num_float64__mlift_pdouble_10188(_x_x1073, _ctx); /*float64*/
  return kk_double_box(_x_x1072, _ctx);
}
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1066(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t x_1_10267;
  kk_string_t _x_x1067;
  kk_define_string_literal(, _s_x1068, 8, "infinity", _ctx)
  _x_x1067 = kk_string_dup(_s_x1068, _ctx); /*string*/
  x_1_10267 = kk_std_text_parse_pstring(_x_x1067, _ctx); /*string*/
  kk_string_drop(x_1_10267, _ctx);
  double _x_x1069;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1070 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_pdouble_10191_fun1071(_ctx), _ctx); /*2401*/
    _x_x1069 = kk_double_unbox(_x_x1070, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x_x1069 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x_x1069, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_pdouble_10191_fun1075__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1075(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdouble_10191_fun1075(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdouble_10191_fun1075, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift_pdouble_10191_fun1080__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1080(kk_function_t _fself, kk_box_t _b_x315, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdouble_10191_fun1080(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdouble_10191_fun1080, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1080(kk_function_t _fself, kk_box_t _b_x315, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1081;
  kk_string_t _x_x1082 = kk_string_unbox(_b_x315); /*string*/
  _x_x1081 = kk_std_num_float64__mlift_pdouble_10189(_x_x1082, _ctx); /*float64*/
  return kk_double_box(_x_x1081, _ctx);
}
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1075(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t x_2_10269;
  kk_string_t _x_x1076;
  kk_define_string_literal(, _s_x1077, 3, "inf", _ctx)
  _x_x1076 = kk_string_dup(_s_x1077, _ctx); /*string*/
  x_2_10269 = kk_std_text_parse_pstring(_x_x1076, _ctx); /*string*/
  kk_string_drop(x_2_10269, _ctx);
  double _x_x1078;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1079 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_pdouble_10191_fun1080(_ctx), _ctx); /*2401*/
    _x_x1078 = kk_double_unbox(_x_x1079, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x_x1078 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x_x1078, _ctx);
}
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1055(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _x_x1056;
  kk_std_core_types__list _x_x1065;
  kk_std_core_types__list _x_x1074 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift_pdouble_10191_fun1075(_ctx), _ctx), kk_std_core_types__new_Nil(_ctx), _ctx); /*list<82>*/
  _x_x1065 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift_pdouble_10191_fun1066(_ctx), _ctx), _x_x1074, _ctx); /*list<82>*/
  _x_x1056 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift_pdouble_10191_fun1057(_ctx), _ctx), _x_x1065, _ctx); /*list<82>*/
  return kk_std_text_parse_choose(_x_x1056, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_pdouble_10191_fun1084__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1084(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdouble_10191_fun1084(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift_pdouble_10191_fun1084, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1084(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_double_box(0x0p+0, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift_pdouble_10191_fun1086__t {
  struct kk_function_s _base;
  bool neg;
};
static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1086(kk_function_t _fself, kk_box_t _b_x359, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_pdouble_10191_fun1086(bool neg, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_pdouble_10191_fun1086__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift_pdouble_10191_fun1086__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift_pdouble_10191_fun1086, kk_context());
  _self->neg = neg;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift_pdouble_10191_fun1086(kk_function_t _fself, kk_box_t _b_x359, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_pdouble_10191_fun1086__t* _self = kk_function_as(struct kk_std_num_float64__mlift_pdouble_10191_fun1086__t*, _fself, _ctx);
  bool neg = _self->neg; /* bool */
  kk_drop_match(_self, {kk_skip_dup(neg, _ctx);}, {}, _ctx)
  double _x_x1087;
  double d_361 = kk_double_unbox(_b_x359, KK_OWNED, _ctx); /*float64*/;
  if (neg) {
    _x_x1087 = (-d_361); /*float64*/
  }
  else {
    _x_x1087 = d_361; /*float64*/
  }
  return kk_double_box(_x_x1087, _ctx);
}

double kk_std_num_float64__mlift_pdouble_10191(bool neg, kk_context_t* _ctx) { /* (neg : bool) -> std/text/parse/parse float64 */ 
  double x_10263;
  kk_box_t _x_x1047;
  kk_std_core_types__list _x_x1048;
  kk_std_core_types__list _x_x1051;
  kk_std_core_types__list _x_x1054;
  kk_std_core_types__list _x_x1083 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift_pdouble_10191_fun1084(_ctx), _ctx), kk_std_core_types__new_Nil(_ctx), _ctx); /*list<82>*/
  _x_x1054 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift_pdouble_10191_fun1055(_ctx), _ctx), _x_x1083, _ctx); /*list<82>*/
  _x_x1051 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift_pdouble_10191_fun1052(_ctx), _ctx), _x_x1054, _ctx); /*list<82>*/
  _x_x1048 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift_pdouble_10191_fun1049(_ctx), _ctx), _x_x1051, _ctx); /*list<82>*/
  _x_x1047 = kk_std_text_parse_choose(_x_x1048, _ctx); /*1594*/
  x_10263 = kk_double_unbox(_x_x1047, KK_OWNED, _ctx); /*float64*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1085 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_pdouble_10191_fun1086(neg, _ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x1085, KK_OWNED, _ctx);
  }
  {
    double d_362 = x_10263; /*float64*/;
    if (neg) {
      return (-d_362);
    }
    {
      return d_362;
    }
  }
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun1089__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun1089(kk_function_t _fself, kk_box_t _b_x364, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1089(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun1089, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun1089(kk_function_t _fself, kk_box_t _b_x364, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1090;
  bool _x_x1091 = kk_bool_unbox(_b_x364); /*bool*/
  _x_x1090 = kk_std_num_float64__mlift_pdouble_10191(_x_x1091, _ctx); /*float64*/
  return kk_double_box(_x_x1090, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun1094__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun1094(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1094(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun1094, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun1094(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1095 = kk_std_num_float64_phexdouble(_ctx); /*float64*/
  return kk_double_box(_x_x1095, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun1097__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun1097(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1097(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun1097, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun1097(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1098 = kk_std_num_float64_pdecdouble(_ctx); /*float64*/
  return kk_double_box(_x_x1098, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun1100__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun1100(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1100(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun1100, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun1102__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun1102(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1102(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun1102, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun1107__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun1107(kk_function_t _fself, kk_box_t _b_x366, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1107(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun1107, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun1107(kk_function_t _fself, kk_box_t _b_x366, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1108;
  kk_string_t _x_x1109 = kk_string_unbox(_b_x366); /*string*/
  _x_x1108 = kk_std_num_float64__mlift_pdouble_10187(_x_x1109, _ctx); /*float64*/
  return kk_double_box(_x_x1108, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun1102(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t x_1_10279;
  kk_string_t _x_x1103;
  kk_define_string_literal(, _s_x1104, 3, "nan", _ctx)
  _x_x1103 = kk_string_dup(_s_x1104, _ctx); /*string*/
  x_1_10279 = kk_std_text_parse_pstring(_x_x1103, _ctx); /*string*/
  kk_string_drop(x_1_10279, _ctx);
  double _x_x1105;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1106 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun1107(_ctx), _ctx); /*2401*/
    _x_x1105 = kk_double_unbox(_x_x1106, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x_x1105 = kk_std_num_float64_nan; /*float64*/
  }
  return kk_double_box(_x_x1105, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun1111__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun1111(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1111(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun1111, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun1116__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun1116(kk_function_t _fself, kk_box_t _b_x368, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1116(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun1116, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun1116(kk_function_t _fself, kk_box_t _b_x368, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1117;
  kk_string_t _x_x1118 = kk_string_unbox(_b_x368); /*string*/
  _x_x1117 = kk_std_num_float64__mlift_pdouble_10188(_x_x1118, _ctx); /*float64*/
  return kk_double_box(_x_x1117, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun1111(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t x_2_10281;
  kk_string_t _x_x1112;
  kk_define_string_literal(, _s_x1113, 8, "infinity", _ctx)
  _x_x1112 = kk_string_dup(_s_x1113, _ctx); /*string*/
  x_2_10281 = kk_std_text_parse_pstring(_x_x1112, _ctx); /*string*/
  kk_string_drop(x_2_10281, _ctx);
  double _x_x1114;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1115 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun1116(_ctx), _ctx); /*2401*/
    _x_x1114 = kk_double_unbox(_x_x1115, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x_x1114 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x_x1114, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun1120__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun1120(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1120(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun1120, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun1125__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun1125(kk_function_t _fself, kk_box_t _b_x370, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1125(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun1125, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun1125(kk_function_t _fself, kk_box_t _b_x370, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1126;
  kk_string_t _x_x1127 = kk_string_unbox(_b_x370); /*string*/
  _x_x1126 = kk_std_num_float64__mlift_pdouble_10189(_x_x1127, _ctx); /*float64*/
  return kk_double_box(_x_x1126, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun1120(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t x_3_10283;
  kk_string_t _x_x1121;
  kk_define_string_literal(, _s_x1122, 3, "inf", _ctx)
  _x_x1121 = kk_string_dup(_s_x1122, _ctx); /*string*/
  x_3_10283 = kk_std_text_parse_pstring(_x_x1121, _ctx); /*string*/
  kk_string_drop(x_3_10283, _ctx);
  double _x_x1123;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1124 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun1125(_ctx), _ctx); /*2401*/
    _x_x1123 = kk_double_unbox(_x_x1124, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x_x1123 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x_x1123, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun1100(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_std_core_types__list _x_x1101;
  kk_std_core_types__list _x_x1110;
  kk_std_core_types__list _x_x1119 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun1120(_ctx), _ctx), kk_std_core_types__new_Nil(_ctx), _ctx); /*list<82>*/
  _x_x1110 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun1111(_ctx), _ctx), _x_x1119, _ctx); /*list<82>*/
  _x_x1101 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun1102(_ctx), _ctx), _x_x1110, _ctx); /*list<82>*/
  return kk_std_text_parse_choose(_x_x1101, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun1129__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun1129(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1129(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun1129, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun1129(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  return kk_double_box(0x0p+0, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun1131__t {
  struct kk_function_s _base;
  bool x_10273;
};
static kk_box_t kk_std_num_float64_pdouble_fun1131(kk_function_t _fself, kk_box_t _b_x414, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun1131(bool x_10273, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdouble_fun1131__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdouble_fun1131__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdouble_fun1131, kk_context());
  _self->x_10273 = x_10273;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun1131(kk_function_t _fself, kk_box_t _b_x414, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdouble_fun1131__t* _self = kk_function_as(struct kk_std_num_float64_pdouble_fun1131__t*, _fself, _ctx);
  bool x_10273 = _self->x_10273; /* bool */
  kk_drop_match(_self, {kk_skip_dup(x_10273, _ctx);}, {}, _ctx)
  double d_417 = kk_double_unbox(_b_x414, KK_OWNED, _ctx); /*float64*/;
  double _x_x1132;
  if (x_10273) {
    _x_x1132 = (-d_417); /*float64*/
  }
  else {
    _x_x1132 = d_417; /*float64*/
  }
  return kk_double_box(_x_x1132, _ctx);
}

double kk_std_num_float64_pdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  bool x_10273 = kk_std_text_parse_sign(_ctx); /*bool*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1088 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun1089(_ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x1088, KK_OWNED, _ctx);
  }
  {
    double x_0_10276;
    kk_box_t _x_x1092;
    kk_std_core_types__list _x_x1093;
    kk_std_core_types__list _x_x1096;
    kk_std_core_types__list _x_x1099;
    kk_std_core_types__list _x_x1128 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun1129(_ctx), _ctx), kk_std_core_types__new_Nil(_ctx), _ctx); /*list<82>*/
    _x_x1099 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun1100(_ctx), _ctx), _x_x1128, _ctx); /*list<82>*/
    _x_x1096 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun1097(_ctx), _ctx), _x_x1099, _ctx); /*list<82>*/
    _x_x1093 = kk_std_core_types__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun1094(_ctx), _ctx), _x_x1096, _ctx); /*list<82>*/
    _x_x1092 = kk_std_text_parse_choose(_x_x1093, _ctx); /*1594*/
    x_0_10276 = kk_double_unbox(_x_x1092, KK_OWNED, _ctx); /*float64*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1130 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun1131(x_10273, _ctx), _ctx); /*2401*/
      return kk_double_unbox(_x_x1130, KK_OWNED, _ctx);
    }
    if (x_10273) {
      return (-x_0_10276);
    }
    {
      return x_0_10276;
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift_parse_float64_10193_fun1134__t {
  struct kk_function_s _base;
  double x;
};
static kk_box_t kk_std_num_float64__mlift_parse_float64_10193_fun1134(kk_function_t _fself, kk_box_t _b_x419, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift_parse_float64_10193_fun1134(double x, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_parse_float64_10193_fun1134__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift_parse_float64_10193_fun1134__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift_parse_float64_10193_fun1134, kk_context());
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift_parse_float64_10193_fun1134(kk_function_t _fself, kk_box_t _b_x419, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift_parse_float64_10193_fun1134__t* _self = kk_function_as(struct kk_std_num_float64__mlift_parse_float64_10193_fun1134__t*, _fself, _ctx);
  double x = _self->x; /* float64 */
  kk_drop_match(_self, {kk_skip_dup(x, _ctx);}, {}, _ctx)
  kk_unit_t wild___421 = kk_Unit;
  kk_unit_unbox(_b_x419);
  return kk_double_box(x, _ctx);
}

double kk_std_num_float64__mlift_parse_float64_10193(double x, kk_context_t* _ctx) { /* (x : float64) -> std/text/parse/parse float64 */ 
  kk_unit_t x_0_10287 = kk_Unit;
  kk_std_text_parse_eof(_ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1133 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift_parse_float64_10193_fun1134(x, _ctx), _ctx); /*2401*/
    return kk_double_unbox(_x_x1133, KK_OWNED, _ctx);
  }
  {
    return x;
  }
}
 
// Parse a float64 number. Can be "NaN", "Inf(inity)" (case-insensitive),
// a fix-point number (`1.2`) or in scientific notation (`-2.3e-5`).
// Also allows floats in [hexadecimal notation](https://books.google.com/books?id=FgMsCwAAQBAJ&pg=PA41) (`0xA.Fp-10`) that can
// be represented precisely (and are the preferred _round trip_ format).


// lift anonymous function
struct kk_std_num_float64_parse_float64_fun1139__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_parse_float64_fun1139(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_parse_float64_fun1139(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_parse_float64_fun1139, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_parse_float64_fun1142__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_parse_float64_fun1142(kk_function_t _fself, kk_box_t _b_x423, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_parse_float64_fun1142(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_parse_float64_fun1142, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_parse_float64_fun1142(kk_function_t _fself, kk_box_t _b_x423, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double _x_x1143;
  double _x_x1144 = kk_double_unbox(_b_x423, KK_OWNED, _ctx); /*float64*/
  _x_x1143 = kk_std_num_float64__mlift_parse_float64_10193(_x_x1144, _ctx); /*float64*/
  return kk_double_box(_x_x1143, _ctx);
}
static kk_box_t kk_std_num_float64_parse_float64_fun1139(kk_function_t _fself, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double x_10291 = kk_std_num_float64_pdouble(_ctx); /*float64*/;
  double _x_x1140;
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1141 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_parse_float64_fun1142(_ctx), _ctx); /*2401*/
    _x_x1140 = kk_double_unbox(_x_x1141, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x_x1140 = kk_std_num_float64__mlift_parse_float64_10193(x_10291, _ctx); /*float64*/
  }
  return kk_double_box(_x_x1140, _ctx);
}

kk_std_core_types__maybe kk_std_num_float64_parse_float64(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> maybe<float64> */ 
  kk_string_t s_0_10108;
  kk_string_t _x_x1135;
  kk_string_t _x_x1136 = kk_string_trim_left(s,kk_context()); /*string*/
  _x_x1135 = kk_string_trim_right(_x_x1136,kk_context()); /*string*/
  s_0_10108 = kk_std_core_string_to_lower(_x_x1135, _ctx); /*string*/
  kk_std_core_sslice__sslice input_10106;
  kk_string_t _x_x1137 = kk_string_dup(s_0_10108, _ctx); /*string*/
  kk_integer_t _x_x1138 = kk_string_len_int(s_0_10108,kk_context()); /*int*/
  input_10106 = kk_std_core_sslice__new_Sslice(_x_x1137, kk_integer_from_small(0), _x_x1138, _ctx); /*sslice/sslice*/
  kk_std_text_parse__parse_error perr_10105 = kk_std_text_parse_parse(input_10106, kk_std_num_float64_new_parse_float64_fun1139(_ctx), _ctx); /*std/text/parse/parse-error<float64>*/;
  if (kk_std_text_parse__is_ParseOk(perr_10105, _ctx)) {
    struct kk_std_text_parse_ParseOk* _con_x1145 = kk_std_text_parse__as_ParseOk(perr_10105, _ctx);
    kk_box_t _box_x429 = _con_x1145->result;
    kk_std_core_sslice__sslice _pat_0_0 = _con_x1145->rest;
    double x_0 = kk_double_unbox(_box_x429, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(perr_10105, _ctx)) {
      kk_std_core_sslice__sslice_drop(_pat_0_0, _ctx);
      kk_box_drop(_box_x429, _ctx);
      kk_datatype_ptr_free(perr_10105, _ctx);
    }
    else {
      kk_datatype_ptr_decref(perr_10105, _ctx);
    }
    return kk_std_core_types__new_Just(kk_double_box(x_0, _ctx), _ctx);
  }
  {
    struct kk_std_text_parse_ParseError* _con_x1146 = kk_std_text_parse__as_ParseError(perr_10105, _ctx);
    kk_std_core_sslice__sslice _pat_5 = _con_x1146->rest;
    kk_string_t msg = _con_x1146->msg;
    if kk_likely(kk_datatype_ptr_is_unique(perr_10105, _ctx)) {
      kk_string_drop(msg, _ctx);
      kk_std_core_sslice__sslice_drop(_pat_5, _ctx);
      kk_datatype_ptr_free(perr_10105, _ctx);
    }
    else {
      kk_datatype_ptr_decref(perr_10105, _ctx);
    }
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Return the sum of a list of floats.
// Uses [Kahan-Babu&scaron;kan-Neumaier summation](https://en.wikipedia.org/wiki/Kahan_summation_algorithm#Further_enhancements)
// to minimize rounding errors. This
// is more precise as Kahan summation and about as fast.
// `[1.0e3,1.0e97,1.0e3,-1.0e97].sum == 2000.0`
// while
// `[1.0e3,1.0e97,1.0e3,-1.0e97].foldl(0.0,(+)) == 0.0` (!)
// A. Neumaier, _Rundungsfehleranalyse einiger Verfahren zur Summation endlicher Summen_.
// Math. Mechanik, 54:39--51, 1974.


// lift anonymous function
struct kk_std_num_float64_sum_fun1148__t {
  struct kk_function_s _base;
  kk_ref_t loc;
  kk_ref_t loc_0;
};
static kk_unit_t kk_std_num_float64_sum_fun1148(kk_function_t _fself, kk_box_t _b_x454, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_sum_fun1148(kk_ref_t loc, kk_ref_t loc_0, kk_context_t* _ctx) {
  struct kk_std_num_float64_sum_fun1148__t* _self = kk_function_alloc_as(struct kk_std_num_float64_sum_fun1148__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_sum_fun1148, kk_context());
  _self->loc = loc;
  _self->loc_0 = loc_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_unit_t kk_std_num_float64_sum_fun1148(kk_function_t _fself, kk_box_t _b_x454, kk_context_t* _ctx) {
  struct kk_std_num_float64_sum_fun1148__t* _self = kk_function_as(struct kk_std_num_float64_sum_fun1148__t*, _fself, _ctx);
  kk_ref_t loc = _self->loc; /* local-var<3410,float64> */
  kk_ref_t loc_0 = _self->loc_0; /* local-var<3410,float64> */
  kk_drop_match(_self, {kk_ref_dup(loc, _ctx);kk_ref_dup(loc_0, _ctx);}, {}, _ctx)
  double x_459 = kk_double_unbox(_b_x454, KK_OWNED, _ctx); /*float64*/;
  double t;
  double _x_x1149;
  kk_box_t _x_x1150;
  kk_ref_t _x_x1151 = kk_ref_dup(loc, _ctx); /*local-var<3410,float64>*/
  _x_x1150 = kk_ref_get(_x_x1151,kk_context()); /*302*/
  _x_x1149 = kk_double_unbox(_x_x1150, KK_OWNED, _ctx); /*float64*/
  t = (_x_x1149 + x_459); /*float64*/
  double c;
  bool _match_x512;
  double _x_x1152;
  double _x_x1153;
  kk_box_t _x_x1154;
  kk_ref_t _x_x1155 = kk_ref_dup(loc, _ctx); /*local-var<3410,float64>*/
  _x_x1154 = kk_ref_get(_x_x1155,kk_context()); /*302*/
  _x_x1153 = kk_double_unbox(_x_x1154, KK_OWNED, _ctx); /*float64*/
  _x_x1152 = kk_double_abs(_x_x1153); /*float64*/
  double _x_x1156 = kk_double_abs(x_459); /*float64*/
  _match_x512 = (_x_x1152 >= _x_x1156); /*bool*/
  if (_match_x512) {
    double _x_x1157;
    double _x_x1158;
    kk_box_t _x_x1159;
    kk_ref_t _x_x1160 = kk_ref_dup(loc, _ctx); /*local-var<3410,float64>*/
    _x_x1159 = kk_ref_get(_x_x1160,kk_context()); /*302*/
    _x_x1158 = kk_double_unbox(_x_x1159, KK_OWNED, _ctx); /*float64*/
    _x_x1157 = (_x_x1158 - t); /*float64*/
    c = (_x_x1157 + x_459); /*float64*/
  }
  else {
    double _x_x1161 = (x_459 - t); /*float64*/
    double _x_x1162;
    kk_box_t _x_x1163;
    kk_ref_t _x_x1164 = kk_ref_dup(loc, _ctx); /*local-var<3410,float64>*/
    _x_x1163 = kk_ref_get(_x_x1164,kk_context()); /*302*/
    _x_x1162 = kk_double_unbox(_x_x1163, KK_OWNED, _ctx); /*float64*/
    c = (_x_x1161 + _x_x1162); /*float64*/
  }
  double _b_x446_448;
  double _x_x1165;
  kk_box_t _x_x1166;
  kk_ref_t _x_x1167 = kk_ref_dup(loc_0, _ctx); /*local-var<3410,float64>*/
  _x_x1166 = kk_ref_get(_x_x1167,kk_context()); /*302*/
  _x_x1165 = kk_double_unbox(_x_x1166, KK_OWNED, _ctx); /*float64*/
  _b_x446_448 = (_x_x1165 + c); /*float64*/
  kk_unit_t __ = kk_Unit;
  kk_unit_t _brw_x511 = kk_Unit;
  kk_ref_set_borrow(loc_0,(kk_double_box(_b_x446_448, _ctx)),kk_context());
  kk_ref_drop(loc_0, _ctx);
  _brw_x511;
  kk_unit_t _brw_x510 = kk_Unit;
  kk_ref_set_borrow(loc,(kk_double_box(t, _ctx)),kk_context());
  kk_ref_drop(loc, _ctx);
  _brw_x510; return kk_Unit;
}

double kk_std_num_float64_sum(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  kk_ref_t loc = kk_ref_alloc((kk_double_box(0x0p+0, _ctx)),kk_context()); /*local-var<3410,float64>*/;
  kk_ref_t loc_0 = kk_ref_alloc((kk_double_box(0x0p+0, _ctx)),kk_context()); /*local-var<3410,float64>*/;
  kk_unit_t ___0 = kk_Unit;
  kk_function_t _x_x1147;
  kk_ref_dup(loc, _ctx);
  kk_ref_dup(loc_0, _ctx);
  _x_x1147 = kk_std_num_float64_new_sum_fun1148(loc, loc_0, _ctx); /*(2872) -> 2873 ()*/
  kk_std_core_list_foreach(xs, _x_x1147, _ctx);
  double res_0;
  double _x_x1168;
  kk_box_t _x_x1169;
  kk_ref_t _x_x1170 = kk_ref_dup(loc, _ctx); /*local-var<3410,float64>*/
  _x_x1169 = kk_ref_get(_x_x1170,kk_context()); /*302*/
  _x_x1168 = kk_double_unbox(_x_x1169, KK_OWNED, _ctx); /*float64*/
  double _x_x1171;
  kk_box_t _x_x1172;
  kk_ref_t _x_x1173 = kk_ref_dup(loc_0, _ctx); /*local-var<3410,float64>*/
  _x_x1172 = kk_ref_get(_x_x1173,kk_context()); /*302*/
  _x_x1171 = kk_double_unbox(_x_x1172, KK_OWNED, _ctx); /*float64*/
  res_0 = (_x_x1168 + _x_x1171); /*float64*/
  double res;
  kk_box_t _x_x1174 = kk_std_core_hnd_prompt_local_var(loc_0, kk_double_box(res_0, _ctx), _ctx); /*4063*/
  res = kk_double_unbox(_x_x1174, KK_OWNED, _ctx); /*float64*/
  kk_box_t _x_x1175 = kk_std_core_hnd_prompt_local_var(loc, kk_double_box(res, _ctx), _ctx); /*4063*/
  return kk_double_unbox(_x_x1175, KK_OWNED, _ctx);
}
 
// The hypotenuse of `x` and `y`: `sqrt(x*x + y*y)`.
// Prevents overflow for large numbers.

double kk_std_num_float64_hypot(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  double xx = kk_double_abs(x); /*float64*/;
  double yy = kk_double_abs(y); /*float64*/;
  double lo;
  bool _match_x509 = (xx <= yy); /*bool*/;
  if (_match_x509) {
    lo = xx; /*float64*/
  }
  else {
    lo = yy; /*float64*/
  }
  double hi;
  bool _match_x508 = (xx >= yy); /*bool*/;
  if (_match_x508) {
    hi = xx; /*float64*/
  }
  else {
    hi = yy; /*float64*/
  }
  bool _match_x507 = (hi == (0x0p+0)); /*bool*/;
  if (_match_x507) {
    return 0x0p+0;
  }
  {
    double z = (lo / hi); /*float64*/;
    double _x_x1176;
    double _x_x1177;
    double _x_x1178 = (z * z); /*float64*/
    _x_x1177 = (0x1p0 + _x_x1178); /*float64*/
    _x_x1176 = sqrt(_x_x1177); /*float64*/
    return (hi * _x_x1176);
  }
}
 
// The square root of the sum of the squares of three floats.
// Prevents overflow for large numbers.

double kk_std_num_float64_xyz_fs_hypot(double x, double y, double z, kk_context_t* _ctx) { /* (x : float64, y : float64, z : float64) -> float64 */ 
  double xx = kk_double_abs(x); /*float64*/;
  double yy = kk_double_abs(y); /*float64*/;
  double zz = kk_double_abs(z); /*float64*/;
  double x_0_10115;
  bool _match_x506 = (xx >= yy); /*bool*/;
  if (_match_x506) {
    x_0_10115 = xx; /*float64*/
  }
  else {
    x_0_10115 = yy; /*float64*/
  }
  double hi;
  bool _match_x505 = (x_0_10115 >= zz); /*bool*/;
  if (_match_x505) {
    hi = x_0_10115; /*float64*/
  }
  else {
    hi = zz; /*float64*/
  }
  bool _match_x504 = (hi == (0x0p+0)); /*bool*/;
  if (_match_x504) {
    return 0x0p+0;
  }
  {
    double x_4_10121 = (zz / hi); /*float64*/;
    double x_2_10119 = (xx / hi); /*float64*/;
    double x_3_10120 = (yy / hi); /*float64*/;
    double _x_x1179;
    double _x_x1180;
    double _x_x1181;
    double _x_x1182 = (x_2_10119 * x_2_10119); /*float64*/
    double _x_x1183 = (x_3_10120 * x_3_10120); /*float64*/
    _x_x1181 = (_x_x1182 + _x_x1183); /*float64*/
    double _x_x1184 = (x_4_10121 * x_4_10121); /*float64*/
    _x_x1180 = (_x_x1181 + _x_x1184); /*float64*/
    _x_x1179 = sqrt(_x_x1180); /*float64*/
    return (hi * _x_x1179);
  }
}
 
// The maximum of a list of absolute values.


// lift anonymous function
struct kk_std_num_float64_list_fs_abs_max_fun1186__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_list_fs_abs_max_fun1186(kk_function_t _fself, kk_box_t _b_x475, kk_box_t _b_x476, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_list_fs_new_abs_max_fun1186(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_list_fs_abs_max_fun1186, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_list_fs_abs_max_fun1186(kk_function_t _fself, kk_box_t _b_x475, kk_box_t _b_x476, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double m_480 = kk_double_unbox(_b_x475, KK_OWNED, _ctx); /*float64*/;
  double x_481 = kk_double_unbox(_b_x476, KK_OWNED, _ctx); /*float64*/;
  double x_0_10124 = kk_double_abs(x_481); /*float64*/;
  double _x_x1187;
  bool _match_x502 = (x_0_10124 >= m_480); /*bool*/;
  if (_match_x502) {
    _x_x1187 = x_0_10124; /*float64*/
  }
  else {
    _x_x1187 = m_480; /*float64*/
  }
  return kk_double_box(_x_x1187, _ctx);
}

double kk_std_num_float64_list_fs_abs_max(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  kk_box_t _x_x1185 = kk_std_core_list_foldl(xs, kk_double_box(0x0p+0, _ctx), kk_std_num_float64_list_fs_new_abs_max_fun1186(_ctx), _ctx); /*1139*/
  return kk_double_unbox(_x_x1185, KK_OWNED, _ctx);
}
 
// The square root of the sum of squares of a list of floats.
// Prevents overflow for large numbers and uses Kahan-Babu&scaron;kan-Neumaier summation
// for precision.


// lift anonymous function
struct kk_std_num_float64_list_fs_hypot_fun1190__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_list_fs_hypot_fun1190(kk_function_t _fself, kk_box_t _b_x485, kk_box_t _b_x486, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_list_fs_new_hypot_fun1190(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_list_fs_hypot_fun1190, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_list_fs_hypot_fun1190(kk_function_t _fself, kk_box_t _b_x485, kk_box_t _b_x486, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  double x_0_10124;
  double _x_x1191 = kk_double_unbox(_b_x486, KK_OWNED, _ctx); /*float64*/
  x_0_10124 = kk_double_abs(_x_x1191); /*float64*/
  double _x_x1192;
  bool _match_x501;
  double _x_x1193;
  kk_box_t _x_x1194 = kk_box_dup(_b_x485, _ctx); /*1139*/
  _x_x1193 = kk_double_unbox(_x_x1194, KK_OWNED, _ctx); /*float64*/
  _match_x501 = (x_0_10124 >= _x_x1193); /*bool*/
  if (_match_x501) {
    kk_box_drop(_b_x485, _ctx);
    _x_x1192 = x_0_10124; /*float64*/
  }
  else {
    _x_x1192 = kk_double_unbox(_b_x485, KK_OWNED, _ctx); /*float64*/
  }
  return kk_double_box(_x_x1192, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_list_fs_hypot_fun1196__t {
  struct kk_function_s _base;
  double hi;
};
static double kk_std_num_float64_list_fs_hypot_fun1196(kk_function_t _fself, double x_0, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_list_fs_new_hypot_fun1196(double hi, kk_context_t* _ctx) {
  struct kk_std_num_float64_list_fs_hypot_fun1196__t* _self = kk_function_alloc_as(struct kk_std_num_float64_list_fs_hypot_fun1196__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_list_fs_hypot_fun1196, kk_context());
  _self->hi = hi;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static double kk_std_num_float64_list_fs_hypot_fun1196(kk_function_t _fself, double x_0, kk_context_t* _ctx) {
  struct kk_std_num_float64_list_fs_hypot_fun1196__t* _self = kk_function_as(struct kk_std_num_float64_list_fs_hypot_fun1196__t*, _fself, _ctx);
  double hi = _self->hi; /* float64 */
  kk_drop_match(_self, {kk_skip_dup(hi, _ctx);}, {}, _ctx)
  double x_0_10126 = (x_0 / hi); /*float64*/;
  return (x_0_10126 * x_0_10126);
}


// lift anonymous function
struct kk_std_num_float64_list_fs_hypot_fun1199__t {
  struct kk_function_s _base;
  kk_function_t _b_x493_496;
};
static kk_box_t kk_std_num_float64_list_fs_hypot_fun1199(kk_function_t _fself, kk_box_t _b_x494, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_list_fs_new_hypot_fun1199(kk_function_t _b_x493_496, kk_context_t* _ctx) {
  struct kk_std_num_float64_list_fs_hypot_fun1199__t* _self = kk_function_alloc_as(struct kk_std_num_float64_list_fs_hypot_fun1199__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_list_fs_hypot_fun1199, kk_context());
  _self->_b_x493_496 = _b_x493_496;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_list_fs_hypot_fun1199(kk_function_t _fself, kk_box_t _b_x494, kk_context_t* _ctx) {
  struct kk_std_num_float64_list_fs_hypot_fun1199__t* _self = kk_function_as(struct kk_std_num_float64_list_fs_hypot_fun1199__t*, _fself, _ctx);
  kk_function_t _b_x493_496 = _self->_b_x493_496; /* (x@0 : float64) -> float64 */
  kk_drop_match(_self, {kk_function_dup(_b_x493_496, _ctx);}, {}, _ctx)
  double _x_x1200;
  double _x_x1201 = kk_double_unbox(_b_x494, KK_OWNED, _ctx); /*float64*/
  _x_x1200 = kk_function_call(double, (kk_function_t, double, kk_context_t*), _b_x493_496, (_b_x493_496, _x_x1201, _ctx), _ctx); /*float64*/
  return kk_double_box(_x_x1200, _ctx);
}

double kk_std_num_float64_list_fs_hypot(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  double hi;
  kk_box_t _x_x1188;
  kk_std_core_types__list _x_x1189 = kk_std_core_types__list_dup(xs, _ctx); /*list<float64>*/
  _x_x1188 = kk_std_core_list_foldl(_x_x1189, kk_double_box(0x0p+0, _ctx), kk_std_num_float64_list_fs_new_hypot_fun1190(_ctx), _ctx); /*1139*/
  hi = kk_double_unbox(_x_x1188, KK_OWNED, _ctx); /*float64*/
  bool _match_x498 = (hi == (0x0p+0)); /*bool*/;
  if (_match_x498) {
    kk_std_core_types__list_drop(xs, _ctx);
    return 0x0p+0;
  }
  {
    double _x_x1195;
    kk_std_core_types__list _b_x492_495 = xs; /*list<float64>*/;
    kk_function_t _b_x493_496 = kk_std_num_float64_list_fs_new_hypot_fun1196(hi, _ctx); /*(x@0 : float64) -> float64*/;
    double _x_x1197;
    kk_std_core_types__list _x_x1198;
    kk_function_t _brw_x499 = kk_std_num_float64_list_fs_new_hypot_fun1199(_b_x493_496, _ctx); /*(2105) -> 2107 2106*/;
    kk_std_core_types__list _brw_x500 = kk_std_core_list_map(_b_x492_495, _brw_x499, _ctx); /*list<2106>*/;
    kk_function_drop(_brw_x499, _ctx);
    _x_x1198 = _brw_x500; /*list<2106>*/
    _x_x1197 = kk_std_num_float64_sum(_x_x1198, _ctx); /*float64*/
    _x_x1195 = sqrt(_x_x1197); /*float64*/
    return (hi * _x_x1195);
  }
}

double kk_std_num_float64_rad2deg;

double kk_std_num_float64_deg2rad;
 
// The area hyperbolic tangent of `d`

double kk_std_num_float64_atanh(double d, kk_context_t* _ctx) { /* (d : float64) -> float64 */ 
  return atanh(d);
}
 
// The area hyperbolic cosine of `d`

double kk_std_num_float64_acosh(double d, kk_context_t* _ctx) { /* (d : float64) -> float64 */ 
  return acosh(d);
}
 
// The area hyperbolic sine of `d`

double kk_std_num_float64_asinh(double d, kk_context_t* _ctx) { /* (d : float64) -> float64 */ 
  return asinh(d);
}

// initialization
void kk_std_num_float64__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core_exn__init(_ctx);
  kk_std_core_bool__init(_ctx);
  kk_std_core_order__init(_ctx);
  kk_std_core_char__init(_ctx);
  kk_std_core_int__init(_ctx);
  kk_std_core_vector__init(_ctx);
  kk_std_core_string__init(_ctx);
  kk_std_core_sslice__init(_ctx);
  kk_std_core_list__init(_ctx);
  kk_std_core_maybe__init(_ctx);
  kk_std_core_maybe2__init(_ctx);
  kk_std_core_either__init(_ctx);
  kk_std_core_tuple__init(_ctx);
  kk_std_core_lazy__init(_ctx);
  kk_std_core_show__init(_ctx);
  kk_std_core_debug__init(_ctx);
  kk_std_core_delayed__init(_ctx);
  kk_std_core_console__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_text_parse__init(_ctx);
  kk_std_num_int32__init(_ctx);
  kk_std_num_int64__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_num_float64_flt_max_prec = kk_integer_from_small(15); /*int*/
  }
  {
    kk_std_num_float64_neginf = kk_std_num_float64_make_neginf(_ctx); /*float64*/
  }
  {
    kk_std_num_float64_posinf = kk_std_num_float64_make_posinf(_ctx); /*float64*/
  }
  {
    kk_std_num_float64_nan = kk_std_num_float64_make_nan(_ctx); /*float64*/
  }
  {
    kk_std_num_float64_rad2deg = ((0x1.68p7) / (0x1.921fb54442d18p1)); /*float64*/
  }
  {
    kk_std_num_float64_deg2rad = ((0x1.921fb54442d18p1) / (0x1.68p7)); /*float64*/
  }
}

// termination
void kk_std_num_float64__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_skip_drop(kk_std_num_float64_deg2rad, _ctx);
  kk_skip_drop(kk_std_num_float64_rad2deg, _ctx);
  kk_skip_drop(kk_std_num_float64_nan, _ctx);
  kk_skip_drop(kk_std_num_float64_posinf, _ctx);
  kk_skip_drop(kk_std_num_float64_neginf, _ctx);
  kk_integer_drop(kk_std_num_float64_flt_max_prec, _ctx);
  kk_std_num_int64__done(_ctx);
  kk_std_num_int32__done(_ctx);
  kk_std_text_parse__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_console__done(_ctx);
  kk_std_core_delayed__done(_ctx);
  kk_std_core_debug__done(_ctx);
  kk_std_core_show__done(_ctx);
  kk_std_core_lazy__done(_ctx);
  kk_std_core_tuple__done(_ctx);
  kk_std_core_either__done(_ctx);
  kk_std_core_maybe2__done(_ctx);
  kk_std_core_maybe__done(_ctx);
  kk_std_core_list__done(_ctx);
  kk_std_core_sslice__done(_ctx);
  kk_std_core_string__done(_ctx);
  kk_std_core_vector__done(_ctx);
  kk_std_core_int__done(_ctx);
  kk_std_core_char__done(_ctx);
  kk_std_core_order__done(_ctx);
  kk_std_core_bool__done(_ctx);
  kk_std_core_exn__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
