// Koka generated module: std/core/list, koka version: 3.1.3, platform: 64-bit
#include "std_core_list.h"
 
// Return the head of list if the list is not empty.

kk_std_core_types__maybe kk_std_core_list_maybe_fs_head(kk_std_core_types__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> maybe<a> */ 
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1378 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1378->head;
    kk_std_core_types__list _pat_0 = _con_x1378->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core_types__list_drop(_pat_0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return kk_std_core_types__new_Just(x, _ctx);
  }
  {
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Return the head of list with a default value in case the list is empty.

kk_box_t kk_std_core_list_default_fs_head(kk_std_core_types__list xs, kk_box_t kkloc_default, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, default : a) -> a */ 
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1379 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1379->head;
    kk_std_core_types__list _pat_0 = _con_x1379->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core_types__list_drop(_pat_0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_drop(kkloc_default, _ctx);
    return x;
  }
  {
    return kkloc_default;
  }
}
 
// Return the tail of list. Returns the empty list if `xs` is empty.

kk_std_core_types__list kk_std_core_list_tail(kk_std_core_types__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> list<a> */ 
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1380 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _pat_0 = _con_x1380->head;
    kk_std_core_types__list xx = _con_x1380->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_pat_0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return xx;
  }
  {
    return kk_std_core_types__new_Nil(_ctx);
  }
}
 
// lifted local: length, len

kk_integer_t kk_std_core_list__unroll_lift_length_5423_10000(kk_std_core_types__list ys, kk_integer_t acc, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, acc : int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1381 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t _pat_0 = _con_x1381->head;
    kk_std_core_types__list yy = _con_x1381->tail;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_box_drop(_pat_0, _ctx);
      kk_datatype_ptr_free(ys, _ctx);
    }
    else {
      kk_std_core_types__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    { // tailcall
      kk_integer_t _x_x1382 = kk_integer_add_small_const(acc, 1, _ctx); /*int*/
      ys = yy;
      acc = _x_x1382;
      goto kk__tailcall;
    }
  }
  {
    return acc;
  }
}
 
// Element-wise list equality

bool kk_std_core_list__lp__at_unroll_x_10001_eq__eq__rp_(kk_std_core_types__list xs, kk_std_core_types__list ys, kk_function_t _implicit_fs__lp__eq__eq__rp_, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>, ?(==) : (a, a) -> bool) -> bool */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1383 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1383->head;
    kk_std_core_types__list xx = _con_x1383->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Nil(ys, _ctx)) {
      kk_std_core_types__list_drop(xx, _ctx);
      kk_box_drop(x, _ctx);
      kk_function_drop(_implicit_fs__lp__eq__eq__rp_, _ctx);
      return false;
    }
    {
      struct kk_std_core_types_Cons* _con_x1384 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t y = _con_x1384->head;
      kk_std_core_types__list yy = _con_x1384->tail;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        kk_datatype_ptr_free(ys, _ctx);
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core_types__list_dup(yy, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      bool _match_x1289;
      kk_function_t _x_x1385 = kk_function_dup(_implicit_fs__lp__eq__eq__rp_, _ctx); /*(785, 785) -> bool*/
      _match_x1289 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x_x1385, (_x_x1385, x, y, _ctx), _ctx); /*bool*/
      if (_match_x1289) { // tailcall
                          xs = xx;
                          ys = yy;
                          goto kk__tailcall;
      }
      {
        kk_std_core_types__list_drop(yy, _ctx);
        kk_std_core_types__list_drop(xx, _ctx);
        kk_function_drop(_implicit_fs__lp__eq__eq__rp_, _ctx);
        return false;
      }
    }
  }
  {
    kk_function_drop(_implicit_fs__lp__eq__eq__rp_, _ctx);
    if (kk_std_core_types__is_Nil(ys, _ctx)) {
      return true;
    }
    {
      struct kk_std_core_types_Cons* _con_x1386 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t _pat_7 = _con_x1386->head;
      kk_std_core_types__list _pat_8 = _con_x1386->tail;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        kk_std_core_types__list_drop(_pat_8, _ctx);
        kk_box_drop(_pat_7, _ctx);
        kk_datatype_ptr_free(ys, _ctx);
      }
      else {
        kk_datatype_ptr_decref(ys, _ctx);
      }
      return false;
    }
  }
}
 
// Order on lists

kk_std_core_types__order kk_std_core_list__unroll_cmp_10002(kk_std_core_types__list xs, kk_std_core_types__list ys, kk_function_t _implicit_fs_cmp, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>, ?cmp : (a, a) -> order) -> order */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1388 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1388->head;
    kk_std_core_types__list xx = _con_x1388->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Nil(ys, _ctx)) {
      kk_std_core_types__list_drop(xx, _ctx);
      kk_box_drop(x, _ctx);
      kk_function_drop(_implicit_fs_cmp, _ctx);
      return kk_std_core_types__new_Gt(_ctx);
    }
    {
      struct kk_std_core_types_Cons* _con_x1389 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t y = _con_x1389->head;
      kk_std_core_types__list yy = _con_x1389->tail;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        kk_datatype_ptr_free(ys, _ctx);
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core_types__list_dup(yy, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_std_core_types__order _match_x1288;
      kk_function_t _x_x1390 = kk_function_dup(_implicit_fs_cmp, _ctx); /*(867, 867) -> order*/
      _match_x1288 = kk_function_call(kk_std_core_types__order, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x_x1390, (_x_x1390, x, y, _ctx), _ctx); /*order*/
      if (kk_std_core_types__is_Eq(_match_x1288, _ctx)) { // tailcall
                                                          xs = xx;
                                                          ys = yy;
                                                          goto kk__tailcall;
      }
      {
        kk_std_core_types__list_drop(yy, _ctx);
        kk_std_core_types__list_drop(xx, _ctx);
        kk_function_drop(_implicit_fs_cmp, _ctx);
        return _match_x1288;
      }
    }
  }
  {
    kk_function_drop(_implicit_fs_cmp, _ctx);
    if (kk_std_core_types__is_Nil(ys, _ctx)) {
      return kk_std_core_types__new_Eq(_ctx);
    }
    {
      struct kk_std_core_types_Cons* _con_x1391 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t _pat_6 = _con_x1391->head;
      kk_std_core_types__list _pat_7 = _con_x1391->tail;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        kk_std_core_types__list_drop(_pat_7, _ctx);
        kk_box_drop(_pat_6, _ctx);
        kk_datatype_ptr_free(ys, _ctx);
      }
      else {
        kk_datatype_ptr_decref(ys, _ctx);
      }
      return kk_std_core_types__new_Lt(_ctx);
    }
  }
}
 
// Take the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core_types__list kk_std_core_list__trmc_take(kk_std_core_types__list xs, kk_integer_t n, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1393 = kk_std_core_types__as_Cons(xs, _ctx);
    if (kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context())) {
      kk_box_t x = _con_x1393->head;
      kk_std_core_types__list xx = _con_x1393->tail;
      kk_reuse_t _ru_x1302 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        _ru_x1302 = (kk_datatype_ptr_reuse(xs, _ctx));
      }
      else {
        kk_box_dup(x, _ctx);
        kk_std_core_types__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_std_core_types__list _trmc_x10360 = kk_datatype_null(); /*list<919>*/;
      kk_std_core_types__list _trmc_x10361 = kk_std_core_types__new_Cons(_ru_x1302, 0, x, _trmc_x10360, _ctx); /*list<919>*/;
      kk_field_addr_t _b_x5_10 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10361, _ctx)->tail, _ctx); /*@field-addr<list<919>>*/;
      { // tailcall
        kk_integer_t _x_x1394 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        kk_std_core_types__cctx _x_x1395 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10361, _ctx)),_b_x5_10,kk_context()); /*ctx<0>*/
        xs = xx;
        n = _x_x1394;
        _acc = _x_x1395;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_std_core_types__list_drop(xs, _ctx);
    kk_integer_drop(n, _ctx);
    kk_box_t _x_x1396 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1396, KK_OWNED, _ctx);
  }
}
 
// Take the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core_types__list kk_std_core_list_take(kk_std_core_types__list xs_0, kk_integer_t n_0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> list<a> */ 
  kk_std_core_types__cctx _x_x1397 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_take(xs_0, n_0, _x_x1397, _ctx);
}
 
// Drop the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core_types__list kk_std_core_list_drop(kk_std_core_types__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1398 = kk_std_core_types__as_Cons(xs, _ctx);
    if (kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context())) {
      kk_box_t _pat_0 = _con_x1398->head;
      kk_std_core_types__list xx = _con_x1398->tail;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_box_drop(_pat_0, _ctx);
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_std_core_types__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      { // tailcall
        kk_integer_t _x_x1399 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        xs = xx;
        n = _x_x1399;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(n, _ctx);
    return xs;
  }
}

kk_std_core_types__list kk_std_core_list__unroll_reverse_acc_10003(kk_std_core_types__list acc, kk_std_core_types__list ys, kk_context_t* _ctx) { /* forall<a> (acc : list<a>, ys : list<a>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1400 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t x = _con_x1400->head;
    kk_std_core_types__list xx = _con_x1400->tail;
    kk_reuse_t _ru_x1304 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1304 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    { // tailcall
      kk_std_core_types__list _x_x1401 = kk_std_core_types__new_Cons(_ru_x1304, 0, x, acc, _ctx); /*list<82>*/
      acc = _x_x1401;
      ys = xx;
      goto kk__tailcall;
    }
  }
  {
    return acc;
  }
}
 
// Append two lists.

kk_std_core_types__list kk_std_core_list__trmc_unroll_append_10004(kk_std_core_types__list xs, kk_std_core_types__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1402 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1402->head;
    kk_std_core_types__list xx = _con_x1402->tail;
    kk_reuse_t _ru_x1305 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1305 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__list _trmc_x10362 = kk_datatype_null(); /*list<1071>*/;
    kk_std_core_types__list _trmc_x10363 = kk_std_core_types__new_Cons(_ru_x1305, 0, x, _trmc_x10362, _ctx); /*list<1071>*/;
    kk_field_addr_t _b_x21_26 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10363, _ctx)->tail, _ctx); /*@field-addr<list<1071>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1403 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10363, _ctx)),_b_x21_26,kk_context()); /*ctx<0>*/
      xs = xx;
      _acc = _x_x1403;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x_x1404 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(ys, _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1404, KK_OWNED, _ctx);
  }
}
 
// Append two lists.

kk_std_core_types__list kk_std_core_list__unroll_append_10004(kk_std_core_types__list xs_0, kk_std_core_types__list ys_0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x_x1405 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_append_10004(xs_0, ys_0, _x_x1405, _ctx);
}
 
// monadic lift

kk_box_t kk_std_core_list__mlift_unroll_foldl_10005_10661(kk_function_t f, kk_std_core_types__list xx, kk_box_t _y_x10421, kk_context_t* _ctx) { /* forall<a,b,e> (f : (b, a) -> e b, xx : list<a>, b) -> e b */ 
  return kk_std_core_list__unroll_foldl_10005(xx, _y_x10421, f, _ctx);
}
 
// Fold a list from the left, i.e. `foldl([1,2],0,(+)) == (0+1)+2`
// Since `foldl` is tail recursive, it is preferred over `foldr` when using an associative function `f`


// lift anonymous function
struct kk_std_core_list__unroll_foldl_10005_fun1410__t {
  struct kk_function_s _base;
  kk_function_t f_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__unroll_foldl_10005_fun1410(kk_function_t _fself, kk_box_t _y_x10421_0, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_unroll_foldl_10005_fun1410(kk_function_t f_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_foldl_10005_fun1410__t* _self = kk_function_alloc_as(struct kk_std_core_list__unroll_foldl_10005_fun1410__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__unroll_foldl_10005_fun1410, kk_context());
  _self->f_0 = f_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__unroll_foldl_10005_fun1410(kk_function_t _fself, kk_box_t _y_x10421_0, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_foldl_10005_fun1410__t* _self = kk_function_as(struct kk_std_core_list__unroll_foldl_10005_fun1410__t*, _fself, _ctx);
  kk_function_t f_0 = _self->f_0; /* (1139, 1138) -> 1140 1139 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<1138> */
  kk_drop_match(_self, {kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  return kk_std_core_list__mlift_unroll_foldl_10005_10661(f_0, xx_0, _y_x10421_0, _ctx);
}

kk_box_t kk_std_core_list__unroll_foldl_10005(kk_std_core_types__list xs, kk_box_t z, kk_function_t f_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, z : b, f : (b, a) -> e b) -> e b */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1408 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1408->head;
    kk_std_core_types__list xx_0 = _con_x1408->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t x_0_10697;
    kk_function_t _x_x1409 = kk_function_dup(f_0, _ctx); /*(1139, 1138) -> 1140 1139*/
    x_0_10697 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x_x1409, (_x_x1409, z, x, _ctx), _ctx); /*1139*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_0_10697, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core_list__new_unroll_foldl_10005_fun1410(f_0, xx_0, _ctx), _ctx);
    }
    { // tailcall
      xs = xx_0;
      z = x_0_10697;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(f_0, _ctx);
    return z;
  }
}
 
// monadic lift

kk_box_t kk_std_core_list__mlift_lift_foldr_10344_10662(kk_std_core_types__list _uniq_xx_10269, kk_function_t f, kk_box_t _uniq_z_10265_0_10354, kk_context_t* _ctx) { /* forall<a,b,e> (list<a>, f : (a, b) -> e b, b) -> e b */ 
  return kk_std_core_list__lift_foldr_10344(f, _uniq_xx_10269, _uniq_z_10265_0_10354, _ctx);
}
 
// lifted local: foldr, @spec-x10271
// specialized: std/core/list/@unroll-foldl@10005, on parameters @uniq-f@10266, using:
// @uniq-f@10266 = fn<(e :: E)>(x: 1189, y: 1188){
//   f(y, x);
// }


// lift anonymous function
struct kk_std_core_list__lift_foldr_10344_fun1413__t {
  struct kk_function_s _base;
  kk_std_core_types__list _uniq_xx_10269_0;
  kk_function_t f_0;
};
static kk_box_t kk_std_core_list__lift_foldr_10344_fun1413(kk_function_t _fself, kk_box_t _uniq_z_10265_0_10354_0, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_lift_foldr_10344_fun1413(kk_std_core_types__list _uniq_xx_10269_0, kk_function_t f_0, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_foldr_10344_fun1413__t* _self = kk_function_alloc_as(struct kk_std_core_list__lift_foldr_10344_fun1413__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__lift_foldr_10344_fun1413, kk_context());
  _self->_uniq_xx_10269_0 = _uniq_xx_10269_0;
  _self->f_0 = f_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__lift_foldr_10344_fun1413(kk_function_t _fself, kk_box_t _uniq_z_10265_0_10354_0, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_foldr_10344_fun1413__t* _self = kk_function_as(struct kk_std_core_list__lift_foldr_10344_fun1413__t*, _fself, _ctx);
  kk_std_core_types__list _uniq_xx_10269_0 = _self->_uniq_xx_10269_0; /* list<1188> */
  kk_function_t f_0 = _self->f_0; /* (1188, 1189) -> 1190 1189 */
  kk_drop_match(_self, {kk_std_core_types__list_dup(_uniq_xx_10269_0, _ctx);kk_function_dup(f_0, _ctx);}, {}, _ctx)
  return kk_std_core_list__mlift_lift_foldr_10344_10662(_uniq_xx_10269_0, f_0, _uniq_z_10265_0_10354_0, _ctx);
}

kk_box_t kk_std_core_list__lift_foldr_10344(kk_function_t f_0, kk_std_core_types__list _uniq_xs_10264, kk_box_t _uniq_z_10265, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a, b) -> e b, list<a>, b) -> e b */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(_uniq_xs_10264, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1411 = kk_std_core_types__as_Cons(_uniq_xs_10264, _ctx);
    kk_box_t _uniq_x_10268 = _con_x1411->head;
    kk_std_core_types__list _uniq_xx_10269_0 = _con_x1411->tail;
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10264, _ctx)) {
      kk_datatype_ptr_free(_uniq_xs_10264, _ctx);
    }
    else {
      kk_box_dup(_uniq_x_10268, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10269_0, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10264, _ctx);
    }
    kk_box_t x_10700;
    kk_function_t _x_x1412 = kk_function_dup(f_0, _ctx); /*(1188, 1189) -> 1190 1189*/
    x_10700 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x_x1412, (_x_x1412, _uniq_x_10268, _uniq_z_10265, _ctx), _ctx); /*1189*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_10700, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core_list__new_lift_foldr_10344_fun1413(_uniq_xx_10269_0, f_0, _ctx), _ctx);
    }
    { // tailcall
      _uniq_xs_10264 = _uniq_xx_10269_0;
      _uniq_z_10265 = x_10700;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(f_0, _ctx);
    return _uniq_z_10265;
  }
}


// lift anonymous function
struct kk_std_core_list_foldl1_fun1422__t {
  struct kk_function_s _base;
  kk_ssize_t i_10703;
};
static kk_box_t kk_std_core_list_foldl1_fun1422(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_foldl1_fun1422(kk_ssize_t i_10703, kk_context_t* _ctx) {
  struct kk_std_core_list_foldl1_fun1422__t* _self = kk_function_alloc_as(struct kk_std_core_list_foldl1_fun1422__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_foldl1_fun1422, kk_context());
  _self->i_10703 = i_10703;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_foldl1_fun1422(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_list_foldl1_fun1422__t* _self = kk_function_as(struct kk_std_core_list_foldl1_fun1422__t*, _fself, _ctx);
  kk_ssize_t i_10703 = _self->i_10703; /* hnd/ev-index */
  kk_drop_match(_self, {kk_skip_dup(i_10703, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i_10703, cont, res, _ctx);
}

kk_box_t kk_std_core_list_foldl1(kk_std_core_types__list xs, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, f : (a, a) -> <exn|e> a) -> <exn|e> a */ 
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1414 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1414->head;
    kk_std_core_types__list xx = _con_x1414->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Nil(xx, _ctx)) {
      kk_function_drop(f, _ctx);
      return x;
    }
    {
      return kk_std_core_list__unroll_foldl_10005(xx, x, f, _ctx);
    }
  }
  {
    kk_function_drop(f, _ctx);
    kk_ssize_t i_10703;
    kk_std_core_hnd__htag _x_x1415 = kk_std_core_hnd__htag_dup(kk_std_core_exn_exn_fs__tag, _ctx); /*hnd/htag<exn>*/
    i_10703 = kk_std_core_hnd__evv_index(_x_x1415, _ctx); /*hnd/ev-index*/
    kk_evv_t w = kk_evv_swap_create1(i_10703,kk_context()); /*hnd/evv<<exn|1245>>*/;
    kk_std_core_hnd__ev ev_10707 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<exn>*/;
    kk_box_t y;
    {
      struct kk_std_core_hnd_Ev* _con_x1416 = kk_std_core_hnd__as_Ev(ev_10707, _ctx);
      kk_box_t _box_x32 = _con_x1416->hnd;
      int32_t m = _con_x1416->marker;
      kk_std_core_exn__exn h = kk_std_core_exn__exn_unbox(_box_x32, KK_BORROWED, _ctx);
      kk_std_core_exn__exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_x1283;
      kk_std_core_hnd__clause1 _brw_x1285 = kk_std_core_exn_throw_exn_fs__select(h, _ctx); /*hnd/clause1<exception,274,exn,275,276>*/;
      kk_datatype_ptr_dropn(h, (KK_I32(2)), _ctx);
      _match_x1283 = _brw_x1285; /*hnd/clause1<exception,274,exn,275,276>*/
      {
        kk_function_t _fun_unbox_x36 = _match_x1283.clause;
        kk_box_t _x_x1417;
        kk_std_core_exn__exception _x_x1418;
        kk_string_t _x_x1419;
        kk_define_string_literal(, _s_x1420, 33, "unexpected Nil in std/core/foldl1", _ctx)
        _x_x1419 = kk_string_dup(_s_x1420, _ctx); /*string*/
        kk_std_core_exn__exception_info _x_x1421;
        kk_std_core_types__optional _match_x1284 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
        if (kk_std_core_types__is_Optional(_match_x1284, _ctx)) {
          kk_box_t _box_x40 = _match_x1284._cons._Optional.value;
          kk_std_core_exn__exception_info _uniq_info_391 = kk_std_core_exn__exception_info_unbox(_box_x40, KK_BORROWED, _ctx);
          kk_std_core_exn__exception_info_dup(_uniq_info_391, _ctx);
          kk_std_core_types__optional_drop(_match_x1284, _ctx);
          _x_x1421 = _uniq_info_391; /*exception-info*/
        }
        else {
          kk_std_core_types__optional_drop(_match_x1284, _ctx);
          _x_x1421 = kk_std_core_exn__new_ExnError(_ctx); /*exception-info*/
        }
        _x_x1418 = kk_std_core_exn__new_Exception(_x_x1419, _x_x1421, _ctx); /*exception*/
        _x_x1417 = kk_std_core_exn__exception_box(_x_x1418, _ctx); /*45*/
        y = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x36, (_fun_unbox_x36, m, ev_10707, _x_x1417, _ctx), _ctx); /*1244*/
      }
    }
    kk_unit_t __ = kk_Unit;
    kk_evv_set(w,kk_context());
    if (kk_yielding(kk_context())) {
      kk_box_drop(y, _ctx);
      return kk_std_core_hnd_yield_cont(kk_std_core_list_new_foldl1_fun1422(i_10703, _ctx), _ctx);
    }
    {
      return y;
    }
  }
}


// lift anonymous function
struct kk_std_core_list_foldr1_fun1431__t {
  struct kk_function_s _base;
  kk_ssize_t i_10712;
};
static kk_box_t kk_std_core_list_foldr1_fun1431(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_foldr1_fun1431(kk_ssize_t i_10712, kk_context_t* _ctx) {
  struct kk_std_core_list_foldr1_fun1431__t* _self = kk_function_alloc_as(struct kk_std_core_list_foldr1_fun1431__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_foldr1_fun1431, kk_context());
  _self->i_10712 = i_10712;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_foldr1_fun1431(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_list_foldr1_fun1431__t* _self = kk_function_as(struct kk_std_core_list_foldr1_fun1431__t*, _fself, _ctx);
  kk_ssize_t i_10712 = _self->i_10712; /* hnd/ev-index */
  kk_drop_match(_self, {kk_skip_dup(i_10712, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i_10712, cont, res, _ctx);
}

kk_box_t kk_std_core_list_foldr1(kk_std_core_types__list xs, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, f : (a, a) -> <exn|e> a) -> <exn|e> a */ 
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn|1279>>*/;
  kk_std_core_types__list x;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    x = kk_std_core_types__new_Nil(_ctx); /*list<1278>*/
  }
  else {
    x = kk_std_core_list__unroll_reverse_acc_10003(kk_std_core_types__new_Nil(_ctx), xs, _ctx); /*list<1278>*/
  }
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_std_core_types__is_Cons(x, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1423 = kk_std_core_types__as_Cons(x, _ctx);
    kk_box_t x_0 = _con_x1423->head;
    kk_std_core_types__list xx = _con_x1423->tail;
    if kk_likely(kk_datatype_ptr_is_unique(x, _ctx)) {
      kk_datatype_ptr_free(x, _ctx);
    }
    else {
      kk_box_dup(x_0, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(x, _ctx);
    }
    if (kk_std_core_types__is_Nil(xx, _ctx)) {
      kk_function_drop(f, _ctx);
      return x_0;
    }
    {
      return kk_std_core_list__unroll_foldl_10005(xx, x_0, f, _ctx);
    }
  }
  {
    kk_function_drop(f, _ctx);
    kk_ssize_t i_10712;
    kk_std_core_hnd__htag _x_x1424 = kk_std_core_hnd__htag_dup(kk_std_core_exn_exn_fs__tag, _ctx); /*hnd/htag<exn>*/
    i_10712 = kk_std_core_hnd__evv_index(_x_x1424, _ctx); /*hnd/ev-index*/
    kk_evv_t w_0 = kk_evv_swap_create1(i_10712,kk_context()); /*hnd/evv<<exn|1279>>*/;
    kk_std_core_hnd__ev ev_10716 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<exn>*/;
    kk_box_t y;
    {
      struct kk_std_core_hnd_Ev* _con_x1425 = kk_std_core_hnd__as_Ev(ev_10716, _ctx);
      kk_box_t _box_x41 = _con_x1425->hnd;
      int32_t m = _con_x1425->marker;
      kk_std_core_exn__exn h = kk_std_core_exn__exn_unbox(_box_x41, KK_BORROWED, _ctx);
      kk_std_core_exn__exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_x1279;
      kk_std_core_hnd__clause1 _brw_x1281 = kk_std_core_exn_throw_exn_fs__select(h, _ctx); /*hnd/clause1<exception,274,exn,275,276>*/;
      kk_datatype_ptr_dropn(h, (KK_I32(2)), _ctx);
      _match_x1279 = _brw_x1281; /*hnd/clause1<exception,274,exn,275,276>*/
      {
        kk_function_t _fun_unbox_x45 = _match_x1279.clause;
        kk_box_t _x_x1426;
        kk_std_core_exn__exception _x_x1427;
        kk_string_t _x_x1428;
        kk_define_string_literal(, _s_x1429, 33, "unexpected Nil in std/core/foldl1", _ctx)
        _x_x1428 = kk_string_dup(_s_x1429, _ctx); /*string*/
        kk_std_core_exn__exception_info _x_x1430;
        kk_std_core_types__optional _match_x1280 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
        if (kk_std_core_types__is_Optional(_match_x1280, _ctx)) {
          kk_box_t _box_x49 = _match_x1280._cons._Optional.value;
          kk_std_core_exn__exception_info _uniq_info_391 = kk_std_core_exn__exception_info_unbox(_box_x49, KK_BORROWED, _ctx);
          kk_std_core_exn__exception_info_dup(_uniq_info_391, _ctx);
          kk_std_core_types__optional_drop(_match_x1280, _ctx);
          _x_x1430 = _uniq_info_391; /*exception-info*/
        }
        else {
          kk_std_core_types__optional_drop(_match_x1280, _ctx);
          _x_x1430 = kk_std_core_exn__new_ExnError(_ctx); /*exception-info*/
        }
        _x_x1427 = kk_std_core_exn__new_Exception(_x_x1428, _x_x1430, _ctx); /*exception*/
        _x_x1426 = kk_std_core_exn__exception_box(_x_x1427, _ctx); /*45*/
        y = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x45, (_fun_unbox_x45, m, ev_10716, _x_x1426, _ctx), _ctx); /*1278*/
      }
    }
    kk_unit_t __ = kk_Unit;
    kk_evv_set(w_0,kk_context());
    if (kk_yielding(kk_context())) {
      kk_box_drop(y, _ctx);
      return kk_std_core_hnd_yield_cont(kk_std_core_list_new_foldr1_fun1431(i_10712, _ctx), _ctx);
    }
    {
      return y;
    }
  }
}
 
// split a list at position `n`

kk_std_core_types__tuple2 kk_std_core_list_split(kk_std_core_types__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> (list<a>, list<a>) */ 
  kk_std_core_types__list _b_x50_52;
  kk_std_core_types__list _x_x1432 = kk_std_core_types__list_dup(xs, _ctx); /*list<1318>*/
  kk_integer_t _x_x1433 = kk_integer_dup(n, _ctx); /*int*/
  kk_std_core_types__cctx _x_x1434 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  _b_x50_52 = kk_std_core_list__trmc_take(_x_x1432, _x_x1433, _x_x1434, _ctx); /*list<1318>*/
  kk_std_core_types__list _b_x51_53 = kk_std_core_list_drop(xs, n, _ctx); /*list<1318>*/;
  return kk_std_core_types__new_Tuple2(kk_std_core_types__list_box(_b_x50_52, _ctx), kk_std_core_types__list_box(_b_x51_53, _ctx), _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_unroll_drop_while_10006_10663(kk_function_t predicate, kk_std_core_types__list xs, kk_std_core_types__list xx, bool _y_x10441, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xs : list<a>, xx : list<a>, bool) -> e list<a> */ 
  if (_y_x10441) {
    kk_std_core_types__list_drop(xs, _ctx);
    return kk_std_core_list__unroll_drop_while_10006(xx, predicate, _ctx);
  }
  {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return xs;
  }
}
 
// Drop all initial elements that satisfy `predicate`


// lift anonymous function
struct kk_std_core_list__unroll_drop_while_10006_fun1438__t {
  struct kk_function_s _base;
  kk_function_t predicate_0;
  kk_std_core_types__list xs_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__unroll_drop_while_10006_fun1438(kk_function_t _fself, kk_box_t _b_x55, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_unroll_drop_while_10006_fun1438(kk_function_t predicate_0, kk_std_core_types__list xs_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_drop_while_10006_fun1438__t* _self = kk_function_alloc_as(struct kk_std_core_list__unroll_drop_while_10006_fun1438__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__unroll_drop_while_10006_fun1438, kk_context());
  _self->predicate_0 = predicate_0;
  _self->xs_0 = xs_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__unroll_drop_while_10006_fun1438(kk_function_t _fself, kk_box_t _b_x55, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_drop_while_10006_fun1438__t* _self = kk_function_as(struct kk_std_core_list__unroll_drop_while_10006_fun1438__t*, _fself, _ctx);
  kk_function_t predicate_0 = _self->predicate_0; /* (1362) -> 1363 bool */
  kk_std_core_types__list xs_0 = _self->xs_0; /* list<1362> */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<1362> */
  kk_drop_match(_self, {kk_function_dup(predicate_0, _ctx);kk_std_core_types__list_dup(xs_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10441_0_57 = kk_bool_unbox(_b_x55); /*bool*/;
  kk_std_core_types__list _x_x1439 = kk_std_core_list__mlift_unroll_drop_while_10006_10663(predicate_0, xs_0, xx_0, _y_x10441_0_57, _ctx); /*list<1362>*/
  return kk_std_core_types__list_box(_x_x1439, _ctx);
}

kk_std_core_types__list kk_std_core_list__unroll_drop_while_10006(kk_std_core_types__list xs_0, kk_function_t predicate_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs_0, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1435 = kk_std_core_types__as_Cons(xs_0, _ctx);
    kk_box_t x = _con_x1435->head;
    kk_std_core_types__list xx_0 = _con_x1435->tail;
    kk_box_dup(x, _ctx);
    kk_std_core_types__list_dup(xx_0, _ctx);
    bool x_0_10721;
    kk_function_t _x_x1436 = kk_function_dup(predicate_0, _ctx); /*(1362) -> 1363 bool*/
    x_0_10721 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1436, (_x_x1436, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1437 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_unroll_drop_while_10006_fun1438(predicate_0, xs_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1437, KK_OWNED, _ctx);
    }
    if (x_0_10721) {
      if kk_likely(kk_datatype_ptr_is_unique(xs_0, _ctx)) {
        kk_std_core_types__list_drop(xx_0, _ctx);
        kk_box_drop(x, _ctx);
        kk_datatype_ptr_free(xs_0, _ctx);
      }
      else {
        kk_datatype_ptr_decref(xs_0, _ctx);
      }
      { // tailcall
        xs_0 = xx_0;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(predicate_0, _ctx);
      return xs_0;
    }
  }
  {
    kk_function_drop(predicate_0, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_unroll_filter_10007_10664(kk_std_core_types__cctx _acc, kk_function_t pred, kk_box_t x, kk_std_core_types__list xx, bool _y_x10447, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, pred : (a) -> e bool, x : a, xx : list<a>, bool) -> e list<a> */ 
  if (_y_x10447) {
    kk_std_core_types__list _trmc_x10364 = kk_datatype_null(); /*list<1424>*/;
    kk_std_core_types__list _trmc_x10365 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _trmc_x10364, _ctx); /*list<1424>*/;
    kk_field_addr_t _b_x63_66 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10365, _ctx)->tail, _ctx); /*@field-addr<list<1424>>*/;
    kk_std_core_types__cctx _x_x1440 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10365, _ctx)),_b_x63_66,kk_context()); /*ctx<0>*/
    return kk_std_core_list__trmc_unroll_filter_10007(xx, pred, _x_x1440, _ctx);
  }
  {
    kk_box_drop(x, _ctx);
    return kk_std_core_list__trmc_unroll_filter_10007(xx, pred, _acc, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filter([1,2,3],odd?) == [1,3]`


// lift anonymous function
struct kk_std_core_list__trmc_unroll_filter_10007_fun1445__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t pred_0;
  kk_box_t x_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_unroll_filter_10007_fun1445(kk_function_t _fself, kk_box_t _b_x71, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_unroll_filter_10007_fun1445(kk_std_core_types__cctx _acc_0, kk_function_t pred_0, kk_box_t x_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_filter_10007_fun1445__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_unroll_filter_10007_fun1445__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_unroll_filter_10007_fun1445, kk_context());
  _self->_acc_0 = _acc_0;
  _self->pred_0 = pred_0;
  _self->x_0 = x_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_unroll_filter_10007_fun1445(kk_function_t _fself, kk_box_t _b_x71, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_filter_10007_fun1445__t* _self = kk_function_as(struct kk_std_core_list__trmc_unroll_filter_10007_fun1445__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<1424>> */
  kk_function_t pred_0 = _self->pred_0; /* (1424) -> 1425 bool */
  kk_box_t x_0 = _self->x_0; /* 1424 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<1424> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(pred_0, _ctx);kk_box_dup(x_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10447_0_89 = kk_bool_unbox(_b_x71); /*bool*/;
  kk_std_core_types__list _x_x1446 = kk_std_core_list__mlift_trmc_unroll_filter_10007_10664(_acc_0, pred_0, x_0, xx_0, _y_x10447_0_89, _ctx); /*list<1424>*/
  return kk_std_core_types__list_box(_x_x1446, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_unroll_filter_10007(kk_std_core_types__list xs, kk_function_t pred_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1441 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x_0 = _con_x1441->head;
    kk_std_core_types__list xx_0 = _con_x1441->tail;
    kk_reuse_t _ru_x1313 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1313 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x_0, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_1_10724;
    kk_function_t _x_x1443 = kk_function_dup(pred_0, _ctx); /*(1424) -> 1425 bool*/
    kk_box_t _x_x1442 = kk_box_dup(x_0, _ctx); /*1424*/
    x_1_10724 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1443, (_x_x1443, _x_x1442, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1313,kk_context());
      kk_box_t _x_x1444 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_unroll_filter_10007_fun1445(_acc_0, pred_0, x_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1444, KK_OWNED, _ctx);
    }
    if (x_1_10724) {
      kk_std_core_types__list _trmc_x10364_0 = kk_datatype_null(); /*list<1424>*/;
      kk_std_core_types__list _trmc_x10365_0 = kk_std_core_types__new_Cons(_ru_x1313, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0, _trmc_x10364_0, _ctx); /*list<1424>*/;
      kk_field_addr_t _b_x77_83 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10365_0, _ctx)->tail, _ctx); /*@field-addr<list<1424>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1447 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10365_0, _ctx)),_b_x77_83,kk_context()); /*ctx<0>*/
        xs = xx_0;
        _acc_0 = _x_x1447;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_x1313,kk_context());
      kk_box_drop(x_0, _ctx);
      { // tailcall
        xs = xx_0;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(pred_0, _ctx);
    kk_box_t _x_x1448 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1448, KK_OWNED, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filter([1,2,3],odd?) == [1,3]`

kk_std_core_types__list kk_std_core_list__unroll_filter_10007(kk_std_core_types__list xs_0, kk_function_t pred_1, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool) -> e list<a> */ 
  kk_std_core_types__cctx _x_x1449 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_filter_10007(xs_0, pred_1, _x_x1449, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_unroll_filter_map_10008_10665(kk_std_core_types__cctx _acc, kk_function_t pred, kk_std_core_types__list xx, kk_std_core_types__maybe _y_x10455, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, pred : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Nothing(_y_x10455, _ctx)) {
    return kk_std_core_list__trmc_unroll_filter_map_10008(xx, pred, _acc, _ctx);
  }
  {
    kk_box_t y = _y_x10455._cons.Just.value;
    kk_std_core_types__list _trmc_x10366 = kk_datatype_null(); /*list<1504>*/;
    kk_std_core_types__list _trmc_x10367 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _trmc_x10366, _ctx); /*list<1504>*/;
    kk_field_addr_t _b_x95_98 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10367, _ctx)->tail, _ctx); /*@field-addr<list<1504>>*/;
    kk_std_core_types__cctx _x_x1451 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10367, _ctx)),_b_x95_98,kk_context()); /*ctx<0>*/
    return kk_std_core_list__trmc_unroll_filter_map_10008(xx, pred, _x_x1451, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filterMap([1,2,3],fn(i) { if i.odd? then Nothing else Just(i*i) }) == [4]`


// lift anonymous function
struct kk_std_core_list__trmc_unroll_filter_map_10008_fun1456__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t pred_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_unroll_filter_map_10008_fun1456(kk_function_t _fself, kk_box_t _b_x105, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_unroll_filter_map_10008_fun1456(kk_std_core_types__cctx _acc_0, kk_function_t pred_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_filter_map_10008_fun1456__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_unroll_filter_map_10008_fun1456__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_unroll_filter_map_10008_fun1456, kk_context());
  _self->_acc_0 = _acc_0;
  _self->pred_0 = pred_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_unroll_filter_map_10008_fun1456(kk_function_t _fself, kk_box_t _b_x105, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_filter_map_10008_fun1456__t* _self = kk_function_as(struct kk_std_core_list__trmc_unroll_filter_map_10008_fun1456__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<1504>> */
  kk_function_t pred_0 = _self->pred_0; /* (1503) -> 1505 maybe<1504> */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<1503> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(pred_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_x10455_0_121 = kk_std_core_types__maybe_unbox(_b_x105, KK_OWNED, _ctx); /*maybe<1504>*/;
  kk_std_core_types__list _x_x1457 = kk_std_core_list__mlift_trmc_unroll_filter_map_10008_10665(_acc_0, pred_0, xx_0, _y_x10455_0_121, _ctx); /*list<1504>*/
  return kk_std_core_types__list_box(_x_x1457, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_unroll_filter_map_10008(kk_std_core_types__list xs, kk_function_t pred_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, pred : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_function_drop(pred_0, _ctx);
    kk_box_t _x_x1452 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1452, KK_OWNED, _ctx);
  }
  {
    struct kk_std_core_types_Cons* _con_x1453 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1453->head;
    kk_std_core_types__list xx_0 = _con_x1453->tail;
    kk_reuse_t _ru_x1314 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1314 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x_0_10729;
    kk_function_t _x_x1454 = kk_function_dup(pred_0, _ctx); /*(1503) -> 1505 maybe<1504>*/
    x_0_10729 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x_x1454, (_x_x1454, x, _ctx), _ctx); /*maybe<1504>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1314,kk_context());
      kk_std_core_types__maybe_drop(x_0_10729, _ctx);
      kk_box_t _x_x1455 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_unroll_filter_map_10008_fun1456(_acc_0, pred_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1455, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x_0_10729, _ctx)) {
      kk_reuse_drop(_ru_x1314,kk_context());
      { // tailcall
        xs = xx_0;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t y_0 = x_0_10729._cons.Just.value;
      kk_std_core_types__list _trmc_x10366_0 = kk_datatype_null(); /*list<1504>*/;
      kk_std_core_types__list _trmc_x10367_0 = kk_std_core_types__new_Cons(_ru_x1314, kk_field_index_of(struct kk_std_core_types_Cons, tail), y_0, _trmc_x10366_0, _ctx); /*list<1504>*/;
      kk_field_addr_t _b_x111_117 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10367_0, _ctx)->tail, _ctx); /*@field-addr<list<1504>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1458 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10367_0, _ctx)),_b_x111_117,kk_context()); /*ctx<0>*/
        xs = xx_0;
        _acc_0 = _x_x1458;
        goto kk__tailcall;
      }
    }
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filterMap([1,2,3],fn(i) { if i.odd? then Nothing else Just(i*i) }) == [4]`

kk_std_core_types__list kk_std_core_list__unroll_filter_map_10008(kk_std_core_types__list xs_0, kk_function_t pred_1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, pred : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1459 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_filter_map_10008(xs_0, pred_1, _x_x1459, _ctx);
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core_list__mlift_unroll_foreach_while_10009_10666(kk_function_t action, kk_std_core_types__list xx, kk_std_core_types__maybe _y_x10463, kk_context_t* _ctx) { /* forall<a,b,e> (action : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e maybe<b> */ 
  if (kk_std_core_types__is_Nothing(_y_x10463, _ctx)) {
    return kk_std_core_list__unroll_foreach_while_10009(xx, action, _ctx);
  }
  {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(action, _ctx);
    return _y_x10463;
  }
}
 
// Invoke `action` for each element of a list while `action` return `Nothing`


// lift anonymous function
struct kk_std_core_list__unroll_foreach_while_10009_fun1464__t {
  struct kk_function_s _base;
  kk_function_t action_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__unroll_foreach_while_10009_fun1464(kk_function_t _fself, kk_box_t _b_x123, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_unroll_foreach_while_10009_fun1464(kk_function_t action_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_foreach_while_10009_fun1464__t* _self = kk_function_alloc_as(struct kk_std_core_list__unroll_foreach_while_10009_fun1464__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__unroll_foreach_while_10009_fun1464, kk_context());
  _self->action_0 = action_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__unroll_foreach_while_10009_fun1464(kk_function_t _fself, kk_box_t _b_x123, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_foreach_while_10009_fun1464__t* _self = kk_function_as(struct kk_std_core_list__unroll_foreach_while_10009_fun1464__t*, _fself, _ctx);
  kk_function_t action_0 = _self->action_0; /* (1575) -> 1577 maybe<1576> */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<1575> */
  kk_drop_match(_self, {kk_function_dup(action_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_x10463_0_125 = kk_std_core_types__maybe_unbox(_b_x123, KK_OWNED, _ctx); /*maybe<1576>*/;
  kk_std_core_types__maybe _x_x1465 = kk_std_core_list__mlift_unroll_foreach_while_10009_10666(action_0, xx_0, _y_x10463_0_125, _ctx); /*maybe<1576>*/
  return kk_std_core_types__maybe_box(_x_x1465, _ctx);
}

kk_std_core_types__maybe kk_std_core_list__unroll_foreach_while_10009(kk_std_core_types__list xs, kk_function_t action_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>) -> e maybe<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_function_drop(action_0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    struct kk_std_core_types_Cons* _con_x1461 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1461->head;
    kk_std_core_types__list xx_0 = _con_x1461->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x_0_10734;
    kk_function_t _x_x1462 = kk_function_dup(action_0, _ctx); /*(1575) -> 1577 maybe<1576>*/
    x_0_10734 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x_x1462, (_x_x1462, x, _ctx), _ctx); /*maybe<1576>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x_0_10734, _ctx);
      kk_box_t _x_x1463 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_unroll_foreach_while_10009_fun1464(action_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__maybe_unbox(_x_x1463, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x_0_10734, _ctx)) { // tailcall
                                                          xs = xx_0;
                                                          goto kk__tailcall;
    }
    {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(action_0, _ctx);
      return x_0_10734;
    }
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core_list__mlift_lift_find_10345_10667(kk_box_t _uniq_x_10278, kk_std_core_types__list _uniq_xx_10279, kk_function_t pred, bool _y_x10469, kk_context_t* _ctx) { /* forall<a,e> (a, list<a>, pred : (a) -> e bool, bool) -> e maybe<a> */ 
  if (_y_x10469) {
    kk_function_drop(pred, _ctx);
    kk_std_core_types__list_drop(_uniq_xx_10279, _ctx);
    return kk_std_core_types__new_Just(_uniq_x_10278, _ctx);
  }
  {
    kk_box_drop(_uniq_x_10278, _ctx);
    return kk_std_core_list__lift_find_10345(pred, _uniq_xx_10279, _ctx);
  }
}
 
// lifted local: find, @spec-x10282
// specialized: std/core/list/@unroll-foreach-while@10009, on parameters @uniq-action@10275, using:
// @uniq-action@10275 = fn<(e :: E)>(x: 1641){
//   match ((pred(x))) {
//     ((std/core/types/True() : bool ) as @pat@1: bool)
//        -> std/core/types/Just<a>(x);
//     ((@skip std/core/types/False() : bool ) as @pat@0@0: bool)
//        -> std/core/types/Nothing<a>;
//   };
// }


// lift anonymous function
struct kk_std_core_list__lift_find_10345_fun1470__t {
  struct kk_function_s _base;
  kk_box_t _uniq_x_10278_0;
  kk_std_core_types__list _uniq_xx_10279_0;
  kk_function_t pred_0;
};
static kk_box_t kk_std_core_list__lift_find_10345_fun1470(kk_function_t _fself, kk_box_t _b_x127, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_lift_find_10345_fun1470(kk_box_t _uniq_x_10278_0, kk_std_core_types__list _uniq_xx_10279_0, kk_function_t pred_0, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_find_10345_fun1470__t* _self = kk_function_alloc_as(struct kk_std_core_list__lift_find_10345_fun1470__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__lift_find_10345_fun1470, kk_context());
  _self->_uniq_x_10278_0 = _uniq_x_10278_0;
  _self->_uniq_xx_10279_0 = _uniq_xx_10279_0;
  _self->pred_0 = pred_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__lift_find_10345_fun1470(kk_function_t _fself, kk_box_t _b_x127, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_find_10345_fun1470__t* _self = kk_function_as(struct kk_std_core_list__lift_find_10345_fun1470__t*, _fself, _ctx);
  kk_box_t _uniq_x_10278_0 = _self->_uniq_x_10278_0; /* 1641 */
  kk_std_core_types__list _uniq_xx_10279_0 = _self->_uniq_xx_10279_0; /* list<1641> */
  kk_function_t pred_0 = _self->pred_0; /* (1641) -> 1642 bool */
  kk_drop_match(_self, {kk_box_dup(_uniq_x_10278_0, _ctx);kk_std_core_types__list_dup(_uniq_xx_10279_0, _ctx);kk_function_dup(pred_0, _ctx);}, {}, _ctx)
  bool _y_x10469_0_129 = kk_bool_unbox(_b_x127); /*bool*/;
  kk_std_core_types__maybe _x_x1471 = kk_std_core_list__mlift_lift_find_10345_10667(_uniq_x_10278_0, _uniq_xx_10279_0, pred_0, _y_x10469_0_129, _ctx); /*maybe<1641>*/
  return kk_std_core_types__maybe_box(_x_x1471, _ctx);
}

kk_std_core_types__maybe kk_std_core_list__lift_find_10345(kk_function_t pred_0, kk_std_core_types__list _uniq_xs_10274, kk_context_t* _ctx) { /* forall<a,e> (pred : (a) -> e bool, list<a>) -> e maybe<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Nil(_uniq_xs_10274, _ctx)) {
    kk_function_drop(pred_0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    struct kk_std_core_types_Cons* _con_x1466 = kk_std_core_types__as_Cons(_uniq_xs_10274, _ctx);
    kk_box_t _uniq_x_10278_0 = _con_x1466->head;
    kk_std_core_types__list _uniq_xx_10279_0 = _con_x1466->tail;
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10274, _ctx)) {
      kk_datatype_ptr_free(_uniq_xs_10274, _ctx);
    }
    else {
      kk_box_dup(_uniq_x_10278_0, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10279_0, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10274, _ctx);
    }
    bool x_10737;
    kk_function_t _x_x1468 = kk_function_dup(pred_0, _ctx); /*(1641) -> 1642 bool*/
    kk_box_t _x_x1467 = kk_box_dup(_uniq_x_10278_0, _ctx); /*1641*/
    x_10737 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1468, (_x_x1468, _x_x1467, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1469 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_lift_find_10345_fun1470(_uniq_x_10278_0, _uniq_xx_10279_0, pred_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__maybe_unbox(_x_x1469, KK_OWNED, _ctx);
    }
    if (x_10737) {
      kk_function_drop(pred_0, _ctx);
      kk_std_core_types__list_drop(_uniq_xx_10279_0, _ctx);
      return kk_std_core_types__new_Just(_uniq_x_10278_0, _ctx);
    }
    {
      kk_box_drop(_uniq_x_10278_0, _ctx);
      { // tailcall
        _uniq_xs_10274 = _uniq_xx_10279_0;
        goto kk__tailcall;
      }
    }
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_range_fs__trmc_list(kk_integer_t lo, kk_integer_t hi, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (lo : int, hi : int, ctx<list<int>>) -> list<int> */ 
  kk__tailcall: ;
  bool _match_x1272 = kk_integer_lte_borrow(lo,hi,kk_context()); /*bool*/;
  if (_match_x1272) {
    kk_std_core_types__list _trmc_x10368 = kk_datatype_null(); /*list<int>*/;
    kk_std_core_types__list _trmc_x10369;
    kk_box_t _x_x1472;
    kk_integer_t _x_x1473 = kk_integer_dup(lo, _ctx); /*int*/
    _x_x1472 = kk_integer_box(_x_x1473, _ctx); /*82*/
    _trmc_x10369 = kk_std_core_types__new_Cons(kk_reuse_null, 0, _x_x1472, _trmc_x10368, _ctx); /*list<int>*/
    kk_field_addr_t _b_x139_144 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10369, _ctx)->tail, _ctx); /*@field-addr<list<int>>*/;
    { // tailcall
      kk_integer_t _x_x1474 = kk_integer_add_small_const(lo, 1, _ctx); /*int*/
      kk_std_core_types__cctx _x_x1475 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10369, _ctx)),_b_x139_144,kk_context()); /*ctx<0>*/
      lo = _x_x1474;
      _acc = _x_x1475;
      goto kk__tailcall;
    }
  }
  {
    kk_integer_drop(lo, _ctx);
    kk_integer_drop(hi, _ctx);
    kk_box_t _x_x1476 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1476, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_range_fs_list(kk_integer_t lo_0, kk_integer_t hi_0, kk_context_t* _ctx) { /* (lo : int, hi : int) -> list<int> */ 
  kk_std_core_types__cctx _x_x1477 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list_range_fs__trmc_list(lo_0, hi_0, _x_x1477, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_unroll_map_10010_10668(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core_types__list xx, kk_box_t _trmc_x10370, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e b, xx : list<a>, b) -> e list<b> */ 
  kk_std_core_types__list _trmc_x10371 = kk_datatype_null(); /*list<2106>*/;
  kk_std_core_types__list _trmc_x10372 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10370, _trmc_x10371, _ctx); /*list<2106>*/;
  kk_field_addr_t _b_x155_158 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10372, _ctx)->tail, _ctx); /*@field-addr<list<2106>>*/;
  kk_std_core_types__cctx _own_x1270 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10372, _ctx)),_b_x155_158,kk_context()); /*ctx<0>*/;
  kk_std_core_types__list _brw_x1271 = kk_std_core_list__trmc_unroll_map_10010(xx, f, _own_x1270, _ctx); /*list<2106>*/;
  kk_function_drop(f, _ctx);
  return _brw_x1271;
}
 
// Apply a function `f` to each element of the input list in sequence.


// lift anonymous function
struct kk_std_core_list__trmc_unroll_map_10010_fun1482__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_unroll_map_10010_fun1482(kk_function_t _fself, kk_box_t _b_x163, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_unroll_map_10010_fun1482(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_map_10010_fun1482__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_unroll_map_10010_fun1482__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_unroll_map_10010_fun1482, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_unroll_map_10010_fun1482(kk_function_t _fself, kk_box_t _b_x163, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_map_10010_fun1482__t* _self = kk_function_as(struct kk_std_core_list__trmc_unroll_map_10010_fun1482__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2106>> */
  kk_function_t f_0 = _self->f_0; /* (2105) -> 2107 2106 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<2105> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10370_0_181 = _b_x163; /*2106*/;
  kk_std_core_types__list _x_x1483 = kk_std_core_list__mlift_trmc_unroll_map_10010_10668(_acc_0, f_0, xx_0, _trmc_x10370_0_181, _ctx); /*list<2106>*/
  return kk_std_core_types__list_box(_x_x1483, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_unroll_map_10010(kk_std_core_types__list xs, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e b, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1478 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1478->head;
    kk_std_core_types__list xx_0 = _con_x1478->tail;
    kk_reuse_t _ru_x1317 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1317 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t x_0_10740;
    kk_function_t _x_x1479 = kk_function_dup(f_0, _ctx); /*(2105) -> 2107 2106*/
    x_0_10740 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x_x1479, (_x_x1479, x, _ctx), _ctx); /*2106*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1317,kk_context());
      kk_box_drop(x_0_10740, _ctx);
      kk_box_t _x_x1480;
      kk_function_t _x_x1481;
      kk_function_dup(f_0, _ctx);
      _x_x1481 = kk_std_core_list__new_trmc_unroll_map_10010_fun1482(_acc_0, f_0, xx_0, _ctx); /*(2400) -> 2402 2401*/
      _x_x1480 = kk_std_core_hnd_yield_extend(_x_x1481, _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1480, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10371_0 = kk_datatype_null(); /*list<2106>*/;
      kk_std_core_types__list _trmc_x10372_0 = kk_std_core_types__new_Cons(_ru_x1317, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0_10740, _trmc_x10371_0, _ctx); /*list<2106>*/;
      kk_field_addr_t _b_x169_175 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10372_0, _ctx)->tail, _ctx); /*@field-addr<list<2106>>*/;
      kk_std_core_types__cctx _own_x1269 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10372_0, _ctx)),_b_x169_175,kk_context()); /*ctx<0>*/;
      { // tailcall
        xs = xx_0;
        _acc_0 = _own_x1269;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_box_t _x_x1484 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1484, KK_OWNED, _ctx);
  }
}
 
// Apply a function `f` to each element of the input list in sequence.

kk_std_core_types__list kk_std_core_list__unroll_map_10010(kk_std_core_types__list xs_0, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e b) -> e list<b> */ 
  kk_std_core_types__cctx _own_x1267 = kk_cctx_empty(kk_context()); /*ctx<0>*/;
  return kk_std_core_list__trmc_unroll_map_10010(xs_0, f_1, _own_x1267, _ctx);
}
 
// lifted local: char/list, @spec-x10290
// specialized: std/core/list/@unroll-map@10010, on parameters @uniq-f@10285, using:
// @uniq-f@10285 = std/core/char/int/char

kk_std_core_types__list kk_std_core_list_char_fs__trmc_lift_list_10346(kk_std_core_types__list _uniq_xs_10284, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (list<int>, ctx<list<char>>) -> list<char> */ 
  if (kk_std_core_types__is_Cons(_uniq_xs_10284, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1485 = kk_std_core_types__as_Cons(_uniq_xs_10284, _ctx);
    kk_box_t _box_x182 = _con_x1485->head;
    kk_std_core_types__list _uniq_xx_10288 = _con_x1485->tail;
    kk_integer_t _uniq_x_10287 = kk_integer_unbox(_box_x182, _ctx);
    kk_reuse_t _ru_x1318 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10284, _ctx)) {
      _ru_x1318 = (kk_datatype_ptr_reuse(_uniq_xs_10284, _ctx));
    }
    else {
      kk_integer_dup(_uniq_x_10287, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10288, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10284, _ctx);
    }
    kk_char_t _trmc_x10373 = kk_integer_clamp32(_uniq_x_10287,kk_context()); /*char*/;
    kk_std_core_types__list _trmc_x10374 = kk_datatype_null(); /*list<char>*/;
    kk_std_core_types__list _trmc_x10375 = kk_std_core_types__new_Cons(_ru_x1318, 0, kk_char_box(_trmc_x10373, _ctx), _trmc_x10374, _ctx); /*list<char>*/;
    kk_field_addr_t _b_x192_197 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10375, _ctx)->tail, _ctx); /*@field-addr<list<char>>*/;
    kk_std_core_types__cctx _brw_x1264;
    kk_std_core_types__cctx _x_x1486 = kk_std_core_types__cctx_dup(_acc, _ctx); /*ctx<list<char>>*/
    _brw_x1264 = kk_cctx_extend_linear(_x_x1486,(kk_std_core_types__list_box(_trmc_x10375, _ctx)),_b_x192_197,kk_context()); /*ctx<0>*/
    kk_std_core_types__list _brw_x1265 = kk_std_core_list_char_fs__trmc_lift_list_10346(_uniq_xx_10288, _brw_x1264, _ctx); /*list<char>*/;
    kk_std_core_types__cctx_drop(_brw_x1264, _ctx);
    return _brw_x1265;
  }
  {
    kk_box_t _x_x1487;
    kk_std_core_types__cctx _x_x1488 = kk_std_core_types__cctx_dup(_acc, _ctx); /*ctx<list<char>>*/
    _x_x1487 = kk_cctx_apply_linear(_x_x1488,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1487, KK_OWNED, _ctx);
  }
}
 
// lifted local: char/list, @spec-x10290
// specialized: std/core/list/@unroll-map@10010, on parameters @uniq-f@10285, using:
// @uniq-f@10285 = std/core/char/int/char

kk_std_core_types__list kk_std_core_list_char_fs__lift_list_10346(kk_std_core_types__list _uniq_xs_10284_0, kk_context_t* _ctx) { /* (list<int>) -> list<char> */ 
  kk_std_core_types__cctx _brw_x1262 = kk_cctx_empty(kk_context()); /*ctx<0>*/;
  kk_std_core_types__list _brw_x1263 = kk_std_core_list_char_fs__trmc_lift_list_10346(_uniq_xs_10284_0, _brw_x1262, _ctx); /*list<char>*/;
  kk_std_core_types__cctx_drop(_brw_x1262, _ctx);
  return _brw_x1263;
}
 
// Create a list of characters from `lo`  to `hi`  (including `hi`).

kk_std_core_types__list kk_std_core_list_char_fs_list(kk_char_t lo, kk_char_t hi, kk_context_t* _ctx) { /* (lo : char, hi : char) -> list<char> */ 
  kk_integer_t lo_0_10745 = kk_integer_from_int(lo,kk_context()); /*int*/;
  kk_integer_t hi_0_10746 = kk_integer_from_int(hi,kk_context()); /*int*/;
  kk_std_core_types__list xs_10070;
  kk_std_core_types__cctx _x_x1489 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  xs_10070 = kk_std_core_list_range_fs__trmc_list(lo_0_10745, hi_0_10746, _x_x1489, _ctx); /*list<int>*/
  if (kk_std_core_types__is_Nil(xs_10070, _ctx)) {
    return kk_std_core_types__new_Nil(_ctx);
  }
  {
    kk_std_core_types__cctx _brw_x1260 = kk_cctx_empty(kk_context()); /*ctx<0>*/;
    kk_std_core_types__list _brw_x1261 = kk_std_core_list_char_fs__trmc_lift_list_10346(xs_10070, _brw_x1260, _ctx); /*list<char>*/;
    kk_std_core_types__cctx_drop(_brw_x1260, _ctx);
    return _brw_x1261;
  }
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list_function_fs__mlift_trmc_list_10669(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t hi, kk_integer_t lo, kk_box_t _trmc_x10376, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, f : (int) -> e a, hi : int, lo : int, a) -> e list<a> */ 
  kk_std_core_types__list _trmc_x10377 = kk_datatype_null(); /*list<1837>*/;
  kk_std_core_types__list _trmc_x10378 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10376, _trmc_x10377, _ctx); /*list<1837>*/;
  kk_field_addr_t _b_x208_211 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10378, _ctx)->tail, _ctx); /*@field-addr<list<1837>>*/;
  kk_integer_t _x_x1490 = kk_integer_add_small_const(lo, 1, _ctx); /*int*/
  kk_std_core_types__cctx _x_x1491 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10378, _ctx)),_b_x208_211,kk_context()); /*ctx<0>*/
  return kk_std_core_list_function_fs__trmc_list(_x_x1490, hi, f, _x_x1491, _ctx);
}
 
// Applies a function `f` to list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.


// lift anonymous function
struct kk_std_core_list_function_fs__trmc_list_fun1495__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_integer_t hi_0;
  kk_integer_t lo_0;
};
static kk_box_t kk_std_core_list_function_fs__trmc_list_fun1495(kk_function_t _fself, kk_box_t _b_x216, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_function_fs__new_trmc_list_fun1495(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_integer_t hi_0, kk_integer_t lo_0, kk_context_t* _ctx) {
  struct kk_std_core_list_function_fs__trmc_list_fun1495__t* _self = kk_function_alloc_as(struct kk_std_core_list_function_fs__trmc_list_fun1495__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_function_fs__trmc_list_fun1495, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->hi_0 = hi_0;
  _self->lo_0 = lo_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_function_fs__trmc_list_fun1495(kk_function_t _fself, kk_box_t _b_x216, kk_context_t* _ctx) {
  struct kk_std_core_list_function_fs__trmc_list_fun1495__t* _self = kk_function_as(struct kk_std_core_list_function_fs__trmc_list_fun1495__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<1837>> */
  kk_function_t f_0 = _self->f_0; /* (int) -> 1838 1837 */
  kk_integer_t hi_0 = _self->hi_0; /* int */
  kk_integer_t lo_0 = _self->lo_0; /* int */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_integer_dup(hi_0, _ctx);kk_integer_dup(lo_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10376_0_234 = _b_x216; /*1837*/;
  kk_std_core_types__list _x_x1496 = kk_std_core_list_function_fs__mlift_trmc_list_10669(_acc_0, f_0, hi_0, lo_0, _trmc_x10376_0_234, _ctx); /*list<1837>*/
  return kk_std_core_types__list_box(_x_x1496, _ctx);
}

kk_std_core_types__list kk_std_core_list_function_fs__trmc_list(kk_integer_t lo_0, kk_integer_t hi_0, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, f : (int) -> e a, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  bool _match_x1258 = kk_integer_lte_borrow(lo_0,hi_0,kk_context()); /*bool*/;
  if (_match_x1258) {
    kk_box_t x_10748;
    kk_function_t _x_x1493 = kk_function_dup(f_0, _ctx); /*(int) -> 1838 1837*/
    kk_integer_t _x_x1492 = kk_integer_dup(lo_0, _ctx); /*int*/
    x_10748 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_context_t*), _x_x1493, (_x_x1493, _x_x1492, _ctx), _ctx); /*1837*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_10748, _ctx);
      kk_box_t _x_x1494 = kk_std_core_hnd_yield_extend(kk_std_core_list_function_fs__new_trmc_list_fun1495(_acc_0, f_0, hi_0, lo_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1494, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10377_0 = kk_datatype_null(); /*list<1837>*/;
      kk_std_core_types__list _trmc_x10378_0 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_10748, _trmc_x10377_0, _ctx); /*list<1837>*/;
      kk_field_addr_t _b_x222_228 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10378_0, _ctx)->tail, _ctx); /*@field-addr<list<1837>>*/;
      { // tailcall
        kk_integer_t _x_x1497 = kk_integer_add_small_const(lo_0, 1, _ctx); /*int*/
        kk_std_core_types__cctx _x_x1498 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10378_0, _ctx)),_b_x222_228,kk_context()); /*ctx<0>*/
        lo_0 = _x_x1497;
        _acc_0 = _x_x1498;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(lo_0, _ctx);
    kk_integer_drop(hi_0, _ctx);
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1499 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1499, KK_OWNED, _ctx);
  }
}
 
// Applies a function `f` to list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_function_fs_list(kk_integer_t lo_1, kk_integer_t hi_1, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, f : (int) -> e a) -> e list<a> */ 
  kk_std_core_types__cctx _x_x1500 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list_function_fs__trmc_list(lo_1, hi_1, f_1, _x_x1500, _ctx);
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_stride_fs__trmc_list(kk_integer_t lo, kk_integer_t hi, kk_integer_t stride, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (lo : int, hi : int, stride : int, ctx<list<int>>) -> list<int> */ 
  kk__tailcall: ;
  bool _match_x1257 = kk_integer_lte_borrow(lo,hi,kk_context()); /*bool*/;
  if (_match_x1257) {
    kk_std_core_types__list _trmc_x10379 = kk_datatype_null(); /*list<int>*/;
    kk_std_core_types__list _trmc_x10380;
    kk_box_t _x_x1501;
    kk_integer_t _x_x1502 = kk_integer_dup(lo, _ctx); /*int*/
    _x_x1501 = kk_integer_box(_x_x1502, _ctx); /*82*/
    _trmc_x10380 = kk_std_core_types__new_Cons(kk_reuse_null, 0, _x_x1501, _trmc_x10379, _ctx); /*list<int>*/
    kk_field_addr_t _b_x244_249 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10380, _ctx)->tail, _ctx); /*@field-addr<list<int>>*/;
    { // tailcall
      kk_integer_t _x_x1503;
      kk_integer_t _x_x1504 = kk_integer_dup(stride, _ctx); /*int*/
      _x_x1503 = kk_integer_add(lo,_x_x1504,kk_context()); /*int*/
      kk_std_core_types__cctx _x_x1505 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10380, _ctx)),_b_x244_249,kk_context()); /*ctx<0>*/
      lo = _x_x1503;
      _acc = _x_x1505;
      goto kk__tailcall;
    }
  }
  {
    kk_integer_drop(stride, _ctx);
    kk_integer_drop(lo, _ctx);
    kk_integer_drop(hi, _ctx);
    kk_box_t _x_x1506 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1506, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_stride_fs_list(kk_integer_t lo_0, kk_integer_t hi_0, kk_integer_t stride_0, kk_context_t* _ctx) { /* (lo : int, hi : int, stride : int) -> list<int> */ 
  kk_std_core_types__cctx _x_x1507 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list_stride_fs__trmc_list(lo_0, hi_0, stride_0, _x_x1507, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list_stridefunction_fs__mlift_trmc_list_10670(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t hi, kk_integer_t lo, kk_integer_t stride, kk_box_t _trmc_x10381, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, f : (int) -> e a, hi : int, lo : int, stride : int, a) -> e list<a> */ 
  kk_std_core_types__list _trmc_x10382 = kk_datatype_null(); /*list<2001>*/;
  kk_std_core_types__list _trmc_x10383 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10381, _trmc_x10382, _ctx); /*list<2001>*/;
  kk_field_addr_t _b_x260_263 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10383, _ctx)->tail, _ctx); /*@field-addr<list<2001>>*/;
  kk_integer_t _x_x1508;
  kk_integer_t _x_x1509 = kk_integer_dup(stride, _ctx); /*int*/
  _x_x1508 = kk_integer_add(lo,_x_x1509,kk_context()); /*int*/
  kk_std_core_types__cctx _x_x1510 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10383, _ctx)),_b_x260_263,kk_context()); /*ctx<0>*/
  return kk_std_core_list_stridefunction_fs__trmc_list(_x_x1508, hi, stride, f, _x_x1510, _ctx);
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.


// lift anonymous function
struct kk_std_core_list_stridefunction_fs__trmc_list_fun1514__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_integer_t hi_0;
  kk_integer_t lo_0;
  kk_integer_t stride_0;
};
static kk_box_t kk_std_core_list_stridefunction_fs__trmc_list_fun1514(kk_function_t _fself, kk_box_t _b_x268, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_stridefunction_fs__new_trmc_list_fun1514(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_integer_t hi_0, kk_integer_t lo_0, kk_integer_t stride_0, kk_context_t* _ctx) {
  struct kk_std_core_list_stridefunction_fs__trmc_list_fun1514__t* _self = kk_function_alloc_as(struct kk_std_core_list_stridefunction_fs__trmc_list_fun1514__t, 7, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_stridefunction_fs__trmc_list_fun1514, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->hi_0 = hi_0;
  _self->lo_0 = lo_0;
  _self->stride_0 = stride_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_stridefunction_fs__trmc_list_fun1514(kk_function_t _fself, kk_box_t _b_x268, kk_context_t* _ctx) {
  struct kk_std_core_list_stridefunction_fs__trmc_list_fun1514__t* _self = kk_function_as(struct kk_std_core_list_stridefunction_fs__trmc_list_fun1514__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2001>> */
  kk_function_t f_0 = _self->f_0; /* (int) -> 2002 2001 */
  kk_integer_t hi_0 = _self->hi_0; /* int */
  kk_integer_t lo_0 = _self->lo_0; /* int */
  kk_integer_t stride_0 = _self->stride_0; /* int */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_integer_dup(hi_0, _ctx);kk_integer_dup(lo_0, _ctx);kk_integer_dup(stride_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10381_0_286 = _b_x268; /*2001*/;
  kk_std_core_types__list _x_x1515 = kk_std_core_list_stridefunction_fs__mlift_trmc_list_10670(_acc_0, f_0, hi_0, lo_0, stride_0, _trmc_x10381_0_286, _ctx); /*list<2001>*/
  return kk_std_core_types__list_box(_x_x1515, _ctx);
}

kk_std_core_types__list kk_std_core_list_stridefunction_fs__trmc_list(kk_integer_t lo_0, kk_integer_t hi_0, kk_integer_t stride_0, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, stride : int, f : (int) -> e a, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  bool _match_x1255 = kk_integer_lte_borrow(lo_0,hi_0,kk_context()); /*bool*/;
  if (_match_x1255) {
    kk_box_t x_10751;
    kk_function_t _x_x1512 = kk_function_dup(f_0, _ctx); /*(int) -> 2002 2001*/
    kk_integer_t _x_x1511 = kk_integer_dup(lo_0, _ctx); /*int*/
    x_10751 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_context_t*), _x_x1512, (_x_x1512, _x_x1511, _ctx), _ctx); /*2001*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_10751, _ctx);
      kk_box_t _x_x1513 = kk_std_core_hnd_yield_extend(kk_std_core_list_stridefunction_fs__new_trmc_list_fun1514(_acc_0, f_0, hi_0, lo_0, stride_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1513, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10382_0 = kk_datatype_null(); /*list<2001>*/;
      kk_std_core_types__list _trmc_x10383_0 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_10751, _trmc_x10382_0, _ctx); /*list<2001>*/;
      kk_field_addr_t _b_x274_280 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10383_0, _ctx)->tail, _ctx); /*@field-addr<list<2001>>*/;
      { // tailcall
        kk_integer_t _x_x1516;
        kk_integer_t _x_x1517 = kk_integer_dup(stride_0, _ctx); /*int*/
        _x_x1516 = kk_integer_add(lo_0,_x_x1517,kk_context()); /*int*/
        kk_std_core_types__cctx _x_x1518 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10383_0, _ctx)),_b_x274_280,kk_context()); /*ctx<0>*/
        lo_0 = _x_x1516;
        _acc_0 = _x_x1518;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(stride_0, _ctx);
    kk_integer_drop(lo_0, _ctx);
    kk_integer_drop(hi_0, _ctx);
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1519 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1519, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core_types__list kk_std_core_list_stridefunction_fs_list(kk_integer_t lo_1, kk_integer_t hi_1, kk_integer_t stride_1, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, stride : int, f : (int) -> e a) -> e list<a> */ 
  kk_std_core_types__cctx _x_x1520 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list_stridefunction_fs__trmc_list(lo_1, hi_1, stride_1, f_1, _x_x1520, _ctx);
}
 
// Apply a function `f` to each character in a string


// lift anonymous function
struct kk_std_core_list_string_fs_map_fun1521__t {
  struct kk_function_s _base;
  kk_function_t f;
};
static kk_box_t kk_std_core_list_string_fs_map_fun1521(kk_function_t _fself, kk_box_t _b_x290, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_string_fs_new_map_fun1521(kk_function_t f, kk_context_t* _ctx) {
  struct kk_std_core_list_string_fs_map_fun1521__t* _self = kk_function_alloc_as(struct kk_std_core_list_string_fs_map_fun1521__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_string_fs_map_fun1521, kk_context());
  _self->f = f;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_string_fs_map_fun1521(kk_function_t _fself, kk_box_t _b_x290, kk_context_t* _ctx) {
  struct kk_std_core_list_string_fs_map_fun1521__t* _self = kk_function_as(struct kk_std_core_list_string_fs_map_fun1521__t*, _fself, _ctx);
  kk_function_t f = _self->f; /* (char) -> 2051 char */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);}, {}, _ctx)
  kk_char_t _x_x1522;
  kk_char_t _x_x1523 = kk_char_unbox(_b_x290, KK_OWNED, _ctx); /*char*/
  _x_x1522 = kk_function_call(kk_char_t, (kk_function_t, kk_char_t, kk_context_t*), f, (f, _x_x1523, _ctx), _ctx); /*char*/
  return kk_char_box(_x_x1522, _ctx);
}


// lift anonymous function
struct kk_std_core_list_string_fs_map_fun1525__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_string_fs_map_fun1525(kk_function_t _fself, kk_box_t _b_x295, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_string_fs_new_map_fun1525(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_string_fs_map_fun1525, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_string_fs_map_fun1525(kk_function_t _fself, kk_box_t _b_x295, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x1526;
  kk_std_core_types__list _x_x1527 = kk_std_core_types__list_unbox(_b_x295, KK_OWNED, _ctx); /*list<char>*/
  _x_x1526 = kk_std_core_string_listchar_fs_string(_x_x1527, _ctx); /*string*/
  return kk_string_box(_x_x1526);
}

kk_string_t kk_std_core_list_string_fs_map(kk_string_t s, kk_function_t f, kk_context_t* _ctx) { /* forall<e> (s : string, f : (char) -> e char) -> e string */ 
  kk_std_core_types__list xs_10074 = kk_std_core_string_list(s, _ctx); /*list<char>*/;
  kk_std_core_types__list x_10754;
  if (kk_std_core_types__is_Nil(xs_10074, _ctx)) {
    kk_function_drop(f, _ctx);
    x_10754 = kk_std_core_types__new_Nil(_ctx); /*list<char>*/
  }
  else {
    kk_std_core_types__cctx _b_x289_293 = kk_cctx_empty(kk_context()); /*ctx<list<char>>*/;
    kk_function_t _brw_x1253 = kk_std_core_list_string_fs_new_map_fun1521(f, _ctx); /*(2105) -> 2107 2106*/;
    kk_std_core_types__list _brw_x1254 = kk_std_core_list__trmc_unroll_map_10010(xs_10074, _brw_x1253, _b_x289_293, _ctx); /*list<2106>*/;
    kk_function_drop(_brw_x1253, _ctx);
    x_10754 = _brw_x1254; /*list<char>*/
  }
  if (kk_yielding(kk_context())) {
    kk_std_core_types__list_drop(x_10754, _ctx);
    kk_box_t _x_x1524 = kk_std_core_hnd_yield_extend(kk_std_core_list_string_fs_new_map_fun1525(_ctx), _ctx); /*2401*/
    return kk_string_unbox(_x_x1524);
  }
  {
    return kk_std_core_string_listchar_fs_string(x_10754, _ctx);
  }
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_unroll_lift_map_indexed_5424_10011_10671(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i_0_10077, kk_std_core_types__list yy, kk_box_t _trmc_x10384, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (idx : int, value : a) -> e b, i@0@10077 : int, yy : list<a>, b) -> e list<b> */ 
  kk_std_core_types__list _trmc_x10385 = kk_datatype_null(); /*list<2199>*/;
  kk_std_core_types__list _trmc_x10386 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10384, _trmc_x10385, _ctx); /*list<2199>*/;
  kk_field_addr_t _b_x302_305 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10386, _ctx)->tail, _ctx); /*@field-addr<list<2199>>*/;
  kk_std_core_types__cctx _x_x1528 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10386, _ctx)),_b_x302_305,kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_lift_map_indexed_5424_10011(f, yy, i_0_10077, _x_x1528, _ctx);
}
 
// lifted local: map-indexed, map-idx


// lift anonymous function
struct kk_std_core_list__trmc_unroll_lift_map_indexed_5424_10011_fun1533__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_integer_t i_0_10077_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__trmc_unroll_lift_map_indexed_5424_10011_fun1533(kk_function_t _fself, kk_box_t _b_x310, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_unroll_lift_map_indexed_5424_10011_fun1533(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_integer_t i_0_10077_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_lift_map_indexed_5424_10011_fun1533__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_unroll_lift_map_indexed_5424_10011_fun1533__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_unroll_lift_map_indexed_5424_10011_fun1533, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->i_0_10077_0 = i_0_10077_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_unroll_lift_map_indexed_5424_10011_fun1533(kk_function_t _fself, kk_box_t _b_x310, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_lift_map_indexed_5424_10011_fun1533__t* _self = kk_function_as(struct kk_std_core_list__trmc_unroll_lift_map_indexed_5424_10011_fun1533__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2199>> */
  kk_function_t f_0 = _self->f_0; /* (idx : int, value : 2198) -> 2200 2199 */
  kk_integer_t i_0_10077_0 = _self->i_0_10077_0; /* int */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<2198> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_integer_dup(i_0_10077_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10384_0_328 = _b_x310; /*2199*/;
  kk_std_core_types__list _x_x1534 = kk_std_core_list__mlift_trmc_unroll_lift_map_indexed_5424_10011_10671(_acc_0, f_0, i_0_10077_0, yy_0, _trmc_x10384_0_328, _ctx); /*list<2199>*/
  return kk_std_core_types__list_box(_x_x1534, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_unroll_lift_map_indexed_5424_10011(kk_function_t f_0, kk_std_core_types__list ys, kk_integer_t i, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a) -> e b, ys : list<a>, i : int, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1529 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1529->head;
    kk_std_core_types__list yy_0 = _con_x1529->tail;
    kk_reuse_t _ru_x1319 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1319 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy_0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_integer_t i_0_10077_0;
    kk_integer_t _x_x1530 = kk_integer_dup(i, _ctx); /*int*/
    i_0_10077_0 = kk_integer_add_small_const(_x_x1530, 1, _ctx); /*int*/
    kk_box_t x_10758;
    kk_function_t _x_x1531 = kk_function_dup(f_0, _ctx); /*(idx : int, value : 2198) -> 2200 2199*/
    x_10758 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x_x1531, (_x_x1531, i, y, _ctx), _ctx); /*2199*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1319,kk_context());
      kk_box_drop(x_10758, _ctx);
      kk_box_t _x_x1532 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_unroll_lift_map_indexed_5424_10011_fun1533(_acc_0, f_0, i_0_10077_0, yy_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1532, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10385_0 = kk_datatype_null(); /*list<2199>*/;
      kk_std_core_types__list _trmc_x10386_0 = kk_std_core_types__new_Cons(_ru_x1319, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_10758, _trmc_x10385_0, _ctx); /*list<2199>*/;
      kk_field_addr_t _b_x316_322 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10386_0, _ctx)->tail, _ctx); /*@field-addr<list<2199>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1535 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10386_0, _ctx)),_b_x316_322,kk_context()); /*ctx<0>*/
        ys = yy_0;
        i = i_0_10077_0;
        _acc_0 = _x_x1535;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(i, _ctx);
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1536 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1536, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-indexed, map-idx

kk_std_core_types__list kk_std_core_list__unroll_lift_map_indexed_5424_10011(kk_function_t f_1, kk_std_core_types__list ys_0, kk_integer_t i_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a) -> e b, ys : list<a>, i : int) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1537 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_lift_map_indexed_5424_10011(f_1, ys_0, i_0, _x_x1537, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_unroll_lift_map_peek_5425_10012_10672(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core_types__list yy, kk_box_t _trmc_x10387, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (value : a, rest : list<a>) -> e b, yy : list<a>, b) -> e list<b> */ 
  kk_std_core_types__list _trmc_x10388 = kk_datatype_null(); /*list<2257>*/;
  kk_std_core_types__list _trmc_x10389 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10387, _trmc_x10388, _ctx); /*list<2257>*/;
  kk_field_addr_t _b_x334_337 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10389, _ctx)->tail, _ctx); /*@field-addr<list<2257>>*/;
  kk_std_core_types__cctx _x_x1540 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10389, _ctx)),_b_x334_337,kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_lift_map_peek_5425_10012(f, yy, _x_x1540, _ctx);
}
 
// lifted local: map-peek, mappeek


// lift anonymous function
struct kk_std_core_list__trmc_unroll_lift_map_peek_5425_10012_fun1545__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__trmc_unroll_lift_map_peek_5425_10012_fun1545(kk_function_t _fself, kk_box_t _b_x342, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_unroll_lift_map_peek_5425_10012_fun1545(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_lift_map_peek_5425_10012_fun1545__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_unroll_lift_map_peek_5425_10012_fun1545__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_unroll_lift_map_peek_5425_10012_fun1545, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_unroll_lift_map_peek_5425_10012_fun1545(kk_function_t _fself, kk_box_t _b_x342, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_lift_map_peek_5425_10012_fun1545__t* _self = kk_function_as(struct kk_std_core_list__trmc_unroll_lift_map_peek_5425_10012_fun1545__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2257>> */
  kk_function_t f_0 = _self->f_0; /* (value : 2256, rest : list<2256>) -> 2258 2257 */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<2256> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10387_0_360 = _b_x342; /*2257*/;
  kk_std_core_types__list _x_x1546 = kk_std_core_list__mlift_trmc_unroll_lift_map_peek_5425_10012_10672(_acc_0, f_0, yy_0, _trmc_x10387_0_360, _ctx); /*list<2257>*/
  return kk_std_core_types__list_box(_x_x1546, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_unroll_lift_map_peek_5425_10012(kk_function_t f_0, kk_std_core_types__list ys, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (value : a, rest : list<a>) -> e b, ys : list<a>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1541 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1541->head;
    kk_std_core_types__list yy_0 = _con_x1541->tail;
    kk_reuse_t _ru_x1320 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1320 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy_0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_box_t x_10767;
    kk_function_t _x_x1543 = kk_function_dup(f_0, _ctx); /*(value : 2256, rest : list<2256>) -> 2258 2257*/
    kk_std_core_types__list _x_x1542 = kk_std_core_types__list_dup(yy_0, _ctx); /*list<2256>*/
    x_10767 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_std_core_types__list, kk_context_t*), _x_x1543, (_x_x1543, y, _x_x1542, _ctx), _ctx); /*2257*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1320,kk_context());
      kk_box_drop(x_10767, _ctx);
      kk_box_t _x_x1544 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_unroll_lift_map_peek_5425_10012_fun1545(_acc_0, f_0, yy_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1544, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10388_0 = kk_datatype_null(); /*list<2257>*/;
      kk_std_core_types__list _trmc_x10389_0 = kk_std_core_types__new_Cons(_ru_x1320, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_10767, _trmc_x10388_0, _ctx); /*list<2257>*/;
      kk_field_addr_t _b_x348_354 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10389_0, _ctx)->tail, _ctx); /*@field-addr<list<2257>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1547 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10389_0, _ctx)),_b_x348_354,kk_context()); /*ctx<0>*/
        ys = yy_0;
        _acc_0 = _x_x1547;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1548 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1548, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-peek, mappeek

kk_std_core_types__list kk_std_core_list__unroll_lift_map_peek_5425_10012(kk_function_t f_1, kk_std_core_types__list ys_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (value : a, rest : list<a>) -> e b, ys : list<a>) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1549 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_lift_map_peek_5425_10012(f_1, ys_0, _x_x1549, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_unroll_lift_map_indexed_peek_5426_10013_10673(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i_0_10085, kk_std_core_types__list yy, kk_box_t _trmc_x10390, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (idx : int, value : a, rest : list<a>) -> e b, i@0@10085 : int, yy : list<a>, b) -> e list<b> */ 
  kk_std_core_types__list _trmc_x10391 = kk_datatype_null(); /*list<2323>*/;
  kk_std_core_types__list _trmc_x10392 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10390, _trmc_x10391, _ctx); /*list<2323>*/;
  kk_field_addr_t _b_x366_369 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10392, _ctx)->tail, _ctx); /*@field-addr<list<2323>>*/;
  kk_std_core_types__cctx _x_x1552 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10392, _ctx)),_b_x366_369,kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_lift_map_indexed_peek_5426_10013(f, yy, i_0_10085, _x_x1552, _ctx);
}
 
// lifted local: map-indexed-peek, mapidx


// lift anonymous function
struct kk_std_core_list__trmc_unroll_lift_map_indexed_peek_5426_10013_fun1558__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_integer_t i_0_10085_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__trmc_unroll_lift_map_indexed_peek_5426_10013_fun1558(kk_function_t _fself, kk_box_t _b_x374, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_unroll_lift_map_indexed_peek_5426_10013_fun1558(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_integer_t i_0_10085_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_lift_map_indexed_peek_5426_10013_fun1558__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_unroll_lift_map_indexed_peek_5426_10013_fun1558__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_unroll_lift_map_indexed_peek_5426_10013_fun1558, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->i_0_10085_0 = i_0_10085_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_unroll_lift_map_indexed_peek_5426_10013_fun1558(kk_function_t _fself, kk_box_t _b_x374, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_lift_map_indexed_peek_5426_10013_fun1558__t* _self = kk_function_as(struct kk_std_core_list__trmc_unroll_lift_map_indexed_peek_5426_10013_fun1558__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2323>> */
  kk_function_t f_0 = _self->f_0; /* (idx : int, value : 2322, rest : list<2322>) -> 2324 2323 */
  kk_integer_t i_0_10085_0 = _self->i_0_10085_0; /* int */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<2322> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_integer_dup(i_0_10085_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10390_0_392 = _b_x374; /*2323*/;
  kk_std_core_types__list _x_x1559 = kk_std_core_list__mlift_trmc_unroll_lift_map_indexed_peek_5426_10013_10673(_acc_0, f_0, i_0_10085_0, yy_0, _trmc_x10390_0_392, _ctx); /*list<2323>*/
  return kk_std_core_types__list_box(_x_x1559, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_unroll_lift_map_indexed_peek_5426_10013(kk_function_t f_0, kk_std_core_types__list ys, kk_integer_t i, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a, rest : list<a>) -> e b, ys : list<a>, i : int, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1553 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1553->head;
    kk_std_core_types__list yy_0 = _con_x1553->tail;
    kk_reuse_t _ru_x1321 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1321 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy_0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_integer_t i_0_10085_0;
    kk_integer_t _x_x1554 = kk_integer_dup(i, _ctx); /*int*/
    i_0_10085_0 = kk_integer_add_small_const(_x_x1554, 1, _ctx); /*int*/
    kk_box_t x_10774;
    kk_function_t _x_x1556 = kk_function_dup(f_0, _ctx); /*(idx : int, value : 2322, rest : list<2322>) -> 2324 2323*/
    kk_std_core_types__list _x_x1555 = kk_std_core_types__list_dup(yy_0, _ctx); /*list<2322>*/
    x_10774 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_std_core_types__list, kk_context_t*), _x_x1556, (_x_x1556, i, y, _x_x1555, _ctx), _ctx); /*2323*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1321,kk_context());
      kk_box_drop(x_10774, _ctx);
      kk_box_t _x_x1557 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_unroll_lift_map_indexed_peek_5426_10013_fun1558(_acc_0, f_0, i_0_10085_0, yy_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1557, KK_OWNED, _ctx);
    }
    {
      kk_std_core_types__list _trmc_x10391_0 = kk_datatype_null(); /*list<2323>*/;
      kk_std_core_types__list _trmc_x10392_0 = kk_std_core_types__new_Cons(_ru_x1321, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_10774, _trmc_x10391_0, _ctx); /*list<2323>*/;
      kk_field_addr_t _b_x380_386 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10392_0, _ctx)->tail, _ctx); /*@field-addr<list<2323>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1560 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10392_0, _ctx)),_b_x380_386,kk_context()); /*ctx<0>*/
        ys = yy_0;
        i = i_0_10085_0;
        _acc_0 = _x_x1560;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(i, _ctx);
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1561 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1561, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-indexed-peek, mapidx

kk_std_core_types__list kk_std_core_list__unroll_lift_map_indexed_peek_5426_10013(kk_function_t f_1, kk_std_core_types__list ys_0, kk_integer_t i_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a, rest : list<a>) -> e b, ys : list<a>, i : int) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1562 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_lift_map_indexed_peek_5426_10013(f_1, ys_0, i_0, _x_x1562, _ctx);
}
 
// Create a list of `n` repeated elements `x`

kk_std_core_types__list kk_std_core_list__trmc_replicate(kk_box_t x, kk_integer_t n, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (x : a, n : int, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  bool _match_x1248 = kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_x1248) {
    kk_std_core_types__list _trmc_x10393 = kk_datatype_null(); /*list<2377>*/;
    kk_std_core_types__list _trmc_x10394;
    kk_box_t _x_x1565 = kk_box_dup(x, _ctx); /*2377*/
    _trmc_x10394 = kk_std_core_types__new_Cons(kk_reuse_null, 0, _x_x1565, _trmc_x10393, _ctx); /*list<2377>*/
    kk_field_addr_t _b_x398_403 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10394, _ctx)->tail, _ctx); /*@field-addr<list<2377>>*/;
    { // tailcall
      kk_integer_t _x_x1566 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
      kk_std_core_types__cctx _x_x1567 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10394, _ctx)),_b_x398_403,kk_context()); /*ctx<0>*/
      n = _x_x1566;
      _acc = _x_x1567;
      goto kk__tailcall;
    }
  }
  {
    kk_box_drop(x, _ctx);
    kk_integer_drop(n, _ctx);
    kk_box_t _x_x1568 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1568, KK_OWNED, _ctx);
  }
}
 
// Create a list of `n` repeated elements `x`

kk_std_core_types__list kk_std_core_list_replicate(kk_box_t x_0, kk_integer_t n_0, kk_context_t* _ctx) { /* forall<a> (x : a, n : int) -> list<a> */ 
  kk_std_core_types__cctx _x_x1569 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_replicate(x_0, n_0, _x_x1569, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_lift_remove_10347_10674(kk_std_core_types__cctx _acc, kk_box_t _uniq_x_10294, kk_std_core_types__list _uniq_xx_10295, kk_function_t pred, bool _y_x10518, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, a, list<a>, pred : (a) -> e bool, bool) -> e list<a> */ 
  if (_y_x10518) {
    kk_box_drop(_uniq_x_10294, _ctx);
    return kk_std_core_list__trmc_lift_remove_10347(pred, _uniq_xx_10295, _acc, _ctx);
  }
  {
    kk_std_core_types__list _trmc_x10395 = kk_datatype_null(); /*list<2415>*/;
    kk_std_core_types__list _trmc_x10396 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _uniq_x_10294, _trmc_x10395, _ctx); /*list<2415>*/;
    kk_field_addr_t _b_x414_417 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10396, _ctx)->tail, _ctx); /*@field-addr<list<2415>>*/;
    kk_std_core_types__cctx _x_x1570 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10396, _ctx)),_b_x414_417,kk_context()); /*ctx<0>*/
    return kk_std_core_list__trmc_lift_remove_10347(pred, _uniq_xx_10295, _x_x1570, _ctx);
  }
}
 
// lifted local: remove, @spec-x10299
// specialized: std/core/list/@unroll-filter@10007, on parameters @uniq-pred@10292, using:
// @uniq-pred@10292 = fn<(e :: E)>(x: 2415){
//   std/core/types/@open<(total :: E),(e :: E),(b : bool) -> bool,(b : bool) -> (e :: E) bool>((fn(b: bool){
//     (match (b) {
//       ((std/core/types/True() : bool ) as @pat@0: bool)
//          -> std/core/types/False;
//       ((@skip std/core/types/False() : bool ) as @pat@0@0: bool)
//          -> std/core/types/True;
//     });
//   }))((pred(x)));
// }


// lift anonymous function
struct kk_std_core_list__trmc_lift_remove_10347_fun1575__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_box_t _uniq_x_10294_0;
  kk_std_core_types__list _uniq_xx_10295_0;
  kk_function_t pred_0;
};
static kk_box_t kk_std_core_list__trmc_lift_remove_10347_fun1575(kk_function_t _fself, kk_box_t _b_x422, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_lift_remove_10347_fun1575(kk_std_core_types__cctx _acc_0, kk_box_t _uniq_x_10294_0, kk_std_core_types__list _uniq_xx_10295_0, kk_function_t pred_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_remove_10347_fun1575__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_lift_remove_10347_fun1575__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_lift_remove_10347_fun1575, kk_context());
  _self->_acc_0 = _acc_0;
  _self->_uniq_x_10294_0 = _uniq_x_10294_0;
  _self->_uniq_xx_10295_0 = _uniq_xx_10295_0;
  _self->pred_0 = pred_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_lift_remove_10347_fun1575(kk_function_t _fself, kk_box_t _b_x422, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_remove_10347_fun1575__t* _self = kk_function_as(struct kk_std_core_list__trmc_lift_remove_10347_fun1575__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2415>> */
  kk_box_t _uniq_x_10294_0 = _self->_uniq_x_10294_0; /* 2415 */
  kk_std_core_types__list _uniq_xx_10295_0 = _self->_uniq_xx_10295_0; /* list<2415> */
  kk_function_t pred_0 = _self->pred_0; /* (2415) -> 2416 bool */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_box_dup(_uniq_x_10294_0, _ctx);kk_std_core_types__list_dup(_uniq_xx_10295_0, _ctx);kk_function_dup(pred_0, _ctx);}, {}, _ctx)
  bool _y_x10518_0_440 = kk_bool_unbox(_b_x422); /*bool*/;
  kk_std_core_types__list _x_x1576 = kk_std_core_list__mlift_trmc_lift_remove_10347_10674(_acc_0, _uniq_x_10294_0, _uniq_xx_10295_0, pred_0, _y_x10518_0_440, _ctx); /*list<2415>*/
  return kk_std_core_types__list_box(_x_x1576, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_lift_remove_10347(kk_function_t pred_0, kk_std_core_types__list _uniq_xs_10291, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,e> (pred : (a) -> e bool, list<a>, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(_uniq_xs_10291, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1571 = kk_std_core_types__as_Cons(_uniq_xs_10291, _ctx);
    kk_box_t _uniq_x_10294_0 = _con_x1571->head;
    kk_std_core_types__list _uniq_xx_10295_0 = _con_x1571->tail;
    kk_reuse_t _ru_x1322 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10291, _ctx)) {
      _ru_x1322 = (kk_datatype_ptr_reuse(_uniq_xs_10291, _ctx));
    }
    else {
      kk_box_dup(_uniq_x_10294_0, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10295_0, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10291, _ctx);
    }
    bool x_10783;
    kk_function_t _x_x1573 = kk_function_dup(pred_0, _ctx); /*(2415) -> 2416 bool*/
    kk_box_t _x_x1572 = kk_box_dup(_uniq_x_10294_0, _ctx); /*2415*/
    x_10783 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1573, (_x_x1573, _x_x1572, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1322,kk_context());
      kk_box_t _x_x1574 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_lift_remove_10347_fun1575(_acc_0, _uniq_x_10294_0, _uniq_xx_10295_0, pred_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1574, KK_OWNED, _ctx);
    }
    if (x_10783) {
      kk_reuse_drop(_ru_x1322,kk_context());
      kk_box_drop(_uniq_x_10294_0, _ctx);
      { // tailcall
        _uniq_xs_10291 = _uniq_xx_10295_0;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core_types__list _trmc_x10395_0 = kk_datatype_null(); /*list<2415>*/;
      kk_std_core_types__list _trmc_x10396_0 = kk_std_core_types__new_Cons(_ru_x1322, kk_field_index_of(struct kk_std_core_types_Cons, tail), _uniq_x_10294_0, _trmc_x10395_0, _ctx); /*list<2415>*/;
      kk_field_addr_t _b_x428_434 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10396_0, _ctx)->tail, _ctx); /*@field-addr<list<2415>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1577 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10396_0, _ctx)),_b_x428_434,kk_context()); /*ctx<0>*/
        _uniq_xs_10291 = _uniq_xx_10295_0;
        _acc_0 = _x_x1577;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(pred_0, _ctx);
    kk_box_t _x_x1578 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1578, KK_OWNED, _ctx);
  }
}
 
// lifted local: remove, @spec-x10299
// specialized: std/core/list/@unroll-filter@10007, on parameters @uniq-pred@10292, using:
// @uniq-pred@10292 = fn<(e :: E)>(x: 2415){
//   std/core/types/@open<(total :: E),(e :: E),(b : bool) -> bool,(b : bool) -> (e :: E) bool>((fn(b: bool){
//     (match (b) {
//       ((std/core/types/True() : bool ) as @pat@0: bool)
//          -> std/core/types/False;
//       ((@skip std/core/types/False() : bool ) as @pat@0@0: bool)
//          -> std/core/types/True;
//     });
//   }))((pred(x)));
// }

kk_std_core_types__list kk_std_core_list__lift_remove_10347(kk_function_t pred_1, kk_std_core_types__list _uniq_xs_10291_0, kk_context_t* _ctx) { /* forall<a,e> (pred : (a) -> e bool, list<a>) -> e list<a> */ 
  kk_std_core_types__cctx _x_x1579 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_remove_10347(pred_1, _uniq_xs_10291_0, _x_x1579, _ctx);
}
 
// monadic lift

kk_std_core_types__tuple2 kk_std_core_list__mlift_unroll_partition_acc_10014_10675(kk_std_core_types__cctx acc1, kk_std_core_types__cctx acc2, kk_function_t pred, kk_box_t x, kk_std_core_types__list xx, bool _y_x10526, kk_context_t* _ctx) { /* forall<a,e> (acc1 : ctx<list<a>>, acc2 : ctx<list<a>>, pred : (a) -> e bool, x : a, xx : list<a>, bool) -> e (list<a>, list<a>) */ 
  if (_y_x10526) {
    kk_std_core_types__list _cctx_x2510;
    kk_std_core_types__list _x_x1581 = kk_datatype_null(); /*list<2566>*/
    _cctx_x2510 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _x_x1581, _ctx); /*list<2566>*/
    kk_field_addr_t _cctx_x2511 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x2510, _ctx)->tail, _ctx); /*@field-addr<list<2566>>*/;
    kk_std_core_types__list _b_x447_457 = _cctx_x2510; /*list<2566>*/;
    kk_field_addr_t _b_x448_458 = _cctx_x2511; /*@field-addr<list<2566>>*/;
    kk_std_core_types__cctx _own_x1245;
    kk_std_core_types__cctx _x_x1582 = kk_cctx_create((kk_std_core_types__list_box(_b_x447_457, _ctx)),_b_x448_458,kk_context()); /*cctx<0,1>*/
    _own_x1245 = kk_cctx_compose(acc1,_x_x1582,kk_context()); /*cctx<398,400>*/
    kk_std_core_types__tuple2 _brw_x1246 = kk_std_core_list__unroll_partition_acc_10014(xx, pred, _own_x1245, acc2, _ctx); /*(list<2566>, list<2566>)*/;
    kk_function_drop(pred, _ctx);
    return _brw_x1246;
  }
  {
    kk_std_core_types__list _cctx_x2553;
    kk_std_core_types__list _x_x1583 = kk_datatype_null(); /*list<2566>*/
    _cctx_x2553 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _x_x1583, _ctx); /*list<2566>*/
    kk_field_addr_t _cctx_x2554 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x2553, _ctx)->tail, _ctx); /*@field-addr<list<2566>>*/;
    kk_std_core_types__list _b_x455_459 = _cctx_x2553; /*list<2566>*/;
    kk_field_addr_t _b_x456_460 = _cctx_x2554; /*@field-addr<list<2566>>*/;
    kk_std_core_types__cctx _own_x1243;
    kk_std_core_types__cctx _x_x1584 = kk_cctx_create((kk_std_core_types__list_box(_b_x455_459, _ctx)),_b_x456_460,kk_context()); /*cctx<0,1>*/
    _own_x1243 = kk_cctx_compose(acc2,_x_x1584,kk_context()); /*cctx<398,400>*/
    kk_std_core_types__tuple2 _brw_x1244 = kk_std_core_list__unroll_partition_acc_10014(xx, pred, acc1, _own_x1243, _ctx); /*(list<2566>, list<2566>)*/;
    kk_function_drop(pred, _ctx);
    return _brw_x1244;
  }
}


// lift anonymous function
struct kk_std_core_list__unroll_partition_acc_10014_fun1592__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx acc1_0;
  kk_std_core_types__cctx acc2_0;
  kk_function_t pred_0;
  kk_box_t x_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__unroll_partition_acc_10014_fun1592(kk_function_t _fself, kk_box_t _b_x468, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_unroll_partition_acc_10014_fun1592(kk_std_core_types__cctx acc1_0, kk_std_core_types__cctx acc2_0, kk_function_t pred_0, kk_box_t x_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_partition_acc_10014_fun1592__t* _self = kk_function_alloc_as(struct kk_std_core_list__unroll_partition_acc_10014_fun1592__t, 8, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__unroll_partition_acc_10014_fun1592, kk_context());
  _self->acc1_0 = acc1_0;
  _self->acc2_0 = acc2_0;
  _self->pred_0 = pred_0;
  _self->x_0 = x_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__unroll_partition_acc_10014_fun1592(kk_function_t _fself, kk_box_t _b_x468, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_partition_acc_10014_fun1592__t* _self = kk_function_as(struct kk_std_core_list__unroll_partition_acc_10014_fun1592__t*, _fself, _ctx);
  kk_std_core_types__cctx acc1_0 = _self->acc1_0; /* ctx<list<2566>> */
  kk_std_core_types__cctx acc2_0 = _self->acc2_0; /* ctx<list<2566>> */
  kk_function_t pred_0 = _self->pred_0; /* (2566) -> 2567 bool */
  kk_box_t x_0 = _self->x_0; /* 2566 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<2566> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(acc1_0, _ctx);kk_std_core_types__cctx_dup(acc2_0, _ctx);kk_function_dup(pred_0, _ctx);kk_box_dup(x_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10526_0_496 = kk_bool_unbox(_b_x468); /*bool*/;
  kk_std_core_types__tuple2 _x_x1593 = kk_std_core_list__mlift_unroll_partition_acc_10014_10675(acc1_0, acc2_0, pred_0, x_0, xx_0, _y_x10526_0_496, _ctx); /*(list<2566>, list<2566>)*/
  return kk_std_core_types__tuple2_box(_x_x1593, _ctx);
}

kk_std_core_types__tuple2 kk_std_core_list__unroll_partition_acc_10014(kk_std_core_types__list xs, kk_function_t pred_0, kk_std_core_types__cctx acc1_0, kk_std_core_types__cctx acc2_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool, acc1 : ctx<list<a>>, acc2 : ctx<list<a>>) -> e (list<a>, list<a>) */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_std_core_types__list _b_x465_485;
    kk_box_t _x_x1585 = kk_cctx_apply(acc1_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x465_485 = kk_std_core_types__list_unbox(_x_x1585, KK_OWNED, _ctx); /*list<2566>*/
    kk_std_core_types__list _b_x466_486;
    kk_box_t _x_x1586 = kk_cctx_apply(acc2_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x466_486 = kk_std_core_types__list_unbox(_x_x1586, KK_OWNED, _ctx); /*list<2566>*/
    return kk_std_core_types__new_Tuple2(kk_std_core_types__list_box(_b_x465_485, _ctx), kk_std_core_types__list_box(_b_x466_486, _ctx), _ctx);
  }
  {
    struct kk_std_core_types_Cons* _con_x1587 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x_0 = _con_x1587->head;
    kk_std_core_types__list xx_0 = _con_x1587->tail;
    kk_reuse_t _ru_x1323 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1323 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x_0, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_1_10788;
    kk_function_t _x_x1589 = kk_function_dup(pred_0, _ctx); /*(2566) -> 2567 bool*/
    kk_box_t _x_x1588 = kk_box_dup(x_0, _ctx); /*2566*/
    x_1_10788 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1589, (_x_x1589, _x_x1588, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1323,kk_context());
      kk_box_t _x_x1590;
      kk_function_t _x_x1591;
      kk_function_dup(pred_0, _ctx);
      _x_x1591 = kk_std_core_list__new_unroll_partition_acc_10014_fun1592(acc1_0, acc2_0, pred_0, x_0, xx_0, _ctx); /*(2400) -> 2402 2401*/
      _x_x1590 = kk_std_core_hnd_yield_extend(_x_x1591, _ctx); /*2401*/
      return kk_std_core_types__tuple2_unbox(_x_x1590, KK_OWNED, _ctx);
    }
    if (x_1_10788) {
      kk_std_core_types__list _cctx_x2510_0;
      kk_std_core_types__list _x_x1594 = kk_datatype_null(); /*list<2566>*/
      _cctx_x2510_0 = kk_std_core_types__new_Cons(_ru_x1323, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0, _x_x1594, _ctx); /*list<2566>*/
      kk_field_addr_t _cctx_x2511_0 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x2510_0, _ctx)->tail, _ctx); /*@field-addr<list<2566>>*/;
      kk_std_core_types__list _b_x475_492 = _cctx_x2510_0; /*list<2566>*/;
      kk_field_addr_t _b_x476_493 = _cctx_x2511_0; /*@field-addr<list<2566>>*/;
      kk_std_core_types__cctx _own_x1242;
      kk_std_core_types__cctx _x_x1595 = kk_cctx_create((kk_std_core_types__list_box(_b_x475_492, _ctx)),_b_x476_493,kk_context()); /*cctx<0,1>*/
      _own_x1242 = kk_cctx_compose(acc1_0,_x_x1595,kk_context()); /*cctx<398,400>*/
      { // tailcall
        xs = xx_0;
        acc1_0 = _own_x1242;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core_types__list _cctx_x2553_0;
      kk_std_core_types__list _x_x1596 = kk_datatype_null(); /*list<2566>*/
      _cctx_x2553_0 = kk_std_core_types__new_Cons(_ru_x1323, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0, _x_x1596, _ctx); /*list<2566>*/
      kk_field_addr_t _cctx_x2554_0 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x2553_0, _ctx)->tail, _ctx); /*@field-addr<list<2566>>*/;
      kk_std_core_types__list _b_x483_494 = _cctx_x2553_0; /*list<2566>*/;
      kk_field_addr_t _b_x484_495 = _cctx_x2554_0; /*@field-addr<list<2566>>*/;
      kk_std_core_types__cctx _own_x1241;
      kk_std_core_types__cctx _x_x1597 = kk_cctx_create((kk_std_core_types__list_box(_b_x483_494, _ctx)),_b_x484_495,kk_context()); /*cctx<0,1>*/
      _own_x1241 = kk_cctx_compose(acc2_0,_x_x1597,kk_context()); /*cctx<398,400>*/
      { // tailcall
        xs = xx_0;
        acc2_0 = _own_x1241;
        goto kk__tailcall;
      }
    }
  }
}
 
// Partition a list in two lists where the first list contains
// those elements that satisfy the given predicate `pred`.
// For example: `partition([1,2,3],odd?) == ([1,3],[2])`

kk_std_core_types__tuple2 kk_std_core_list_partition(kk_std_core_types__list xs, kk_function_t pred, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool) -> e (list<a>, list<a>) */ 
  kk_std_core_types__cctx acc1_10094 = kk_cctx_empty(kk_context()); /*ctx<list<2610>>*/;
  kk_std_core_types__cctx acc2_10095 = kk_cctx_empty(kk_context()); /*ctx<list<2610>>*/;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_std_core_types__list _b_x513_515;
    kk_box_t _x_x1600 = kk_cctx_apply(acc1_10094,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x513_515 = kk_std_core_types__list_unbox(_x_x1600, KK_OWNED, _ctx); /*list<2610>*/
    kk_std_core_types__list _b_x514_516;
    kk_box_t _x_x1601 = kk_cctx_apply(acc2_10095,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x514_516 = kk_std_core_types__list_unbox(_x_x1601, KK_OWNED, _ctx); /*list<2610>*/
    return kk_std_core_types__new_Tuple2(kk_std_core_types__list_box(_b_x513_515, _ctx), kk_std_core_types__list_box(_b_x514_516, _ctx), _ctx);
  }
  {
    return kk_std_core_list__unroll_partition_acc_10014(xs, pred, acc1_10094, acc2_10095, _ctx);
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core_list__mlift_lift_lookup_10348_10676(kk_std_core_types__tuple2 _uniq_x_10305, kk_std_core_types__list _uniq_xx_10306, kk_function_t pred, bool _y_x10535, kk_context_t* _ctx) { /* forall<a,b,e> ((a, b), list<(a, b)>, pred : (a) -> e bool, bool) -> e maybe<b> */ 
  if (_y_x10535) {
    kk_function_drop(pred, _ctx);
    kk_std_core_types__list_drop(_uniq_xx_10306, _ctx);
    kk_box_t _x_x1602;
    {
      kk_box_t _x_0 = _uniq_x_10305.snd;
      kk_box_dup(_x_0, _ctx);
      kk_std_core_types__tuple2_drop(_uniq_x_10305, _ctx);
      _x_x1602 = _x_0; /*2742*/
    }
    return kk_std_core_types__new_Just(_x_x1602, _ctx);
  }
  {
    kk_std_core_types__tuple2_drop(_uniq_x_10305, _ctx);
    return kk_std_core_list__lift_lookup_10348(pred, _uniq_xx_10306, _ctx);
  }
}
 
// lifted local: lookup, @spec-x10309
// specialized: std/core/list/@unroll-foreach-while@10009, on parameters @uniq-action@10302, using:
// @uniq-action@10302 = fn<(e :: E)>(kv: (2741, 2742)){
//   match ((pred((std/core/types/@open<(total :: E),(e :: E),(tuple2 : (a, b)) -> a,(tuple2 : (a, b)) -> (e :: E) a>((fn(tuple2: (2741, 2742)){
//     (match (tuple2) {
//       ((@skip std/core/types/Tuple2((@x: 2741) : a, (@pat@0@0: 2742) : a) : (a, b) ) as @pat@1: (2741, 2742))
//          -> @x;
//     });
//   }))(kv))))) {
//     ((std/core/types/True() : bool ) as @pat@2: bool)
//        -> std/core/types/Just<a>((std/core/types/@open<(total :: E),(e :: E),(tuple2 : (a, b)) -> b,(tuple2 : (a, b)) -> (e :: E) b>((fn(tuple2@0: (2741, 2742)){
//         (match (tuple2@0) {
//           ((@skip std/core/types/Tuple2((@pat@0@1: 2741) : a, (@x@0: 2742) : a) : (a, b) ) as @pat@3: (2741, 2742))
//              -> @x@0;
//         });
//       }))(kv)));
//     ((@skip std/core/types/False() : bool ) as @pat@0@2: bool)
//        -> std/core/types/Nothing<a>;
//   };
// }


// lift anonymous function
struct kk_std_core_list__lift_lookup_10348_fun1607__t {
  struct kk_function_s _base;
  kk_std_core_types__tuple2 _uniq_x_10305_0;
  kk_std_core_types__list _uniq_xx_10306_0;
  kk_function_t pred_0;
};
static kk_box_t kk_std_core_list__lift_lookup_10348_fun1607(kk_function_t _fself, kk_box_t _b_x523, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_lift_lookup_10348_fun1607(kk_std_core_types__tuple2 _uniq_x_10305_0, kk_std_core_types__list _uniq_xx_10306_0, kk_function_t pred_0, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_lookup_10348_fun1607__t* _self = kk_function_alloc_as(struct kk_std_core_list__lift_lookup_10348_fun1607__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__lift_lookup_10348_fun1607, kk_context());
  _self->_uniq_x_10305_0 = _uniq_x_10305_0;
  _self->_uniq_xx_10306_0 = _uniq_xx_10306_0;
  _self->pred_0 = pred_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__lift_lookup_10348_fun1607(kk_function_t _fself, kk_box_t _b_x523, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_lookup_10348_fun1607__t* _self = kk_function_as(struct kk_std_core_list__lift_lookup_10348_fun1607__t*, _fself, _ctx);
  kk_std_core_types__tuple2 _uniq_x_10305_0 = _self->_uniq_x_10305_0; /* (2741, 2742) */
  kk_std_core_types__list _uniq_xx_10306_0 = _self->_uniq_xx_10306_0; /* list<(2741, 2742)> */
  kk_function_t pred_0 = _self->pred_0; /* (2741) -> 2743 bool */
  kk_drop_match(_self, {kk_std_core_types__tuple2_dup(_uniq_x_10305_0, _ctx);kk_std_core_types__list_dup(_uniq_xx_10306_0, _ctx);kk_function_dup(pred_0, _ctx);}, {}, _ctx)
  bool _y_x10535_0_525 = kk_bool_unbox(_b_x523); /*bool*/;
  kk_std_core_types__maybe _x_x1608 = kk_std_core_list__mlift_lift_lookup_10348_10676(_uniq_x_10305_0, _uniq_xx_10306_0, pred_0, _y_x10535_0_525, _ctx); /*maybe<2742>*/
  return kk_std_core_types__maybe_box(_x_x1608, _ctx);
}

kk_std_core_types__maybe kk_std_core_list__lift_lookup_10348(kk_function_t pred_0, kk_std_core_types__list _uniq_xs_10301, kk_context_t* _ctx) { /* forall<a,b,e> (pred : (a) -> e bool, list<(a, b)>) -> e maybe<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Nil(_uniq_xs_10301, _ctx)) {
    kk_function_drop(pred_0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    struct kk_std_core_types_Cons* _con_x1603 = kk_std_core_types__as_Cons(_uniq_xs_10301, _ctx);
    kk_box_t _box_x521 = _con_x1603->head;
    kk_std_core_types__list _uniq_xx_10306_0 = _con_x1603->tail;
    kk_std_core_types__tuple2 _uniq_x_10305_0 = kk_std_core_types__tuple2_unbox(_box_x521, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10301, _ctx)) {
      kk_std_core_types__tuple2_dup(_uniq_x_10305_0, _ctx);
      kk_box_drop(_box_x521, _ctx);
      kk_datatype_ptr_free(_uniq_xs_10301, _ctx);
    }
    else {
      kk_std_core_types__tuple2_dup(_uniq_x_10305_0, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10306_0, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10301, _ctx);
    }
    bool x_10791;
    kk_function_t _x_x1605 = kk_function_dup(pred_0, _ctx); /*(2741) -> 2743 bool*/
    kk_box_t _x_x1604;
    {
      kk_box_t _x = _uniq_x_10305_0.fst;
      kk_box_dup(_x, _ctx);
      _x_x1604 = _x; /*2741*/
    }
    x_10791 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1605, (_x_x1605, _x_x1604, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1606 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_lift_lookup_10348_fun1607(_uniq_x_10305_0, _uniq_xx_10306_0, pred_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__maybe_unbox(_x_x1606, KK_OWNED, _ctx);
    }
    if (x_10791) {
      kk_function_drop(pred_0, _ctx);
      kk_std_core_types__list_drop(_uniq_xx_10306_0, _ctx);
      kk_box_t _x_x1609;
      {
        kk_box_t _x_0_0 = _uniq_x_10305_0.snd;
        kk_box_dup(_x_0_0, _ctx);
        kk_std_core_types__tuple2_drop(_uniq_x_10305_0, _ctx);
        _x_x1609 = _x_0_0; /*2742*/
      }
      return kk_std_core_types__new_Just(_x_x1609, _ctx);
    }
    {
      kk_std_core_types__tuple2_drop(_uniq_x_10305_0, _ctx);
      { // tailcall
        _uniq_xs_10301 = _uniq_xx_10306_0;
        goto kk__tailcall;
      }
    }
  }
}
 
// monadic lift

kk_integer_t kk_std_core_list__mlift_unroll_index_of_acc_10015_10677(kk_integer_t idx, kk_function_t pred, kk_std_core_types__list xx, bool _y_x10542, kk_context_t* _ctx) { /* forall<a,e> (idx : int, pred : (a) -> e bool, xx : list<a>, bool) -> e int */ 
  if (_y_x10542) {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(pred, _ctx);
    return idx;
  }
  {
    kk_integer_t _x_x1610 = kk_integer_add_small_const(idx, 1, _ctx); /*int*/
    return kk_std_core_list__unroll_index_of_acc_10015(xx, pred, _x_x1610, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_list__unroll_index_of_acc_10015_fun1614__t {
  struct kk_function_s _base;
  kk_integer_t idx_0;
  kk_function_t pred_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__unroll_index_of_acc_10015_fun1614(kk_function_t _fself, kk_box_t _b_x527, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_unroll_index_of_acc_10015_fun1614(kk_integer_t idx_0, kk_function_t pred_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_index_of_acc_10015_fun1614__t* _self = kk_function_alloc_as(struct kk_std_core_list__unroll_index_of_acc_10015_fun1614__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__unroll_index_of_acc_10015_fun1614, kk_context());
  _self->idx_0 = idx_0;
  _self->pred_0 = pred_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__unroll_index_of_acc_10015_fun1614(kk_function_t _fself, kk_box_t _b_x527, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_index_of_acc_10015_fun1614__t* _self = kk_function_as(struct kk_std_core_list__unroll_index_of_acc_10015_fun1614__t*, _fself, _ctx);
  kk_integer_t idx_0 = _self->idx_0; /* int */
  kk_function_t pred_0 = _self->pred_0; /* (2795) -> 2796 bool */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<2795> */
  kk_drop_match(_self, {kk_integer_dup(idx_0, _ctx);kk_function_dup(pred_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10542_0_529 = kk_bool_unbox(_b_x527); /*bool*/;
  kk_integer_t _x_x1615 = kk_std_core_list__mlift_unroll_index_of_acc_10015_10677(idx_0, pred_0, xx_0, _y_x10542_0_529, _ctx); /*int*/
  return kk_integer_box(_x_x1615, _ctx);
}

kk_integer_t kk_std_core_list__unroll_index_of_acc_10015(kk_std_core_types__list xs, kk_function_t pred_0, kk_integer_t idx_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool, idx : int) -> e int */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1611 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1611->head;
    kk_std_core_types__list xx_0 = _con_x1611->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_0_10794;
    kk_function_t _x_x1612 = kk_function_dup(pred_0, _ctx); /*(2795) -> 2796 bool*/
    x_0_10794 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1612, (_x_x1612, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1613 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_unroll_index_of_acc_10015_fun1614(idx_0, pred_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_integer_unbox(_x_x1613, _ctx);
    }
    if (x_0_10794) {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(pred_0, _ctx);
      return idx_0;
    }
    { // tailcall
      kk_integer_t _x_x1616 = kk_integer_add_small_const(idx_0, 1, _ctx); /*int*/
      xs = xx_0;
      idx_0 = _x_x1616;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(pred_0, _ctx);
    kk_integer_drop(idx_0, _ctx);
    return kk_integer_from_small(-1);
  }
}
 
// monadic lift

kk_unit_t kk_std_core_list__mlift_unroll_foreach_10016_10678(kk_function_t action, kk_std_core_types__list xx, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<a,e> (action : (a) -> e (), xx : list<a>, wild_ : ()) -> e () */ 
  kk_std_core_list__unroll_foreach_10016(xx, action, _ctx); return kk_Unit;
}
 
// Invoke `action` for each element of a list


// lift anonymous function
struct kk_std_core_list__unroll_foreach_10016_fun1620__t {
  struct kk_function_s _base;
  kk_function_t action_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__unroll_foreach_10016_fun1620(kk_function_t _fself, kk_box_t _b_x531, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_unroll_foreach_10016_fun1620(kk_function_t action_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_foreach_10016_fun1620__t* _self = kk_function_alloc_as(struct kk_std_core_list__unroll_foreach_10016_fun1620__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__unroll_foreach_10016_fun1620, kk_context());
  _self->action_0 = action_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__unroll_foreach_10016_fun1620(kk_function_t _fself, kk_box_t _b_x531, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_foreach_10016_fun1620__t* _self = kk_function_as(struct kk_std_core_list__unroll_foreach_10016_fun1620__t*, _fself, _ctx);
  kk_function_t action_0 = _self->action_0; /* (2872) -> 2873 () */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<2872> */
  kk_drop_match(_self, {kk_function_dup(action_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_unit_t wild___0_533 = kk_Unit;
  kk_unit_unbox(_b_x531);
  kk_unit_t _x_x1621 = kk_Unit;
  kk_std_core_list__mlift_unroll_foreach_10016_10678(action_0, xx_0, wild___0_533, _ctx);
  return kk_unit_box(_x_x1621);
}

kk_unit_t kk_std_core_list__unroll_foreach_10016(kk_std_core_types__list xs, kk_function_t action_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, action : (a) -> e ()) -> e () */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1617 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1617->head;
    kk_std_core_types__list xx_0 = _con_x1617->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_unit_t x_0_10797 = kk_Unit;
    kk_function_t _x_x1618 = kk_function_dup(action_0, _ctx); /*(2872) -> 2873 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_box_t, kk_context_t*), _x_x1618, (_x_x1618, x, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1619 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_unroll_foreach_10016_fun1620(action_0, xx_0, _ctx), _ctx); /*2401*/
      kk_unit_unbox(_x_x1619); return kk_Unit;
    }
    { // tailcall
      xs = xx_0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(action_0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_unroll_map_while_10017_10679(kk_std_core_types__cctx _acc, kk_function_t action, kk_std_core_types__list xx, kk_std_core_types__maybe _y_x10555, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, action : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Just(_y_x10555, _ctx)) {
    kk_box_t y = _y_x10555._cons.Just.value;
    kk_std_core_types__list _trmc_x10397 = kk_datatype_null(); /*list<2947>*/;
    kk_std_core_types__list _trmc_x10398 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _trmc_x10397, _ctx); /*list<2947>*/;
    kk_field_addr_t _b_x539_544 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10398, _ctx)->tail, _ctx); /*@field-addr<list<2947>>*/;
    kk_std_core_types__cctx _x_x1622 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10398, _ctx)),_b_x539_544,kk_context()); /*ctx<0>*/
    return kk_std_core_list__trmc_unroll_map_while_10017(xx, action, _x_x1622, _ctx);
  }
  {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(action, _ctx);
    kk_box_t _x_x1623 = kk_cctx_apply(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1623, KK_OWNED, _ctx);
  }
}
 
// Invoke `action` on each element of a list while `action` returns `Just`


// lift anonymous function
struct kk_std_core_list__trmc_unroll_map_while_10017_fun1628__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t action_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_unroll_map_while_10017_fun1628(kk_function_t _fself, kk_box_t _b_x553, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_unroll_map_while_10017_fun1628(kk_std_core_types__cctx _acc_0, kk_function_t action_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_map_while_10017_fun1628__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_unroll_map_while_10017_fun1628__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_unroll_map_while_10017_fun1628, kk_context());
  _self->_acc_0 = _acc_0;
  _self->action_0 = action_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_unroll_map_while_10017_fun1628(kk_function_t _fself, kk_box_t _b_x553, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_map_while_10017_fun1628__t* _self = kk_function_as(struct kk_std_core_list__trmc_unroll_map_while_10017_fun1628__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<2947>> */
  kk_function_t action_0 = _self->action_0; /* (2946) -> 2948 maybe<2947> */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<2946> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(action_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_x10555_0_573 = kk_std_core_types__maybe_unbox(_b_x553, KK_OWNED, _ctx); /*maybe<2947>*/;
  kk_std_core_types__list _x_x1629 = kk_std_core_list__mlift_trmc_unroll_map_while_10017_10679(_acc_0, action_0, xx_0, _y_x10555_0_573, _ctx); /*list<2947>*/
  return kk_std_core_types__list_box(_x_x1629, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_unroll_map_while_10017(kk_std_core_types__list xs, kk_function_t action_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_function_drop(action_0, _ctx);
    kk_box_t _x_x1624 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1624, KK_OWNED, _ctx);
  }
  {
    struct kk_std_core_types_Cons* _con_x1625 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1625->head;
    kk_std_core_types__list xx_0 = _con_x1625->tail;
    kk_reuse_t _ru_x1327 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1327 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x_0_10800;
    kk_function_t _x_x1626 = kk_function_dup(action_0, _ctx); /*(2946) -> 2948 maybe<2947>*/
    x_0_10800 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x_x1626, (_x_x1626, x, _ctx), _ctx); /*maybe<2947>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1327,kk_context());
      kk_std_core_types__maybe_drop(x_0_10800, _ctx);
      kk_box_t _x_x1627 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_unroll_map_while_10017_fun1628(_acc_0, action_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1627, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Just(x_0_10800, _ctx)) {
      kk_box_t y_0 = x_0_10800._cons.Just.value;
      kk_std_core_types__list _trmc_x10397_0 = kk_datatype_null(); /*list<2947>*/;
      kk_std_core_types__list _trmc_x10398_0 = kk_std_core_types__new_Cons(_ru_x1327, kk_field_index_of(struct kk_std_core_types_Cons, tail), y_0, _trmc_x10397_0, _ctx); /*list<2947>*/;
      kk_field_addr_t _b_x559_567 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10398_0, _ctx)->tail, _ctx); /*@field-addr<list<2947>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1630 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10398_0, _ctx)),_b_x559_567,kk_context()); /*ctx<0>*/
        xs = xx_0;
        _acc_0 = _x_x1630;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_x1327,kk_context());
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(action_0, _ctx);
      kk_box_t _x_x1631 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
      return kk_std_core_types__list_unbox(_x_x1631, KK_OWNED, _ctx);
    }
  }
}
 
// Invoke `action` on each element of a list while `action` returns `Just`

kk_std_core_types__list kk_std_core_list__unroll_map_while_10017(kk_std_core_types__list xs_0, kk_function_t action_1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1632 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_map_while_10017(xs_0, action_1, _x_x1632, _ctx);
}
 
// monadic lift

kk_unit_t kk_std_core_list__mlift_lift_foreach_indexed_10349_10680(kk_std_core_types__list _uniq_xx_10315, kk_function_t action, kk_ref_t i, kk_unit_t _uniq_x___10316, kk_context_t* _ctx) { /* forall<h,a,e> (list<a>, action : (int, a) -> e (), i : local-var<h,int>, ()) -> <local<h>|e> () */ 
  kk_std_core_list__lift_foreach_indexed_10349(action, i, _uniq_xx_10315, _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10681_fun1635__t {
  struct kk_function_s _base;
  kk_std_core_types__list _uniq_xx_10315_0;
  kk_function_t action_0;
  kk_ref_t i_0;
};
static kk_box_t kk_std_core_list__mlift_lift_foreach_indexed_10349_10681_fun1635(kk_function_t _fself, kk_box_t _b_x579, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_mlift_lift_foreach_indexed_10349_10681_fun1635(kk_std_core_types__list _uniq_xx_10315_0, kk_function_t action_0, kk_ref_t i_0, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10681_fun1635__t* _self = kk_function_alloc_as(struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10681_fun1635__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__mlift_lift_foreach_indexed_10349_10681_fun1635, kk_context());
  _self->_uniq_xx_10315_0 = _uniq_xx_10315_0;
  _self->action_0 = action_0;
  _self->i_0 = i_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__mlift_lift_foreach_indexed_10349_10681_fun1635(kk_function_t _fself, kk_box_t _b_x579, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10681_fun1635__t* _self = kk_function_as(struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10681_fun1635__t*, _fself, _ctx);
  kk_std_core_types__list _uniq_xx_10315_0 = _self->_uniq_xx_10315_0; /* list<3078> */
  kk_function_t action_0 = _self->action_0; /* (int, 3078) -> 3079 () */
  kk_ref_t i_0 = _self->i_0; /* local-var<3068,int> */
  kk_drop_match(_self, {kk_std_core_types__list_dup(_uniq_xx_10315_0, _ctx);kk_function_dup(action_0, _ctx);kk_ref_dup(i_0, _ctx);}, {}, _ctx)
  kk_unit_t _uniq_x___10316_0_581 = kk_Unit;
  kk_unit_unbox(_b_x579);
  kk_unit_t _x_x1636 = kk_Unit;
  kk_std_core_list__mlift_lift_foreach_indexed_10349_10680(_uniq_xx_10315_0, action_0, i_0, _uniq_x___10316_0_581, _ctx);
  return kk_unit_box(_x_x1636);
}

kk_unit_t kk_std_core_list__mlift_lift_foreach_indexed_10349_10681(kk_std_core_types__list _uniq_xx_10315_0, kk_function_t action_0, kk_ref_t i_0, kk_integer_t _y_x10565, kk_context_t* _ctx) { /* forall<h,a,e> (list<a>, action : (int, a) -> e (), i : local-var<h,int>, int) -> <local<h>|e> () */ 
  kk_integer_t _b_x575_577 = kk_integer_add_small_const(_y_x10565, 1, _ctx); /*int*/;
  kk_unit_t x_10805 = kk_Unit;
  kk_ref_set_borrow(i_0,(kk_integer_box(_b_x575_577, _ctx)),kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1634 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_mlift_lift_foreach_indexed_10349_10681_fun1635(_uniq_xx_10315_0, action_0, i_0, _ctx), _ctx); /*2401*/
    kk_unit_unbox(_x_x1634); return kk_Unit;
  }
  {
    kk_std_core_list__mlift_lift_foreach_indexed_10349_10680(_uniq_xx_10315_0, action_0, i_0, x_10805, _ctx); return kk_Unit;
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10682_fun1640__t {
  struct kk_function_s _base;
  kk_std_core_types__list _uniq_xx_10315_1;
  kk_function_t action_1;
  kk_ref_t i_1;
};
static kk_box_t kk_std_core_list__mlift_lift_foreach_indexed_10349_10682_fun1640(kk_function_t _fself, kk_box_t _b_x585, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_mlift_lift_foreach_indexed_10349_10682_fun1640(kk_std_core_types__list _uniq_xx_10315_1, kk_function_t action_1, kk_ref_t i_1, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10682_fun1640__t* _self = kk_function_alloc_as(struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10682_fun1640__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__mlift_lift_foreach_indexed_10349_10682_fun1640, kk_context());
  _self->_uniq_xx_10315_1 = _uniq_xx_10315_1;
  _self->action_1 = action_1;
  _self->i_1 = i_1;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__mlift_lift_foreach_indexed_10349_10682_fun1640(kk_function_t _fself, kk_box_t _b_x585, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10682_fun1640__t* _self = kk_function_as(struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10682_fun1640__t*, _fself, _ctx);
  kk_std_core_types__list _uniq_xx_10315_1 = _self->_uniq_xx_10315_1; /* list<3078> */
  kk_function_t action_1 = _self->action_1; /* (int, 3078) -> 3079 () */
  kk_ref_t i_1 = _self->i_1; /* local-var<3068,int> */
  kk_drop_match(_self, {kk_std_core_types__list_dup(_uniq_xx_10315_1, _ctx);kk_function_dup(action_1, _ctx);kk_ref_dup(i_1, _ctx);}, {}, _ctx)
  kk_integer_t _y_x10565_0_587 = kk_integer_unbox(_b_x585, _ctx); /*int*/;
  kk_unit_t _x_x1641 = kk_Unit;
  kk_std_core_list__mlift_lift_foreach_indexed_10349_10681(_uniq_xx_10315_1, action_1, i_1, _y_x10565_0_587, _ctx);
  return kk_unit_box(_x_x1641);
}

kk_unit_t kk_std_core_list__mlift_lift_foreach_indexed_10349_10682(kk_std_core_types__list _uniq_xx_10315_1, kk_function_t action_1, kk_ref_t i_1, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<h,a,e> (list<a>, action : (int, a) -> e (), i : local-var<h,int>, wild_ : ()) -> <local<h>|e> () */ 
  kk_integer_t x_0_10807;
  kk_box_t _x_x1637;
  kk_ref_t _x_x1638 = kk_ref_dup(i_1, _ctx); /*local-var<3068,int>*/
  _x_x1637 = kk_ref_get(_x_x1638,kk_context()); /*302*/
  x_0_10807 = kk_integer_unbox(_x_x1637, _ctx); /*int*/
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_0_10807, _ctx);
    kk_box_t _x_x1639 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_mlift_lift_foreach_indexed_10349_10682_fun1640(_uniq_xx_10315_1, action_1, i_1, _ctx), _ctx); /*2401*/
    kk_unit_unbox(_x_x1639); return kk_Unit;
  }
  {
    kk_std_core_list__mlift_lift_foreach_indexed_10349_10681(_uniq_xx_10315_1, action_1, i_1, x_0_10807, _ctx); return kk_Unit;
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10683_fun1644__t {
  struct kk_function_s _base;
  kk_std_core_types__list _uniq_xx_10315_2;
  kk_function_t action_2;
  kk_ref_t i_2;
};
static kk_box_t kk_std_core_list__mlift_lift_foreach_indexed_10349_10683_fun1644(kk_function_t _fself, kk_box_t _b_x589, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_mlift_lift_foreach_indexed_10349_10683_fun1644(kk_std_core_types__list _uniq_xx_10315_2, kk_function_t action_2, kk_ref_t i_2, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10683_fun1644__t* _self = kk_function_alloc_as(struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10683_fun1644__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__mlift_lift_foreach_indexed_10349_10683_fun1644, kk_context());
  _self->_uniq_xx_10315_2 = _uniq_xx_10315_2;
  _self->action_2 = action_2;
  _self->i_2 = i_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__mlift_lift_foreach_indexed_10349_10683_fun1644(kk_function_t _fself, kk_box_t _b_x589, kk_context_t* _ctx) {
  struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10683_fun1644__t* _self = kk_function_as(struct kk_std_core_list__mlift_lift_foreach_indexed_10349_10683_fun1644__t*, _fself, _ctx);
  kk_std_core_types__list _uniq_xx_10315_2 = _self->_uniq_xx_10315_2; /* list<3078> */
  kk_function_t action_2 = _self->action_2; /* (int, 3078) -> 3079 () */
  kk_ref_t i_2 = _self->i_2; /* local-var<3068,int> */
  kk_drop_match(_self, {kk_std_core_types__list_dup(_uniq_xx_10315_2, _ctx);kk_function_dup(action_2, _ctx);kk_ref_dup(i_2, _ctx);}, {}, _ctx)
  kk_unit_t wild___0_591 = kk_Unit;
  kk_unit_unbox(_b_x589);
  kk_unit_t _x_x1645 = kk_Unit;
  kk_std_core_list__mlift_lift_foreach_indexed_10349_10682(_uniq_xx_10315_2, action_2, i_2, wild___0_591, _ctx);
  return kk_unit_box(_x_x1645);
}

kk_unit_t kk_std_core_list__mlift_lift_foreach_indexed_10349_10683(kk_box_t _uniq_x_10314, kk_std_core_types__list _uniq_xx_10315_2, kk_function_t action_2, kk_ref_t i_2, kk_integer_t j, kk_context_t* _ctx) { /* forall<h,a,e> (a, list<a>, action : (int, a) -> e (), i : local-var<h,int>, j : int) -> <local<h>|e> () */ 
  kk_unit_t x_1_10809 = kk_Unit;
  kk_function_t _x_x1642 = kk_function_dup(action_2, _ctx); /*(int, 3078) -> 3079 ()*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x_x1642, (_x_x1642, j, _uniq_x_10314, _ctx), _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x1643 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_mlift_lift_foreach_indexed_10349_10683_fun1644(_uniq_xx_10315_2, action_2, i_2, _ctx), _ctx); /*2401*/
    kk_unit_unbox(_x_x1643); return kk_Unit;
  }
  {
    kk_std_core_list__mlift_lift_foreach_indexed_10349_10682(_uniq_xx_10315_2, action_2, i_2, x_1_10809, _ctx); return kk_Unit;
  }
}
 
// lifted local: foreach-indexed, @spec-x10318
// specialized: std/core/list/@unroll-foreach@10016, on parameters @uniq-action@10312, using:
// @uniq-action@10312 = fn<<(local :: H -> X)<(h :: H)>|(e :: E)>>(x: 3078){
//   val j : int;
//   val _ : ();
//   std/core/types/local-set<int,(e :: E),(h :: H)>(i, (std/core/types/@open<(total :: E),<(local :: H -> X)<(h :: H)>|(e :: E)>,(x : int, y : int) -> int,(x : int, y : int) -> <(local :: H -> X)<(h :: H)>|(e :: E)> int>((fn(x@0: int, y: int){
//       (std/core/int/int-add(x@0, y));
//     }))((std/core/types/local-get<int,(h :: H),(e :: E)>(i)), 1)));
// }


// lift anonymous function
struct kk_std_core_list__lift_foreach_indexed_10349_fun1650__t {
  struct kk_function_s _base;
  kk_box_t _uniq_x_10314_0;
  kk_std_core_types__list _uniq_xx_10315_3;
  kk_function_t action_4;
  kk_ref_t i_3;
};
static kk_box_t kk_std_core_list__lift_foreach_indexed_10349_fun1650(kk_function_t _fself, kk_box_t _b_x595, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_lift_foreach_indexed_10349_fun1650(kk_box_t _uniq_x_10314_0, kk_std_core_types__list _uniq_xx_10315_3, kk_function_t action_4, kk_ref_t i_3, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_foreach_indexed_10349_fun1650__t* _self = kk_function_alloc_as(struct kk_std_core_list__lift_foreach_indexed_10349_fun1650__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__lift_foreach_indexed_10349_fun1650, kk_context());
  _self->_uniq_x_10314_0 = _uniq_x_10314_0;
  _self->_uniq_xx_10315_3 = _uniq_xx_10315_3;
  _self->action_4 = action_4;
  _self->i_3 = i_3;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__lift_foreach_indexed_10349_fun1650(kk_function_t _fself, kk_box_t _b_x595, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_foreach_indexed_10349_fun1650__t* _self = kk_function_as(struct kk_std_core_list__lift_foreach_indexed_10349_fun1650__t*, _fself, _ctx);
  kk_box_t _uniq_x_10314_0 = _self->_uniq_x_10314_0; /* 3078 */
  kk_std_core_types__list _uniq_xx_10315_3 = _self->_uniq_xx_10315_3; /* list<3078> */
  kk_function_t action_4 = _self->action_4; /* (int, 3078) -> 3079 () */
  kk_ref_t i_3 = _self->i_3; /* local-var<3068,int> */
  kk_drop_match(_self, {kk_box_dup(_uniq_x_10314_0, _ctx);kk_std_core_types__list_dup(_uniq_xx_10315_3, _ctx);kk_function_dup(action_4, _ctx);kk_ref_dup(i_3, _ctx);}, {}, _ctx)
  kk_integer_t j_0_612 = kk_integer_unbox(_b_x595, _ctx); /*int*/;
  kk_unit_t _x_x1651 = kk_Unit;
  kk_std_core_list__mlift_lift_foreach_indexed_10349_10683(_uniq_x_10314_0, _uniq_xx_10315_3, action_4, i_3, j_0_612, _ctx);
  return kk_unit_box(_x_x1651);
}


// lift anonymous function
struct kk_std_core_list__lift_foreach_indexed_10349_fun1654__t {
  struct kk_function_s _base;
  kk_std_core_types__list _uniq_xx_10315_3;
  kk_function_t action_4;
  kk_ref_t i_3;
};
static kk_box_t kk_std_core_list__lift_foreach_indexed_10349_fun1654(kk_function_t _fself, kk_box_t _b_x597, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_lift_foreach_indexed_10349_fun1654(kk_std_core_types__list _uniq_xx_10315_3, kk_function_t action_4, kk_ref_t i_3, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_foreach_indexed_10349_fun1654__t* _self = kk_function_alloc_as(struct kk_std_core_list__lift_foreach_indexed_10349_fun1654__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__lift_foreach_indexed_10349_fun1654, kk_context());
  _self->_uniq_xx_10315_3 = _uniq_xx_10315_3;
  _self->action_4 = action_4;
  _self->i_3 = i_3;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__lift_foreach_indexed_10349_fun1654(kk_function_t _fself, kk_box_t _b_x597, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_foreach_indexed_10349_fun1654__t* _self = kk_function_as(struct kk_std_core_list__lift_foreach_indexed_10349_fun1654__t*, _fself, _ctx);
  kk_std_core_types__list _uniq_xx_10315_3 = _self->_uniq_xx_10315_3; /* list<3078> */
  kk_function_t action_4 = _self->action_4; /* (int, 3078) -> 3079 () */
  kk_ref_t i_3 = _self->i_3; /* local-var<3068,int> */
  kk_drop_match(_self, {kk_std_core_types__list_dup(_uniq_xx_10315_3, _ctx);kk_function_dup(action_4, _ctx);kk_ref_dup(i_3, _ctx);}, {}, _ctx)
  kk_unit_t wild___1_613 = kk_Unit;
  kk_unit_unbox(_b_x597);
  kk_unit_t _x_x1655 = kk_Unit;
  kk_std_core_list__mlift_lift_foreach_indexed_10349_10682(_uniq_xx_10315_3, action_4, i_3, wild___1_613, _ctx);
  return kk_unit_box(_x_x1655);
}


// lift anonymous function
struct kk_std_core_list__lift_foreach_indexed_10349_fun1659__t {
  struct kk_function_s _base;
  kk_std_core_types__list _uniq_xx_10315_3;
  kk_function_t action_4;
  kk_ref_t i_3;
};
static kk_box_t kk_std_core_list__lift_foreach_indexed_10349_fun1659(kk_function_t _fself, kk_box_t _b_x601, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_lift_foreach_indexed_10349_fun1659(kk_std_core_types__list _uniq_xx_10315_3, kk_function_t action_4, kk_ref_t i_3, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_foreach_indexed_10349_fun1659__t* _self = kk_function_alloc_as(struct kk_std_core_list__lift_foreach_indexed_10349_fun1659__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__lift_foreach_indexed_10349_fun1659, kk_context());
  _self->_uniq_xx_10315_3 = _uniq_xx_10315_3;
  _self->action_4 = action_4;
  _self->i_3 = i_3;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__lift_foreach_indexed_10349_fun1659(kk_function_t _fself, kk_box_t _b_x601, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_foreach_indexed_10349_fun1659__t* _self = kk_function_as(struct kk_std_core_list__lift_foreach_indexed_10349_fun1659__t*, _fself, _ctx);
  kk_std_core_types__list _uniq_xx_10315_3 = _self->_uniq_xx_10315_3; /* list<3078> */
  kk_function_t action_4 = _self->action_4; /* (int, 3078) -> 3079 () */
  kk_ref_t i_3 = _self->i_3; /* local-var<3068,int> */
  kk_drop_match(_self, {kk_std_core_types__list_dup(_uniq_xx_10315_3, _ctx);kk_function_dup(action_4, _ctx);kk_ref_dup(i_3, _ctx);}, {}, _ctx)
  kk_integer_t _y_x10565_1_614 = kk_integer_unbox(_b_x601, _ctx); /*int*/;
  kk_unit_t _x_x1660 = kk_Unit;
  kk_std_core_list__mlift_lift_foreach_indexed_10349_10681(_uniq_xx_10315_3, action_4, i_3, _y_x10565_1_614, _ctx);
  return kk_unit_box(_x_x1660);
}


// lift anonymous function
struct kk_std_core_list__lift_foreach_indexed_10349_fun1662__t {
  struct kk_function_s _base;
  kk_std_core_types__list _uniq_xx_10315_3;
  kk_function_t action_4;
  kk_ref_t i_3;
};
static kk_box_t kk_std_core_list__lift_foreach_indexed_10349_fun1662(kk_function_t _fself, kk_box_t _b_x607, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_lift_foreach_indexed_10349_fun1662(kk_std_core_types__list _uniq_xx_10315_3, kk_function_t action_4, kk_ref_t i_3, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_foreach_indexed_10349_fun1662__t* _self = kk_function_alloc_as(struct kk_std_core_list__lift_foreach_indexed_10349_fun1662__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__lift_foreach_indexed_10349_fun1662, kk_context());
  _self->_uniq_xx_10315_3 = _uniq_xx_10315_3;
  _self->action_4 = action_4;
  _self->i_3 = i_3;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__lift_foreach_indexed_10349_fun1662(kk_function_t _fself, kk_box_t _b_x607, kk_context_t* _ctx) {
  struct kk_std_core_list__lift_foreach_indexed_10349_fun1662__t* _self = kk_function_as(struct kk_std_core_list__lift_foreach_indexed_10349_fun1662__t*, _fself, _ctx);
  kk_std_core_types__list _uniq_xx_10315_3 = _self->_uniq_xx_10315_3; /* list<3078> */
  kk_function_t action_4 = _self->action_4; /* (int, 3078) -> 3079 () */
  kk_ref_t i_3 = _self->i_3; /* local-var<3068,int> */
  kk_drop_match(_self, {kk_std_core_types__list_dup(_uniq_xx_10315_3, _ctx);kk_function_dup(action_4, _ctx);kk_ref_dup(i_3, _ctx);}, {}, _ctx)
  kk_unit_t _uniq_x___10316_1_615 = kk_Unit;
  kk_unit_unbox(_b_x607);
  kk_unit_t _x_x1663 = kk_Unit;
  kk_std_core_list__mlift_lift_foreach_indexed_10349_10680(_uniq_xx_10315_3, action_4, i_3, _uniq_x___10316_1_615, _ctx);
  return kk_unit_box(_x_x1663);
}

kk_unit_t kk_std_core_list__lift_foreach_indexed_10349(kk_function_t action_4, kk_ref_t i_3, kk_std_core_types__list _uniq_xs_10311, kk_context_t* _ctx) { /* forall<h,a,e> (action : (int, a) -> e (), i : local-var<h,int>, list<a>) -> <local<h>|e> () */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(_uniq_xs_10311, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1646 = kk_std_core_types__as_Cons(_uniq_xs_10311, _ctx);
    kk_box_t _uniq_x_10314_0 = _con_x1646->head;
    kk_std_core_types__list _uniq_xx_10315_3 = _con_x1646->tail;
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10311, _ctx)) {
      kk_datatype_ptr_free(_uniq_xs_10311, _ctx);
    }
    else {
      kk_box_dup(_uniq_x_10314_0, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10315_3, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10311, _ctx);
    }
    kk_integer_t x_2_10812;
    kk_box_t _x_x1647;
    kk_ref_t _x_x1648 = kk_ref_dup(i_3, _ctx); /*local-var<3068,int>*/
    _x_x1647 = kk_ref_get(_x_x1648,kk_context()); /*302*/
    x_2_10812 = kk_integer_unbox(_x_x1647, _ctx); /*int*/
    if (kk_yielding(kk_context())) {
      kk_integer_drop(x_2_10812, _ctx);
      kk_box_t _x_x1649 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_lift_foreach_indexed_10349_fun1650(_uniq_x_10314_0, _uniq_xx_10315_3, action_4, i_3, _ctx), _ctx); /*2401*/
      kk_unit_unbox(_x_x1649); return kk_Unit;
    }
    {
      kk_unit_t x_3_10815 = kk_Unit;
      kk_function_t _x_x1652 = kk_function_dup(action_4, _ctx); /*(int, 3078) -> 3079 ()*/
      kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x_x1652, (_x_x1652, x_2_10812, _uniq_x_10314_0, _ctx), _ctx);
      if (kk_yielding(kk_context())) {
        kk_box_t _x_x1653 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_lift_foreach_indexed_10349_fun1654(_uniq_xx_10315_3, action_4, i_3, _ctx), _ctx); /*2401*/
        kk_unit_unbox(_x_x1653); return kk_Unit;
      }
      {
        kk_integer_t x_4_10819;
        kk_box_t _x_x1656;
        kk_ref_t _x_x1657 = kk_ref_dup(i_3, _ctx); /*local-var<3068,int>*/
        _x_x1656 = kk_ref_get(_x_x1657,kk_context()); /*302*/
        x_4_10819 = kk_integer_unbox(_x_x1656, _ctx); /*int*/
        if (kk_yielding(kk_context())) {
          kk_integer_drop(x_4_10819, _ctx);
          kk_box_t _x_x1658 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_lift_foreach_indexed_10349_fun1659(_uniq_xx_10315_3, action_4, i_3, _ctx), _ctx); /*2401*/
          kk_unit_unbox(_x_x1658); return kk_Unit;
        }
        {
          kk_integer_t _b_x603_605 = kk_integer_add_small_const(x_4_10819, 1, _ctx); /*int*/;
          kk_unit_t x_5_10822 = kk_Unit;
          kk_ref_set_borrow(i_3,(kk_integer_box(_b_x603_605, _ctx)),kk_context());
          if (kk_yielding(kk_context())) {
            kk_box_t _x_x1661 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_lift_foreach_indexed_10349_fun1662(_uniq_xx_10315_3, action_4, i_3, _ctx), _ctx); /*2401*/
            kk_unit_unbox(_x_x1661); return kk_Unit;
          }
          { // tailcall
            _uniq_xs_10311 = _uniq_xx_10315_3;
            goto kk__tailcall;
          }
        }
      }
    }
  }
  {
    kk_ref_drop(i_3, _ctx);
    kk_function_drop(action_4, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Invoke `action` for each element of a list, passing also the position of the element.

kk_unit_t kk_std_core_list_foreach_indexed(kk_std_core_types__list xs, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, action : (int, a) -> e ()) -> e () */ 
  kk_ref_t loc = kk_ref_alloc((kk_integer_box(kk_integer_from_small(0), _ctx)),kk_context()); /*local-var<3068,int>*/;
  kk_unit_t res = kk_Unit;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_function_drop(action, _ctx);
  }
  else {
    kk_ref_t _x_x1664 = kk_ref_dup(loc, _ctx); /*local-var<3068,int>*/
    kk_std_core_list__lift_foreach_indexed_10349(action, _x_x1664, xs, _ctx);
  }
  kk_box_t _x_x1665 = kk_std_core_hnd_prompt_local_var(loc, kk_unit_box(res), _ctx); /*4063*/
  kk_unit_unbox(_x_x1665); return kk_Unit;
}
 
// lifted local: intersperse, before

kk_std_core_types__list kk_std_core_list__trmc_unroll_lift_intersperse_5427_10018(kk_box_t sep, kk_std_core_types__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (sep : a, ys : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1666 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1666->head;
    kk_std_core_types__list yy = _con_x1666->tail;
    kk_reuse_t _ru_x1329 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1329 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _trmc_x10399;
    kk_std_core_types__list _x_x1667 = kk_datatype_null(); /*list<3150>*/
    _trmc_x10399 = kk_std_core_types__new_Cons(_ru_x1329, 0, y, _x_x1667, _ctx); /*list<3150>*/
    kk_field_addr_t _b_x627_632 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10399, _ctx)->tail, _ctx); /*@field-addr<list<3150>>*/;
    { // tailcall
      kk_box_t _x_x1668 = kk_box_dup(sep, _ctx); /*3150*/
      kk_std_core_types__cctx _x_x1669;
      kk_box_t _x_x1670;
      kk_std_core_types__list _x_x1671 = kk_std_core_types__new_Cons(kk_reuse_null, 0, sep, _trmc_x10399, _ctx); /*list<82>*/
      _x_x1670 = kk_std_core_types__list_box(_x_x1671, _ctx); /*0*/
      _x_x1669 = kk_cctx_extend_linear(_acc,_x_x1670,_b_x627_632,kk_context()); /*ctx<0>*/
      sep = _x_x1668;
      ys = yy;
      _acc = _x_x1669;
      goto kk__tailcall;
    }
  }
  {
    kk_box_drop(sep, _ctx);
    kk_box_t _x_x1672 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1672, KK_OWNED, _ctx);
  }
}
 
// lifted local: intersperse, before

kk_std_core_types__list kk_std_core_list__unroll_lift_intersperse_5427_10018(kk_box_t sep_0, kk_std_core_types__list ys_0, kk_context_t* _ctx) { /* forall<a> (sep : a, ys : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x_x1673 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_lift_intersperse_5427_10018(sep_0, ys_0, _x_x1673, _ctx);
}
 
// Insert a separator `sep`  between all elements of a list `xs` .

kk_std_core_types__list kk_std_core_list_intersperse(kk_std_core_types__list xs, kk_box_t sep, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, sep : a) -> list<a> */ 
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1675 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1675->head;
    kk_std_core_types__list xx = _con_x1675->tail;
    kk_reuse_t _ru_x1330 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1330 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__list _x_x1676;
    if (kk_std_core_types__is_Nil(xx, _ctx)) {
      kk_box_drop(sep, _ctx);
      _x_x1676 = kk_std_core_types__new_Nil(_ctx); /*forall<a> list<a>*/
    }
    else {
      kk_std_core_types__cctx _x_x1677 = kk_cctx_empty(kk_context()); /*ctx<0>*/
      _x_x1676 = kk_std_core_list__trmc_unroll_lift_intersperse_5427_10018(sep, xx, _x_x1677, _ctx); /*forall<a> list<a>*/
    }
    return kk_std_core_types__new_Cons(_ru_x1330, 0, x, _x_x1676, _ctx);
  }
  {
    kk_box_drop(sep, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
}
 
// Concatenate all strings in a list

kk_string_t kk_std_core_list_joinsep(kk_std_core_types__list xs, kk_string_t sep, kk_context_t* _ctx) { /* (xs : list<string>, sep : string) -> string */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_string_drop(sep, _ctx);
    return kk_string_empty();
  }
  {
    struct kk_std_core_types_Cons* _con_x1679 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x638 = _con_x1679->head;
    kk_std_core_types__list _pat_1 = _con_x1679->tail;
    if (kk_std_core_types__is_Nil(_pat_1, _ctx)) {
      kk_string_t x = kk_string_unbox(_box_x638);
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_string_drop(sep, _ctx);
      return x;
    }
  }
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1680 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x639 = _con_x1680->head;
    kk_std_core_types__list _pat_3 = _con_x1680->tail;
    if (kk_std_core_types__is_Cons(_pat_3, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1681 = kk_std_core_types__as_Cons(_pat_3, _ctx);
      kk_box_t _box_x640 = _con_x1681->head;
      kk_std_core_types__list _pat_4 = _con_x1681->tail;
      if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
        kk_string_t _x_x1682 = kk_string_dup(sep, _ctx); /*string*/
        kk_string_t _x_x1683 = kk_string_empty(); /*string*/
        if (kk_string_is_eq(_x_x1682,_x_x1683,kk_context())) {
          kk_string_t x_0 = kk_string_unbox(_box_x639);
          kk_string_t y = kk_string_unbox(_box_x640);
          if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
            if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
              kk_datatype_ptr_free(_pat_3, _ctx);
            }
            else {
              kk_string_dup(y, _ctx);
              kk_datatype_ptr_decref(_pat_3, _ctx);
            }
            kk_datatype_ptr_free(xs, _ctx);
          }
          else {
            kk_string_dup(x_0, _ctx);
            kk_string_dup(y, _ctx);
            kk_datatype_ptr_decref(xs, _ctx);
          }
          kk_string_drop(sep, _ctx);
          return kk_std_core_types__lp__plus__plus__rp_(x_0, y, _ctx);
        }
      }
    }
  }
  {
    kk_vector_t _x_x1685 = kk_std_core_vector_unvlist(xs, _ctx); /*vector<911>*/
    return kk_string_join_with(_x_x1685,sep,kk_context());
  }
}
 
// Concatenate all strings in a list

kk_string_t kk_std_core_list_concat_fs_join(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_types_Cons* _con_x1687 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x641 = _con_x1687->head;
    kk_std_core_types__list _pat_1 = _con_x1687->tail;
    if (kk_std_core_types__is_Nil(_pat_1, _ctx)) {
      kk_string_t x = kk_string_unbox(_box_x641);
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      return x;
    }
  }
  {
    struct kk_std_core_types_Cons* _con_x1688 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x642 = _con_x1688->head;
    kk_std_core_types__list _pat_3 = _con_x1688->tail;
    struct kk_std_core_types_Cons* _con_x1689 = kk_std_core_types__as_Cons(_pat_3, _ctx);
    kk_box_t _box_x643 = _con_x1689->head;
    kk_std_core_types__list _pat_4 = _con_x1689->tail;
    if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
      kk_string_t x_0 = kk_string_unbox(_box_x642);
      kk_string_t y = kk_string_unbox(_box_x643);
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
          kk_datatype_ptr_free(_pat_3, _ctx);
        }
        else {
          kk_string_dup(y, _ctx);
          kk_datatype_ptr_decref(_pat_3, _ctx);
        }
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_string_dup(x_0, _ctx);
        kk_string_dup(y, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      return kk_std_core_types__lp__plus__plus__rp_(x_0, y, _ctx);
    }
  }
  {
    kk_vector_t _x_x1690 = kk_std_core_vector_unvlist(xs, _ctx); /*vector<911>*/
    return kk_string_join(_x_x1690,kk_context());
  }
}
 
// monadic lift

kk_string_t kk_std_core_list__mlift_show_10684(kk_std_core_types__list _c_x10574, kk_context_t* _ctx) { /* (list<string>) -> string */ 
  kk_string_t _x_x1691;
  kk_define_string_literal(, _s_x1692, 1, "[", _ctx)
  _x_x1691 = kk_string_dup(_s_x1692, _ctx); /*string*/
  kk_string_t _x_x1693;
  kk_string_t _x_x1694;
  if (kk_std_core_types__is_Nil(_c_x10574, _ctx)) {
    _x_x1694 = kk_string_empty(); /*string*/
    goto _match_x1695;
  }
  {
    struct kk_std_core_types_Cons* _con_x1697 = kk_std_core_types__as_Cons(_c_x10574, _ctx);
    kk_box_t _box_x644 = _con_x1697->head;
    kk_std_core_types__list _pat_1 = _con_x1697->tail;
    if (kk_std_core_types__is_Nil(_pat_1, _ctx)) {
      kk_string_t x = kk_string_unbox(_box_x644);
      if kk_likely(kk_datatype_ptr_is_unique(_c_x10574, _ctx)) {
        kk_datatype_ptr_free(_c_x10574, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_datatype_ptr_decref(_c_x10574, _ctx);
      }
      _x_x1694 = x; /*string*/
      goto _match_x1695;
    }
  }
  if (kk_std_core_types__is_Cons(_c_x10574, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1698 = kk_std_core_types__as_Cons(_c_x10574, _ctx);
    kk_box_t _box_x645 = _con_x1698->head;
    kk_std_core_types__list _pat_3 = _con_x1698->tail;
    if (kk_std_core_types__is_Cons(_pat_3, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1699 = kk_std_core_types__as_Cons(_pat_3, _ctx);
      kk_box_t _box_x646 = _con_x1699->head;
      kk_std_core_types__list _pat_4 = _con_x1699->tail;
      if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
        kk_string_t _x_x1700;
        kk_define_string_literal(, _s_x1701, 1, ",", _ctx)
        _x_x1700 = kk_string_dup(_s_x1701, _ctx); /*string*/
        kk_string_t _x_x1702 = kk_string_empty(); /*string*/
        if (kk_string_is_eq(_x_x1700,_x_x1702,kk_context())) {
          kk_string_t x_0 = kk_string_unbox(_box_x645);
          kk_string_t y = kk_string_unbox(_box_x646);
          if kk_likely(kk_datatype_ptr_is_unique(_c_x10574, _ctx)) {
            if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
              kk_datatype_ptr_free(_pat_3, _ctx);
            }
            else {
              kk_string_dup(y, _ctx);
              kk_datatype_ptr_decref(_pat_3, _ctx);
            }
            kk_datatype_ptr_free(_c_x10574, _ctx);
          }
          else {
            kk_string_dup(x_0, _ctx);
            kk_string_dup(y, _ctx);
            kk_datatype_ptr_decref(_c_x10574, _ctx);
          }
          _x_x1694 = kk_std_core_types__lp__plus__plus__rp_(x_0, y, _ctx); /*string*/
          goto _match_x1695;
        }
      }
    }
  }
  {
    kk_vector_t _x_x1704 = kk_std_core_vector_unvlist(_c_x10574, _ctx); /*vector<911>*/
    kk_string_t _x_x1705;
    kk_define_string_literal(, _s_x1706, 1, ",", _ctx)
    _x_x1705 = kk_string_dup(_s_x1706, _ctx); /*string*/
    _x_x1694 = kk_string_join_with(_x_x1704,_x_x1705,kk_context()); /*string*/
  }
  _match_x1695: ;
  kk_string_t _x_x1707;
  kk_define_string_literal(, _s_x1708, 1, "]", _ctx)
  _x_x1707 = kk_string_dup(_s_x1708, _ctx); /*string*/
  _x_x1693 = kk_std_core_types__lp__plus__plus__rp_(_x_x1694, _x_x1707, _ctx); /*string*/
  return kk_std_core_types__lp__plus__plus__rp_(_x_x1691, _x_x1693, _ctx);
}
 
// Show a list


// lift anonymous function
struct kk_std_core_list_show_fun1709__t {
  struct kk_function_s _base;
  kk_function_t _implicit_fs_show;
};
static kk_box_t kk_std_core_list_show_fun1709(kk_function_t _fself, kk_box_t _b_x650, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_show_fun1709(kk_function_t _implicit_fs_show, kk_context_t* _ctx) {
  struct kk_std_core_list_show_fun1709__t* _self = kk_function_alloc_as(struct kk_std_core_list_show_fun1709__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list_show_fun1709, kk_context());
  _self->_implicit_fs_show = _implicit_fs_show;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list_show_fun1709(kk_function_t _fself, kk_box_t _b_x650, kk_context_t* _ctx) {
  struct kk_std_core_list_show_fun1709__t* _self = kk_function_as(struct kk_std_core_list_show_fun1709__t*, _fself, _ctx);
  kk_function_t _implicit_fs_show = _self->_implicit_fs_show; /* (3341) -> 3342 string */
  kk_drop_match(_self, {kk_function_dup(_implicit_fs_show, _ctx);}, {}, _ctx)
  kk_string_t _x_x1710 = kk_function_call(kk_string_t, (kk_function_t, kk_box_t, kk_context_t*), _implicit_fs_show, (_implicit_fs_show, _b_x650, _ctx), _ctx); /*string*/
  return kk_string_box(_x_x1710);
}


// lift anonymous function
struct kk_std_core_list_show_fun1712__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_show_fun1712(kk_function_t _fself, kk_box_t _b_x655, kk_context_t* _ctx);
static kk_function_t kk_std_core_list_new_show_fun1712(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_show_fun1712, _ctx)
  return kk_function_static_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_show_fun1712(kk_function_t _fself, kk_box_t _b_x655, kk_context_t* _ctx) {
  kk_function_static_drop(_fself,kk_context());
  kk_string_t _x_x1713;
  kk_std_core_types__list _x_x1714 = kk_std_core_types__list_unbox(_b_x655, KK_OWNED, _ctx); /*list<string>*/
  _x_x1713 = kk_std_core_list__mlift_show_10684(_x_x1714, _ctx); /*string*/
  return kk_string_box(_x_x1713);
}

kk_string_t kk_std_core_list_show(kk_std_core_types__list xs, kk_function_t _implicit_fs_show, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, ?show : (a) -> e string) -> e string */ 
  kk_std_core_types__list x_10831;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_function_drop(_implicit_fs_show, _ctx);
    x_10831 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
  }
  else {
    kk_std_core_types__cctx _b_x649_653 = kk_cctx_empty(kk_context()); /*ctx<list<string>>*/;
    kk_function_t _brw_x1227 = kk_std_core_list_new_show_fun1709(_implicit_fs_show, _ctx); /*(2105) -> 2107 2106*/;
    kk_std_core_types__list _brw_x1228 = kk_std_core_list__trmc_unroll_map_10010(xs, _brw_x1227, _b_x649_653, _ctx); /*list<2106>*/;
    kk_function_drop(_brw_x1227, _ctx);
    x_10831 = _brw_x1228; /*list<string>*/
  }
  if (kk_yielding(kk_context())) {
    kk_std_core_types__list_drop(x_10831, _ctx);
    kk_box_t _x_x1711 = kk_std_core_hnd_yield_extend(kk_std_core_list_new_show_fun1712(_ctx), _ctx); /*2401*/
    return kk_string_unbox(_x_x1711);
  }
  {
    kk_string_t _x_x1715;
    kk_define_string_literal(, _s_x1716, 1, "[", _ctx)
    _x_x1715 = kk_string_dup(_s_x1716, _ctx); /*string*/
    kk_string_t _x_x1717;
    kk_string_t _x_x1718;
    if (kk_std_core_types__is_Nil(x_10831, _ctx)) {
      _x_x1718 = kk_string_empty(); /*string*/
      goto _match_x1719;
    }
    {
      struct kk_std_core_types_Cons* _con_x1721 = kk_std_core_types__as_Cons(x_10831, _ctx);
      kk_box_t _box_x656 = _con_x1721->head;
      kk_std_core_types__list _pat_1_0 = _con_x1721->tail;
      if (kk_std_core_types__is_Nil(_pat_1_0, _ctx)) {
        kk_string_t x_0 = kk_string_unbox(_box_x656);
        if kk_likely(kk_datatype_ptr_is_unique(x_10831, _ctx)) {
          kk_datatype_ptr_free(x_10831, _ctx);
        }
        else {
          kk_string_dup(x_0, _ctx);
          kk_datatype_ptr_decref(x_10831, _ctx);
        }
        _x_x1718 = x_0; /*string*/
        goto _match_x1719;
      }
    }
    if (kk_std_core_types__is_Cons(x_10831, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1722 = kk_std_core_types__as_Cons(x_10831, _ctx);
      kk_box_t _box_x657 = _con_x1722->head;
      kk_std_core_types__list _pat_3 = _con_x1722->tail;
      if (kk_std_core_types__is_Cons(_pat_3, _ctx)) {
        struct kk_std_core_types_Cons* _con_x1723 = kk_std_core_types__as_Cons(_pat_3, _ctx);
        kk_box_t _box_x658 = _con_x1723->head;
        kk_std_core_types__list _pat_4 = _con_x1723->tail;
        if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
          kk_string_t _x_x1724;
          kk_define_string_literal(, _s_x1725, 1, ",", _ctx)
          _x_x1724 = kk_string_dup(_s_x1725, _ctx); /*string*/
          kk_string_t _x_x1726 = kk_string_empty(); /*string*/
          if (kk_string_is_eq(_x_x1724,_x_x1726,kk_context())) {
            kk_string_t x_0_0 = kk_string_unbox(_box_x657);
            kk_string_t y = kk_string_unbox(_box_x658);
            if kk_likely(kk_datatype_ptr_is_unique(x_10831, _ctx)) {
              if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
                kk_datatype_ptr_free(_pat_3, _ctx);
              }
              else {
                kk_string_dup(y, _ctx);
                kk_datatype_ptr_decref(_pat_3, _ctx);
              }
              kk_datatype_ptr_free(x_10831, _ctx);
            }
            else {
              kk_string_dup(x_0_0, _ctx);
              kk_string_dup(y, _ctx);
              kk_datatype_ptr_decref(x_10831, _ctx);
            }
            _x_x1718 = kk_std_core_types__lp__plus__plus__rp_(x_0_0, y, _ctx); /*string*/
            goto _match_x1719;
          }
        }
      }
    }
    {
      kk_vector_t _x_x1728 = kk_std_core_vector_unvlist(x_10831, _ctx); /*vector<911>*/
      kk_string_t _x_x1729;
      kk_define_string_literal(, _s_x1730, 1, ",", _ctx)
      _x_x1729 = kk_string_dup(_s_x1730, _ctx); /*string*/
      _x_x1718 = kk_string_join_with(_x_x1728,_x_x1729,kk_context()); /*string*/
    }
    _match_x1719: ;
    kk_string_t _x_x1731;
    kk_define_string_literal(, _s_x1732, 1, "]", _ctx)
    _x_x1731 = kk_string_dup(_s_x1732, _ctx); /*string*/
    _x_x1717 = kk_std_core_types__lp__plus__plus__rp_(_x_x1718, _x_x1731, _ctx); /*string*/
    return kk_std_core_types__lp__plus__plus__rp_(_x_x1715, _x_x1717, _ctx);
  }
}
 
// Zip two lists together by pairing the corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core_types__list kk_std_core_list__trmc_unroll_zip_10019(kk_std_core_types__list xs, kk_std_core_types__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a,b> (xs : list<a>, ys : list<b>, ctx<list<(a, b)>>) -> list<(a, b)> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1733 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1733->head;
    kk_std_core_types__list xx = _con_x1733->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Cons(ys, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1734 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t y = _con_x1734->head;
      kk_std_core_types__list yy = _con_x1734->tail;
      kk_reuse_t _ru_x1344 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_x1344 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core_types__list_dup(yy, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_std_core_types__list _trmc_x10401 = kk_datatype_null(); /*list<(3454, 3455)>*/;
      kk_std_core_types__list _trmc_x10402;
      kk_box_t _x_x1735;
      kk_std_core_types__tuple2 _x_x1736 = kk_std_core_types__new_Tuple2(x, y, _ctx); /*(137, 138)*/
      _x_x1735 = kk_std_core_types__tuple2_box(_x_x1736, _ctx); /*82*/
      _trmc_x10402 = kk_std_core_types__new_Cons(_ru_x1344, 0, _x_x1735, _trmc_x10401, _ctx); /*list<(3454, 3455)>*/
      kk_field_addr_t _b_x669_676 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10402, _ctx)->tail, _ctx); /*@field-addr<list<(3454, 3455)>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1737 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10402, _ctx)),_b_x669_676,kk_context()); /*ctx<0>*/
        xs = xx;
        ys = yy;
        _acc = _x_x1737;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core_types__list_drop(xx, _ctx);
      kk_box_drop(x, _ctx);
      kk_box_t _x_x1738 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
      return kk_std_core_types__list_unbox(_x_x1738, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core_types__list_drop(ys, _ctx);
    kk_box_t _x_x1739 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1739, KK_OWNED, _ctx);
  }
}
 
// Zip two lists together by pairing the corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core_types__list kk_std_core_list__unroll_zip_10019(kk_std_core_types__list xs_0, kk_std_core_types__list ys_0, kk_context_t* _ctx) { /* forall<a,b> (xs : list<a>, ys : list<b>) -> list<(a, b)> */ 
  kk_std_core_types__cctx _x_x1740 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_zip_10019(xs_0, ys_0, _x_x1740, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_unroll_zipwith_10020_10685(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core_types__list xx, kk_std_core_types__list yy, kk_box_t _trmc_x10403, kk_context_t* _ctx) { /* forall<a,b,c,e> (ctx<list<c>>, f : (a, b) -> e c, xx : list<a>, yy : list<b>, c) -> e list<c> */ 
  kk_std_core_types__list _trmc_x10404 = kk_datatype_null(); /*list<3534>*/;
  kk_std_core_types__list _trmc_x10405 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10403, _trmc_x10404, _ctx); /*list<3534>*/;
  kk_field_addr_t _b_x689_692 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10405, _ctx)->tail, _ctx); /*@field-addr<list<3534>>*/;
  kk_std_core_types__cctx _own_x1224 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10405, _ctx)),_b_x689_692,kk_context()); /*ctx<0>*/;
  kk_std_core_types__list _brw_x1225 = kk_std_core_list__trmc_unroll_zipwith_10020(xx, yy, f, _own_x1224, _ctx); /*list<3534>*/;
  kk_function_drop(f, _ctx);
  return _brw_x1225;
}
 
// Zip two lists together by apply a function `f` to all corresponding elements.
// The returned list is only as long as the smallest input list.


// lift anonymous function
struct kk_std_core_list__trmc_unroll_zipwith_10020_fun1747__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_std_core_types__list xx_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__trmc_unroll_zipwith_10020_fun1747(kk_function_t _fself, kk_box_t _b_x697, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_unroll_zipwith_10020_fun1747(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_std_core_types__list xx_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_zipwith_10020_fun1747__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_unroll_zipwith_10020_fun1747__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_unroll_zipwith_10020_fun1747, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->xx_0 = xx_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_unroll_zipwith_10020_fun1747(kk_function_t _fself, kk_box_t _b_x697, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_zipwith_10020_fun1747__t* _self = kk_function_as(struct kk_std_core_list__trmc_unroll_zipwith_10020_fun1747__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<3534>> */
  kk_function_t f_0 = _self->f_0; /* (3532, 3533) -> 3535 3534 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<3532> */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<3533> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10403_0_719 = _b_x697; /*3534*/;
  kk_std_core_types__list _x_x1748 = kk_std_core_list__mlift_trmc_unroll_zipwith_10020_10685(_acc_0, f_0, xx_0, yy_0, _trmc_x10403_0_719, _ctx); /*list<3534>*/
  return kk_std_core_types__list_box(_x_x1748, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_unroll_zipwith_10020(kk_std_core_types__list xs, kk_std_core_types__list ys, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,c,e> (xs : list<a>, ys : list<b>, f : (a, b) -> e c, ctx<list<c>>) -> e list<c> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1742 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1742->head;
    kk_std_core_types__list xx_0 = _con_x1742->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Cons(ys, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1743 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t y = _con_x1743->head;
      kk_std_core_types__list yy_0 = _con_x1743->tail;
      kk_reuse_t _ru_x1346 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_x1346 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core_types__list_dup(yy_0, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_box_t x_0_10838;
      kk_function_t _x_x1744 = kk_function_dup(f_0, _ctx); /*(3532, 3533) -> 3535 3534*/
      x_0_10838 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x_x1744, (_x_x1744, x, y, _ctx), _ctx); /*3534*/
      if (kk_yielding(kk_context())) {
        kk_reuse_drop(_ru_x1346,kk_context());
        kk_box_drop(x_0_10838, _ctx);
        kk_box_t _x_x1745;
        kk_function_t _x_x1746;
        kk_function_dup(f_0, _ctx);
        _x_x1746 = kk_std_core_list__new_trmc_unroll_zipwith_10020_fun1747(_acc_0, f_0, xx_0, yy_0, _ctx); /*(2400) -> 2402 2401*/
        _x_x1745 = kk_std_core_hnd_yield_extend(_x_x1746, _ctx); /*2401*/
        return kk_std_core_types__list_unbox(_x_x1745, KK_OWNED, _ctx);
      }
      {
        kk_std_core_types__list _trmc_x10404_0 = kk_datatype_null(); /*list<3534>*/;
        kk_std_core_types__list _trmc_x10405_0 = kk_std_core_types__new_Cons(_ru_x1346, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0_10838, _trmc_x10404_0, _ctx); /*list<3534>*/;
        kk_field_addr_t _b_x703_711 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10405_0, _ctx)->tail, _ctx); /*@field-addr<list<3534>>*/;
        kk_std_core_types__cctx _own_x1223 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10405_0, _ctx)),_b_x703_711,kk_context()); /*ctx<0>*/;
        { // tailcall
          xs = xx_0;
          ys = yy_0;
          _acc_0 = _own_x1223;
          goto kk__tailcall;
        }
      }
    }
    {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_box_drop(x, _ctx);
      kk_box_t _x_x1749 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
      return kk_std_core_types__list_unbox(_x_x1749, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core_types__list_drop(ys, _ctx);
    kk_box_t _x_x1750 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1750, KK_OWNED, _ctx);
  }
}
 
// Zip two lists together by apply a function `f` to all corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core_types__list kk_std_core_list__unroll_zipwith_10020(kk_std_core_types__list xs_0, kk_std_core_types__list ys_0, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,b,c,e> (xs : list<a>, ys : list<b>, f : (a, b) -> e c) -> e list<c> */ 
  kk_std_core_types__cctx _own_x1221 = kk_cctx_empty(kk_context()); /*ctx<0>*/;
  return kk_std_core_list__trmc_unroll_zipwith_10020(xs_0, ys_0, f_1, _own_x1221, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_unroll_zipwith_iter_10021_10686(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i, kk_std_core_types__list xx, kk_std_core_types__list yy, kk_box_t _trmc_x10406, kk_context_t* _ctx) { /* forall<a,b,c,d,e> (ctx<list<a>>, f : (int, b, c) -> e d, i : int, xx : list<b>, yy : list<c>, d) -> e list<d> */ 
  kk_std_core_types__list _trmc_x10407 = kk_datatype_null(); /*list<3616>*/;
  kk_std_core_types__list _trmc_x10408 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), _trmc_x10406, _trmc_x10407, _ctx); /*list<3616>*/;
  kk_field_addr_t _b_x725_728 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10408, _ctx)->tail, _ctx); /*@field-addr<list<3616>>*/;
  kk_integer_t _own_x1218 = kk_integer_add_small_const(i, 1, _ctx); /*int*/;
  kk_std_core_types__cctx _own_x1217 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10408, _ctx)),_b_x725_728,kk_context()); /*ctx<0>*/;
  kk_std_core_types__list _brw_x1219 = kk_std_core_list__trmc_unroll_zipwith_iter_10021(_own_x1218, xx, yy, f, _own_x1217, _ctx); /*list<3612>*/;
  kk_function_drop(f, _ctx);
  return _brw_x1219;
}


// lift anonymous function
struct kk_std_core_list__trmc_unroll_zipwith_iter_10021_fun1757__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_integer_t i_0;
  kk_std_core_types__list xx_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__trmc_unroll_zipwith_iter_10021_fun1757(kk_function_t _fself, kk_box_t _b_x733, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_unroll_zipwith_iter_10021_fun1757(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_integer_t i_0, kk_std_core_types__list xx_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_zipwith_iter_10021_fun1757__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_unroll_zipwith_iter_10021_fun1757__t, 7, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_unroll_zipwith_iter_10021_fun1757, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->i_0 = i_0;
  _self->xx_0 = xx_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_unroll_zipwith_iter_10021_fun1757(kk_function_t _fself, kk_box_t _b_x733, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_zipwith_iter_10021_fun1757__t* _self = kk_function_as(struct kk_std_core_list__trmc_unroll_zipwith_iter_10021_fun1757__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<3612>> */
  kk_function_t f_0 = _self->f_0; /* (int, 3614, 3615) -> 3617 3616 */
  kk_integer_t i_0 = _self->i_0; /* int */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<3614> */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<3615> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_integer_dup(i_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_x10406_0_755 = _b_x733; /*3616*/;
  kk_std_core_types__list _x_x1758 = kk_std_core_list__mlift_trmc_unroll_zipwith_iter_10021_10686(_acc_0, f_0, i_0, xx_0, yy_0, _trmc_x10406_0_755, _ctx); /*list<3616>*/
  return kk_std_core_types__list_box(_x_x1758, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_unroll_zipwith_iter_10021(kk_integer_t i_0, kk_std_core_types__list xs, kk_std_core_types__list ys, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,c,e> (i : int, xs : list<a>, ys : list<b>, f : (int, a, b) -> e c, ctx<list<c>>) -> e list<c> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1751 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1751->head;
    kk_std_core_types__list xx_0 = _con_x1751->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Cons(ys, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1752 = kk_std_core_types__as_Cons(ys, _ctx);
      kk_box_t y = _con_x1752->head;
      kk_std_core_types__list yy_0 = _con_x1752->tail;
      kk_reuse_t _ru_x1348 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_x1348 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core_types__list_dup(yy_0, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_box_t x_0_10844;
      kk_function_t _x_x1754 = kk_function_dup(f_0, _ctx); /*(int, 3614, 3615) -> 3617 3616*/
      kk_integer_t _x_x1753 = kk_integer_dup(i_0, _ctx); /*int*/
      x_0_10844 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_box_t, kk_context_t*), _x_x1754, (_x_x1754, _x_x1753, x, y, _ctx), _ctx); /*3616*/
      if (kk_yielding(kk_context())) {
        kk_reuse_drop(_ru_x1348,kk_context());
        kk_box_drop(x_0_10844, _ctx);
        kk_box_t _x_x1755;
        kk_function_t _x_x1756;
        kk_function_dup(f_0, _ctx);
        _x_x1756 = kk_std_core_list__new_trmc_unroll_zipwith_iter_10021_fun1757(_acc_0, f_0, i_0, xx_0, yy_0, _ctx); /*(2400) -> 2402 2401*/
        _x_x1755 = kk_std_core_hnd_yield_extend(_x_x1756, _ctx); /*2401*/
        return kk_std_core_types__list_unbox(_x_x1755, KK_OWNED, _ctx);
      }
      {
        kk_std_core_types__list _trmc_x10407_0 = kk_datatype_null(); /*list<3616>*/;
        kk_std_core_types__list _trmc_x10408_0 = kk_std_core_types__new_Cons(_ru_x1348, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0_10844, _trmc_x10407_0, _ctx); /*list<3616>*/;
        kk_field_addr_t _b_x739_747 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10408_0, _ctx)->tail, _ctx); /*@field-addr<list<3616>>*/;
        kk_integer_t _own_x1216 = kk_integer_add_small_const(i_0, 1, _ctx); /*int*/;
        kk_std_core_types__cctx _own_x1215 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10408_0, _ctx)),_b_x739_747,kk_context()); /*ctx<0>*/;
        { // tailcall
          i_0 = _own_x1216;
          xs = xx_0;
          ys = yy_0;
          _acc_0 = _own_x1215;
          goto kk__tailcall;
        }
      }
    }
    {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_box_drop(x, _ctx);
      kk_integer_drop(i_0, _ctx);
      kk_box_t _x_x1759 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
      return kk_std_core_types__list_unbox(_x_x1759, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core_types__list_drop(ys, _ctx);
    kk_integer_drop(i_0, _ctx);
    kk_box_t _x_x1760 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1760, KK_OWNED, _ctx);
  }
}

kk_std_core_types__list kk_std_core_list__unroll_zipwith_iter_10021(kk_integer_t i_1, kk_std_core_types__list xs_0, kk_std_core_types__list ys_0, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,b,c,e> (i : int, xs : list<a>, ys : list<b>, f : (int, a, b) -> e c) -> e list<c> */ 
  kk_std_core_types__cctx _own_x1213 = kk_cctx_empty(kk_context()); /*ctx<0>*/;
  return kk_std_core_list__trmc_unroll_zipwith_iter_10021(i_1, xs_0, ys_0, f_1, _own_x1213, _ctx);
}
 
// lifted local: unzip, iter

kk_std_core_types__tuple2 kk_std_core_list__unroll_lift_unzip_5428_10022(kk_std_core_types__list ys, kk_std_core_types__cctx acc1, kk_std_core_types__cctx acc2, kk_context_t* _ctx) { /* forall<a,b,c,d> (ys : list<(a, b)>, acc1 : cctx<c,list<a>>, acc2 : cctx<d,list<b>>) -> (c, d) */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1761 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t _box_x756 = _con_x1761->head;
    kk_std_core_types__tuple2 _pat_0 = kk_std_core_types__tuple2_unbox(_box_x756, KK_BORROWED, _ctx);
    kk_std_core_types__list xx = _con_x1761->tail;
    kk_box_t x = _pat_0.fst;
    kk_box_t y = _pat_0.snd;
    kk_reuse_t _ru_x1349 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_box_dup(x, _ctx);
      kk_box_dup(y, _ctx);
      kk_box_drop(_box_x756, _ctx);
      _ru_x1349 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_box_dup(y, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _cctx_x3716;
    kk_std_core_types__list _x_x1762 = kk_datatype_null(); /*list<3816>*/
    _cctx_x3716 = kk_std_core_types__new_Cons(_ru_x1349, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _x_x1762, _ctx); /*list<3816>*/
    kk_field_addr_t _cctx_x3717 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x3716, _ctx)->tail, _ctx); /*@field-addr<list<3816>>*/;
    kk_std_core_types__list _cctx_x3756;
    kk_std_core_types__list _x_x1763 = kk_datatype_null(); /*list<3817>*/
    _cctx_x3756 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _x_x1763, _ctx); /*list<3817>*/
    kk_field_addr_t _cctx_x3757 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x3756, _ctx)->tail, _ctx); /*@field-addr<list<3817>>*/;
    kk_std_core_types__list _b_x769_777 = _cctx_x3716; /*list<3816>*/;
    kk_field_addr_t _b_x770_778 = _cctx_x3717; /*@field-addr<list<3816>>*/;
    kk_std_core_types__list _b_x771_779 = _cctx_x3756; /*list<3817>*/;
    kk_field_addr_t _b_x772_780 = _cctx_x3757; /*@field-addr<list<3817>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1764;
      kk_std_core_types__cctx _x_x1765 = kk_cctx_create((kk_std_core_types__list_box(_b_x769_777, _ctx)),_b_x770_778,kk_context()); /*cctx<0,1>*/
      _x_x1764 = kk_cctx_compose(acc1,_x_x1765,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1766;
      kk_std_core_types__cctx _x_x1767 = kk_cctx_create((kk_std_core_types__list_box(_b_x771_779, _ctx)),_b_x772_780,kk_context()); /*cctx<0,1>*/
      _x_x1766 = kk_cctx_compose(acc2,_x_x1767,kk_context()); /*cctx<398,400>*/
      ys = xx;
      acc1 = _x_x1764;
      acc2 = _x_x1766;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x_x1768 = kk_cctx_apply(acc1,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1769 = kk_cctx_apply(acc2,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    return kk_std_core_types__new_Tuple2(_x_x1768, _x_x1769, _ctx);
  }
}
 
// Unzip a list of pairs into two lists

kk_std_core_types__tuple2 kk_std_core_list_unzip(kk_std_core_types__list xs, kk_context_t* _ctx) { /* forall<a,b> (xs : list<(a, b)>) -> (list<a>, list<b>) */ 
  kk_std_core_types__cctx acc1_10151 = kk_cctx_empty(kk_context()); /*ctx<list<3862>>*/;
  kk_std_core_types__cctx acc2_10152 = kk_cctx_empty(kk_context()); /*ctx<list<3863>>*/;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_std_core_types__list _b_x797_799;
    kk_box_t _x_x1772 = kk_cctx_apply(acc1_10151,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x797_799 = kk_std_core_types__list_unbox(_x_x1772, KK_OWNED, _ctx); /*list<3862>*/
    kk_std_core_types__list _b_x798_800;
    kk_box_t _x_x1773 = kk_cctx_apply(acc2_10152,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x798_800 = kk_std_core_types__list_unbox(_x_x1773, KK_OWNED, _ctx); /*list<3863>*/
    return kk_std_core_types__new_Tuple2(kk_std_core_types__list_box(_b_x797_799, _ctx), kk_std_core_types__list_box(_b_x798_800, _ctx), _ctx);
  }
  {
    return kk_std_core_list__unroll_lift_unzip_5428_10022(xs, acc1_10151, acc2_10152, _ctx);
  }
}
 
// lifted local: unzip3, iter

kk_std_core_types__tuple3 kk_std_core_list__unroll_lift_unzip3_5429_10023(kk_std_core_types__list ys, kk_std_core_types__cctx acc1, kk_std_core_types__cctx acc2, kk_std_core_types__cctx acc3, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,b1> (ys : list<(a, b, c)>, acc1 : cctx<d,list<a>>, acc2 : cctx<a1,list<b>>, acc3 : cctx<b1,list<c>>) -> (d, a1, b1) */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1774 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t _box_x805 = _con_x1774->head;
    kk_std_core_types__tuple3 _pat_0 = kk_std_core_types__tuple3_unbox(_box_x805, KK_BORROWED, _ctx);
    kk_std_core_types__list xx = _con_x1774->tail;
    kk_box_t x = _pat_0.fst;
    kk_box_t y = _pat_0.snd;
    kk_box_t z = _pat_0.thd;
    kk_reuse_t _ru_x1350 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_box_dup(x, _ctx);
      kk_box_dup(y, _ctx);
      kk_box_dup(z, _ctx);
      kk_box_drop(_box_x805, _ctx);
      _ru_x1350 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_box_dup(y, _ctx);
      kk_box_dup(z, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _cctx_x3919;
    kk_std_core_types__list _x_x1775 = kk_datatype_null(); /*list<4077>*/
    _cctx_x3919 = kk_std_core_types__new_Cons(_ru_x1350, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _x_x1775, _ctx); /*list<4077>*/
    kk_field_addr_t _cctx_x3920 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x3919, _ctx)->tail, _ctx); /*@field-addr<list<4077>>*/;
    kk_std_core_types__list _cctx_x3959;
    kk_std_core_types__list _x_x1776 = kk_datatype_null(); /*list<4078>*/
    _cctx_x3959 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _x_x1776, _ctx); /*list<4078>*/
    kk_field_addr_t _cctx_x3960 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x3959, _ctx)->tail, _ctx); /*@field-addr<list<4078>>*/;
    kk_std_core_types__list _cctx_x3999;
    kk_std_core_types__list _x_x1777 = kk_datatype_null(); /*list<4079>*/
    _cctx_x3999 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), z, _x_x1777, _ctx); /*list<4079>*/
    kk_field_addr_t _cctx_x4000 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x3999, _ctx)->tail, _ctx); /*@field-addr<list<4079>>*/;
    kk_std_core_types__list _b_x824_836 = _cctx_x3919; /*list<4077>*/;
    kk_field_addr_t _b_x825_837 = _cctx_x3920; /*@field-addr<list<4077>>*/;
    kk_std_core_types__list _b_x826_838 = _cctx_x3959; /*list<4078>*/;
    kk_field_addr_t _b_x827_839 = _cctx_x3960; /*@field-addr<list<4078>>*/;
    kk_std_core_types__list _b_x828_840 = _cctx_x3999; /*list<4079>*/;
    kk_field_addr_t _b_x829_841 = _cctx_x4000; /*@field-addr<list<4079>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1778;
      kk_std_core_types__cctx _x_x1779 = kk_cctx_create((kk_std_core_types__list_box(_b_x824_836, _ctx)),_b_x825_837,kk_context()); /*cctx<0,1>*/
      _x_x1778 = kk_cctx_compose(acc1,_x_x1779,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1780;
      kk_std_core_types__cctx _x_x1781 = kk_cctx_create((kk_std_core_types__list_box(_b_x826_838, _ctx)),_b_x827_839,kk_context()); /*cctx<0,1>*/
      _x_x1780 = kk_cctx_compose(acc2,_x_x1781,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1782;
      kk_std_core_types__cctx _x_x1783 = kk_cctx_create((kk_std_core_types__list_box(_b_x828_840, _ctx)),_b_x829_841,kk_context()); /*cctx<0,1>*/
      _x_x1782 = kk_cctx_compose(acc3,_x_x1783,kk_context()); /*cctx<398,400>*/
      ys = xx;
      acc1 = _x_x1778;
      acc2 = _x_x1780;
      acc3 = _x_x1782;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x_x1784 = kk_cctx_apply(acc1,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1785 = kk_cctx_apply(acc2,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1786 = kk_cctx_apply(acc3,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    return kk_std_core_types__new_Tuple3(_x_x1784, _x_x1785, _x_x1786, _ctx);
  }
}
 
// Unzip a list of triples into three lists

kk_std_core_types__tuple3 kk_std_core_list_unzip3(kk_std_core_types__list xs, kk_context_t* _ctx) { /* forall<a,b,c> (xs : list<(a, b, c)>) -> (list<a>, list<b>, list<c>) */ 
  kk_std_core_types__cctx acc1_10154 = kk_cctx_empty(kk_context()); /*ctx<list<4143>>*/;
  kk_std_core_types__cctx acc2_10155 = kk_cctx_empty(kk_context()); /*ctx<list<4144>>*/;
  kk_std_core_types__cctx acc3_10156 = kk_cctx_empty(kk_context()); /*ctx<list<4145>>*/;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_std_core_types__list _b_x866_869;
    kk_box_t _x_x1790 = kk_cctx_apply(acc1_10154,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x866_869 = kk_std_core_types__list_unbox(_x_x1790, KK_OWNED, _ctx); /*list<4143>*/
    kk_std_core_types__list _b_x867_870;
    kk_box_t _x_x1791 = kk_cctx_apply(acc2_10155,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x867_870 = kk_std_core_types__list_unbox(_x_x1791, KK_OWNED, _ctx); /*list<4144>*/
    kk_std_core_types__list _b_x868_871;
    kk_box_t _x_x1792 = kk_cctx_apply(acc3_10156,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x868_871 = kk_std_core_types__list_unbox(_x_x1792, KK_OWNED, _ctx); /*list<4145>*/
    return kk_std_core_types__new_Tuple3(kk_std_core_types__list_box(_b_x866_869, _ctx), kk_std_core_types__list_box(_b_x867_870, _ctx), kk_std_core_types__list_box(_b_x868_871, _ctx), _ctx);
  }
  {
    return kk_std_core_list__unroll_lift_unzip3_5429_10023(xs, acc1_10154, acc2_10155, acc3_10156, _ctx);
  }
}
 
// lifted local: unzip4, iter

kk_std_core_types__tuple4 kk_std_core_list__unroll_lift_unzip4_5430_10024(kk_std_core_types__list ys, kk_std_core_types__cctx acc1, kk_std_core_types__cctx acc2, kk_std_core_types__cctx acc3, kk_std_core_types__cctx acc4, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,b1,c1,d1> (ys : list<(a, b, c, d)>, acc1 : cctx<a1,list<a>>, acc2 : cctx<b1,list<b>>, acc3 : cctx<c1,list<c>>, acc4 : cctx<d1,list<d>>) -> (a1, b1, c1, d1) */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1793 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t _box_x878 = _con_x1793->head;
    kk_std_core_types__tuple4 _pat_0 = kk_std_core_types__tuple4_unbox(_box_x878, KK_BORROWED, _ctx);
    struct kk_std_core_types_Tuple4* _con_x1794 = kk_std_core_types__as_Tuple4(_pat_0, _ctx);
    kk_std_core_types__list xx = _con_x1793->tail;
    kk_box_t x = _con_x1794->fst;
    kk_box_t y = _con_x1794->snd;
    kk_box_t z = _con_x1794->thd;
    kk_box_t w = _con_x1794->field4;
    kk_reuse_t _ru_x1352 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      if kk_likely(kk_datatype_ptr_is_unique(_pat_0, _ctx)) {
        kk_datatype_ptr_free(_pat_0, _ctx);
      }
      else {
        kk_box_dup(w, _ctx);
        kk_box_dup(x, _ctx);
        kk_box_dup(y, _ctx);
        kk_box_dup(z, _ctx);
        kk_datatype_ptr_decref(_pat_0, _ctx);
      }
      _ru_x1352 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(w, _ctx);
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_box_dup(y, _ctx);
      kk_box_dup(z, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _cctx_x4208;
    kk_std_core_types__list _x_x1795 = kk_datatype_null(); /*list<4424>*/
    _cctx_x4208 = kk_std_core_types__new_Cons(_ru_x1352, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _x_x1795, _ctx); /*list<4424>*/
    kk_field_addr_t _cctx_x4209 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4208, _ctx)->tail, _ctx); /*@field-addr<list<4424>>*/;
    kk_std_core_types__list _cctx_x4248;
    kk_std_core_types__list _x_x1796 = kk_datatype_null(); /*list<4425>*/
    _cctx_x4248 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _x_x1796, _ctx); /*list<4425>*/
    kk_field_addr_t _cctx_x4249 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4248, _ctx)->tail, _ctx); /*@field-addr<list<4425>>*/;
    kk_std_core_types__list _cctx_x4288;
    kk_std_core_types__list _x_x1797 = kk_datatype_null(); /*list<4426>*/
    _cctx_x4288 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), z, _x_x1797, _ctx); /*list<4426>*/
    kk_field_addr_t _cctx_x4289 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4288, _ctx)->tail, _ctx); /*@field-addr<list<4426>>*/;
    kk_std_core_types__list _cctx_x4328;
    kk_std_core_types__list _x_x1798 = kk_datatype_null(); /*list<4427>*/
    _cctx_x4328 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), w, _x_x1798, _ctx); /*list<4427>*/
    kk_field_addr_t _cctx_x4329 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4328, _ctx)->tail, _ctx); /*@field-addr<list<4427>>*/;
    kk_std_core_types__list _b_x903_919 = _cctx_x4208; /*list<4424>*/;
    kk_field_addr_t _b_x904_920 = _cctx_x4209; /*@field-addr<list<4424>>*/;
    kk_std_core_types__list _b_x905_921 = _cctx_x4248; /*list<4425>*/;
    kk_field_addr_t _b_x906_922 = _cctx_x4249; /*@field-addr<list<4425>>*/;
    kk_std_core_types__list _b_x907_923 = _cctx_x4288; /*list<4426>*/;
    kk_field_addr_t _b_x908_924 = _cctx_x4289; /*@field-addr<list<4426>>*/;
    kk_std_core_types__list _b_x909_925 = _cctx_x4328; /*list<4427>*/;
    kk_field_addr_t _b_x910_926 = _cctx_x4329; /*@field-addr<list<4427>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1799;
      kk_std_core_types__cctx _x_x1800 = kk_cctx_create((kk_std_core_types__list_box(_b_x903_919, _ctx)),_b_x904_920,kk_context()); /*cctx<0,1>*/
      _x_x1799 = kk_cctx_compose(acc1,_x_x1800,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1801;
      kk_std_core_types__cctx _x_x1802 = kk_cctx_create((kk_std_core_types__list_box(_b_x905_921, _ctx)),_b_x906_922,kk_context()); /*cctx<0,1>*/
      _x_x1801 = kk_cctx_compose(acc2,_x_x1802,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1803;
      kk_std_core_types__cctx _x_x1804 = kk_cctx_create((kk_std_core_types__list_box(_b_x907_923, _ctx)),_b_x908_924,kk_context()); /*cctx<0,1>*/
      _x_x1803 = kk_cctx_compose(acc3,_x_x1804,kk_context()); /*cctx<398,400>*/
      kk_std_core_types__cctx _x_x1805;
      kk_std_core_types__cctx _x_x1806 = kk_cctx_create((kk_std_core_types__list_box(_b_x909_925, _ctx)),_b_x910_926,kk_context()); /*cctx<0,1>*/
      _x_x1805 = kk_cctx_compose(acc4,_x_x1806,kk_context()); /*cctx<398,400>*/
      ys = xx;
      acc1 = _x_x1799;
      acc2 = _x_x1801;
      acc3 = _x_x1803;
      acc4 = _x_x1805;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x_x1807 = kk_cctx_apply(acc1,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1808 = kk_cctx_apply(acc2,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1809 = kk_cctx_apply(acc3,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    kk_box_t _x_x1810 = kk_cctx_apply(acc4,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    return kk_std_core_types__new_Tuple4(kk_reuse_null, 0, _x_x1807, _x_x1808, _x_x1809, _x_x1810, _ctx);
  }
}
 
// Unzip a list of quadruples into four lists

kk_std_core_types__tuple4 kk_std_core_list_unzip4(kk_std_core_types__list xs, kk_context_t* _ctx) { /* forall<a,b,c,d> (xs : list<(a, b, c, d)>) -> (list<a>, list<b>, list<c>, list<d>) */ 
  kk_std_core_types__cctx acc1_10158 = kk_cctx_empty(kk_context()); /*ctx<list<4510>>*/;
  kk_std_core_types__cctx acc2_10159 = kk_cctx_empty(kk_context()); /*ctx<list<4511>>*/;
  kk_std_core_types__cctx acc3_10160 = kk_cctx_empty(kk_context()); /*ctx<list<4512>>*/;
  kk_std_core_types__cctx acc4_10161 = kk_cctx_empty(kk_context()); /*ctx<list<4513>>*/;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_std_core_types__list _b_x959_963;
    kk_box_t _x_x1815 = kk_cctx_apply(acc1_10158,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x959_963 = kk_std_core_types__list_unbox(_x_x1815, KK_OWNED, _ctx); /*list<4510>*/
    kk_std_core_types__list _b_x960_964;
    kk_box_t _x_x1816 = kk_cctx_apply(acc2_10159,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x960_964 = kk_std_core_types__list_unbox(_x_x1816, KK_OWNED, _ctx); /*list<4511>*/
    kk_std_core_types__list _b_x961_965;
    kk_box_t _x_x1817 = kk_cctx_apply(acc3_10160,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x961_965 = kk_std_core_types__list_unbox(_x_x1817, KK_OWNED, _ctx); /*list<4512>*/
    kk_std_core_types__list _b_x962_966;
    kk_box_t _x_x1818 = kk_cctx_apply(acc4_10161,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x962_966 = kk_std_core_types__list_unbox(_x_x1818, KK_OWNED, _ctx); /*list<4513>*/
    return kk_std_core_types__new_Tuple4(kk_reuse_null, 0, kk_std_core_types__list_box(_b_x959_963, _ctx), kk_std_core_types__list_box(_b_x960_964, _ctx), kk_std_core_types__list_box(_b_x961_965, _ctx), kk_std_core_types__list_box(_b_x962_966, _ctx), _ctx);
  }
  {
    return kk_std_core_list__unroll_lift_unzip4_5430_10024(xs, acc1_10158, acc2_10159, acc3_10160, acc4_10161, _ctx);
  }
}
 
// monadic lift

kk_std_core_types__tuple2 kk_std_core_list__mlift_unroll_lift_span_5431_10025_10687(kk_std_core_types__cctx acc, kk_function_t predicate, kk_box_t y, kk_std_core_types__list ys, kk_std_core_types__list yy, bool _y_x10592, kk_context_t* _ctx) { /* forall<a,b,e> (acc : cctx<a,list<b>>, predicate : (b) -> e bool, y : b, ys : list<b>, yy : list<b>, bool) -> e (a, list<b>) */ 
  if (_y_x10592) {
    kk_std_core_types__list_drop(ys, _ctx);
    kk_std_core_types__list _cctx_x4568;
    kk_std_core_types__list _x_x1819 = kk_datatype_null(); /*list<4658>*/
    _cctx_x4568 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _x_x1819, _ctx); /*list<4658>*/
    kk_field_addr_t _cctx_x4569 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4568, _ctx)->tail, _ctx); /*@field-addr<list<4658>>*/;
    kk_std_core_types__cctx acc_0_10118;
    kk_std_core_types__cctx _x_x1820 = kk_cctx_create((kk_std_core_types__list_box(_cctx_x4568, _ctx)),_cctx_x4569,kk_context()); /*cctx<0,1>*/
    acc_0_10118 = kk_cctx_compose(acc,_x_x1820,kk_context()); /*cctx<4635,list<4658>>*/
    return kk_std_core_list__unroll_lift_span_5431_10025(predicate, yy, acc_0_10118, _ctx);
  }
  {
    kk_std_core_types__list_drop(yy, _ctx);
    kk_box_drop(y, _ctx);
    kk_function_drop(predicate, _ctx);
    kk_box_t _b_x987_989 = kk_cctx_apply(acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*4635*/;
    return kk_std_core_types__new_Tuple2(_b_x987_989, kk_std_core_types__list_box(ys, _ctx), _ctx);
  }
}
 
// lifted local: span, span-acc


// lift anonymous function
struct kk_std_core_list__unroll_lift_span_5431_10025_fun1825__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx acc_0;
  kk_function_t predicate_0;
  kk_box_t y_0;
  kk_std_core_types__list ys_0;
  kk_std_core_types__list yy_0;
};
static kk_box_t kk_std_core_list__unroll_lift_span_5431_10025_fun1825(kk_function_t _fself, kk_box_t _b_x994, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_unroll_lift_span_5431_10025_fun1825(kk_std_core_types__cctx acc_0, kk_function_t predicate_0, kk_box_t y_0, kk_std_core_types__list ys_0, kk_std_core_types__list yy_0, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_lift_span_5431_10025_fun1825__t* _self = kk_function_alloc_as(struct kk_std_core_list__unroll_lift_span_5431_10025_fun1825__t, 7, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__unroll_lift_span_5431_10025_fun1825, kk_context());
  _self->acc_0 = acc_0;
  _self->predicate_0 = predicate_0;
  _self->y_0 = y_0;
  _self->ys_0 = ys_0;
  _self->yy_0 = yy_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__unroll_lift_span_5431_10025_fun1825(kk_function_t _fself, kk_box_t _b_x994, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_lift_span_5431_10025_fun1825__t* _self = kk_function_as(struct kk_std_core_list__unroll_lift_span_5431_10025_fun1825__t*, _fself, _ctx);
  kk_std_core_types__cctx acc_0 = _self->acc_0; /* cctx<4635,list<4658>> */
  kk_function_t predicate_0 = _self->predicate_0; /* (4658) -> 4659 bool */
  kk_box_t y_0 = _self->y_0; /* 4658 */
  kk_std_core_types__list ys_0 = _self->ys_0; /* list<4658> */
  kk_std_core_types__list yy_0 = _self->yy_0; /* list<4658> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(acc_0, _ctx);kk_function_dup(predicate_0, _ctx);kk_box_dup(y_0, _ctx);kk_std_core_types__list_dup(ys_0, _ctx);kk_std_core_types__list_dup(yy_0, _ctx);}, {}, _ctx)
  bool _y_x10592_0_1022 = kk_bool_unbox(_b_x994); /*bool*/;
  kk_std_core_types__tuple2 _x_x1826 = kk_std_core_list__mlift_unroll_lift_span_5431_10025_10687(acc_0, predicate_0, y_0, ys_0, yy_0, _y_x10592_0_1022, _ctx); /*(4635, list<4658>)*/
  return kk_std_core_types__tuple2_box(_x_x1826, _ctx);
}

kk_std_core_types__tuple2 kk_std_core_list__unroll_lift_span_5431_10025(kk_function_t predicate_0, kk_std_core_types__list ys_0, kk_std_core_types__cctx acc_0, kk_context_t* _ctx) { /* forall<a,e,b> (predicate : (a) -> e bool, ys : list<a>, acc : cctx<b,list<a>>) -> e (b, list<a>) */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys_0, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1821 = kk_std_core_types__as_Cons(ys_0, _ctx);
    kk_box_t y_0 = _con_x1821->head;
    kk_std_core_types__list yy_0 = _con_x1821->tail;
    kk_box_dup(y_0, _ctx);
    kk_std_core_types__list_dup(yy_0, _ctx);
    bool x_10855;
    kk_function_t _x_x1823 = kk_function_dup(predicate_0, _ctx); /*(4658) -> 4659 bool*/
    kk_box_t _x_x1822 = kk_box_dup(y_0, _ctx); /*4658*/
    x_10855 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1823, (_x_x1823, _x_x1822, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1824 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_unroll_lift_span_5431_10025_fun1825(acc_0, predicate_0, y_0, ys_0, yy_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__tuple2_unbox(_x_x1824, KK_OWNED, _ctx);
    }
    if (x_10855) {
      kk_reuse_t _ru_x1353 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys_0, _ctx)) {
        kk_std_core_types__list_drop(yy_0, _ctx);
        kk_box_drop(y_0, _ctx);
        _ru_x1353 = (kk_datatype_ptr_reuse(ys_0, _ctx));
      }
      else {
        kk_datatype_ptr_decref(ys_0, _ctx);
      }
      kk_std_core_types__list _cctx_x4568_0;
      kk_std_core_types__list _x_x1827 = kk_datatype_null(); /*list<4658>*/
      _cctx_x4568_0 = kk_std_core_types__new_Cons(_ru_x1353, kk_field_index_of(struct kk_std_core_types_Cons, tail), y_0, _x_x1827, _ctx); /*list<4658>*/
      kk_field_addr_t _cctx_x4569_0 = kk_field_addr_create(&kk_std_core_types__as_Cons(_cctx_x4568_0, _ctx)->tail, _ctx); /*@field-addr<list<4658>>*/;
      kk_std_core_types__cctx acc_0_10118_0;
      kk_std_core_types__cctx _x_x1828 = kk_cctx_create((kk_std_core_types__list_box(_cctx_x4568_0, _ctx)),_cctx_x4569_0,kk_context()); /*cctx<0,1>*/
      acc_0_10118_0 = kk_cctx_compose(acc_0,_x_x1828,kk_context()); /*cctx<4635,list<4658>>*/
      { // tailcall
        ys_0 = yy_0;
        acc_0 = acc_0_10118_0;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core_types__list_drop(yy_0, _ctx);
      kk_box_drop(y_0, _ctx);
      kk_function_drop(predicate_0, _ctx);
      kk_box_t _b_x1007_1014 = kk_cctx_apply(acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*4635*/;
      return kk_std_core_types__new_Tuple2(_b_x1007_1014, kk_std_core_types__list_box(ys_0, _ctx), _ctx);
    }
  }
  {
    kk_function_drop(predicate_0, _ctx);
    kk_box_t _b_x1011_1018 = kk_cctx_apply(acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*4635*/;
    return kk_std_core_types__new_Tuple2(_b_x1011_1018, kk_std_core_types__list_box(ys_0, _ctx), _ctx);
  }
}

kk_std_core_types__tuple2 kk_std_core_list_span(kk_std_core_types__list xs, kk_function_t predicate, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e (list<a>, list<a>) */ 
  kk_std_core_types__cctx acc = kk_cctx_empty(kk_context()); /*ctx<list<4658>>*/;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    kk_function_drop(predicate, _ctx);
    kk_std_core_types__list _b_x1033_1035;
    kk_box_t _x_x1829 = kk_cctx_apply(acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*386*/
    _b_x1033_1035 = kk_std_core_types__list_unbox(_x_x1829, KK_OWNED, _ctx); /*list<4658>*/
    return kk_std_core_types__new_Tuple2(kk_std_core_types__list_box(_b_x1033_1035, _ctx), kk_std_core_types__list_box(xs, _ctx), _ctx);
  }
  {
    return kk_std_core_list__unroll_lift_span_5431_10025(predicate, xs, acc, _ctx);
  }
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_unroll_take_while_10026_10688(kk_std_core_types__cctx _acc, kk_function_t predicate, kk_box_t x, kk_std_core_types__list xx, bool _y_x10600, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, predicate : (a) -> e bool, x : a, xx : list<a>, bool) -> e list<a> */ 
  if (_y_x10600) {
    kk_std_core_types__list _trmc_x10409 = kk_datatype_null(); /*list<4714>*/;
    kk_std_core_types__list _trmc_x10410 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), x, _trmc_x10409, _ctx); /*list<4714>*/;
    kk_field_addr_t _b_x1044_1049 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10410, _ctx)->tail, _ctx); /*@field-addr<list<4714>>*/;
    kk_std_core_types__cctx _x_x1830 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10410, _ctx)),_b_x1044_1049,kk_context()); /*ctx<0>*/
    return kk_std_core_list__trmc_unroll_take_while_10026(xx, predicate, _x_x1830, _ctx);
  }
  {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_box_drop(x, _ctx);
    kk_function_drop(predicate, _ctx);
    kk_box_t _x_x1831 = kk_cctx_apply(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1831, KK_OWNED, _ctx);
  }
}
 
// Keep only those initial elements that satisfy `predicate`


// lift anonymous function
struct kk_std_core_list__trmc_unroll_take_while_10026_fun1836__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t predicate_0;
  kk_box_t x_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_unroll_take_while_10026_fun1836(kk_function_t _fself, kk_box_t _b_x1056, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_unroll_take_while_10026_fun1836(kk_std_core_types__cctx _acc_0, kk_function_t predicate_0, kk_box_t x_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_take_while_10026_fun1836__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_unroll_take_while_10026_fun1836__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_unroll_take_while_10026_fun1836, kk_context());
  _self->_acc_0 = _acc_0;
  _self->predicate_0 = predicate_0;
  _self->x_0 = x_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_unroll_take_while_10026_fun1836(kk_function_t _fself, kk_box_t _b_x1056, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_take_while_10026_fun1836__t* _self = kk_function_as(struct kk_std_core_list__trmc_unroll_take_while_10026_fun1836__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<4714>> */
  kk_function_t predicate_0 = _self->predicate_0; /* (4714) -> 4715 bool */
  kk_box_t x_0 = _self->x_0; /* 4714 */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<4714> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(predicate_0, _ctx);kk_box_dup(x_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10600_0_1078 = kk_bool_unbox(_b_x1056); /*bool*/;
  kk_std_core_types__list _x_x1837 = kk_std_core_list__mlift_trmc_unroll_take_while_10026_10688(_acc_0, predicate_0, x_0, xx_0, _y_x10600_0_1078, _ctx); /*list<4714>*/
  return kk_std_core_types__list_box(_x_x1837, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_unroll_take_while_10026(kk_std_core_types__list xs, kk_function_t predicate_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1832 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x_0 = _con_x1832->head;
    kk_std_core_types__list xx_0 = _con_x1832->tail;
    kk_reuse_t _ru_x1354 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1354 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x_0, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_1_10858;
    kk_function_t _x_x1834 = kk_function_dup(predicate_0, _ctx); /*(4714) -> 4715 bool*/
    kk_box_t _x_x1833 = kk_box_dup(x_0, _ctx); /*4714*/
    x_1_10858 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1834, (_x_x1834, _x_x1833, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1354,kk_context());
      kk_box_t _x_x1835 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_unroll_take_while_10026_fun1836(_acc_0, predicate_0, x_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1835, KK_OWNED, _ctx);
    }
    if (x_1_10858) {
      kk_std_core_types__list _trmc_x10409_0 = kk_datatype_null(); /*list<4714>*/;
      kk_std_core_types__list _trmc_x10410_0 = kk_std_core_types__new_Cons(_ru_x1354, kk_field_index_of(struct kk_std_core_types_Cons, tail), x_0, _trmc_x10409_0, _ctx); /*list<4714>*/;
      kk_field_addr_t _b_x1062_1070 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10410_0, _ctx)->tail, _ctx); /*@field-addr<list<4714>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1838 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10410_0, _ctx)),_b_x1062_1070,kk_context()); /*ctx<0>*/
        xs = xx_0;
        _acc_0 = _x_x1838;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_x1354,kk_context());
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_box_drop(x_0, _ctx);
      kk_function_drop(predicate_0, _ctx);
      kk_box_t _x_x1839 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
      return kk_std_core_types__list_unbox(_x_x1839, KK_OWNED, _ctx);
    }
  }
  {
    kk_function_drop(predicate_0, _ctx);
    kk_box_t _x_x1840 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1840, KK_OWNED, _ctx);
  }
}
 
// Keep only those initial elements that satisfy `predicate`

kk_std_core_types__list kk_std_core_list__unroll_take_while_10026(kk_std_core_types__list xs_0, kk_function_t predicate_1, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e list<a> */ 
  kk_std_core_types__cctx _x_x1841 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_take_while_10026(xs_0, predicate_1, _x_x1841, _ctx);
}
 
// Concatenate all strings in a list in reverse order

kk_string_t kk_std_core_list_reverse_join(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  kk_std_core_types__list xs_0_10122;
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    xs_0_10122 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
  }
  else {
    xs_0_10122 = kk_std_core_list__unroll_reverse_acc_10003(kk_std_core_types__new_Nil(_ctx), xs, _ctx); /*list<string>*/
  }
  if (kk_std_core_types__is_Nil(xs_0_10122, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_types_Cons* _con_x1844 = kk_std_core_types__as_Cons(xs_0_10122, _ctx);
    kk_box_t _box_x1079 = _con_x1844->head;
    kk_std_core_types__list _pat_1 = _con_x1844->tail;
    if (kk_std_core_types__is_Nil(_pat_1, _ctx)) {
      kk_string_t x = kk_string_unbox(_box_x1079);
      if kk_likely(kk_datatype_ptr_is_unique(xs_0_10122, _ctx)) {
        kk_datatype_ptr_free(xs_0_10122, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_datatype_ptr_decref(xs_0_10122, _ctx);
      }
      return x;
    }
  }
  {
    struct kk_std_core_types_Cons* _con_x1845 = kk_std_core_types__as_Cons(xs_0_10122, _ctx);
    kk_box_t _box_x1080 = _con_x1845->head;
    kk_std_core_types__list _pat_3 = _con_x1845->tail;
    struct kk_std_core_types_Cons* _con_x1846 = kk_std_core_types__as_Cons(_pat_3, _ctx);
    kk_box_t _box_x1081 = _con_x1846->head;
    kk_std_core_types__list _pat_4 = _con_x1846->tail;
    if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
      kk_string_t x_0 = kk_string_unbox(_box_x1080);
      kk_string_t y = kk_string_unbox(_box_x1081);
      if kk_likely(kk_datatype_ptr_is_unique(xs_0_10122, _ctx)) {
        if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
          kk_datatype_ptr_free(_pat_3, _ctx);
        }
        else {
          kk_string_dup(y, _ctx);
          kk_datatype_ptr_decref(_pat_3, _ctx);
        }
        kk_datatype_ptr_free(xs_0_10122, _ctx);
      }
      else {
        kk_string_dup(x_0, _ctx);
        kk_string_dup(y, _ctx);
        kk_datatype_ptr_decref(xs_0_10122, _ctx);
      }
      return kk_std_core_types__lp__plus__plus__rp_(x_0, y, _ctx);
    }
  }
  {
    kk_vector_t _x_x1847 = kk_std_core_vector_unvlist(xs_0_10122, _ctx); /*vector<911>*/
    return kk_string_join(_x_x1847,kk_context());
  }
}
 
// lifted local: concat, concat-pre

kk_std_core_types__list kk_std_core_list__trmc_lift_concat_5432(kk_std_core_types__list ys, kk_std_core_types__list zss, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, zss : list<list<a>>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1851 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1851->head;
    kk_std_core_types__list yy = _con_x1851->tail;
    kk_reuse_t _ru_x1358 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1358 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _trmc_x10411 = kk_datatype_null(); /*list<4817>*/;
    kk_std_core_types__list _trmc_x10412 = kk_std_core_types__new_Cons(_ru_x1358, 0, y, _trmc_x10411, _ctx); /*list<4817>*/;
    kk_field_addr_t _b_x1087_1093 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10412, _ctx)->tail, _ctx); /*@field-addr<list<4817>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1852 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10412, _ctx)),_b_x1087_1093,kk_context()); /*ctx<0>*/
      ys = yy;
      _acc = _x_x1852;
      goto kk__tailcall;
    }
  }
  if (kk_std_core_types__is_Cons(zss, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1853 = kk_std_core_types__as_Cons(zss, _ctx);
    kk_box_t _box_x1088 = _con_x1853->head;
    kk_std_core_types__list zzs = _con_x1853->tail;
    kk_std_core_types__list zs = kk_std_core_types__list_unbox(_box_x1088, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(zss, _ctx)) {
      kk_datatype_ptr_free(zss, _ctx);
    }
    else {
      kk_std_core_types__list_dup(zs, _ctx);
      kk_std_core_types__list_dup(zzs, _ctx);
      kk_datatype_ptr_decref(zss, _ctx);
    }
    { // tailcall
      ys = zs;
      zss = zzs;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x_x1854 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1854, KK_OWNED, _ctx);
  }
}
 
// lifted local: concat, concat-pre

kk_std_core_types__list kk_std_core_list__lift_concat_5432(kk_std_core_types__list ys_0, kk_std_core_types__list zss_0, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, zss : list<list<a>>) -> list<a> */ 
  kk_std_core_types__cctx _x_x1855 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_concat_5432(ys_0, zss_0, _x_x1855, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_lift_flatmap_5433_10689(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core_types__list zz, kk_std_core_types__list ys_1_10131, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e list<b>, zz : list<a>, ys@1@10131 : list<b>) -> e list<b> */ 
  return kk_std_core_list__trmc_lift_flatmap_5433(f, ys_1_10131, zz, _acc, _ctx);
}
 
// lifted local: flatmap, flatmap-pre


// lift anonymous function
struct kk_std_core_list__trmc_lift_flatmap_5433_fun1862__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_std_core_types__list zz_0;
};
static kk_box_t kk_std_core_list__trmc_lift_flatmap_5433_fun1862(kk_function_t _fself, kk_box_t _b_x1106, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_lift_flatmap_5433_fun1862(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_std_core_types__list zz_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_flatmap_5433_fun1862__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_lift_flatmap_5433_fun1862__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_lift_flatmap_5433_fun1862, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->zz_0 = zz_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_lift_flatmap_5433_fun1862(kk_function_t _fself, kk_box_t _b_x1106, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_lift_flatmap_5433_fun1862__t* _self = kk_function_as(struct kk_std_core_list__trmc_lift_flatmap_5433_fun1862__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<4903>> */
  kk_function_t f_0 = _self->f_0; /* (4902) -> 4904 list<4903> */
  kk_std_core_types__list zz_0 = _self->zz_0; /* list<4902> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(zz_0, _ctx);}, {}, _ctx)
  kk_std_core_types__list ys_1_10131_0_1118 = kk_std_core_types__list_unbox(_b_x1106, KK_OWNED, _ctx); /*list<4903>*/;
  kk_std_core_types__list _x_x1863 = kk_std_core_list__mlift_trmc_lift_flatmap_5433_10689(_acc_0, f_0, zz_0, ys_1_10131_0_1118, _ctx); /*list<4903>*/
  return kk_std_core_types__list_box(_x_x1863, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_lift_flatmap_5433(kk_function_t f_0, kk_std_core_types__list ys, kk_std_core_types__list zs, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e list<b>, ys : list<b>, zs : list<a>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(ys, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1857 = kk_std_core_types__as_Cons(ys, _ctx);
    kk_box_t y = _con_x1857->head;
    kk_std_core_types__list yy = _con_x1857->tail;
    kk_reuse_t _ru_x1360 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_x1360 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core_types__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core_types__list _trmc_x10413 = kk_datatype_null(); /*list<4903>*/;
    kk_std_core_types__list _trmc_x10414 = kk_std_core_types__new_Cons(_ru_x1360, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _trmc_x10413, _ctx); /*list<4903>*/;
    kk_field_addr_t _b_x1104_1111 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10414, _ctx)->tail, _ctx); /*@field-addr<list<4903>>*/;
    { // tailcall
      kk_std_core_types__cctx _x_x1858 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10414, _ctx)),_b_x1104_1111,kk_context()); /*ctx<0>*/
      ys = yy;
      _acc_0 = _x_x1858;
      goto kk__tailcall;
    }
  }
  if (kk_std_core_types__is_Cons(zs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1859 = kk_std_core_types__as_Cons(zs, _ctx);
    kk_box_t z = _con_x1859->head;
    kk_std_core_types__list zz_0 = _con_x1859->tail;
    if kk_likely(kk_datatype_ptr_is_unique(zs, _ctx)) {
      kk_datatype_ptr_free(zs, _ctx);
    }
    else {
      kk_box_dup(z, _ctx);
      kk_std_core_types__list_dup(zz_0, _ctx);
      kk_datatype_ptr_decref(zs, _ctx);
    }
    kk_std_core_types__list x_10865;
    kk_function_t _x_x1860 = kk_function_dup(f_0, _ctx); /*(4902) -> 4904 list<4903>*/
    x_10865 = kk_function_call(kk_std_core_types__list, (kk_function_t, kk_box_t, kk_context_t*), _x_x1860, (_x_x1860, z, _ctx), _ctx); /*list<4903>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__list_drop(x_10865, _ctx);
      kk_box_t _x_x1861 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_lift_flatmap_5433_fun1862(_acc_0, f_0, zz_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1861, KK_OWNED, _ctx);
    }
    { // tailcall
      ys = x_10865;
      zs = zz_0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1864 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1864, KK_OWNED, _ctx);
  }
}
 
// lifted local: flatmap, flatmap-pre

kk_std_core_types__list kk_std_core_list__lift_flatmap_5433(kk_function_t f_1, kk_std_core_types__list ys_0, kk_std_core_types__list zs_0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e list<b>, ys : list<b>, zs : list<a>) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1865 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_lift_flatmap_5433(f_1, ys_0, zs_0, _x_x1865, _ctx);
}
 
// monadic lift

kk_std_core_types__list kk_std_core_list__mlift_trmc_unroll_flatmap_maybe_10027_10690(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core_types__list xx, kk_std_core_types__maybe _y_x10614, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Just(_y_x10614, _ctx)) {
    kk_box_t y = _y_x10614._cons.Just.value;
    kk_std_core_types__list _trmc_x10415 = kk_datatype_null(); /*list<4986>*/;
    kk_std_core_types__list _trmc_x10416 = kk_std_core_types__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_types_Cons, tail), y, _trmc_x10415, _ctx); /*list<4986>*/;
    kk_field_addr_t _b_x1124_1127 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10416, _ctx)->tail, _ctx); /*@field-addr<list<4986>>*/;
    kk_std_core_types__cctx _x_x1867 = kk_cctx_extend(_acc,(kk_std_core_types__list_box(_trmc_x10416, _ctx)),_b_x1124_1127,kk_context()); /*ctx<0>*/
    return kk_std_core_list__trmc_unroll_flatmap_maybe_10027(xx, f, _x_x1867, _ctx);
  }
  {
    return kk_std_core_list__trmc_unroll_flatmap_maybe_10027(xx, f, _acc, _ctx);
  }
}
 
// Concatenate the `Just` result elements from applying a function to all elements.


// lift anonymous function
struct kk_std_core_list__trmc_unroll_flatmap_maybe_10027_fun1871__t {
  struct kk_function_s _base;
  kk_std_core_types__cctx _acc_0;
  kk_function_t f_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__trmc_unroll_flatmap_maybe_10027_fun1871(kk_function_t _fself, kk_box_t _b_x1132, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_trmc_unroll_flatmap_maybe_10027_fun1871(kk_std_core_types__cctx _acc_0, kk_function_t f_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_flatmap_maybe_10027_fun1871__t* _self = kk_function_alloc_as(struct kk_std_core_list__trmc_unroll_flatmap_maybe_10027_fun1871__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__trmc_unroll_flatmap_maybe_10027_fun1871, kk_context());
  _self->_acc_0 = _acc_0;
  _self->f_0 = f_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__trmc_unroll_flatmap_maybe_10027_fun1871(kk_function_t _fself, kk_box_t _b_x1132, kk_context_t* _ctx) {
  struct kk_std_core_list__trmc_unroll_flatmap_maybe_10027_fun1871__t* _self = kk_function_as(struct kk_std_core_list__trmc_unroll_flatmap_maybe_10027_fun1871__t*, _fself, _ctx);
  kk_std_core_types__cctx _acc_0 = _self->_acc_0; /* ctx<list<4986>> */
  kk_function_t f_0 = _self->f_0; /* (4985) -> 4987 maybe<4986> */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<4985> */
  kk_drop_match(_self, {kk_std_core_types__cctx_dup(_acc_0, _ctx);kk_function_dup(f_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_x10614_0_1150 = kk_std_core_types__maybe_unbox(_b_x1132, KK_OWNED, _ctx); /*maybe<4986>*/;
  kk_std_core_types__list _x_x1872 = kk_std_core_list__mlift_trmc_unroll_flatmap_maybe_10027_10690(_acc_0, f_0, xx_0, _y_x10614_0_1150, _ctx); /*list<4986>*/
  return kk_std_core_types__list_box(_x_x1872, _ctx);
}

kk_std_core_types__list kk_std_core_list__trmc_unroll_flatmap_maybe_10027(kk_std_core_types__list xs, kk_function_t f_0, kk_std_core_types__cctx _acc_0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1868 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1868->head;
    kk_std_core_types__list xx_0 = _con_x1868->tail;
    kk_reuse_t _ru_x1362 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_x1362 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x_0_10871;
    kk_function_t _x_x1869 = kk_function_dup(f_0, _ctx); /*(4985) -> 4987 maybe<4986>*/
    x_0_10871 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x_x1869, (_x_x1869, x, _ctx), _ctx); /*maybe<4986>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_x1362,kk_context());
      kk_std_core_types__maybe_drop(x_0_10871, _ctx);
      kk_box_t _x_x1870 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_trmc_unroll_flatmap_maybe_10027_fun1871(_acc_0, f_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_std_core_types__list_unbox(_x_x1870, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Just(x_0_10871, _ctx)) {
      kk_box_t y_0 = x_0_10871._cons.Just.value;
      kk_std_core_types__list _trmc_x10415_0 = kk_datatype_null(); /*list<4986>*/;
      kk_std_core_types__list _trmc_x10416_0 = kk_std_core_types__new_Cons(_ru_x1362, kk_field_index_of(struct kk_std_core_types_Cons, tail), y_0, _trmc_x10415_0, _ctx); /*list<4986>*/;
      kk_field_addr_t _b_x1138_1144 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10416_0, _ctx)->tail, _ctx); /*@field-addr<list<4986>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1873 = kk_cctx_extend(_acc_0,(kk_std_core_types__list_box(_trmc_x10416_0, _ctx)),_b_x1138_1144,kk_context()); /*ctx<0>*/
        xs = xx_0;
        _acc_0 = _x_x1873;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_x1362,kk_context());
      { // tailcall
        xs = xx_0;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(f_0, _ctx);
    kk_box_t _x_x1874 = kk_cctx_apply(_acc_0,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1874, KK_OWNED, _ctx);
  }
}
 
// Concatenate the `Just` result elements from applying a function to all elements.

kk_std_core_types__list kk_std_core_list__unroll_flatmap_maybe_10027(kk_std_core_types__list xs_0, kk_function_t f_1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x_x1875 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_flatmap_maybe_10027(xs_0, f_1, _x_x1875, _ctx);
}
 
// Concatenate a list of `:maybe` values

kk_std_core_types__list kk_std_core_list__trmc_unroll_concat_maybe_10028(kk_std_core_types__list xs, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<maybe<a>>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1877 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x1151 = _con_x1877->head;
    kk_std_core_types__list xx = _con_x1877->tail;
    kk_std_core_types__maybe x = kk_std_core_types__maybe_unbox(_box_x1151, KK_BORROWED, _ctx);
    kk_reuse_t _ru_x1363 = kk_reuse_null; /*@reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core_types__maybe_dup(x, _ctx);
      kk_box_drop(_box_x1151, _ctx);
      _ru_x1363 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_std_core_types__maybe_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Just(x, _ctx)) {
      kk_box_t y = x._cons.Just.value;
      kk_std_core_types__list _trmc_x10417 = kk_datatype_null(); /*list<5048>*/;
      kk_std_core_types__list _trmc_x10418 = kk_std_core_types__new_Cons(_ru_x1363, 0, y, _trmc_x10417, _ctx); /*list<5048>*/;
      kk_field_addr_t _b_x1157_1162 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10418, _ctx)->tail, _ctx); /*@field-addr<list<5048>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1878 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10418, _ctx)),_b_x1157_1162,kk_context()); /*ctx<0>*/
        xs = xx;
        _acc = _x_x1878;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_x1363,kk_context());
      { // tailcall
        xs = xx;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_box_t _x_x1879 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1879, KK_OWNED, _ctx);
  }
}
 
// Concatenate a list of `:maybe` values

kk_std_core_types__list kk_std_core_list__unroll_concat_maybe_10028(kk_std_core_types__list xs_0, kk_context_t* _ctx) { /* forall<a> (xs : list<maybe<a>>) -> list<a> */ 
  kk_std_core_types__cctx _x_x1880 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_unroll_concat_maybe_10028(xs_0, _x_x1880, _ctx);
}
 
// Return the last element of a list (or `Nothing` for the empty list)

kk_std_core_types__maybe kk_std_core_list_last(kk_std_core_types__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> maybe<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1882 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_std_core_types__list _pat_0 = _con_x1882->tail;
    if (kk_std_core_types__is_Nil(_pat_0, _ctx)) {
      kk_box_t x = _con_x1882->head;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_box_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      return kk_std_core_types__new_Just(x, _ctx);
    }
  }
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1883 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _pat_2 = _con_x1883->head;
    kk_std_core_types__list xx = _con_x1883->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_pat_2, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    { // tailcall
      xs = xx;
      goto kk__tailcall;
    }
  }
  {
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Return the list without its last element.
// Return an empty list for an empty list.

kk_std_core_types__list kk_std_core_list__trmc_init(kk_std_core_types__list xs, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1884 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_std_core_types__list xx = _con_x1884->tail;
    if (kk_std_core_types__is_Cons(xx, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1885 = kk_std_core_types__as_Cons(xx, _ctx);
      kk_box_t x = _con_x1884->head;
      kk_reuse_t _ru_x1366 = kk_reuse_null; /*@reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        _ru_x1366 = (kk_datatype_ptr_reuse(xs, _ctx));
      }
      else {
        kk_box_dup(x, _ctx);
        kk_std_core_types__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_std_core_types__list _trmc_x10419 = kk_datatype_null(); /*list<5135>*/;
      kk_std_core_types__list _trmc_x10420 = kk_std_core_types__new_Cons(_ru_x1366, 0, x, _trmc_x10419, _ctx); /*list<5135>*/;
      kk_field_addr_t _b_x1173_1178 = kk_field_addr_create(&kk_std_core_types__as_Cons(_trmc_x10420, _ctx)->tail, _ctx); /*@field-addr<list<5135>>*/;
      { // tailcall
        kk_std_core_types__cctx _x_x1886 = kk_cctx_extend_linear(_acc,(kk_std_core_types__list_box(_trmc_x10420, _ctx)),_b_x1173_1178,kk_context()); /*ctx<0>*/
        xs = xx;
        _acc = _x_x1886;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_std_core_types__list_drop(xs, _ctx);
    kk_box_t _x_x1887 = kk_cctx_apply_linear(_acc,(kk_std_core_types__list_box(kk_std_core_types__new_Nil(_ctx), _ctx)),kk_context()); /*-1*/
    return kk_std_core_types__list_unbox(_x_x1887, KK_OWNED, _ctx);
  }
}
 
// Return the list without its last element.
// Return an empty list for an empty list.

kk_std_core_types__list kk_std_core_list_init(kk_std_core_types__list xs_0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x_x1888 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core_list__trmc_init(xs_0, _x_x1888, _ctx);
}
 
// Get (zero-based) element `n`  of a list. Return a `:maybe` type.

kk_std_core_types__maybe kk_std_core_list__unroll_index_10029(kk_std_core_types__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> maybe<a> */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1889 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1889->head;
    kk_std_core_types__list xx = _con_x1889->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool _match_x1204 = kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
    if (_match_x1204) {
      kk_box_drop(x, _ctx);
      { // tailcall
        kk_integer_t _x_x1890 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        xs = xx;
        n = _x_x1890;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core_types__list_drop(xx, _ctx);
      bool _match_x1205;
      bool _brw_x1206 = kk_integer_eq_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
      kk_integer_drop(n, _ctx);
      _match_x1205 = _brw_x1206; /*bool*/
      if (_match_x1205) {
        return kk_std_core_types__new_Just(x, _ctx);
      }
      {
        kk_box_drop(x, _ctx);
        return kk_std_core_types__new_Nothing(_ctx);
      }
    }
  }
  {
    kk_integer_drop(n, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// monadic lift

bool kk_std_core_list__mlift_unroll_all_10030_10691(kk_function_t predicate, kk_std_core_types__list xx, bool _y_x10622, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xx : list<a>, bool) -> e bool */ 
  if (_y_x10622) {
    return kk_std_core_list__unroll_all_10030(xx, predicate, _ctx);
  }
  {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return false;
  }
}
 
// Do all elements satisfy a predicate ?


// lift anonymous function
struct kk_std_core_list__unroll_all_10030_fun1894__t {
  struct kk_function_s _base;
  kk_function_t predicate_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__unroll_all_10030_fun1894(kk_function_t _fself, kk_box_t _b_x1185, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_unroll_all_10030_fun1894(kk_function_t predicate_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_all_10030_fun1894__t* _self = kk_function_alloc_as(struct kk_std_core_list__unroll_all_10030_fun1894__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__unroll_all_10030_fun1894, kk_context());
  _self->predicate_0 = predicate_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__unroll_all_10030_fun1894(kk_function_t _fself, kk_box_t _b_x1185, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_all_10030_fun1894__t* _self = kk_function_as(struct kk_std_core_list__unroll_all_10030_fun1894__t*, _fself, _ctx);
  kk_function_t predicate_0 = _self->predicate_0; /* (5263) -> 5264 bool */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<5263> */
  kk_drop_match(_self, {kk_function_dup(predicate_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10622_0_1187 = kk_bool_unbox(_b_x1185); /*bool*/;
  bool _x_x1895 = kk_std_core_list__mlift_unroll_all_10030_10691(predicate_0, xx_0, _y_x10622_0_1187, _ctx); /*bool*/
  return kk_bool_box(_x_x1895);
}

bool kk_std_core_list__unroll_all_10030(kk_std_core_types__list xs, kk_function_t predicate_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e bool */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1891 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1891->head;
    kk_std_core_types__list xx_0 = _con_x1891->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_0_10877;
    kk_function_t _x_x1892 = kk_function_dup(predicate_0, _ctx); /*(5263) -> 5264 bool*/
    x_0_10877 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1892, (_x_x1892, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1893 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_unroll_all_10030_fun1894(predicate_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_bool_unbox(_x_x1893);
    }
    if (x_0_10877) { // tailcall
                     xs = xx_0;
                     goto kk__tailcall;
    }
    {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(predicate_0, _ctx);
      return false;
    }
  }
  {
    kk_function_drop(predicate_0, _ctx);
    return true;
  }
}
 
// monadic lift

bool kk_std_core_list__mlift_unroll_any_10031_10692(kk_function_t predicate, kk_std_core_types__list xx, bool _y_x10628, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xx : list<a>, bool) -> e bool */ 
  if (_y_x10628) {
    kk_std_core_types__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return true;
  }
  {
    return kk_std_core_list__unroll_any_10031(xx, predicate, _ctx);
  }
}
 
// Are there any elements in a list that satisfy a predicate ?


// lift anonymous function
struct kk_std_core_list__unroll_any_10031_fun1899__t {
  struct kk_function_s _base;
  kk_function_t predicate_0;
  kk_std_core_types__list xx_0;
};
static kk_box_t kk_std_core_list__unroll_any_10031_fun1899(kk_function_t _fself, kk_box_t _b_x1189, kk_context_t* _ctx);
static kk_function_t kk_std_core_list__new_unroll_any_10031_fun1899(kk_function_t predicate_0, kk_std_core_types__list xx_0, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_any_10031_fun1899__t* _self = kk_function_alloc_as(struct kk_std_core_list__unroll_any_10031_fun1899__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_list__unroll_any_10031_fun1899, kk_context());
  _self->predicate_0 = predicate_0;
  _self->xx_0 = xx_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_list__unroll_any_10031_fun1899(kk_function_t _fself, kk_box_t _b_x1189, kk_context_t* _ctx) {
  struct kk_std_core_list__unroll_any_10031_fun1899__t* _self = kk_function_as(struct kk_std_core_list__unroll_any_10031_fun1899__t*, _fself, _ctx);
  kk_function_t predicate_0 = _self->predicate_0; /* (5308) -> 5309 bool */
  kk_std_core_types__list xx_0 = _self->xx_0; /* list<5308> */
  kk_drop_match(_self, {kk_function_dup(predicate_0, _ctx);kk_std_core_types__list_dup(xx_0, _ctx);}, {}, _ctx)
  bool _y_x10628_0_1191 = kk_bool_unbox(_b_x1189); /*bool*/;
  bool _x_x1900 = kk_std_core_list__mlift_unroll_any_10031_10692(predicate_0, xx_0, _y_x10628_0_1191, _ctx); /*bool*/
  return kk_bool_box(_x_x1900);
}

bool kk_std_core_list__unroll_any_10031(kk_std_core_types__list xs, kk_function_t predicate_0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e bool */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1896 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t x = _con_x1896->head;
    kk_std_core_types__list xx_0 = _con_x1896->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core_types__list_dup(xx_0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x_0_10880;
    kk_function_t _x_x1897 = kk_function_dup(predicate_0, _ctx); /*(5308) -> 5309 bool*/
    x_0_10880 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x_x1897, (_x_x1897, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x1898 = kk_std_core_hnd_yield_extend(kk_std_core_list__new_unroll_any_10031_fun1899(predicate_0, xx_0, _ctx), _ctx); /*2401*/
      return kk_bool_unbox(_x_x1898);
    }
    if (x_0_10880) {
      kk_std_core_types__list_drop(xx_0, _ctx);
      kk_function_drop(predicate_0, _ctx);
      return true;
    }
    { // tailcall
      xs = xx_0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(predicate_0, _ctx);
    return false;
  }
}
 
// lifted local: sum, @spec-x10327
// specialized: std/core/list/@unroll-foldl@10005, on parameters @uniq-f@10322, using:
// @uniq-f@10322 = std/core/int/(+)

kk_integer_t kk_std_core_list__lift_sum_10350(kk_std_core_types__list _uniq_xs_10320, kk_integer_t _uniq_z_10321, kk_context_t* _ctx) { /* (list<int>, int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(_uniq_xs_10320, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1901 = kk_std_core_types__as_Cons(_uniq_xs_10320, _ctx);
    kk_box_t _box_x1192 = _con_x1901->head;
    kk_std_core_types__list _uniq_xx_10325 = _con_x1901->tail;
    kk_integer_t _uniq_x_10324 = kk_integer_unbox(_box_x1192, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10320, _ctx)) {
      kk_datatype_ptr_free(_uniq_xs_10320, _ctx);
    }
    else {
      kk_integer_dup(_uniq_x_10324, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10325, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10320, _ctx);
    }
    { // tailcall
      kk_integer_t _x_x1902 = kk_std_core_int__lp__plus__rp_(_uniq_z_10321, _uniq_x_10324, _ctx); /*int*/
      _uniq_xs_10320 = _uniq_xx_10325;
      _uniq_z_10321 = _x_x1902;
      goto kk__tailcall;
    }
  }
  {
    return _uniq_z_10321;
  }
}
 
// lifted local: minimum, @spec-x10335
// specialized: std/core/list/@unroll-foldl@10005, on parameters @uniq-f@10330, using:
// @uniq-f@10330 = std/core/int/min

kk_integer_t kk_std_core_list__lift_minimum_10351(kk_std_core_types__list _uniq_xs_10328, kk_integer_t _uniq_z_10329, kk_context_t* _ctx) { /* (list<int>, int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(_uniq_xs_10328, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1903 = kk_std_core_types__as_Cons(_uniq_xs_10328, _ctx);
    kk_box_t _box_x1193 = _con_x1903->head;
    kk_std_core_types__list _uniq_xx_10333 = _con_x1903->tail;
    kk_integer_t _uniq_x_10332 = kk_integer_unbox(_box_x1193, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10328, _ctx)) {
      kk_datatype_ptr_free(_uniq_xs_10328, _ctx);
    }
    else {
      kk_integer_dup(_uniq_x_10332, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10333, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10328, _ctx);
    }
    { // tailcall
      kk_integer_t _x_x1904 = kk_std_core_int_min(_uniq_z_10329, _uniq_x_10332, _ctx); /*int*/
      _uniq_xs_10328 = _uniq_xx_10333;
      _uniq_z_10329 = _x_x1904;
      goto kk__tailcall;
    }
  }
  {
    return _uniq_z_10329;
  }
}
 
// Returns the smallest element of a list of integers (or `default` (=`0`) for the empty list)

kk_integer_t kk_std_core_list_minimum(kk_std_core_types__list xs, kk_std_core_types__optional kkloc_default, kk_context_t* _ctx) { /* (xs : list<int>, default : ? int) -> int */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    if (kk_std_core_types__is_Optional(kkloc_default, _ctx)) {
      kk_box_t _box_x1194 = kkloc_default._cons._Optional.value;
      kk_integer_t _uniq_default_5340 = kk_integer_unbox(_box_x1194, _ctx);
      kk_integer_dup(_uniq_default_5340, _ctx);
      kk_std_core_types__optional_drop(kkloc_default, _ctx);
      return _uniq_default_5340;
    }
    {
      kk_std_core_types__optional_drop(kkloc_default, _ctx);
      return kk_integer_from_small(0);
    }
  }
  {
    struct kk_std_core_types_Cons* _con_x1905 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x1195 = _con_x1905->head;
    kk_std_core_types__list xx = _con_x1905->tail;
    kk_integer_t x = kk_integer_unbox(_box_x1195, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_integer_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__optional_drop(kkloc_default, _ctx);
    if (kk_std_core_types__is_Nil(xx, _ctx)) {
      return x;
    }
    {
      return kk_std_core_list__lift_minimum_10351(xx, x, _ctx);
    }
  }
}
 
// lifted local: maximum, @spec-x10343
// specialized: std/core/list/@unroll-foldl@10005, on parameters @uniq-f@10338, using:
// @uniq-f@10338 = std/core/int/max

kk_integer_t kk_std_core_list__lift_maximum_10352(kk_std_core_types__list _uniq_xs_10336, kk_integer_t _uniq_z_10337, kk_context_t* _ctx) { /* (list<int>, int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core_types__is_Cons(_uniq_xs_10336, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1906 = kk_std_core_types__as_Cons(_uniq_xs_10336, _ctx);
    kk_box_t _box_x1196 = _con_x1906->head;
    kk_std_core_types__list _uniq_xx_10341 = _con_x1906->tail;
    kk_integer_t _uniq_x_10340 = kk_integer_unbox(_box_x1196, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(_uniq_xs_10336, _ctx)) {
      kk_datatype_ptr_free(_uniq_xs_10336, _ctx);
    }
    else {
      kk_integer_dup(_uniq_x_10340, _ctx);
      kk_std_core_types__list_dup(_uniq_xx_10341, _ctx);
      kk_datatype_ptr_decref(_uniq_xs_10336, _ctx);
    }
    { // tailcall
      kk_integer_t _x_x1907 = kk_std_core_int_max(_uniq_z_10337, _uniq_x_10340, _ctx); /*int*/
      _uniq_xs_10336 = _uniq_xx_10341;
      _uniq_z_10337 = _x_x1907;
      goto kk__tailcall;
    }
  }
  {
    return _uniq_z_10337;
  }
}
 
// Returns the largest element of a list of integers (or `default` (=`0`) for the empty list)

kk_integer_t kk_std_core_list_maximum(kk_std_core_types__list xs, kk_std_core_types__optional kkloc_default, kk_context_t* _ctx) { /* (xs : list<int>, default : ? int) -> int */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    if (kk_std_core_types__is_Optional(kkloc_default, _ctx)) {
      kk_box_t _box_x1197 = kkloc_default._cons._Optional.value;
      kk_integer_t _uniq_default_5373 = kk_integer_unbox(_box_x1197, _ctx);
      kk_integer_dup(_uniq_default_5373, _ctx);
      kk_std_core_types__optional_drop(kkloc_default, _ctx);
      return _uniq_default_5373;
    }
    {
      kk_std_core_types__optional_drop(kkloc_default, _ctx);
      return kk_integer_from_small(0);
    }
  }
  {
    struct kk_std_core_types_Cons* _con_x1908 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x1198 = _con_x1908->head;
    kk_std_core_types__list xx = _con_x1908->tail;
    kk_integer_t x = kk_integer_unbox(_box_x1198, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_integer_dup(x, _ctx);
      kk_std_core_types__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__optional_drop(kkloc_default, _ctx);
    if (kk_std_core_types__is_Nil(xx, _ctx)) {
      return x;
    }
    {
      return kk_std_core_list__lift_maximum_10352(xx, x, _ctx);
    }
  }
}
 
// Join a list of strings with newlines

kk_string_t kk_std_core_list_unlines(kk_std_core_types__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  if (kk_std_core_types__is_Nil(xs, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_types_Cons* _con_x1912 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x1199 = _con_x1912->head;
    kk_std_core_types__list _pat_1 = _con_x1912->tail;
    if (kk_std_core_types__is_Nil(_pat_1, _ctx)) {
      kk_string_t x = kk_string_unbox(_box_x1199);
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      return x;
    }
  }
  if (kk_std_core_types__is_Cons(xs, _ctx)) {
    struct kk_std_core_types_Cons* _con_x1913 = kk_std_core_types__as_Cons(xs, _ctx);
    kk_box_t _box_x1200 = _con_x1913->head;
    kk_std_core_types__list _pat_3 = _con_x1913->tail;
    if (kk_std_core_types__is_Cons(_pat_3, _ctx)) {
      struct kk_std_core_types_Cons* _con_x1914 = kk_std_core_types__as_Cons(_pat_3, _ctx);
      kk_box_t _box_x1201 = _con_x1914->head;
      kk_std_core_types__list _pat_4 = _con_x1914->tail;
      if (kk_std_core_types__is_Nil(_pat_4, _ctx)) {
        kk_string_t _x_x1915;
        kk_define_string_literal(, _s_x1916, 1, "\n", _ctx)
        _x_x1915 = kk_string_dup(_s_x1916, _ctx); /*string*/
        kk_string_t _x_x1917 = kk_string_empty(); /*string*/
        if (kk_string_is_eq(_x_x1915,_x_x1917,kk_context())) {
          kk_string_t x_0 = kk_string_unbox(_box_x1200);
          kk_string_t y = kk_string_unbox(_box_x1201);
          if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
            if kk_likely(kk_datatype_ptr_is_unique(_pat_3, _ctx)) {
              kk_datatype_ptr_free(_pat_3, _ctx);
            }
            else {
              kk_string_dup(y, _ctx);
              kk_datatype_ptr_decref(_pat_3, _ctx);
            }
            kk_datatype_ptr_free(xs, _ctx);
          }
          else {
            kk_string_dup(x_0, _ctx);
            kk_string_dup(y, _ctx);
            kk_datatype_ptr_decref(xs, _ctx);
          }
          return kk_std_core_types__lp__plus__plus__rp_(x_0, y, _ctx);
        }
      }
    }
  }
  {
    kk_vector_t _x_x1919 = kk_std_core_vector_unvlist(xs, _ctx); /*vector<911>*/
    kk_string_t _x_x1920;
    kk_define_string_literal(, _s_x1921, 1, "\n", _ctx)
    _x_x1920 = kk_string_dup(_s_x1921, _ctx); /*string*/
    return kk_string_join_with(_x_x1919,_x_x1920,kk_context());
  }
}

// initialization
void kk_std_core_list__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_undiv__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core_exn__init(_ctx);
  kk_std_core_char__init(_ctx);
  kk_std_core_string__init(_ctx);
  kk_std_core_int__init(_ctx);
  kk_std_core_vector__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_core_list__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_core_vector__done(_ctx);
  kk_std_core_int__done(_ctx);
  kk_std_core_string__done(_ctx);
  kk_std_core_char__done(_ctx);
  kk_std_core_exn__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_undiv__done(_ctx);
  kk_std_core_types__done(_ctx);
}
